#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define maxn 16
#define MIC -1000

long max[maxn*maxn][maxn][maxn][maxn][2][2];
char pli[maxn*maxn][maxn][maxn][maxn][2][2];
char pls[maxn*maxn][maxn][maxn][maxn][2][2];
char pup[maxn*maxn][maxn][maxn][maxn][2][2];
char pdown[maxn*maxn][maxn][maxn][maxn][2][2];
long map[maxn][maxn],sum[maxn][maxn];
long m,n,sq;

void readdata(void);
void compute(void);
void writedata(void);

int main()
{
readdata();
compute();
writedata();
return 0;
}

void readdata(void)
{
long i,j;

scanf("%ld %ld %ld",&m,&n,&sq);
for (i=1;i<=m;i++)
  for (j=1;j<=n;j++)
    scanf("%ld",&map[i][j]);
}

long intersect(long a,long b,long c,long d)
{
if ((c>=a && c<=b) || (d>=a && d<=b) ||
    (a>=c && a<=d) || (b>=c && b<=d)) return 1;
else return 0;
}

void compute(void)
{
long i,j,oil,nsq,c,li,ls,up,down,nextnsq,nextli,nextls,nextup,nextdown;

/* compute partial sums */
for (j=1;j<=n;j++)
  {
  sum[0][j]=0;
  for (i=1;i<=m;i++)
    sum[i][j]=sum[i-1][j]+map[i][j];
  }

/* initalize stuff */
for (nsq=0;nsq<=m*n;nsq++)
  for (c=1;c<=n;c++)
    for (li=1;li<=m;li++)
      for (ls=li;ls<=m;ls++)
        for (up=0;up<=1;up++)
          for (down=0;down<=1;down++)
            max[nsq][c][li][ls][up][down]=MIC;

memset(pli,0,sizeof(pli));
memset(pls,0,sizeof(pls));
memset(pup,0,sizeof(pup));
memset(pdown,0,sizeof(pdown));

/* Do a DP */
for (c=1;c<=n;c++)
  {
  /* add a new starting interval */
  for (li=1;li<=m;li++)
    for (ls=li;ls<=m;ls++)
      if (sum[ls][c]-sum[li-1][c]>max[ls-li+1][c][li][ls][1][1])
        max[ls-li+1][c][li][ls][1][1]=sum[ls][c]-sum[li-1][c];

  /* test all solutions so far */
  for (nsq=1;nsq<=c*m;nsq++)
    for (li=1;li<=m;li++)
      for (ls=li;ls<=m;ls++)
        for (up=0;up<=1;up++)
          for (down=0;down<=1;down++)
            if (max[nsq][c][li][ls][up][down]>MIC)

              /* choose the interval for the next column */

              for (nextli=1;nextli<=m;nextli++)
                if ((nextli<li && up) || (nextli>=li))
                  {
                  if (nextli<=li) nextup=up;
                  else nextup=0;

                  for (nextls=nextli;nextls<=m;nextls++)
                    if ((nextls>ls && down) || (nextls<=ls))
                      {
                      if (nextls>=ls) nextdown=down;
                      else nextdown=0;

                      oil=max[nsq][c][li][ls][up][down]+
                          sum[nextls][c+1]-sum[nextli-1][c+1];

                      if (oil>max[nsq+nextls-nextli+1][c+1][nextli][nextls][nextup][nextdown] &&
                          intersect(li,ls,nextli,nextls))
                        {
                        max[nsq+nextls-nextli+1][c+1][nextli][nextls][nextup][nextdown]=oil;
                        pli[nsq+nextls-nextli+1][c+1][nextli][nextls][nextup][nextdown]=li;
                        pls[nsq+nextls-nextli+1][c+1][nextli][nextls][nextup][nextdown]=ls;
                        pup[nsq+nextls-nextli+1][c+1][nextli][nextls][nextup][nextdown]=up;
                        pdown[nsq+nextls-nextli+1][c+1][nextli][nextls][nextup][nextdown]=down;
                        }
                      }
                  }

  }
}

void writedata(void)
{
long i,best,nsq,c,li,ls,up,down,cok,liok,lsok,upok,downok;

for (best=MIC,c=1;c<=n;c++)
  for (li=1;li<=m;li++)
    for (ls=li;ls<=m;ls++)
      for (up=0;up<=1;up++)
        for (down=0;down<=1;down++)
          if (max[sq][c][li][ls][up][down]>best)
            {
            best=max[sq][c][li][ls][up][down];
            cok=c; liok=li; lsok=ls; upok=up; downok=down;
            }

printf("Oil : %ld\n",best);
nsq=sq;
while (nsq>0)
  {
  /*
  printf("* %ld\n",max[nsq][cok][liok][lsok][upok][downok]);
  */
  for (i=liok;i<=lsok;i++)
    printf("%ld %ld\n",i,cok);

  li=pli[nsq][cok][liok][lsok][upok][downok];
  ls=pls[nsq][cok][liok][lsok][upok][downok];
  up=pup[nsq][cok][liok][lsok][upok][downok];
  down=pdown[nsq][cok][liok][lsok][upok][downok];
  nsq-=(lsok-liok+1);
  liok=li; lsok=ls; upok=up; downok=down;
  cok--;
  }
}
