#include <stdio.h>
#include <math.h>

#define NMAX 21
#define eps 1e-9

double x[NMAX][NMAX], y[NMAX][NMAX], v, pip2;
int i, j, k, N;

void compute(double xa, double ya, double xb, double yb, double &xr, double &yr)
{
	double uli, uls, u, d;

	uli = 0.0; /* atan2(yb - ya, xb - xa) */
	uls = pip2; /* 2.0 * pip2 */

	while (fabs(uls - uli) > eps)
	{
		u = 0.5 * (uli + uls);

		xr = xa + 2.0 * cos(u);
		yr = ya + 2.0 * sin(u);

		d = (xr - xb) * (xr - xb) + (yr - yb) * (yr - yb);
		if (d < 4.0)
			uli = u;
		else
			uls = u;
	}
}

int main()
{
	pip2 = acos(0);

	//freopen("d.in", "r", stdin);

	while (1)
	{
		scanf("%d", &N);
		if (!N)
			break;

		for (i = 1; i <= N; i++)
		{
			scanf("%lf", &x[N][i]);
			y[N][i] = 1.0;
		}

		/* sorteaza centrele */
		for (i = 1; i < N; i++)
			for (j = i + 1; j <= N; j++)
				if (x[N][i] > x[N][j])
				{
					v = x[N][i];
					x[N][i] = x[N][j];
					x[N][j] = v;
				}

		for (k = N - 1; k >= 1; k--)
			for (i = 1; i <= k; i++)
				compute(x[k + 1][i], y[k + 1][i], x[k + 1][i + 1], y[k + 1][i + 1],
						x[k][i], y[k][i]);

		printf("%.4lf %.4lf\n", x[1][1], y[1][1]);
	}

	return 0;
}