#include <stdio.h>
#include <string.h>
#include <math.h>

#define NMAX 211
#define INF 666666666
#define QL 5000666

int xh[NMAX], yh[NMAX], xm[NMAX], ym[NMAX];

int nv[NMAX], v[NMAX][NMAX], c[NMAX][NMAX];
int d[2 * NMAX], f[2 * NMAX], viz[2 * NMAX]; 
int q[QL], t[NMAX];

int i, j, k, M, N, nh, nm, s, C;
char ch;

int eflux()
{
	int i, p1 = 0, p2 = 0, cost, cur, poz, min;

	memset(t, 0, sizeof(t));

	for (i = 1; i <= N; i++)
		if (!f[i])
		{
			d[i] = 0;
			q[p2++] = i;
			viz[i] = 1;
		}
		else
		{
			d[i] = INF;
			viz[i] = 0;
		}

	for (i=N+1; i <= 2*N; i++)
	{
		d[i] = INF;
		viz[i] = 0;
	}

	while (p1 < p2)
	{
		cur = q[p1];

		if (viz[t[cur]])
		{
			viz[cur] = 0;
			p1++;
			continue;
		}

		if (cur <= N)
			for (i = 0; i < nv[cur]; i++)
			{
				cost = d[cur] + c[cur][v[cur][i]];
				if ((cost < d[v[cur][i]]) && (v[cur][i] != f[cur]))
				{		
					d[v[cur][i]] = cost;
					
					if (!viz[ v[cur][i] ])
					{
						viz[v[cur][i]] = 1;
						q[p2] = v[cur][i];
						p2++;
					}

					t[v[cur][i]] = cur;
				}
			}
		else
		{
			if (f[cur])
			{
				cost = d[cur] - c[f[cur]][cur];

				if (cost < d[f[cur]])
				{
					d[f[cur]] = cost;
					if (!viz[ f[cur] ])
					{
						viz[f[cur]] = 1;
						q[p2] = f[cur];
						p2++;
					}

					t[f[cur]] = cur;
				}
			}
		}


		viz[cur] = 0;
		p1++;
	}

	poz = 0; min = INF;
	for (i = N+1; i <= 2*N; i++)
		if (d[i] < min && !f[i])
		{
			min = d[i];
			poz = i;
		}

	if (poz)
		s+=min, C++;

	return poz;
}

void creste(int ps)
{
	int poz = ps;

	while (t[poz])
	{
		if (poz > N)
		{
			f[ t[poz] ] = poz;
			f[ poz ] = t[poz];
		}

		poz = t[poz];
	}
}

int main()
{
	int ps;

	//freopen("e.in", "r", stdin);

	while (1)
	{
		scanf("%d %d", &N, &M);
		if (!N)
			break;

		nm = nh = 0;
		for (i = 1; i <= N; i++)
			for (j = 1; j <= M; j++)
			{
				scanf(" %c", &ch);
				if (ch == 'H')
				{
					nh++;
					xh[nh] = i;
					yh[nh] = j;
				}
				else
				if (ch == 'm')
				{
					nm++;
					xm[nm] = i;
					ym[nm] = j;
				}
			}

		/* cuplaj de cost minim */
		N = nm;

		for (i = 1; i <= N; i++)
		{
			nv[i] = N;

			for (j = 1; j <= N; j++)
			{
				v[i][j - 1] = N + j;
				c[i][j + N] = abs(xm[i] - xh[j]) + abs(ym[i] - yh[j]);
			}
		}

		for (i = 1; i <= 2 * N; i++)
			f[i] = 0;

		s = C = 0;
		while (ps = eflux())
			creste(ps);

		printf("%d\n", s);
	}

	return 0;
}