#include <stdio.h>
#include <string.h>

#define NMAX 22
#define MAXPATHS 500000
#define INF 666666

int D[NMAX][NMAX], v[NMAX][NMAX], nv[NMAX];
int p[NMAX], viz[NMAX], DMAX, dd[NMAX], used[NMAX];
int o[NMAX], oaux[NMAX];
int path[MAXPATHS][NMAX], n[MAXPATHS], d[MAXPATHS];
int i, j, k, N, M, st, fi, np, dcur;

/* Dijkstra */
int dmin(int start)
{
	int i, j, k, min;

	memset(used, 0, sizeof(used));

	used[start] = 1;
	for (i = 1; i <= N; i++)
		dd[i] = INF;
	dd[start] = 0;

	k = start;
	while (1)
	{
		if (k == fi)
			break;

		for (j = 0; j < nv[k]; j++)
		{
			i = v[k][j];

			if (!used[i] && !viz[i] && dd[i] > dd[k] + D[k][i])
				dd[i] = dd[k] + D[k][i];
		}

		min = INF;
		for (i = 1; i <= N; i++)
			if (!used[i] && !viz[i] && dd[i] < min)
				min = dd[i], k = i;

		if (min == INF)
			break;

		used[k] = 1;
	}

	return dd[fi];
}

void bkt(int niv)
{
	int i, j, k;

	if (p[niv - 1] == fi)
	{
		np++;

		if (np >= MAXPATHS)
		{
			/* eroare */
			k = 0;
			niv /= k;
			p[niv] = 1;
		}
		else /* adauga ruta */
		{
			n[np - 1] = niv - 1;
			d[np - 1] = dcur;

			for (i = 1; i < niv; i++)
				path[np - 1][i - 1] = p[i];
		}
	}
	else
	{
		k = p[niv -1];
		for (j = 0; j < nv[k]; j++)
		{
			i = v[k][j];

			if (!viz[i])
			{
				dcur += D[k][i];

				if (dcur <= DMAX)
				{
					viz[i] = 1;
					p[niv] = i;

					//if (dcur + dmin(i) <= DMAX)
						bkt(niv + 1);

					//p[niv] = 0;
					viz[i] = 0;
				}

				dcur -= D[k][i];
			}
		}
	}
}

int compare(int i1, int i2)
{
	int i;

	if (d[i1] < d[i2])
		return -1;

	if (d[i2] < d[i1])
		return +1;

	for (i = 0; i < n[i1]; i++)
		if (path[i1][i] < path[i2][i])
			return -1;
		else
		if (path[i2][i] < path[i1][i])
			return +1;

	return -1;
}

void sort(int li, int ls)
{
	int i, j, k, m;

	if (ls > li)
	{
		sort(li, (li + ls) >> 1);
		sort(((li + ls) >> 1) + 1, ls);

		m = (li + ls) >> 1;
		k = li - 1;
		i = li;
		j = m + 1;

		while (i <= m && j <= ls)
		{
			k++;
			if (compare(o[i], o[j]) == -1)
				oaux[k] = o[i++];
			else
				oaux[k] = o[j++];
		}

		while (i <= m)
			oaux[++k] = o[i++];

		while (j <= ls)
			oaux[++k] = o[j++];
	
		for (k = li; k <= ls; k++)
			o[k] = oaux[k];
	}
}

int main()
{
	int t = 0;

	//freopen("g.in", "r", stdin);

	while (1)
	{
		scanf("%d", &N);
		if (N == -1)
			break;

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				D[i][j] = INF;

		memset(nv, 0, sizeof(nv));
		scanf("%d", &M);
		while (M--)
		{
			scanf("%d %d %d", &i, &j, &k);

			if (D[i][j] == INF)
			{
				v[i][nv[i]++] = j;
				v[j][nv[j]++] = i;
			}

			if (k < D[i][j])
				D[i][j] = D[j][i] = k;
		}	
	
		scanf("%d %d %d", &st, &fi, &DMAX);
		
		memset(viz, 0, sizeof(viz));
		viz[1] = st;
		p[1] = st;

		dcur = np = 0;
		bkt(2);

		if (t > 0)
			printf("\n");

		printf("Case %d:\n", ++t);
		
		if (np == 0)
			printf(" NO ACCEPTABLE TOURS\n");
		else
		{
			/* sorteaza */
			for (i = 0; i < np; i++)
				o[i] = i;

			sort(0, np - 1);
		
			for (i = 0; i < np; i++)
			{
				printf(" %d:", d[o[i]]);
				for (j = 0; j < n[o[i]]; j++)
					printf(" %d", path[o[i]][j]);
				printf("\n");
			}
		}
	}
	

	return 0;
}