#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

const char input[256] = "errors.in";
const char output[256] = "errors.out";

void Init();
void AddWord(char *s);
int SearchSubWord(char *s);
int SearchWord(char *s);
void Prepare();
char *GetWord();


int Analize(char *s)
{
    char s1[128];
    int nn = 0;
    int i,j,l,i1,j1;
    char cc;

    l = strlen(s);
    nn += SearchSubWord(s);
    memcpy(s1, s+1, l);
    nn += SearchSubWord(s1);
    j = 1;
    for(i=1;s[i]!=0;i++)
        if(s[i]!=s[i-1])
        {
            s1[i-1] = s[i-1];
            nn += SearchSubWord(s1);
            j++;
        }
    l = i;
    if (SearchWord(s) > 0) nn -= j;
    for(i=0;i<l-1;i++)
        if(s[i+1]!=s[i])
        {
            cc = s[i+1] + s[i];
            j = i+2;
            while(j<l)
                if(s[j] == s[j-2]) j++;
                else break;
            
            for(i1 = i;i1<j;i1++)
            {
                memcpy(s1,s,l+1);
                s1[i1] = cc-s1[i1];
                for(j1 = i1+1;j1<j;j1++)
                {
                    s1[j1] = cc - s1[j1];
                    nn -= SearchWord(s1);
                }
            }
            i=j-2;
        }

    return nn;
}

int main()
{
    char w[1024],w1[1024];
    FILE *f, *fout = fopen(output, "wt");
    int i,j;
    int ndic;

    if ((f = fopen(input,"rt")) == NULL) return -1;

    fscanf(f,"%d %d",&ndic,&i);

    Init();
    for(j=0;j<ndic;j++)
    {
        fgets(w,512,f);
        for(i=0;w[i]!=0;i++)
            if(w[i]<=' ') w[i] = 0;
        if (i < 2) { j--; continue;}
        AddWord(w);
    }

    Prepare();

    while( fscanf(f,"%s",w) > 0)
    {
        for(i=0;w[i]!=0;i++)
            if(w[i]<=' ') w[i] = 0;
        if (i<1)continue;
        i = Analize(w);
        if (i != 1) fprintf(fout, "%s %d\n",w, i);
        else fprintf(fout, "%s 1 %s\n",w, GetWord());
    }
    fclose(f);
    fclose(fout);

//    _exit(0);
    return 0;
}




const int maxl = 30;
const int maxn = 30000;


struct SubWord{
    char text[maxl];
    int iWord;
    int count;
};


char word[maxn][maxl];
SubWord sub[maxn*maxl];

int orderWord[maxn];
int orderSub[maxl*maxn];

int nWord;
int nSub;


int iWord = 0;

void Init()
{
    nWord = 0;
    nSub = 0;
}

void AddWord(char *s)
{
    memcpy(word[nWord++], s, maxl);
}


int CompareWord(const void *v1, const void *v2)
{
    const int i1 = *((const int*)v1);
    const int i2 = *((const int*)v2);
    return strcmp(word[i1], word[i2]);
}

int CompareSub(const void *v1, const void *v2)
{
    const int i1 = *((const int*)v1);
    const int i2 = *((const int*)v2);
    return strcmp(sub[i1].text, sub[i2].text);
}


void Prepare()
{
    int i,j, nn;
    char *s;
    for(i=0;i<nWord;i++) orderWord[i] = i;
    
    qsort(orderWord, nWord, sizeof(int),  CompareWord);
    nn = 0;
    for(i=0;i<nWord;i++)
    {
        s = word[i];
        sub[nn].iWord = i;
        memcpy(sub[nn].text, s, maxl-1);
        nn++;
        sub[nn].iWord = i;
        memcpy(sub[nn].text, s+1, maxl-1);
        nn++;
        for(j=1;s[j]!=0;j++)
            if (s[j] != s[j-1])
            {
                sub[nn].iWord = i;
                memcpy(sub[nn].text, sub[nn-1].text, maxl-1);
                sub[nn].text[j-1] = s[j-1];
                nn++;
            }
    }
    for(i=0;i<nn;i++) orderSub[i] = i;
    qsort(orderSub, nn, sizeof(int),CompareSub);
    sub[orderSub[0]].count = 1;
    j = 0;
    for(i=1;i<nn;i++)
        if (strcmp(sub[orderSub[i]].text, sub[orderSub[j]].text) == 0) 
            sub[orderSub[j]].count++;
        else 
        {
            j++;
            orderSub[j] = orderSub[i];
            sub[orderSub[j]].count = 1;
        }
    nSub = j+1;
}

int SearchSubWord(char *s)
{
    int l,r,m;

    l = 0;
    r = nSub;
    while(l<r-1)
    {
        m = (l+r)/2;
        switch (strcmp(sub[orderSub[m]].text,s))
        {
            case -1: {l = m+1; break;}
            case  1: {r = m; break;}
            case  0:
                {
                    iWord = sub[orderSub[m]].iWord; 
                    return sub[orderSub[m]].count;
                }
        }
    }
    if (strcmp(sub[orderSub[l]].text,s) == 0) 
    {
        iWord = sub[orderSub[l]].iWord;
        return sub[orderSub[l]].count;
    }
    return 0;
}

int SearchWord(char *s)
{
    int l,r,m;
    l = 0;
    r = nWord;
    while(l<r-1)
    {
        m = (l+r)/2;
        switch (strcmp(word[orderWord[m]],s))
        {
            case -1: {l = m+1; break;}
            case  1: {r = m; break;}
            case  0:
                {
                    iWord = orderWord[m];
                    return 1;
                }
        }
    }
    if (strcmp(word[orderWord[l]], s) == 0) 
    {
        iWord = orderWord[l];
        return 1;
    }
    return 0;
}

char * GetWord()
{
    return word[iWord];
}
