{$APPTYPE CONSOLE}
Program AMindbogginglyStupidErrorFinderThatCanNeverAchieveConsiderablePerfomanceBecauseOfTheWorldDisbalanceThatIsNowImprovedByFantasticIdeasOfEugenes;
{$H+}

Type
  Integer=LongInt;

Const
  TaskID='errors';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=40002;
  MinChar=#33;
  MaxChar=#127;

Type
  PTrie=^TTrie;
  TTrie=Record
    Leaf,LeafBy:Integer;
    Child:Array[MinChar..MaxChar]Of PTrie;
  End;

Var
  DictN:Integer;
  Dict:Array[1..MaxN]Of String;
  CheckN:Integer;
  Check:Array[1..MaxN+1]Of String;
  RootSmall,RootBig:PTrie;
  Res,ResLast:Array[1..MaxN]Of Integer;

Function ReadWord:String;
Var
  S:String;
  Ch:Char;
Begin
  Repeat
    Read(Ch);
  Until (Ch>' ') Or EOF;
  S:='';
  If Ch>' ' Then
    Repeat
      S:=S+Ch;
      If EOF Then Break;
      Read(Ch);
    Until Ch<=' ';
  ReadWord:=S;
End;

Procedure Load;
Var
  I:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(DictN);
  Read(CheckN);
  For I:=1 To DictN Do
    Dict[I]:=ReadWord;
  For I:=1 To CheckN Do
    Check[I]:=ReadWord;
  Close(Input);
End;

Procedure AddWord(S:String; Root:PTrie; What:Integer);
Var
  Cur:PTrie;
  J:Integer;
Begin
  Cur:=Root;
  For J:=1 To Length(S) Do Begin
    If Cur^.Child[S[J]]=Nil Then Begin
      New(Cur^.Child[S[J]]);
      Cur:=Cur^.Child[S[J]];
      FillChar(Cur^,SizeOf(Cur^),0);
    End Else Cur:=Cur^.Child[S[J]];
  End;
  Inc(Cur^.Leaf);
  Cur^.LeafBy:=What;
End;

Procedure MakeTrie;
Var
  I,J:Integer;
Begin
  New(RootSmall);
  FillChar(RootSmall^,SizeOf(RootSmall^),0);
  For I:=1 To DictN Do Begin
    AddWord(Dict[I],RootSmall,I);
  End;
  New(RootBig);
  FillChar(RootBig^,SizeOf(RootBig^),0);
  For I:=1 To DictN Do Begin
    AddWord(Dict[I],RootBig,I);
    For J:=1 To Length(Dict[I]) Do If (J=1) Or (Dict[I][J]<>Dict[I][J-1]) Then
      AddWord(Copy(Dict[I],1,J-1)+Copy(Dict[I],J+1,1000),RootBig,I);
  End;
End;

Function WalkTrie(S:String; Root:PTrie; Var WhereLeaf:Integer):Integer;
Var
  Cur:PTrie;
  J:Integer;
Begin
  Cur:=Root;
  For J:=1 To Length(S) Do Begin
    If Cur^.Child[S[J]]=Nil Then Begin WalkTrie:=0; Exit; End;
    Cur:=Cur^.Child[S[J]];
  End;
  WalkTrie:=Cur^.Leaf;
  If Cur^.LeafBy>0 Then
    WhereLeaf:=Cur^.LeafBy;
End;

Procedure Solve;
Var
  I,J,K,Am:Integer;
  Ch1,Ch2:Char;
  S1:String;
  Dummy:Integer;
Begin
  For I:=1 To CheckN Do Begin
    Res[I]:=0;
    Inc(Res[I],WalkTrie(Check[I],RootBig,ResLast[I]));
    Am:=0;
    For J:=1 To Length(Check[I]) Do
      If (J=1) Or (Check[I][J]<>Check[I][J-1]) Then Begin
        Inc(Am);
        Inc(Res[I],WalkTrie(Copy(Check[I],1,J-1)+Copy(Check[I],J+1,1000),RootBig,ResLast[I]));
      End;
    If WalkTrie(Check[I],RootSmall,Dummy)>0 Then Begin
      Dec(Res[I],Am);
    End;
    For J:=1 To Length(Check[I])-1 Do If Check[I][J]<>Check[I][J+1] Then Begin
      S1:=Check[I];
      Ch1:=S1[J];
      Ch2:=S1[J+1];
      S1[J]:=Ch2;
      For K:=J+1 To Length(S1) Do Begin
        If Odd(K-J) Then Begin
          If S1[K]<>Ch2 Then Break;
          S1[K]:=Ch1;
        End Else Begin
          If S1[K]<>Ch1 Then Break;
          S1[K]:=Ch2;
        End;
        If WalkTrie(S1,RootSmall,Dummy)>0 Then
          Dec(Res[I]);
      End;
    End;
  End;
  WriteLn(Res[617]);
End;

Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To CheckN Do Begin
    Write(Check[I],' ',Res[I]);
    Case Res[I] Of
      1:WriteLn(' ',Dict[ResLast[I]]);
      Else WriteLn;
    End;
  End;
  Close(Output);
End;

Begin
  Load;
  MakeTrie;
  Solve;
  Save;
End.