{$APPTYPE CONSOLE}
Program TheUltimateGraphBuilderAndConverterBasedUponStrongFundamentOfCanonicalFormAndEvenMoreStrongHopeThatTwoTimesTwoEqualsFour;

Type
  Integer=LongInt;

Const
  TaskID='gosha';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=1002;
  MaxRes=MaxN*MaxN;

Type
  TGraph=Array[1..MaxN,1..MaxN]Of Boolean;
  TRes=Record
    Len:Integer;
    Data:Array[1..MaxRes]Of Record
      ID1,ID2,ID3,ID4:SmallInt;
    End;
  End;

Var
  N:Integer;
  G1,G2,GTmp:TGraph;
  R1,R2:TRes;
  Degree:Array[1..MaxN]Of Integer;
  PermN:Integer;
  Perm:Array[1..MaxN]Of Integer;
  Alive:Array[1..MaxN]Of Boolean;

Procedure Load;
Var
  I,A,B,M:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  FillChar(G1,SizeOf(G1),False);
  FillChar(G2,SizeOf(G2),False);
  Read(M);
  For I:=1 To M Do Begin
    Read(A,B);
    G2[A,B]:=True;
    G2[B,A]:=True;
  End;
  For I:=1 To M Do Begin
    Read(A,B);
    G1[A,B]:=True;
    G1[B,A]:=True;
  End;
  Close(Input);
End;

Function Greater(A,B:Integer):Boolean;
Begin
  Greater:=(Degree[A]>Degree[B]) Or ((Degree[A]=Degree[B]) And (A<B));
End;

Procedure QSort(L,R:Integer);
Var
  I,J,X,Y:Integer;
Begin
  I:=L;
  J:=R;
  X:=Perm[L+Random(R-L+1)];
  While I<=J Do Begin
    While Greater(Perm[I],X) Do Inc(I);
    While Greater(X,Perm[J]) Do Dec(J);
    If I<=J Then Begin
      Y:=Perm[I];
      Perm[I]:=Perm[J];
      Perm[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  End;
  If L<J Then QSort(L,J);
  If I<R Then QSort(I,R);
End;

Procedure GSet(A,B:Integer; Edge:Boolean);
Begin
  GTmp[A,B]:=Edge;
  GTmp[B,A]:=Edge;
End;

Procedure Normalize(Const G:TGraph; Var R:TRes);
Var
  I,J1,J2,K,Max,MI:Integer;
Begin
  GTmp:=G;
  R.Len:=0;
  FillChar(Degree,SizeOf(Degree),0);
  For J1:=1 To N Do
    For J2:=1 To J1-1 Do If GTmp[J1,J2] Then Begin
      Inc(Degree[J1]);
      Inc(Degree[J2]);
    End;
  For J1:=1 To N Do Alive[J1]:=True;
  GTmp:=G;
  For I:=1 To N Do Begin
    Max:=-1;
    MI:=0;
    For J1:=1 To N Do If Alive[J1] And (Degree[J1]>Max) Then Begin
      Max:=Degree[J1];
      MI:=J1;
    End;
    Alive[MI]:=False;
    PermN:=0;
    For J1:=1 To N Do If Alive[J1] Then Begin
      Inc(PermN);
      Perm[PermN]:=J1;
    End;
    If PermN>0 Then QSort(1,PermN);
    J1:=1;
    J2:=PermN;
    While J1<J2 Do Begin
      While (J1<=PermN) And GTmp[MI][Perm[J1]] Do Inc(J1);
      While (J2>=1) And Not GTmp[MI][Perm[J2]] Do Dec(J2);
      If J1<J2 Then Begin
        For K:=1 To PermN Do If (K<>J1) And (K<>J2) And GTmp[Perm[J1]][Perm[K]] And Not GTmp[Perm[J2]][Perm[K]] Then Break;
        Inc(R.Len);
        With R.Data[R.Len] Do Begin
          ID1:=MI;
          ID2:=Perm[J2];
          ID3:=Perm[K];
          ID4:=Perm[J1];
        End;
        GSet(MI,Perm[J1],True);
        GSet(MI,Perm[J2],False);
        GSet(Perm[J1],Perm[K],False);
        GSet(Perm[J2],Perm[K],True);
        Inc(J1);
        Dec(J2);
      End;
    End;
    For J1:=1 To N Do If Alive[J1] And GTmp[MI][J1] Then Dec(Degree[J1]);
  End;
End;

Procedure Solve;
Begin
  Normalize(G1,R1);
  Normalize(G2,R2);
End;

Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
//  WriteLn(R1.Len+R2.Len);
  For I:=1 To R1.Len Do With R1.Data[I] Do
    WriteLn(ID1,' ',ID2,' ',ID3,' ',ID4,' ',ID1,' ',ID4,' ',ID3,' ',ID2);
  For I:=R2.Len DownTo 1 Do With R2.Data[I] Do
    WriteLn(ID1,' ',ID4,' ',ID3,' ',ID2,' ',ID1,' ',ID2,' ',ID3,' ',ID4);
  Close(Output);
End;

Begin
  RandSeed:=427547331;
  Load;
  Solve;
  Save;
End.
