{$apptype console}
{$o-,q+,r+}

{Problem : SWITCH}
{Solved by Sergey Orshanskiy}

const MAX_V = 20000;
type
  tarr = array [1..MAX_V] of array of integer;
var
  n, m, x, y, i, k, l, r, j : integer;
  v1, v2, v3, v4, v5, dr1, dr2, dr3, dr4 : integer;
  deg, d2 : array [1..MAX_V] of integer;
  e, e2 : tarr;
  tmp : array [1..MAX_V] of integer;
procedure Sort(var e : tarr; k : integer; l, r : integer);
var t, m, i, j : integer;
begin
  if r < l then exit;
  m := e[k][l + random(r - l + 1)];
  i := l;
  j := r;
  while i <= j do
  begin
    while e[k][i] < m do inc(i);
    while e[k][j] > m do dec(j);
    if i <= j then
    begin
      t := e[k][i];
      e[k][i] := e[k][j];
      e[k][j] := t;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then Sort(e, k, i, r);
  if l < j then Sort(e, k, l, j);
end;

procedure kill(x, y : integer);
begin
  e[x][y] := e[x][deg[x]];
  dec(deg[x]);
end;

function find(x, y : integer) : integer;
begin
  result := 1;
  while (abs(e[x][result]) <> y) and (result <= deg[x]) do inc(result);
  if result > deg[x] then result := 0;
end;
procedure addedge(x, y : integer);
var i:integer;
begin
  i := 1;
  while (i<=deg[x]) and (e[x][i] <> -y) do inc(i);
  if i <= deg[x] then kill(x, i) else
  begin
    inc(deg[x]);
    e[x][deg[x]] := y;
  end;
  i := 1;
  while (i <= deg[y]) and (e[y][i] <> -x) do inc(i);
  if i <= deg[y] then kill(y, i) else
  begin
    inc(deg[y]);
    e[y][deg[y]] := x;
  end;
end;
begin
  randseed := 3472;
  assign(input, 'gosha.in');
  reset(input);
  assign(output, 'gosha.out');
  rewrite(output);

  read(n, m);
  assert((n >= 0) and (n <= MAX_V));
  assert((m>=0));
  fillchar(deg, sizeof(deg), 0);
  fillchar(d2, sizeof(d2), 0);
  for i := 1 to n do e[i] := nil;
  for i := 1 to m do
  begin
    read(x, y);
    assert(x <> y);
    assert((x >= 1) and (x <= n) and (y >= 1) and (y <= n));
    inc(deg[x]);
    if deg[x] > d2[x] then
    begin
      d2[x] := d2[x] shl 1 + 1;
      SetLength(e[x], d2[x] + 1);
    end;
    e[x][deg[x]] := y;
    inc(deg[y]);
    if deg[y] > d2[y] then
    begin
      d2[y] := d2[y] shl 1 + 1;
      SetLength(e[y], d2[y] + 1);
    end;
    e[y][deg[y]] := x;
  end;

  for i := 1 to n do SetLength(e[i], deg[i] + 1);
  for i := 1 to n do
    Sort(e, i, 1, deg[i]);
  for i := 1 to n do SetLength(e2[i], deg[i] + 1);

  fillchar(d2, sizeof(d2), 0);
  for i := 1 to m do
  begin
    read(x, y);
    assert(x <> y);
    assert((x >= 1) and (x <= n) and (y >= 1) and (y <= n));    
    inc(d2[x]);
    e2[x][d2[x]] := y;
    inc(d2[y]);
    e2[y][d2[y]] := x;
  end;
  for i := 1 to n do assert(deg[i] = d2[i]);
  for i := 1 to n do
    Sort(e2, i, 1, deg[i]);


  for i := 1 to n do
  begin
    k := 0;
    l := 1;
    r := 1;
    repeat
      while (l <= deg[i]) and ((r > deg[i]) or (e[i][l] < e2[i][r])) do
      begin
        inc(k);
        tmp[k] := e[i][l];
        inc(l);
      end;
      while (r <= deg[i]) and ((l > deg[i]) or (e2[i][r] < e[i][l])) do
      begin
        inc(k);
        tmp[k] := -e2[i][r];
        inc(r);
      end;
      while (l <= deg[i]) and (r <= deg[i]) and (e[i][l] = e2[i][r]) do
      begin
        inc(l);
        inc(r);
      end;
    until (l > deg[i]) and (r > deg[i]);
    e2[i] := nil;
    deg[i] := k;
    SetLength(e[i], k + 1);
    for j := 1 to k do
      e[i][j] := tmp[j];
  end;

  // Now simply solving the problem

  for i := 1 to n do
    while deg[i] > 0 do
    begin
      v1 := i;
      j := 1;
      while (e[v1][j] < 0) do inc(j);
      dr1 := j;
      v2 := e[v1][dr1];
      j := 1;
      while (e[v2][j] > 0) or (-e[v2][j] = v1) do inc(j);
      dr2 := j;
      v3 := abs(e[v2][dr2]);
      j := 1;
      while (e[v3][j] < 0) or (e[v3][j] = v1) or (e[v3][j] = v2) do inc(j);
      dr3 := j;
      v4 := e[v3][dr3];
      j := 1;
      while (e[v4][j] > 0) or (-e[v4][j] = v2) or (-e[v4][j] = v3) do inc(j);
      dr4 := j;
      v5 := -e[v4][dr4];

//      writeln(v1,'-',v2,' ',v3,'-',v4, ' --> ',v2,'-',v3,' ',v4,'-',v1);
      writeln(v1:4,' ',v2:4,' ',v3:4,' ',v4:4);
      if v5 = v1 then
      begin
        kill(v1, dr1);
        kill(v2, dr2);
        kill(v3, dr3);
        kill(v4, dr4);
        kill(v1, find(v1, v4));
        kill(v2, find(v2, v1));
        kill(v3, find(v3, v2));
        kill(v4, find(v4, v3));
      end else
      begin
        kill(v1, dr1);
        kill(v2, dr2);
        kill(v3, dr3);
        kill(v4, find(v4, v3));
        kill(v3, find(v3, v2));
        kill(v2, find(v2, v1));
        addedge(v1, v4);
      end;
    end;

  for i := 1 to n do
  begin
    e[i] := nil;
  end;
end.