{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$APPTYPE CONSOLE}
const
    MAX_LEAP_YEARS = 10000;
    MAX_HOLIDAYS = 10000;
    MAX_DAYS_PER_WEEK = 10000;

function GCD(a, b: longint): longint;
var
    t: longint;
begin
    while a <> 0 do begin
        t := b mod a;
        b := a;
        a := t;
    end;
    GCD := b;
end;

var
    daysPerWeek, daysPerYear: longint;

    cl: longint;
    l: array [0..MAX_LEAP_YEARS + 1] of longint;

    ch, chl: longint;
    h: array [1..MAX_HOLIDAYS] of longint;

    q, ql: array [1..MAX_DAYS_PER_WEEK] of longint;
    p, pl: array [1..MAX_DAYS_PER_WEEK] of longint;

    rh, rhs: array [1..2 * MAX_DAYS_PER_WEEK] of longint;

    i, j: longint;
    years: longint;
    d: longint;
    step: longint;
    period: longint;
    day, days: longint;
    mini: longint;
    qdays: longint;
    holidays: longint;

procedure update(years: longint);
var
    i: longint;
begin
    d := years div period;
    for i := 1 to period do begin
        inc(p[(day + (i - 1) * step - 1) mod daysPerWeek + 1], d);
    end;
    for i := 1 to years mod period do begin
        inc(p[(day + (i - 1) * step - 1) mod daysPerWeek + 1]);
    end;
    day := (day + step * years - 1) mod daysPerWeek + 1;
    days := days - daysPerYear * years;
end;

begin
    assign(input, 'holidays.in'); reset(input);
    assign(output, 'holidays.out'); rewrite(output);

    while not seekeof do begin
    read(daysPerWeek, daysPerYear);

    read(cl);
    for i := 1 to cl do begin
        read(l[i]);
    end;

    read(ch);
    for i := 1 to ch do begin
        read(h[i]);
    end;

    read(days);
    qdays := days;

    l[0] := 0;
    l[cl + 1] := days div daysPerYear + 1;

    fillchar(q, sizeof(q), 0);
    fillchar(ql, sizeof(ql), 0);
    for i := 1 to ch do begin
        if h[i] <= daysPerYear then begin
            inc(q[(h[i] - 1) mod daysPerWeek + 1]);
        end;
        inc(ql[(h[i] - 1) mod daysPerWeek + 1]);
    end;

    step := daysPerYear mod daysPerWeek;
    period := daysPerWeek div GCD(daysPerWeek, step);
    day := 1;

    fillchar(p, sizeof(p), 0);
    fillchar(pl, sizeof(pl), 0);
    for i := 1 to cl + 1 do begin
        years := l[i] - l[i - 1] - 1;
        if days <= int64(years) * daysPerYear then begin
            update(days div daysPerYear);
            break;
        end;
        update(years);

        if days <= daysPerYear + 1 then begin
            break;
        end;
        inc(pl[day]);
        day := (day + daysPerYear) mod daysPerWeek + 1;
        days := days - daysPerYear - 1;
    end;

    holidays := (qdays - 1) div daysPerWeek;
    fillchar(rh, sizeof(rh), 0);
    for i := 1 to ch do begin
        if days >= h[i] then begin
            inc(rh[(day + h[i] - 2) mod daysPerWeek + 1]);
            inc(holidays);
        end;
    end;

    {
    for i := 1 to daysPerWeek do begin
        for j := 1 to daysPerWeek do begin
            inc(rh[(i + j - 2) mod daysPerWeek + 1], q[i] * p[j] + ql[i] * pl[j]);
        end;
    end;
    }
    for i := 1 to daysPerWeek do begin
        for j := 1 to daysPerWeek do begin
            inc(rh[i + j - 1], q[i] * p[j] + ql[i] * pl[j]);
        end;
    end;
    for i := 1 to daysPerWeek do begin
        rh[i] := rh[i] + rh[i + daysPerWeek];
    end;

    chl := ch;
    if (ch > 0) and (h[ch] = daysPerYear + 1) then dec(chl);
    for i := 1 to daysPerWeek do begin
        holidays := holidays + p[i] * chl + pl[i] * ch;
    end;

    rhs := rh;
    for i := 1 to daysPerWeek do begin
        if (qdays - 1) mod daysPerWeek + 1 >= i then begin
            dec(rhs[i]);
        end;
    end;

    mini := 1;
    for i := 2 to daysPerWeek do begin
        if rhs[mini] > rhs[i] then begin
            mini := i;
        end;
    end;

{    writeln('Choose holiday on day of week: ', mini);
    writeln('Number of holidays: ', holidays - rhs[mini]);
    writeln('Number of matched: ', rh[mini]);}
    writeln(mini, ' ', holidays - rhs[mini]);
    end;

    close(input);
    close(output);
end.