{{$APPTYPE CONSOLE}
{$o+,q-,r-}

// Problem HOLIDAYS
// Solution by Sergey Orshanskiy

const
        MAX_PER_WEEK = 10000;
        MAX_PER_YEAR = 1000000;
        MAX_LEAP_YEARS = 10000;
        MAX_HOLIDAYS = 1000000;

var dw : integer;    // days per week
    dy : integer;    // days per year
    nleap : integer; // number of leap years
    nh : integer;    // number of holidays
    leap : array [1..MAX_LEAP_YEARS] of integer; // leap years
    hs : array [1..MAX_HOLIDAYS] of integer; // state holidays
    dur, alldur : int64;     // duration of work
    P, Pl : array [1..MAX_PER_WEEK] of integer; // how many normal and leap years
                                                // of our work start with that day
    Q, Ql : array [1..MAX_PER_WEEK] of integer; // how many state holidays we get on
                                                // i-th day of normal and leap year
                                                // if started with 1st day of week
    Q2 : array [1..MAX_PER_WEEK] of integer; // the same - about the last year - IF it
                                             // started in 1st day of week
    year : integer;    // current year
    day  : integer;    // current day of week
    curleap : integer; // number of following leap year
    len : integer;     // number of days in the current year
    bestS, S, nhol, left, ans, bestans : int64;
    x, y, yy, t, bestx : integer;
    y_u : integer;
    i, j : integer;
    nyears : integer;

// day of week normalization
function norm(x : int64) : integer;
begin
        if x > 0 then norm := (x - 1) mod dw + 1 else
        norm := dw - (abs(x) mod dw);
end;

function gcd(x, y : int64) : int64;
var nd : int64;
begin
        while x > 0 do
        begin
                nd := x;
                x := y mod x;
                y := nd;
        end;
        gcd := y;
end;

begin
        if paramcount < 1 then assign(input, 'holidays.in') else
            assign(input, paramstr(1));
        reset(input);
        if paramcount < 2 then assign(output, 'holidays.out') else
            assign(output, paramstr(2));
        rewrite(output);

        read(dw, dy); // days per week, days per year
        assert((dw >= 1) and (dw <= MAX_PER_WEEK));
        assert((dy >= 1) and (dy <= MAX_PER_YEAR));
        read(nleap); // Number of leap years
        assert((nleap >= 0) and (nleap <= MAX_LEAP_YEARS));
        for i := 1 to nleap do read(leap[i]); // leap years
        for i := 1 to nleap - 1 do assert(leap[i] < leap[i + 1]);
        read(nh); // number of holidays
        assert((nh >= 0) and (nh <= MAX_HOLIDAYS));
        for i := 1 to nh do read(hs[i]); // state holidays
        for i := 1 to nh - 1 do assert(hs[i] < hs[i + 1]);
        read(dur); // duration of work
        alldur := dur;
/////////////////////////////////////////////
        fillchar(p,  sizeof(p),  0);
        fillchar(pl, sizeof(pl), 0);
        year := 1;
        day := 1;
        curleap := 1;
        while true do
        begin
                if (curleap <= nleap) and (leap[curleap] = year) then
                begin
                        len := dy + 1;
                        if len > dur then break;
                        inc(Pl[day]);
                        day := norm(day + len);
                        dur := dur - len;
                        inc(year);
                        inc(curleap);
                end else
                begin
                        len := dy;
                        if len > dur then break;
                        nyears := dur div dy;
                        if (curleap <= nleap) and (leap[curleap] < year + nyears) then
                                nyears := leap[curleap] - year;
                        y_u := dw div gcd(dw, dy); // years until same day of week
                        x := day;
                        y := nyears mod y_u;
                        t := nyears div y_u;
                        repeat
                                P[x] := P[x] + t;
                                if y > 0 then inc(P[x]);
                                dec(y);
                                x := norm(x + dy);
                        until x = day;
                        day := norm(int64(day) + int64(len) * nyears);
                        dur := dur - int64(len) * nyears;
                        year := year + nyears;
                end;
        end;
        // Now filled P and Pl, and we have the tail - 'dur' days, first day of week - 'day'


        // Calculating Q and Ql, and Q2
        fillchar(Q,  sizeof(Q),  0);
        fillchar(Ql, sizeof(Ql), 0);
        fillchar(Q2, sizeof(Q2), 0);
        for i := 1 to nh do
        begin
                x := (hs[i] - 1) mod dw + 1;
                inc(Ql[x]);
                if (hs[i] <= dy) then inc(Q[x]);
                if (hs[i] <= dur) then inc(Q2[x]);
        end;
        // End of calculating Q and Ql, and Q2

        // Base number of holidays
        nhol := (year - 1) * nh;
        for i := 1 to nh do if hs[i] <= dur then inc(nhol);
        for i := 1 to nh do if hs[i] > dy then // there is a party on extra-day
        begin
                nhol := nhol - (year - 1);
                for j := 1 to nleap do if leap[j] < year then inc(nhol);
                break;
        end;
        nhol := nhol + (alldur div dw);
        left := alldur mod dw;

        bestx := 0;
        bestans := -1;

        for x := 1 to dw do // holiday day
        begin
                S := 0;

                yy := x;
                for y := 1 to dw do // start with that day
                begin
                        // S := S + P[y] * Q[norm(x - y + 1)] + Pl[y] * Ql[norm(x - y + 1)];
                       S := S + P[y] * Q[yy] + Pl[y] * Ql[yy];
                       dec(yy);
                       if yy = 0 then yy := dw;
                end;
                S := S + Q2[norm(x - day + 1)];

                ans := nhol;
                if x <= left then inc(ans);
                ans := ans - S;
                if ans > bestans then
                begin
                        bestans := ans;
                        bestx := x;
                        bestS := S;
                end;

    end;
        assert(bestans >= 0);
        writeln(bestx,' ',bestans);
  
end.