{$apptype console}
{$o-,q+,r+}

uses
  SysUtils;

const
  dx: array[1..4] of integer = (0, 1, 0, -1);
  dy: array[1..4] of integer = (-1, 0, 1, 0);
  back: array[1..4] of integer = (3, 4, 1, 2);
  maxn = 1000;

var
  n, m: integer;
  sx, sy, sd, fx, fy, fd: integer;
  a: array[1..maxn, 1..maxn] of integer;
  best, bestx, besty, bestd: integer;
  dist: integer;

function norm(x, y: integer): boolean;
begin
  norm := (x >= 1) and (x <= n) and (y >= 1) and (y <= m);
end;

procedure go(var x, y, d: integer);
begin
  if a[x, y] = 2 then begin
    if d = 1 then d := 2 else
    if d = 2 then d := 1 else
    if d = 3 then d := 4 else
    if d = 4 then d := 3;
  end else if a[x, y] = 1 then begin
    if d = 1 then d := 4 else
    if d = 4 then d := 1 else
    if d = 3 then d := 2 else
    if d = 2 then d := 3;
  end;
  x := x - dx[d];
  y := y - dy[d];
end;

var
  i, j, k: integer;
  x, y, d: integer;
  z, z1, z2: array[1..maxn, 1..maxn, 1..4] of boolean;
  d1, d2: array[1..maxn, 1..maxn, 1..4] of integer;
  dr1, dr2: integer;
  xx, yy, dd: integer;
  pathdist: integer;
  fl: boolean;

begin
  assign(input, 'pinball.in');
  reset(input);
  assign(output, 'pinball.out');
  rewrite(output);

  read(m, n, k);
  dec(k);

  assert((n >= 1) and (n <= 1000) and (m >= 1) and (m <= 1000));

  read(sy, sx, sd);
  read(fy, fx, fd);

  assert((sx >= 1) and (sx <= n) and (sy >= 1) and (sy <= m) and (sd >= 1) and (sd <= 4));
  assert((fx >= 1) and (fx <= n) and (fy >= 1) and (fy <= m) and (fd >= 1) and (fd <= 4));
  x := sx + dx[sd];
  y := sy + dy[sd];
  assert((x < 1) or (x > n) or (y < 1) or (y > m));
  x := fx + dx[fd];
  y := fy + dy[fd];
  assert((x < 1) or (x > n) or (y < 1) or (y > m));

  for i := 1 to k do begin
    read(y, x);
    assert((x >= 1) and (x <= n) and (y >= 1) and (y <= m));
    assert(a[x, y] = 0);
    read(a[x, y]);
  end;

  x := fx;
  y := fy;
  d := fd;
  dist := 0;
  while norm(x, y) do begin
    inc(dist);
    d2[x, y, d] := dist;
    z2[x, y, d] := true;
    go(x, y, d);
  end;
  pathdist := dist;

  x := sx;
  y := sy;
  d := sd;
  dist := 0;
  while norm(x, y) do begin
    inc(dist);
    d1[x, y, d] := dist;
    z1[x, y, d] := true;
    go(x, y, d);
  end;

  if (x = fx + dx[fd]) and (y = fy + dy[fd]) then begin
    best := -1;
    //deleting path-cycles.
    for x := 1 to n do begin
      for y := 1 to m do if a[x, y] = 0 then begin
        for dr1 := 1 to 4 do
          for dr2 := 1 to 4 do if z1[x, y, dr1] and z2[x, y, dr2] and (dr2 <> dr1 + 2) and (dr1 <> dr2 + 2) then begin
            dist := d1[x, y, dr1] + d2[x, y, dr2] - 1;
            if (best = -1) or (dist < best) then begin
              best := dist;
              bestx := x;
              besty := y;
              if (dr1 * dr2 = 2) or (dr1 * dr2 = 12) then 
                bestd := 1
              else
                bestd := 2;
            end;
          end;
      end;
    end;
    //Placing on the empty cell
    for x := 1 to n do begin
      for y := 1 to m do begin
        fl := true;
        for dr1 := 1 to 4 do if z1[x, y, dr1] then fl := false;
        if fl and (a[x, y] = 0) then begin
          if (best = -1) or (pathdist < best) then begin
            best := pathdist;
            bestx := x;
            besty := y;
            bestd := 1;
          end;
        end;
      end;
    end;
    //Finding minimal cycle
    for x := 1 to n do begin
      for y := 1 to m do begin
        fl := false;
        for dr1 := 1 to 4 do if z1[x, y, dr1] then fl := true;
        if fl and (a[x, y] = 0) then begin
          for dr1 := 1 to 4 do if not z[x, y, dr1] and not z1[x, y, dr1] and not z2[x, y, dr1] then begin
            dist := 0;
            xx := x;
            yy := y;
            dd := dr1;
            while norm(xx, yy) and not z[xx, yy, dd] do begin
              inc(dist);
              z[xx, yy, dd] := true;
              go(xx, yy, dd);
            end;
            if (xx = x) and (yy = y) and (dd = dr1) then
              if (best = -1) or (pathdist + dist < best) then begin
                best := pathdist + dist;
                bestx := x;
                besty := y;
                bestd := 1;
              end;
          end;
        end;
      end;
    end;
  end else begin
    best := -1;

    for x := 1 to n do begin
      for y := 1 to m do if a[x, y] = 0 then begin
        for dr1 := 1 to 4 do
          for dr2 := 1 to 4 do begin
            if z1[x, y, dr1] and z2[x, y, dr2] and ((best = -1) or (d1[x, y, dr1] + d2[x, y, dr2] < best)) then begin
              best := d1[x, y, dr1] + d2[x, y, dr2];
              bestx := x;
              besty := y;
              if (dr1 * dr2 = 2) or (dr1 * dr2 = 12) then bestd := 1 else bestd := 2;
            end;
          end;
      end;
    end;

  end;

  writeln(ErrOutput, best);

  if best = -1 then begin
    assert(false);
  end else begin
    writeln(besty,' ',bestx,' ',bestd);
  end;

end.
