{
  Dmitry Orlov
}

{$apptype console}

{$R-,I+,S+,Q+,O-}

program template;
const
 nmax = 2100;
 kmax = 101000;
 mmax = 101000;
 infinity = 2000000000;
 cinfile = 'redhat.in';
 coutfile = 'redhat.out';
type
 int = longint;
 real = extended;
 tptr = ^tlist;
 tlist = record
  inf :int;
  w :int;
  number :int;
  next :tptr;
 end;
 tWolf = record
  time :int;
  rib :int;
 end;
 tWolfPtr = ^tWolfList;
 tWolfList = record
  startTime :int;
  finishTime :int;
  next :tWolfPtr;
 end;
var
 n,m,k :int;
 gr :array [1..nmax] of tptr;
 wolf :array [1..kmax] of tWolf;
 d :array [1..nmax] of int;
 used :array [1..nmax] of boolean;
 prev :array [1..nmax] of int;
 wolfList :array [1..mmax] of tWolfPtr;
 endOfWolfList :array [1..mmax] of tWolfPtr;
 path :array [0..nmax] of int;
 wolfTime :int;
 ans :int;
 ribNumber :array [1..nmax] of int;

procedure init;
begin
 ans := 0;
 wolfTime := 0;
 fillchar (gr,sizeof(gr),0);
 fillchar (wolf,sizeof(wolf),0);
 fillchar (used,sizeof(used),0);
 fillchar (d,sizeof(d),0);
 fillchar (prev,sizeof(prev),0);
 fillchar (wolfList,sizeof(wolfList),0);
 fillchar (path,sizeof(path),0);
 fillchar (endOfWolfList,sizeof(endOfWolfList),0);
 fillchar (ribNumber,sizeof(ribNumber),0);
end;

procedure add (var list :tptr; value :int; time :int; number :int);
var x :tptr;
begin
 new (x);
 x^.inf := value;
 x^.w := time;
 x^.number := number;
 x^.next := list;
 list := x;
end;

procedure addWolf (ribNumber :int; sTime,fTime :int);
var x :tWolfPtr;
begin
 if wolfList[ribNumber] = nil then
  begin
   new (wolfList[ribNumber]);
   wolfList[ribNumber]^.startTime := sTime;
   wolfList[ribNumber]^.finishTime := fTime;
   wolfList[ribNumber]^.next := nil;
   endOfWolfList[ribNumber] := wolfList[ribNumber];
   exit;
  end;
 new (endOfWolfList[ribNumber]^.next);
 x := endOfWolfList[ribNumber]^.next;
 x^.startTime := sTime;
 x^.finishTime := fTime;
 x^.next := nil;
 endOfWolfList[ribNumber] := x;
end;

procedure readdata;
var i,j :int;
    u,v,t :int;
begin
 assign (input,cinfile);
 reset (input);
 read (n,m,k);
 for i := 1 to m do
  begin
   read (u,v,t);
   add (gr[u],v,t,i);
   add (gr[v],u,t,i);
  end;
 j := 0; 
 for i := 1 to k do
  begin
   read (v,t);
   j := j + t;
   wolfTime := j;
   wolf[k].time := j;
   wolf[k].rib := v;
   addWolf (v,j-t,j); 
  end;
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln ('YES');
 write (path[0],' ');
 for i := path[0] downto 1 do
  write (path[i],' ');
 close (output);
end;

function intersect (a,b,c,d :int):boolean;
begin
 intersect := ((c >= a) and (c <= b)) or ((d >= a) and (d <= b)) or
         ((a >= c) and (a <= d)) or ((b >= c) and (b <= d)); 
end;

function timeToWait (time :int; runTime :int; rib :int):int;
var x :tWolfPtr;
begin
 result := time;
 x := wolfList[rib];
 while not (x = nil) do
  begin
   if intersect (result,result + runTime,x^.startTime,x^.finishTime) then
    if x^.finishTime > result then
     result := x^.finishTime;
   x := x^.next; 
  end;
end;

procedure outNo;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln ('NO');
 close (output);
 halt;
end;

procedure solve;
var i,j :int;
    x :tptr;
    time :int;
    res,cur :int;
begin
 for i := 1 to n do
  d[i] := infinity;
 d[1] := 0;
 for i := 1 to n do
  begin
   cur := 0;
   res := infinity;
   for j := 1 to n do
    if not used[j] then
     if d[j] < res then
      begin
       res := d[j];
       cur := j;
      end;
   if cur = 0 then
    break;
   used[cur] := true;
   x := gr[cur];
   while not (x = nil) do
    begin
     time := timeToWait (d[cur],x^.w,x^.number);
     if time + x^.w < d[x^.inf] then
      begin
       d[x^.inf] := time + x^.w;
       prev[x^.inf] := cur;
       ribNumber[x^.inf] := x^.number;
      end;
     x := x^.next; 
    end;
  end;
 if not used[n] then
  outNo;
 if d[n] >= wolfTime then
  outNo;
 cur := n;
 while not (cur = 1) do
  begin
   inc(path[0]);
   path[path[0]] := ribNumber[cur];
   cur := prev[cur];
  end;
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.
