{$o-,q+,r+}
uses
  sysutils;

const
  maxn = 2000;
  maxm = 100000;
  maxk = 100000;

var
  last: integer;
  edge, srce, dest, next, time: array[1..maxm*2] of integer;
  head: array[1..maxn] of integer;

  edgepos: array[1..maxm, 1..2] of integer;

  lastw: integer;
  nextw: array[0..maxk] of integer;
  time1, time2: array[1..maxk] of integer;
  headw, tailw: array[1..maxm] of integer;

  lastv: integer;
  nextv: array[0..maxk] of integer;
  edgev, timev: array[1..maxk] of integer;
  headv, tailv: array[1..maxn] of integer;


procedure AddEdge(i, j: integer; k, kk: integer; t: integer);
begin
  inc(last);
  srce[last] := i;
  dest[last] := j;
  time[last] := t;
  next[last] := head[i];
  head[i] := last;
  edge[last] := k;
  edgepos[k, kk] := last;
end;

procedure AddWolf(e, t1, t2: integer);
begin
  inc(lastw);
  time1[lastw] := t1;
  time2[lastw] := t2;
  nextw[tailw[e]] := lastw;
  if tailw[e] = 0 then begin
    headw[e] := lastw;
  end;
  tailw[e] := lastw;
end;

procedure AddWolfVertex(v, t, e: integer);
begin
  inc(lastv);
  timev[lastv] := t;
  edgev[lastv] := e;
  nextv[tailv[v]] := lastv;
  if tailv[v] = 0 then begin
    headv[v] := lastv;
  end;
  tailv[v] := lastv;
end;

var
  start, finish: array[1..maxn] of integer;
  visit: array[1..maxk] of integer;

function Occupied(v, t: integer): boolean;
var
  l, r, m: integer;
begin
  l := start[v] - 1;
  r := finish[v] + 1;
  while r - l > 1 do begin
    m := (l + r) shr 1;
    if visit[m] < t then l := m else r := m;
  end;
  Occupied := ((r <= finish[v]) and (visit[r] = t));
end;

function Valid(t1, t2: integer; t, dt: integer; v: integer): integer;
begin
  inc(t1);
  dec(t2);
  if t1 < t then
    t1 := t;
  if t2 - t1 >= dt then
  begin
    if Occupied(v, t1 + dt) then
      valid := t1 + dt + 1
    else
      valid := t1 + dt;
  end else begin
    valid := -1;
  end;
end;

var
  tw: integer;

function GetTime(e: integer; t: integer): integer;
var
  hw, tt, t1, t2: integer;
begin
  hw := headw[edge[e]];
  t1 := -2;
  while hw <> 0 do begin
    t2 := time1[hw];

    tt := valid(t1, t2, t, time[e], dest[e]);
    if tt > -1 then begin
      GetTime := tt;
      exit;
    end;

    t1 := time2[hw];
    hw := nextw[hw];
  end;
  t2 := tw + time[e] + 2;

  GetTime := valid(t1, t2, t, time[e], dest[e]);
end;

var
  from: array[1..maxn] of integer;
  d, count: array[1..maxn] of integer;

procedure print(i: integer);
begin
  if i <> 1 then begin
    print(srce[from[i]]);
    writeln(edge[from[i]]);//, ' ', d[i] / 2 : 0 : 1);
  end;
end;

var
  h, v, t, n, m, w, i, j, k: integer;
  z: array[1..maxn] of boolean;
  tt: integer;

begin
  assign(input, 'redhat.in');
  reset(input);
  assign(output, 'redhat.out');
  rewrite(output);

  last := 0;
  lastw := 0;

  read(n, m, w);
  for i := 1 to m do begin
    read(j, k, t);
    AddEdge(j, k, i, 1, t * 2);
    AddEdge(k, j, i, 2, t * 2);
  end;

  t := 0;
  v := 1;
  for i := 1 to w do begin
    read(j, k);
    AddWolf(j, t, t + 2 * k);
    AddWolfVertex(v, t, j);

    if srce[edgepos[j, 1]] = v then
      v := dest[edgepos[j, 1]]
    else if srce[edgepos[j, 2]] = v then
      v := dest[edgepos[j, 2]]
    else
      runerror(239);

    t := t + 2 * k;
  end;

  j := 0;
  for i := 1 to n do begin
    start[i] := j+1;
    h := headv[i];
    while h <> 0 do begin
      inc(j);
      visit[j] := timev[h];
      h := nextv[h];
    end;
    finish[i] := j;
  end;

  tw := t;

  d[1] := 0;
  count[1] := 0;
  from[1] := 0;
  for i := 2 to n do d[i] := -1;
  fillchar(z, sizeof(z), 0);

  while true do begin
    j := -1;
    for i := 1 to n do
      if (not z[i]) and (d[i] > -1) and ((j = -1) or (d[i] < d[j])) then j := i;
    if j = -1 then break;

    z[j] := true;

    t := d[j];

    h := head[j];
    while h <> 0 do begin
      tt := GetTime(h, t);
      if (tt <> -1) and ((d[dest[h]] = -1) or (d[dest[h]] > tt)) then begin
        d[dest[h]] := tt;
        count[dest[h]] := count[j] + 1;
        from[dest[h]] := h;
      end;
      h := next[h];
    end;
  end;

  if (d[n] >= tw) or (d[n] = -1) then begin
    writeln('NO');
  end else begin
    writeln('YES');
    writeln(count[n]);
    print(n);
  end;
end.
