{$APPTYPE CONSOLE}
Program SomeStrangeRedHatStoryDecoderAndSolverThatMakesEveryoneInThisStupidWorldHappyIncludingTheGranny;

Type
  Integer=LongInt;

Const
  TaskID='redhat';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=2002;
  MaxM=100002;
  MaxK=100002;
  Infinity=MaxLongInt Div 2;

Var
  N,M,K:Integer;
  First:Array[1..MaxN]Of Integer;
  Edge:Array[1..2*MaxM]Of Record
    Src,Dst:Integer;
    Len:Integer;
    Next:Integer;
    FirstWolf:Integer;
  End;
  Wolf:Array[1..2*MaxK]Of Record
    At,Time,Start:Integer;
    Next:Integer;
  End;
  WolfTime:Integer;
  Mark:Array[1..MaxN]Of Boolean;
  By,L:Array[1..MaxN]Of Integer;
  ResLen:Integer;
  Res:Array[1..MaxN]Of Record
    Through,FinishTime:Integer;
  End;

Procedure Load;
Var
  I:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M,K);
  FillChar(First,SizeOf(First),0);
  For I:=1 To M Do With Edge[I] Do Begin
    Read(Src,Dst,Len);
    Len:=Len*2;
    Next:=First[Src];
    First[Src]:=I;
    Edge[I+M].Src:=Dst;
    Edge[I+M].Dst:=Src;
    Edge[I+M].Len:=Len;
    Edge[I+M].Next:=First[Dst];
    First[Dst]:=I+M;
  End;
  M:=2*M;
  For I:=1 To M Do With Edge[I] Do FirstWolf:=0;
  For I:=1 To K Do With Wolf[I] Do Begin
    Read(At,Time);
    Time:=Time*2;
    If I=1 Then Start:=0 Else Start:=Wolf[I-1].Start+Wolf[I-1].Time;
    Next:=0;
    Wolf[I+K].At:=At+M Div 2;
    Wolf[I+K].Time:=Time;
    Wolf[I+K].Start:=Start;
    Wolf[I+K].Next:=0;
  End;
  If K=0 Then WolfTime:=0 Else WolfTime:=Wolf[K].Start+Wolf[K].Time;
  K:=2*K;
  For I:=K DownTo 1 Do With Wolf[I] Do Begin
    Next:=Edge[At].FirstWolf;
    Edge[At].FirstWolf:=I;
  End;
  Close(Input);
End;

Procedure Relax(Num:Integer);
Var
  I:Integer;
  FreeAt,GetAt:Integer;
Begin
  With Edge[Num] Do Begin
    I:=FirstWolf;
    FreeAt:=1;
    While (I>0) And (Wolf[I].Start<L[Src]) Do Begin
      FreeAt:=Wolf[I].Start+Wolf[I].Time+1;
      I:=Wolf[I].Next;
    End;
    If L[Src]>FreeAt Then FreeAt:=L[Src];
    While (I>0) And (FreeAt+Len>=Wolf[I].Start) Do Begin
      FreeAt:=Wolf[I].Start+Wolf[I].Time+1;
      I:=Wolf[I].Next;
    End;
    GetAt:=FreeAt+Len;
    If GetAt<L[Dst] Then Begin
      By[Dst]:=Num;
      L[Dst]:=GetAt;
    End;
  End;
End;

Procedure Otkat(At:Integer);
Begin
  If By[At]=0 Then Exit;
  Otkat(Edge[By[At]].Src);
  Inc(ResLen);
  With Res[ResLen] Do Begin
    Through:=By[At];
    If Through>M Div 2 Then Dec(Through,M Div 2);
    FinishTime:=L[At];
  End;
End;

Procedure Solve;
Var
  I,MinAt,Min:Integer;
Begin
  FillChar(Mark,SizeOf(Mark),False);
  For I:=1 To N Do L[I]:=Infinity;
  L[1]:=1;
  By[1]:=0;
  While Not Mark[N] Do Begin
    Min:=Infinity;
    MinAt:=0;
    For I:=1 To N Do If Not Mark[I] And (L[I]<Min) Then Begin
      Min:=L[I];
      MinAt:=I;
    End;
    Mark[MinAt]:=True;
    I:=First[MinAt];
    While I>0 Do With Edge[I] Do Begin
      If Not Mark[Dst] Then
        Relax(I);
      I:=Edge[I].Next;
    End;
  End;
  ResLen:=0;
  Otkat(N);
End;

Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  If L[N]<WolfTime Then Begin
    WriteLn('YES');
    WriteLn(ResLen);
    For I:=1 To ResLen Do With Res[I] Do Begin
      WriteLn(Through);//,' ',FinishTime/2:0:1);
    End;
  End Else WriteLn('NO');
  Close(Output);
End;

Begin
  Load;
  Solve;
  Save;
End.