{$apptype console}
{$o-,q+,r+}
// Problem : RED HAT
// Solved by Orshanskiy Sergey
const
  MAX_WAYS = 100000;
  MAX_N = 2000;
  MAX_PATH = 100000;
  inf = 1000000000; // 10^9
var
  // redhat pathes
  xhead : array [1..MAX_N] of integer; // edge lists
  // head of wolf segments on the same path
  wfhd : array [1..MAX_WAYS * 2] of integer;
  xend, t : array [1..MAX_WAYS * 2] of integer;
  xnext : array [1..MAX_WAYS * 2] of integer;
  flag : array [1..MAX_N] of boolean;
  dist, from : array [1..MAX_N] of integer;
  summ, i, j, n, m, k, cur, b, e, tt, free, mn, q : integer;
  // wolf's way. p-way, v-duration, st-starttime
  p, v, st : array [1..MAX_PATH] of integer;

  tmp, t2 : array of integer;
  // next time when wolf will choose that path
  next : array [1..MAX_PATH] of integer;

procedure update(x, frm, tt : integer); // from means path
begin
  if dist[x] > tt then
  begin
    dist[x] := tt;
    from[x] := frm;
  end;
end;

begin
  assign(input, 'redhat.in');
  reset(input);
  assign(output, 'redhat.out');
  rewrite(output);
  read(n, m, k);
  assert((n >= 2) and (n <= MAX_N));
  assert((m >= 1) and (m <= MAX_WAYS));
  assert((k >= 1) and (k <= MAX_PATH));

  free := 1;
  fillchar(xhead, sizeof(xhead), 0);
  for i := 1 to m do
  begin
    read(b, e, tt);
    assert((b <> e) and (tt > 0));
    xnext[free] := xhead[b];
    xhead[b] := free;
    xend[free] := e;
    t[free] := tt;
    inc(free);
    xnext[free] := xhead[e];
    xhead[e] := free;
    xend[free] := b;
    t[free] := tt;
    inc(free);
  end;
  for i := 1 to k do
    read(p[i], v[i]);

  fillchar(from, sizeof(from), 0);
  cur := 0;
  for i := 1 to k do
  begin
    st[i] := cur;
    cur := cur + v[i];
  end;

  summ := cur;

  SetLength(tmp, m+1);
  for i := 1 to m do tmp[i] := 0;
  for i := k downto 1 do
  begin
    next[i] := tmp[p[i]];
    tmp[p[i]] := i;
  end;
  tmp := nil;
  for i := 1 to 2 *  m do wfhd[i] := 0; // first wolf's appearing on that way
  for i := 1 to k do
    if wfhd[2 * p[i]] = 0 then
    begin
      wfhd[2 * p[i] - 1] := i;
      wfhd[2 * p[i]] := i;
    end;
  // Dijkstra
  dist[1] := 0;
  for i := 2 to n do dist[i] := inf;
  fillchar(flag, sizeof(flag), false);

  repeat
    mn := -1;
    for i := 1 to n do if (not flag[i]) and ((mn = -1) or (dist[i] < dist[mn])) then
      mn := i;
    if mn = -1 then break;
    flag[mn] := true;
    j := xhead[mn];
    while j <> 0 do
    begin
      q := wfhd[j];
      while (q <> 0) and (st[q] + v[q] <= dist[mn]) do
        q := next[q];
      if (q = 0) or (dist[mn] + t[j] < st[q]) then
      begin
        update(xend[j], j, dist[mn] + t[j]);
      end else
      begin
        while (next[q] <> 0) and (st[next[q]] - (st[q] + v[q])  <= t[j]) do
          q := next[q];
        update(xend[j], j, st[q] + v[q] + t[j]);
      end;
      j := xnext[j];
    end;
    if mn = n then break;
  until false;
  if dist[n] >= summ then writeln('NO') else
  begin
    writeln('YES');
    SetLength(tmp, n + 1);
    SetLength(t2, n + 1);
    cur := 1;
    i := n;
    while i <> 1 do
    begin
      tmp[cur] := (from[i]+1) div 2;
      t2[cur] := dist[i];
      if xend[2*tmp[cur]] = i then
        i := xend[2*tmp[cur]-1] else
        i := xend[2*tmp[cur]];
      inc(cur);
    end;
    dec(cur);
    writeln(cur);
    for i := cur downto 1 do writeln(tmp[i]);//, ' ',t2[i]+0.5:0:1);
//    writeln;
  end;
end.