{
  Dmitry Orlov
}

{$apptype console}

{$R-,I-,S-,Q-,O+}

program template;
const
 nmax = 850;
 k = 32768;
 cinfile = 'skier.in';
 coutfile = 'skier.out';
type
 int = longint;
 real = extended;
 tpoint = record
  x,y :int;
 end;
 tSegment = record
  x1,x2 :int;
  y :int;
  c :int;
 end;
 tEventType = (_no,_beg,_end);
 tEvent = record
  x,y :int;
  et :tEventType;
  penalty :int;
 end;
var
 n,m :int;
 addY :int;
 s :array [1..nmax] of tSegment;
{ event :array [1..2*nmax] of tEvent;}
 p :array [1..2*nmax] of tEvent;
 d :array [1..2*nmax] of real;
 sum :int;
 start,finish :tpoint;
 ans :real;
 ph :array [1..k] of int;

procedure init;
begin
 ans := 0;
 sum := 0;
 fillchar (s,sizeof(s),0);
{ fillchar (event,sizeof(event),0);}
 fillchar (p,sizeof(p),0);
 fillchar (d,sizeof(d),0);
 randseed := 6342312;
 fillchar (ph,sizeof(ph),0);
end;

procedure readdata;
var i,j :int;
begin
 addY :=
 10000;
 assign (input,cinfile);
 reset (input);
 read (n);
 read (start.x,start.y);
 read (finish.x,finish.y);
 if start.y < addY then
  addY := start.y;
 if finish.y < addY then
  addY := finish.y; 
 for i := 1 to n do
  begin
   read (s[i].x1,s[i].x2,s[i].y,s[i].c);
   if s[i].y < addY then
    addY := s[i].y;
   sum := sum + s[i].c;
  end; 
 close (input);
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans:0:13);
 close (output);
end;

procedure swapEvent (var a,b :tEvent);
var tmp :tEvent;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure swapReal (var a,b :real);
var tmp :real;
begin
 tmp := a;
 a := b;
 b := tmp;
end;

procedure sort (l,r :int);
var yy :int;
    i,j :int;
begin
 i := l;
 j := r;
 yy := p[l + random(r-l+1)].y;
 repeat
  while p[i].y > yy do
   inc(i);
  while p[j].y < yy do
   dec(j);
  if i <= j then
   begin
    swapEvent (p[i],p[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  sort (i,r);
 if l < j then
  sort (l,j);
end;

procedure sortByAngle (range :int;number :int);

function less (var a,b :tEvent):boolean;
var x1,y1,x2,y2 :int;
begin
 x1 := a.x - p[number].x;
 y1 := a.y - p[number].y;
 x2 := b.x - p[number].x;
 y2 := b.y - p[number].y;
 if x1*y2 - x2*y1 <> 0 then
  less := (x1*y2 - x2*y1 < 0)
 else
  less := a.et < b.et; 
end;

procedure qsort (l,r :int);
var i,j :int;
    x :tEvent;
begin
 i := l;
 j := r;
 x := p[l + random(r-l+1)];
 repeat
  while less (p[i],x) do
   inc(i);
  while less (x,p[j]) do
   dec(j);
  if i <= j then
   begin
    swapEvent (p[i],p[j]);
    swapReal (d[i],d[j]);
    inc(i);
    dec(j);
   end;
 until i > j;
 if i < r then
  qsort (i,r);
 if l < j then
  qsort (l,j);
end;

begin
 qsort (1,range);
end;

function h (x :int):int;
begin
 result := 0;
 while x and 1 = 0 do
  begin
   inc(result);
   x := x shr 1;
  end;
end;

procedure add (y :int; value :int);
begin
 while (y <= k) do
  begin
   inc(ph[y],value);
   y := y + 1 shl h(y);
  end;
end;

function cums (y :int):int;
var i,j :int;
begin
 result := 0;
 j := y;
 i := 0;
 while j > 0 do
  begin
   inc(result,ph[j]);
   j := j - (1 shl h(j));
   inc(i);
  end;
 end;



{
procedure add (x,value :int);
begin
 inc(ph[x],value);
end;

function cums (x :int):int;
begin
 result := 0;
 while x > 0 do
  begin
   inc(result,ph[x]);
   dec(x);
  end;
end;
}

function dist (var a,b :tEvent):real;
begin
 dist := sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
end;

procedure solve;
var i,j,b :int;
    min :real;
    t :real;
    l :int;
begin
 dec(addY);
 dec (start.y,addY);
 dec (finish.y,addY);
 for i := 1 to n do
  dec (s[i].y,addY);
 m := 2;
 p[1].x := start.x;
 p[1].y := start.y;
 p[1].et := _no;
 p[1].penalty := 0;
 p[2].x := finish.x;
 p[2].y := finish.y;
 p[2].et := _no;
 p[2].penalty := 0;
 for i := 1 to n do
  begin
   if (s[i].y >= start.y) or (s[i].y <= finish.y) then
    continue;
   inc(m);
   p[m].x := s[i].x1;
   p[m].y := s[i].y;
   p[m].et := _beg;
   p[m].penalty := s[i].c;
   inc(m);
   p[m].x := s[i].x2;
   p[m].y := s[i].y;
   p[m].et := _end;
   p[m].penalty := s[i].c;
  end;
 sort (1,m);
 d[1] := sum;
 for i := 2 to m do
  begin
   b := i-1;
   while (p[b].y = p[i].y) do
    dec(b);
   sortByAngle (b,i);
   min := 1e100;
   for j := 1 to b do
    begin
     if p[j].et = _beg then
      add (p[j].y,p[j].penalty);
     t := d[j] + dist(p[j],p[i]) - cums(p[j].y);
    if t < min then
      min := t;
     if p[j].et = _end then
      add (p[j].y,-p[j].penalty);
    end;
   d[i] := min; 
  end;
 ans := d[m];  
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.
