{$apptype console}
{$o-,q-,r-}



uses
  SysUtils, Math;

type
  point = record t: char; x, y, yy, n: integer; end;

const
  maxn = 1000;
  maxm = maxn*2+2;
  maxy = 10000;
  maxtr = maxn * 10;

var
  p: array[1..maxm] of point;
  v: array[1..maxtr] of integer;
  nm: array[1..maxm] of integer;
  an: array[1..maxm] of real;
  tr: integer;

procedure Add(vv, i: integer);
var
  l, r, j, m: integer;
begin
  while i <= tr do begin
    v[i] := v[i] + vv;
    i := i or (i + 1);
  end;
end;

function GetSum(l, r: integer): integer;
  function Get(i: integer): integer;
  var
    s: integer;
  begin
    s := 0;
    while i > 0 do begin
      s := s + v[i];
      i := (i and (i + 1)) - 1;
    end;
    Get := s;
  end;
begin
  GetSum := Get(r) - Get(l-1);
end;

procedure sort(l, r: integer);
var
  i, j, t: integer;
  xx, tt: real;
begin
  i := l;
  j := r;
  xx := an[l + random(r - l + 1)];
  while i <= j do begin
    while an[i] < xx do inc(i);
    while an[j] > xx do dec(j);
    if i <= j then begin
      t := nm[i];
      nm[i] := nm[j];
      nm[j] := t;
      tt := an[i];
      an[i] := an[j];
      an[j] := tt;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then sort(i, r);
  if l < j then sort(l, j);
end;

procedure sort2(l, r: integer);
var
  i, j, x: integer;
  t: point;
begin
  i := l;
  j := r;
  x := p[l + random(r-l+1)].y;
  while i <= j do begin
    while p[i].y < x do inc(i);
    while p[j].y > x do dec(j);
    if i <= j then begin
      t := p[i];
      p[i] := p[j];
      p[j] := t;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then sort2(i, r);
  if l < j then sort2(l, j);
end;


var
  pr: array[1..maxm] of integer;

procedure printpath(i: integer);
begin
  if i = 0 then exit;
  printpath(pr[i]);
  writeln(p[i].x,' ',p[i].y);
end;


var
  n, sx, sy, fx, fy: integer;
  a, b, y, c: array[1..maxn] of integer;
  i, j, m, k: integer;
  z: array[1..maxm] of boolean;
  d: array[1..maxm] of real;
  dist: real;

const
  inf = 1e100;


begin
  assign(input, 'skier.in');
  reset(input);
  assign(output, 'skier.out');
  rewrite(output);

  read(n, sx, sy, fx, fy);

  for i := 1 to n do read(a[i], b[i], y[i], c[i]);

  m := 2;
  p[1].t := 's';
  p[1].x := sx;
  p[1].y := sy;
  p[2].t := 'f';
  p[2].x := fx;
  p[2].y := fy;

  for i := 1 to n do begin
    inc(m);
    p[m].x := a[i];
    p[m].y := y[i];
    p[m].t := 'l';
    p[m].n := i;
    inc(m);
    p[m].x := b[i];
    p[m].y := y[i];
    p[m].t := 'r';
    p[m].n := i;
  end;

  sort2(1, m);

  p[1].yy := 1;

  for i := 2 to m do
    if p[i].y > p[i-1].y then
      p[i].yy := p[i-1].yy + 1
    else
      p[i].yy := p[i-1].yy;

  tr := p[m].yy;

  for i := 1 to m do z[i] := false;
  for i := 1 to m do d[i] := inf;
  for i := 1 to m do if p[i].t = 's' then d[i] := 0;

  while true do begin
    j := -1;
    for i := 1 to m do if not z[i] then begin
      if (j = -1) or (d[i] < d[j]) then j := i;
    end;
    if j = -1 then break;
    z[j] := true;

    k := 0;
    for i := 1 to m do if p[i].y < p[j].y then begin
      inc(k);
      nm[k] := i;
    end;

    for i := 1 to k do an[i] := arctan2(p[nm[i]].y - p[j].y, p[nm[i]].x - p[j].x);
    if k > 1 then sort(1, k);

    for i := 1 to k do if p[nm[i]].t = 'l' then Add(c[p[nm[i]].n], p[nm[i]].yy);

    for i := 1 to k do begin
      if p[nm[i]].t = 'l' then Add(-c[p[nm[i]].n], p[nm[i]].yy);

      dist := hypot(p[nm[i]].x - p[j].x, p[nm[i]].y - p[j].y) + GetSum(p[nm[i]].yy, p[j].yy - 1);

      if d[nm[i]] > d[j] + dist then begin
        d[nm[i]] := d[j] + dist;
        pr[nm[i]] := j;
      end;

      if p[nm[i]].t = 'r' then Add(c[p[nm[i]].n], p[nm[i]].yy);
    end;

    for i := 1 to k do if p[nm[i]].t = 'l' then Add(-c[p[nm[i]].n], p[nm[i]].yy);
  end;

  for i := 1 to m do if p[i].t = 'f' then j := i;

  writeln(d[j]:0:4);
//  printpath(j);

  close(input);
  close(output);
end.