{$o-,q+,r+}
uses
  sysutils, math;

var
  n, m, src, tar, ss, i, j: integer;
  nh: integer;
  c, tt, p: array[1..30000] of integer;
  d: array[1..30000] of int64;

const
  ARR = 1;
  CHG = 0;
  RED = 0;
  GRN = 1;

type
  TEvent = record key, time: int64; evtype, vert: integer; end;

var
  heap: array[1..60000] of TEvent;
  p_heap: array[1..30000] of integer; //place in heap for arrivial events
  head: array[1..30000] of integer;
  next, dest, tm: array[1..400000] of integer;
  last: integer;

procedure AddEdge(a, b, t: integer);
begin
  inc(last);
  dest[last] := b;
  tm[last] := t;
  next[last] := head[a];
  head[a] := last;
end;

procedure Swap(a, b: integer);
var
  t: TEvent;
begin
  t := heap[a];
  heap[a] := heap[b];
  heap[b] := t;
  if heap[a].evtype = ARR then p_heap[heap[a].vert] := a;
  if heap[b].evtype = ARR then p_heap[heap[b].vert] := b;
end;

procedure SiftDown(i: integer);
var
  j, jj: integer;
begin
  j := i;
  while j shl 1 <= nh do begin
    if heap[j shl 1].key < heap[j].key then jj := j shl 1 else jj := j;
    if (j shl 1 + 1 <= nh) and (heap[j shl 1 + 1].key < heap[jj].key) then jj := j shl 1 + 1;
    if jj = j then exit;
    Swap(j, jj);
    j := jj;
  end;
end;

procedure SiftUp(i: integer);
var
  j, jj: integer;
begin
  j := i;
  while j > 1 do begin
    jj := j shr 1;
    if heap[jj].key <= heap[j].key then exit;
    Swap(j, jj);
    j := jj;
  end;
end;

procedure AddEvent(time: int64; evtype, vert: integer);
begin
  inc(nh);
  heap[nh].time := time;
  heap[nh].evtype := evtype;
  heap[nh].vert := vert;
  heap[nh].key := time * 2 + evtype; // Changes first
  if evtype = ARR then p_heap[vert] := nh;
  SiftUp(nh);
end;

function DeleteMin: TEvent;
begin
  assert(nh > 0);
  result := heap[1];
  swap(1, nh);
  dec(nh);
  SiftDown(1);
end;

const
  inf = int64(1) shl 60;
  maxcount = 131072;

var
  aaa, bbb, ttt: integer;
  ctm, count: integer;
  t: TEvent;
  ds: integer;

begin
  assign(input, 'traffic.in');
  reset(input);
  assign(output, 'traffic.out');
  rewrite(output);

  read(n, m, src, tar);

  assert(seekeoln);
  assert((n >= 2) and (n <= 30000) and (m >= 0) and (m <= 200000) and
         (src <> tar) and (src >= 1) and (src <= n) and (tar >= 1) and (tar <= n));

  for i := 1 to n do begin
    read(c[i], tt[i], p[i]);
    assert((c[i] = 0) or (c[i] = 1));
    assert((tt[i] >= 1) and (tt[i] <= 1000000000));
    assert((p[i] >= 1) and (p[i] <= 1000000000));
  end;

  for i := 1 to m do begin
    read(aaa, bbb, ttt);
    assert((aaa >= 1) and (aaa <= n) and (bbb >= 1) and (bbb <= n) and (ttt >= 1) and (ttt <= 1000000));
    AddEdge(aaa, bbb, ttt);
    AddEdge(bbb, aaa, ttt);
  end;


  ss := 0;
  for i := 1 to n do ss := ss + tt[i];
  ctm := 0;

  for i := 1 to n do d[i] := inf;
  d[src] := 0;

  nh := 0;
  for i := 1 to n do AddEvent(d[i], ARR, i);
  for i := 1 to n do AddEvent(tt[i], CHG, i);

  count := 0;
  while count <= maxcount do begin
    if heap[1].evtype = ARR then begin
      t := DeleteMin;
//writeln(t.time,': Arrive to ',t.vert);
      if t.vert = tar then begin
        writeln(d[tar]);
        exit;
      end;
      if c[t.vert] = 0 then begin
        t.time := tt[t.vert];
        AddEvent(t.time, t.evtype, t.vert);
        continue;
      end;
      i := head[t.vert];
      while i <> 0 do begin
        if d[dest[i]] > t.time + tm[i] then begin
          d[dest[i]] := t.time + tm[i];
          j := p_heap[dest[i]];
          heap[j].time := d[dest[i]];
          heap[j].key := heap[j].time * 2 + heap[j].evtype;
          SiftUp(p_heap[dest[i]]);
        end;
        i := next[i];
      end;
    end else begin
      t := heap[1];
      ss := ss - (t.time - ctm) * n;
      assert(ss >= 0);
      if ss = 0 then break;
      ctm := t.time;
      ds := 0;
      while heap[1].key = t.key do begin
        inc(count);
        t := DeleteMin;
//write(t.time,': Change ',t.vert,' to ');
        assert(t.evtype = CHG);
        tt[t.vert] := ctm + (ss - 1) mod p[t.vert] + 1;
        ds := ds + (ss - 1) mod p[t.vert] + 1;
        t.time := tt[t.vert];
        c[t.vert] := 1 - c[t.vert];
//writeln(c[t.vert], ' next change at ',t.time,' count = ',count);
        AddEvent(t.time, t.evtype, t.vert);
      end;
      ss := ss + ds;
    end;
  end;
  if d[tar] < inf then writeln(d[tar]) else writeln(-1);
end.
