{
          

    :      
    :       
    :     
}

{$APPTYPE CONSOLE}

uses
    Math;

const
    inFile = 'ancient.in';
    outFile = 'ancient.out';

    maxN = 100000;
    maxC = 1000000000;
    infinity = maxlongint;

type
    TSegment = array[0..1] of integer;
    TPerm = array[1..maxN] of integer;

    TNode = record
        i : integer;
        left, right : integer;
        median : integer;
    end;

    TTree = array[1..maxN] of TNode;

var
    n : integer;
    s : array[1..maxN] of TSegment;
    t : TTree;

    minLen : integer;
    answer1, answer2 : integer;

procedure Swap(var a, b : integer);
var
    c : integer;

begin
    c := a;
    a := b;
    b := c;
end;

procedure QSort(var p : TPerm; coord : integer);
var
    i : integer;
    
    procedure Sort(left, right : integer);
    var
        i, j : integer;
        x : integer;

    begin
        i := left;
        j := right;
        x := s[p[left + random(right - left)],coord];
        repeat
            while s[p[i],coord] < x do
                inc(i);
            while x < s[p[j],coord] do
                dec(j);
            if i <= j then begin
                Swap(p[i], p[j]);
                inc(i);
                dec(j);
            end;
        until i >= j;;
        if left < j then
            Sort(left, j);
        if i < right then
            Sort(i, right);
    end;

begin
    for i := 1 to n do
        p[i] := i;
    Sort(1, n);
end;

procedure BuildPrioritySearchTree(var t : TTree; coord : integer; min : boolean);
var
    m : integer;
    p : TPerm;

    function Build(left, right : integer) : integer;
    var
        i, j : integer;

    begin
        j := 0;
        for i := left to right do
            if (j = 0) or (min xor (s[p[i],coord] < s[p[j],coord])) then
                j := i;

        inc(m);
        result := m;

        t[m].i := p[j];
        t[m].left := 0;
        t[m].right := 0;

        for i := j - 1 downto left do
            p[i+1] := p[i];
        inc(left);

        if left <= right then begin
            i := (left + right) div 2;
            t[result].median := s[p[i],1 - coord];
            t[result].left := Build(left, i);
            if i < right then
                t[result].right := Build(i + 1, right);
        end;
    end;

begin
    m := 0;
    QSort(p, 1 - coord);
    Build(1, n);
end;

procedure Solve;

    procedure Update(i, j : integer);
    var
        left, right : integer;

    begin
        if i <> j then begin
            left := max(s[i,0], s[j,0]);
            right := min(s[i,1], s[j,1]);
            if (left < right) and (right - left < minLen) then begin
                answer1 := i;
                answer2 := j;
                minLen := right - left;
            end;
        end;
    end;

    procedure SolveCase(coord : integer);
    var
        i, cur : integer;

    begin
        for i := 1 to n do begin
            cur := 1;
            while cur <> 0 do begin
                Update(i, t[cur].i);
                if s[i,coord] <= t[cur].median then
                    cur := t[cur].left
                else
                    cur := t[cur].right;
            end;
        end;
    end;

begin
    minLen := infinity;
    answer1 := 0;

    BuildPrioritySearchTree(t, 0, false);
    SolveCase(0);

    BuildPrioritySearchTree(t, 1, true);
    SolveCase(1);
end;

procedure ReadData;
var
    i : integer;

begin
    assign(input, inFile);
    reset(input);

    read(n);
    if (n < 1) or (n > maxN) then
        RunError(239);

    for i := 1 to n do begin
        read(s[i,0], s[i,1]);
        if (abs(s[i,0]) > maxC) or (abs(s[i,1]) > maxC) or (s[i,0] >= s[i,1]) then
            RunError(239);
    end;

    close(input);
end;

procedure WriteData;
begin
    assign(output, outFile);
    rewrite(output);
    if answer1 = 0 then
        writeln(0)
    else
        writeln(answer1, ' ', answer2);
    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
