{
          

    :     
    :       
    :     
}

{$APPTYPE CONSOLE}

const
    inFile = 'fraction.in';
    outFile = 'fraction.out';

    maxN = 200;
    maxL = 100;
    maxP = 10000;

type
    THuge = array[1..maxL] of shortint;

var
    n : integer;
    p : array[1..maxN] of integer;

    answer1, answer2 : THuge;


procedure HInit(var h : THuge; value : integer);
begin
    fillchar(h, sizeof(h), 0);
    h[1] := value;
end;

procedure HMul(var h : THuge; m : integer);
var
    i : integer;
    x, carry : integer;
    
begin
    carry := 0;
    for i := 1 to maxL do begin
        x := carry + h[i] * m;
        h[i] := x mod 10;
        carry := x div 10;
    end;
    if carry <> 0 then
        RunError(239);
end;

procedure HPrint(const h : THuge);
var
    i, j : integer;

begin
    i := maxL;
    while (i >= 1) and (h[i] = 0) do
        dec(i);
    if i > 0 then
        for j := i downto 1 do
            write(h[j])
    else
        write(0);
    writeln;
end;

procedure Solve;
var
    i, j : integer;
    tmp : integer;
    flag : boolean;

begin
    HInit(answer1, 1);
    HInit(answer2, 1);

    if n =  1 then
        exit;

    for i := 3 to n do
        for j := i + 1 to n do
            if p[i] > p[j] then begin
                tmp := p[i];
                p[i] := p[j];
                p[j] := tmp;
            end;

    flag := false;
    i := 3;
    while i <= n do begin
        j := i;
        while (j <= n) and (p[j] = p[i]) do
            inc(j);

        HMul(answer1, j - i + 1);

        if (p[1] <> p[2]) and (p[i] = p[1]) then
            HMul(answer2, (j - i + 1) div 2)
        else if (p[1] <> p[2]) and (p[i] = p[2]) then begin
            HMul(answer2, (j - i - 1) div 2 + 1);
            flag := true;
        end else
            HMul(answer2, (j - i) div 2 + 1);

        i := j;
    end;

    if (p[1] <> p[2]) and not flag then
        HInit(answer2, 0);
end;

procedure ReadData;
var
    i, j : integer;

begin
    assign(input, inFile);
    reset(input);

    read(n);
    if (n < 1) or (n > maxN) then
        RunError(239);

    for i := 1 to n do begin
        read(p[i]);
        if (p[i] < 2) or (p[i] > maxP) then
            RunError(239);
        for j := 2 to p[i] do begin
            if j * j > p[i] then
                break;
            if p[i] mod j = 0 then
                RunError(239);
        end;
    end;

    close(input);
end;

procedure WriteData;
begin
    assign(output, outFile);
    rewrite(output);
    HPrint(answer1);
    HPrint(answer2);
    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
