{
          

    :     
    :      ,  
    :     
}

{$APPTYPE CONSOLE}
{$O-,Q+,R+}
{$DEFINE ALLOWMULTITEST}

program light;

uses
    math, sysutils;

const
    maxn = 100;
    maxc = 1000;
    minv = 0.01;
    maxv = 10000;
    mind = 1e-2;

    eps = 1e-8;
    infty = 1e100;

var
    n: longint;
    px, py: extended;
    x, y: array [0..maxn + 1] of extended;
    v: extended;
    u: array [0..maxn] of boolean;
    ans: array [0..maxn] of extended;

{ ,   y   x  z }
function between(x, y, z: extended): boolean;
begin
    between := 
        ((x - eps < y) and (y < z + eps)) or
        ((z - eps < y) and (y < x + eps));
end;

{    ,       ang }
procedure project(x0, y0: extended; ang: extended; var xp, yp: extended);
var
    c: extended;
begin
    c := x0 * cos(ang) + y0 * sin(ang);
    xp := c * cos(ang);
    yp := c * sin(ang);
end;

function angle(x1, y1, x2, y2: extended): extended;
begin
    angle := arctan2(x1 * y2 - x2 * y1, x1 * x2 + y1 * y2);
end;

{ 
    ,   ,    , 
          ang
}
function walk(xp, yp: extended; p: longint; ang: extended): extended;
var
    d1, d2: extended;
    x0, y0: extended;
    mina, maxa: extended;
    mini, maxi: longint;
    i: longint;
    an: array [1..maxn] of extended;
begin
    if u[p] then begin
        walk := ans[p];
        exit;
    end;
    u[p] := true;
    ans[p] := infty;

    if abs(xp * sin(ang) - yp * cos(ang)) < eps then
    begin
        ans[p] := 0;
        walk := ans[p];
        exit;
    end;

    project(xp, yp, ang, x0, y0);

    mina := infty;
    maxa := -infty;
    mini := 0;
    maxi := 0;
    for i := 1 to n do
    begin   
        if hypot(x[i] - xp, y[i] - yp) > eps then
        begin
            an[i] := angle(x[i] - xp, y[i] - yp, x0 - xp, y0 - yp);
            if mina > an[i] then begin
                mina := an[i];
                mini := i;
            end;
            if maxa < an[i] then begin
                maxa := an[i];
                maxi := i;
            end;
        end;
    end;

    assert(mini <> 0);
    assert(maxi <> 0);

    if (maxa < eps) or (mina > -eps) or (maxa - mina > pi - eps) then
    begin
        ans[p] := hypot(x0 - xp, y0 - yp);
    end else begin
        d1 := hypot(x[maxi] - xp, y[maxi] - yp) + walk(x[maxi], y[maxi], maxi, ang);
        d2 := hypot(x[mini] - xp, y[mini] - yp) + walk(x[mini], y[mini], mini, ang);
        ans[p] := min(d1, d2);
    end;
    walk := ans[p];
end;

var
    mina, maxa, minpa, maxpa: extended;
    alpha: extended;
    i: longint;
    dmin, dmax, answer: extended;

begin
    assign(input, 'light.in');
    reset(input);
    assign(output, 'light.out');
    rewrite(output);


    read(px, py, v);
    read(n);

    for i := 1 to n do
        read(x[i], y[i]);
    mina := infty;
    maxa := -infty;
    minpa := infty;
    maxpa := -infty;

    for i := 1 to n do
    begin
        alpha := arctan2(y[i], x[i]);
        if alpha < mina then mina := alpha;
        if alpha > maxa then maxa := alpha;

        alpha := angle(x[i] - px, y[i] - py, 0 - px, 0 - py);
        if alpha < minpa then minpa := alpha;
        if alpha > maxpa then maxpa := alpha;
    end;

    if (maxpa < eps) or (minpa > -eps) or (maxpa - minpa > pi - eps) then
    begin
        answer := 0;
    end else begin
        fillchar(u, sizeof(u), 0);
        dmin := walk(px, py, 0, mina);
        fillchar(u, sizeof(u), 0);
        dmax := walk(px, py, 0, maxa);
        answer := min(dmin, dmax);
    end;

    writeln(answer / v :0 :20);

    close(input);
    close(output);
end.