{
          

    :     
    :       ,  
    :     
}

{Max: No testchecks implemented!}

{.$define DEBUG}
{$APPTYPE CONSOLE}

uses
    Math;
    
const
    inFile = 'light.in';
    outFile = 'light.out';

    maxN = 1000;
    eps = 1e-10;
    infinity = 1e100;

type
    float = extended;

var
    answer : float;
    n : integer;
    v : float;
    x, y : array[0..maxN+1] of float;
    x0, y0 : float;

    minI0, maxI0 : integer;
    minI1, maxI1 : integer;

function det(a, b, c, d : float) : float;
begin
    det := a * d - b * c;
end;

function Intersect(x1, y1, x2, y2, x3, y3, x4, y4 : float) : boolean;
var
    _x1, _y1, _x2, _y2, _x3, _y3, _x4, _y4 : float;

begin
    _x1 := min(x1, x2);
    _y1 := min(y1, y2);
    _x2 := max(x1, x2);
    _y2 := max(y1, y2);
    _x3 := min(x3, x4);
    _y3 := min(y3, y4);
    _x4 := max(x3, x4);
    _y4 := max(y3, y4);

    Intersect := false;

    if (max(_x1, _x3) > min(_x2, _x4) + eps) or
       (max(_y1, _y3) > min(_y2, _y4) + eps) then
        exit;

    Intersect :=
       (det(x3 - x1, y3 - y1, x2 - x1, y2 - y1) * det(x4 - x1, y4 - y1, x2 - x1, y2 - y1) < -eps) and
       (det(x1 - x3, y1 - y3, x4 - x3, y4 - y3) * det(x2 - x3, y2 - y3, x4 - x3, y4 - y3) < -eps);
end;

procedure GetProjection(i : integer; x1, y1 : float; var x2, y2 : float);
var
    n, nx, ny, p : float;

begin
    n := sqrt(sqr(x[i]) + sqr(y[i]));
    nx := x[i] / n;
    ny := y[i] / n;
    p := x1 * nx + y1 * ny;
    x2 := nx * p;
    y2 := ny * p;
end;

procedure GetBase(x0, y0 : float; var minI, maxI : integer);
var
    i : integer;

begin
    minI := 1;
    maxI := 1;
    for i := 1 to n do begin
        if det(x[i] - x0, y[i] - y0, x[minI] - x0, y[minI] - y0) > 0 then
            minI := i;
        if det(x[i] - x0, y[i] - y0, x[maxI] - x0, y[maxI] - y0) < 0 then
            maxI := i;
    end;
end;

function IsGood(x0, y0 : float) : float;
var
    x1, y1 : float;
    x2, y2 : float;

    function TryThis(x1, y1 : float) : float;
    var
        i : integer;

    begin
        result := infinity;
        for i := 1 to n do
            if Intersect(x0, y0, x1, y1, x[i], y[i], x[i+1], y[i+1]) then
                exit;
        result := sqrt(sqr(x0 - x1) + sqr(y0 - y1));
    end;

begin
    GetProjection(minI0, x0, y0, x1, y1);
    GetProjection(maxI0, x0, y0, x2, y2);
    result := min(TryThis(x1, y1), TryThis(x2, y2));
end;

function IsInSight(x0, y0 : float) : boolean;
var
    i : integer;
    a, b : integer;

begin
    IsInSight := false;
    for i := 1 to n do
        if Intersect(0, 0, x0, y0, x[i], y[i], x[i+1], y[i+1]) then
            exit;

    a := 0;
    b := 0;
    for i := 1 to n do
        if (abs(det(x[i], y[i], x0, y0)) < eps) and
           (sqr(x[i]) + sqr(y[i]) < sqr(x0) + sqr(y0) + eps) then begin
            if a = 0 then
                a := i
            else if b = 0 then
                b := i
            else
                RunError(239);
        end;

    IsInSight := (a = 0) or (b = a + 1) or ((a = 1) and (b = n));
end;

procedure Solve;

    function TryThis(s, d, e : integer) : float;
    var
        i : integer;
        cur, r : float;

    begin
{$ifdef DEBUG}
        writeln('Trying from vertex ', s, ' to vertex ', e, ', direction is ', d);
{$endif}
        result := infinity;
        cur := sqrt(sqr(x0 - x[s]) + sqr(y0 - y[s]));
        i := s;
        repeat
            r := IsGood(x[i], y[i]);
{$ifdef DEBUG}
            if r < infinity then
                writeln('Vertex ', i, ' is found to be good, total length is ', cur + r:0:4);
{$endif}
            if result > cur + r then
                result := cur + r;
            cur := cur + sqrt(sqr(x[i] - x[i+d]) + sqr(y[i] - y[i+d]));
            if i = e then
                break;
            inc(i, d);
            if i < 0 then
                i := n;
            if i > n then
                i := 1;
        until false;
    end;

begin
    GetBase(0, 0, minI0, maxI0);
    GetBase(x0, y0, minI1, maxI1);

    if not IsInSight(x0, y0) then begin
       answer := IsGood(x0, y0);
{$ifdef DEBUG}
       if answer < infinity then
            writeln('Have direct projection of length ', answer:0:4);
{$endif}
       answer := min(answer, min(TryThis(minI1, +1, maxI0), TryThis(maxI1, -1, minI0)))   ;
    end else begin
        answer := 0.0;
{$ifdef DEBUG}
        writeln('Light is in sight');
{$endif}
    end;
end;

procedure ReadData;
var
    i : integer;

begin
    assign(input, inFile);
    reset(input);

    read(x0, y0, v);
    read(n);
    for i := 1 to n do
        read(x[i], y[i]);

    x[0] := x[n];
    y[0] := y[n];

    x[n+1] := x[1];
    y[n+1] := y[1];

    close(input);
end;

procedure WriteData;
begin
    assign(output, outFile);
    rewrite(output);
    writeln(answer / v:0:10);
    close(output);
end;

begin
    ReadData;
    Solve;
    WriteData;
end.
