{
          

    :      
    :       
    :     
}

program table;

uses
    sysutils;

const
    minallowedint = -32768;
    maxallowedint = 32767;

    maxt = 32767;

    maxfilesize = 32767;

var
    ch: char;

function nextval: string;
var
    r: string;
begin
    r := '';
    while not (ch in [',', ';', '.']) do
    begin
        if (ch < #32) or (ch > #126) then
            runerror(239);
        if ch = '\' then
        begin
            if eof then runerror(239);
            read(ch);
            if not (ch in [',', ';', '.', '\']) then
                runerror(239);
        end;
        r := r + ch;
        if eof then runerror(239);
        read(ch);
    end;
    nextval := r;
end;

function nextt: char;
begin
    if not (ch in [',', ';', '.']) then
        runerror(239);
    nextt := ch;

    if eof and (ch <> '.') then
        runerror(239);

    if not eof then
    begin
        read(ch);
        if ch = #13 then
        begin
            if eof then runerror(239);
            read(ch);
            if ch <> #10 then runerror(239);
            if not eof then
                read(ch);
        end;
    end;
end;

function isvalidn(s: string): boolean;
var
    t, i: longint;
begin
    isvalidn := false;
    if length(s) > 6 then exit;
    if length(s) = 0 then runerror(240);

    if not (s[1] in ['-', '0'..'9']) then 
        exit;

    if s = '-' then
        exit;

    if ((s[1] = '0') and (s <> '0')) or ((s[1] = '-') and (s[2] = '0')) then
        exit;

    for i := 2 to length(s) do
        if not (s[i] in ['0'..'9']) then
            exit;

    t := strtoint(s);
    if (t < minallowedint) or (t > maxallowedint) then
        exit;

    isvalidn := true;
end;

var
    r, c: longint;
    cols: array [1..maxt] of longint;
    maxc: longint;
    t: char;
    i, j: longint;
    num, empty: array [1..maxt] of boolean;
    s: string;
    f: file;

begin
    assign(f, 'table.in');
    reset(f, 1);
    if filesize(f) > maxfilesize then runerror(239);
    close(f);

    assign(input, 'table.in');
    reset(input);

    assign(output, 'table.out');
    rewrite(output);

    for j := 1 to maxt do
    begin
        num[j] := true;
        empty[j] := true;
    end;

    r := 1;
    c := 1;
    read(ch);
    while true do
    begin
        s := nextval;
        cols[r] := c;
        if s <> '' then
        begin
            empty[c] := false;
            if not isvalidn(s) then
                num[c] := false;
        end;

        t := nextt;
        if t = ',' then
            inc(c)
        else if t = ';' then begin
            inc(r);
            c := 1;
        end else if t = '.' then begin
            break;
        end else begin
            runerror(239);
        end;
    end;

    if not eof then runerror(239);

    maxc := 0;
    for i := 1 to r do
        if cols[i] > maxc then
            maxc := cols[i];

    while (maxc > 0) and (empty[maxc]) do
        dec(maxc);

    for j := 1 to maxc do
    begin
        if empty[j] then
            write('EMPTY')
        else if num[j] then
            write('NUMBER')
        else 
            write('STRING');

        if j < maxc then
            write(',');
    end;
    writeln('.');

    close(input);
    close(output);
end.