{
          

    :      
    :       
    :     
}

{$APPTYPE CONSOLE}
uses
    SysUtils;

const
    inFile = 'table.in';
    outFile = 'table.out';

    maxL = 32767;
    maxC = maxL;

    digits = ['0'..'9'];
    loN = -32768;
    hiN = 32767;

type
    TType = (_empty, _number, _string);

var
    len : integer = 0;
    nCols : integer;
    answer : array[1..maxC] of TType;
    lookahead : char = #0;

function GetChar : char;
begin
    if lookahead = #0 then begin
        if EOF then
            RunError(239);
        read(result);
        inc(len);
        if len > maxL then
            RunError(239);
    end else begin
        result := lookahead;
        lookahead := #0;
    end;
end;

procedure UngetChar(ch : char);
begin
    if lookahead <> #0 then
        RunError(241);
    lookahead := ch;
end;

procedure SetCellType(col : integer; t : TType);
begin
    if nCols < col then
        nCols := col;
    if answer[col] < t then
        answer[col] := t;
end;

function IsValidNumber(s : string) : boolean;
var
    i, j : integer;

begin
    IsValidNumber := false;
    i := 1;
    if (i > length(s)) or ((s[i] <> '-') and not (s[i] in digits)) then
        exit;
    if s[i] = '-' then
        inc(i);
    if i > length(s) then
        exit;
    if (s[i] = '0') and (i + 1 <= length(s)) then
        exit;
    if (s[i] = '0') and (i > 1) then
        exit;
    for j := i to length(s) do
        if not (s[j] in digits) then
            exit;
    IsValidNumber := true;
end;

procedure ReadData;
var
    i, col : integer;
    v : integer;
    ch, ach : char;
    token : string;

begin
    assign(input, inFile);
    reset(input);

    nCols := 0;
    for i := 1 to maxC do
        answer[i] := _empty;

    col := 1;
    repeat
        token := '';
        repeat
            ch := GetChar;
            case ch of
                ',', ';', '.' :
                    break;

                '\' : begin
                  ch := GetChar;
                  if not (ch in [',',';','.','\']) then
                      RunError(239);
                end;
            end;

            if (ch < #26) or (ch > #126) then
                RunError(239);

            if answer[col] < _string then begin
                token := token + ch;
                if (length(token) > 6) or
                   (not (ch in digits) and (ch <> '-')) or
                   ((ch = '-') and (length(token) > 1)) then
                    SetCellType(col, _string);
            end;
        until false;

        if length(token) > 0 then begin
            if IsValidNumber(token) then
                v := strtoint(token)
            else
                v := hiN + 1;
            if (v >= loN) and (v <= hiN) then
                SetCellType(col, _number)
            else
                SetCellType(col, _string);
        end else
            SetCellType(col, _empty);

        if not EOF then begin
            ach := GetChar;
            if ach = #13 then begin
                if GetChar <> #10 then
                    RunError(239);
            end else
                UngetChar(ach);
        end;

        case ch of
            '.' : break;
            ',' : inc(col);
            ';' : col := 1;
        end;
    until false;

    if not EOF then
        RunError(239);

    while (nCols > 0) and (answer[nCols] = _empty) do
        dec(nCols);

    close(input);
end;

procedure WriteData;
var
    i : integer;

begin
    assign(output, outFile);
    rewrite(output);
    for i := 1 to nCols do begin
        case answer[i] of
            _empty :    write('EMPTY');
            _number :   write('NUMBER');
            _string :   write('STRING');
        end;
        if i < nCols then
            write(',');
    end;
    writeln('.');
    close(output);
end;

begin
    ReadData;
    WriteData;
end.
