#include <assert.h>
#include <stdio.h>

enum
{
  maxlen = 10000,
  maxs = maxlen + 1,
  nil = -1,
  maxc = 1 << 7
};

int next[maxs][maxc];
int term[maxs];
int par[maxs], par_c[maxs];
int q[maxs];
int s[maxlen];
int a[maxlen + 1], b[maxlen + 1];
int p;
int xcur;

int dfs( int i )
{
  if (i == p)
    return 1;
  else
  {
    int cur = 0;
    int j = i;

    while (1)
    {
      if (cur == nil)
        return 0;
      if (term[cur] && cur != xcur)
      {
        if (!a[j])
        {
          a[j] = 1;
          b[j] = dfs(j);
        }
        if (b[j])
          return 1;
      }
      if (j == p)
        return 0;
      cur = next[cur][s[j]];
      j++;
    }
  }
}

void xdfs( int i )
{
  int c;
  
  if (term[i])
  {
    int j;

    for (j = 0; j < p; j++)
      putchar(s[j]);
    putchar('\n');
  }
  for (c = 0; c < maxc; c++)
    if (next[i][c] != nil)
    {
      s[p] = c;
      p++;
      xdfs(next[i][c]);
      p--;
    }
}

int main( void )
{
  int c;
  int f, r;
  int avail;

  freopen("concat.in", "r", stdin);
  freopen("concat.out", "w", stdout);
  
  for (c = 0; c < maxc; c++)
    next[0][c] = nil;
  term[0] = 0;
  avail = 1;
  while (1)
  {
    int c = getchar();
    int cur;

    if (c == EOF)
      break;
    cur = 0;
    while (c != '\n')
    {
      if (next[cur][c] == nil)
      {
        int d;
        
        next[cur][c] = avail;
        for (d = 0; d < maxc; d++)
          next[avail][d] = nil;
        term[avail] = 0;
        par[avail] = cur;
        par_c[avail] = c;
        avail++;
      }
      cur = next[cur][c];
      c = getchar();
    }
    term[cur] = 1;
  }
  q[0] = 0;
  f = 0;
  r = 1;
  while (f < r)
  {
    int cur = q[f];

    f++;
    for (c = 0; c < maxc; c++)
      if (next[cur][c] != nil)
      {
        q[r] = next[cur][c];
        r++;
      }
      
    if (term[cur])
    {
      int cn = cur;
      int i;

      p = 0;

      while (cn != 0)
      {
        s[p++] = par_c[cn];
        cn = par[cn];
      }
      for (i = 0; i < p / 2; i++)
      {
        int t = s[i];

        s[i] = s[p - 1 - i];
        s[p - 1 - i] = t;
      }
      for (i = 0; i <= p; i++)
        a[i] = 0;
      xcur = cur;
      if (dfs(0))
        term[cur] = 0;
    }
  }
  p = 0;
  xdfs(0);
  return 0;
}
