{$Q+,R+,O-}
program macro;
const MaxN=500;  MaxX=2000;  MaxE=MaxN*8;  MaxP=MaxN*2;  _NO=-17;
type Point=record x, f, dx : integer end;
     Event=record x, y, f, dx, dx1 : integer end;
     PEvent=^Event; PPoint=^Point;
var
  E    : array [1..MaxE] of PEvent;
  P    : array [1..MaxP] of PPoint;
  TotE, PN : integer;

procedure newevt (_x, _y, _f, _dx, _dx1 : integer);
begin
  inc(TotE);  if TotE > MaxE then runerror (239);
  new(E[TotE]);  with E[TotE]^ do begin 
    x:=_x; y:=_y; f:=_f; dx:=_dx; dx1:=_dx1 end;
end;

function cmpevt (P, Q : PEvent) : integer;
begin
  if P.y < Q.y then result := -1 else
  if P.y > Q.y then result := 1 else
  if (P.dx = _NO) and (Q.dx > _NO) then result := -1 else
  if (Q.dx = _NO) and (P.dx > _NO) then result := 1 else
  if (P.dx1 <> _NO) and (Q.dx1 = _NO) then result := -1 else
  if (Q.dx1 <> _NO) and (P.dx1 = _NO) then result := 1 else
  if P.x < Q.x then result := -1 else
  if P.x > Q.x then result := 1 else
  if P.f > Q.f then result := -1 else
  if P.f < Q.f then result := 1 else
  if P.dx < Q.dx then result := -1 else
  if P.dx > Q.dx then result := 1 else
  if P.dx1 < Q.dx1 then result := -1 else
  if P.dx1 > Q.dx1 then result := 1 else result := 0
end;

procedure qsort (a, b : integer);
var h, t : PEvent;  i, j : integer;
begin
  if a >= b then exit;
  h := E[(a + b) shr 1];
  i := a;  j := b;
  repeat
    while cmpevt (E[i], h) < 0 do inc (i);
    while cmpevt (E[j], h) > 0 do dec (j);
    if i <= j then begin t:=E[i]; E[i]:=E[j]; E[j]:=t; inc(i); dec(j) end
  until i > j;
  qsort (a, j);
  qsort (i, b)
end;

procedure do_create (a, b : integer);
var i, s : integer;  T : PPoint;
begin
  s := b - a;  dec (b);  i := PN;  inc (PN, s);
  while s > 0 do
    if (i = 0) or (P[i].x < E[b].x) or
      ((P[i].x = E[b].x) and (P[i].f >= E[b].f)) then begin
        new (T);  T.x :=  E[b].x;  T.f := E[b].f;  T.dx := E[b].dx1;
        P[i+s] := T;  dec (b);  dec (s)
    end else begin P[i+s] := P[i];  dec(i);  if i < 0 then runerror (239) end;
end;

procedure do_change (V : PEvent);
var i, j, k : integer;
begin
  i := 0;  j := PN + 1;
  while j - i > 1 do begin
    k := (i + j) shr 1;
    if (V.x <= P[k].x) then j := k else i := k
  end;
  while (j <= PN) and (V.x = P[j].x) do begin
    if (V.dx = P[j].dx) and (V.f = P[j].f) then 
      begin P[j].dx := V.dx1;  exit end;
    inc (j)
  end;
  runerror (239)
end;

procedure resort1;
var i, j : integer;  Z : PPoint;
begin
  for i := 2 to PN do begin
    Z := P[i];
    j := i - 1;
    while (j >= 1) and ((Z.x < P[j].x) or ((Z.x = P[j].x) and ((Z.f > P[j].f)
      or ((Z.f = P[j].f) and (Z.dx < P[j].dx))))) do
        begin P[j+1]:=P[j];  dec (j) end;
    P[j+1] := Z
  end
end;

procedure resort2;
var i, j : integer;  Z : PPoint;
begin
  for i := 2 to PN do begin
    Z := P[i];
    j := i - 1;
    while (j >= 1) and ((Z.x < P[j].x) or ((Z.x = P[j].x) and ((Z.dx < P[j].dx)
      or ((Z.dx = P[j].dx) and (Z.f > P[j].f))))) do
        begin P[j+1]:=P[j];  dec (j) end;
    P[j+1] := Z
  end
end;

procedure do_delete (a, b : integer);
var i, j : integer;
begin
  for i := a to b - 1 do do_change (E[i]);
  j := 0;
  for i := 1 to PN do
    if P[i].dx <> _NO then begin inc(j); P[j] := P[i] end
                      else begin dispose (P[i]);  P[i]:=nil end;
  PN := j
end;

var w, dw, K : integer;

procedure calc_width;
var i, s : integer;
begin
  w := 0;  dw := 0;
  for i := 1 to PN - 1 do
    if P[i].x > P[i+1].x then runerror (239);
  s := 0;
  for i := 1 to PN do
    if P[i].f = 1 then begin
      inc(s);  if s = K then begin dec (w, P[i].x);  dec (dw, P[i].dx) end
    end else begin
      if s = K then begin inc (w, P[i].x+1);  inc (dw, P[i].dx) end;
      dec(s);  if s < 0 then runerror (239);
    end;
  if s <> 0 then
    runerror (239)
end;

function work : integer;
var i, j, y0, yp, dy, dy0, s : integer;
begin
  Result := 0;
  if TotE = 0 then exit;
  y0 := E[1].y;  yp := y0 - 1;  w := 0;  dw := 0;  i := 1;  PN := 0;
  repeat
    dy := y0 - yp;  if dy <= 0 then runerror (239);
    if dy > 1 then Result := Result + w*(dy-1) + dw*(dy*(dy-1) shr 1);
    if dy > 0 then for s := 1 to PN do inc(P[s].x, dy*P[s].dx);
    resort1;
    j := i;
    while (j <= TotE) and (E[j].y = y0) and (E[j].dx = _NO) do inc (j);
    if i < j then begin do_create (i, j);  i := j end;
    while (i <= TotE) and (E[i].y = y0) and (E[i].dx1 <> _NO) do begin
      do_change (E[i]);  inc (i)
    end;
    resort1;
    calc_width;  Result := Result + w;
    j := i;
    while (j <= TotE) and (E[j].y = y0) and (E[j].dx1 = _NO) do inc (j);
    if i < j then begin do_delete (i, j);  i := j;  end;
    resort2;
    calc_width;
    if i > TotE then break;
    dy0 := E[i].y - y0;
    for j := 1 to PN-1 do
      if P[j].dx > P[j+1].dx then begin
        dy := P[j+1].x - P[j].x;  if dy <= 0 then runerror (239);
        if P[j].dx - P[j+1].dx = 2 then dy := (dy + 1) shr 1;
        if dy < dy0 then dy0 := dy
      end;
    yp := y0;  y0 := y0 + dy0
  until false;
  if (w <> 0) or (dw <> 0) or (PN <> 0) then runerror (239)
end;

var i, N, Xc, Yc, R, u, v : integer;
begin
  assign (input, 'octagons.in');  reset (input);
  assign (output, 'octagons.out');  rewrite (output);
  repeat
    read (N);  if (N <= 0) or (N > MaxN) then runerror (239);
    TotE := 0;
    for i := 1 to N do begin
      read (Xc, Yc, R);
      if (abs(Xc) > MaxX) or (abs(Yc) > MaxX) or (R <= 0) or
         (R > MaxX) then runerror (239);
      u := R * 405451 div 438857;
      v := R * 738651 div 565339;
      if v > 2 * u then v := 2 * u;
      {writeln (sqr(2*u+1)-2*(2*u-v)*(2*u-v+1));}
      if (v <= u) and (R > 1) then runerror (239);
      if v = 2 * u then begin
        newevt (Xc-u, Yc-u, 1, _NO, 0);
        newevt (Xc+u, Yc-u, -1, _NO, 0);
        newevt (Xc-u, Yc+u, 1, 0, _NO);
        newevt (Xc+u, Yc+u, -1, 0, _NO)
      end else begin
        newevt (Xc+u-v, Yc-u, 1, _NO, -1);
        newevt (Xc-u+v, Yc-u, -1, _NO, 1);
        newevt (Xc-u, Yc+u-v, 1, -1, 0);
        newevt (Xc+u, Yc+u-v, -1, 1, 0);
        newevt (Xc-u, Yc-u+v, 1, 0, 1);
        newevt (Xc+u, Yc-u+v, -1, 0, -1);
        newevt (Xc+u-v, Yc+u, 1, 1, _NO);
        newevt (Xc-u+v, Yc+u, -1, -1, _NO)
      end
    end;
    qsort (1, TotE);
    read (K);  if (K <= 0) or (K > MaxN) then runerror (239);
    writeln (work);
    for i := 1 to TotE do dispose (E[i])
  until seekeof
end.
