{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00400000}
{$MAXSTACKSIZE $00400000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

{

  Sample solution for the task ""
  Copyright(c) by Michael Mirzayanov

  Last revision date : ??.04.2004

}

program Shablon;

  uses
    SysUtils, Math;

  const
    cInFile = 'thruput.in';
    cOutFile = 'thruput.out';
    nmax = 100000;
    INF = $3fffffff;

  type
    int = longint;
    TEdge = record
      a, b : int;
      l : int;
    end;
    TList = ^TNode;
    TNode = record
      inf : int;
      next : TList;
      num : int;
    end;

  var
    n : int;
    ans : int;

    value : array [1..nmax] of int;
    parent : array [1..nmax] of int;
    edge : array [1..nmax - 1] of TEdge;
    graph : array [1..nmax] of TList;
    visited : array [1..nmax] of boolean;
    depth : array [1..nmax] of int;

  function findmax(a, b : int) : int;
  begin
    result := -INF;
    while a <> b do
      if depth[a] > depth[b] then begin
        result := max(result, value[a]);
        a := parent[a];
      end else begin
        result := max(result, value[b]);
        b := parent[b];
      end;
  end;

  function DFS(idx : int; d : int) : int;
    var
      x : TList;
  begin
    if visited[idx] then exit;
    visited[idx] := true;
    depth[idx] := d;

    x := graph[idx];
    while x <> nil do begin
      if not visited[x^.inf] then begin
        parent[x^.inf] := idx;
        value[x^.inf] := edge[x^.num].l;
        DFS(x^.inf, d + 1);
      end;
      x := x^.next;
    end
  end;

  procedure swap(var a, b : int);
    var
      t : int;
  begin
    t := a;
    a := b;
    b := t;
  end;

  procedure ReadData;
    var
      i, j : int;
      x : TList;
      c : char;
      a, b : int;
      str : string;
      p, q : int;
      posspace : int;
  begin
    assign(input, cInFile);
    reset(input);
    
    assign(output, cOutFile);
    rewrite(output);

    readln(n);

    parent[1] := 1;
    value[1] := 0;
    for i := 1 to n - 1 do begin
      readln(edge[i].a, edge[i].b, edge[i].l);

      new(x);
      x^.inf := edge[i].b;
      x^.next := graph[edge[i].a];
      x^.num := i;
      graph[edge[i].a] := x;

      new(x);
      x^.inf := edge[i].a;
      x^.next := graph[edge[i].b];
      x^.num := i;
      graph[edge[i].b] := x;
    end;

    fillchar(visited, SizeOf(visited), 0);
    DFS(1, 0);

    for i := 1 to n do
      assert(visited[i]);

    while true do begin
      str:='';
      repeat
        read(c);
      until c>' ';
      repeat
        str:=str+c;
        if eof then break;
        read(c);
      until c<=' ';
      if str = 'DONE' then begin
        close(output);
        break;
      end;
      if str = 'QUERY' then begin
        read(a,b);
        writeln(findmax(a, b));
        continue;
      end;
      if str = 'CHANGE' then begin
        read(a,b);
        p := edge[a].a;
        q := edge[a].b;

        if parent[p] <> q then
          swap(p, q);

        value[p] := b;

        continue;
      end;
      assert(false);
    end;

    close(input);
  end;

begin
  ReadData;
end.
