Program MakeLoveNotWar;
Uses SysUtils;

Type
  Integer=LongInt;

Const
  TaskID='triples';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=102;
  TimeLimit=1.8/24/60/60;
  NumTries=100;

Type
  TArr=Array[1..MaxN,1..MaxN]Of Integer;
  TPerm=Array[1..MaxN]Of Integer;

Var
  N:Integer;
  AB,BC,CA:TArr;
  Cur,Best:Integer;
  BPermA,BPermB,BPermC:TPerm;
  PermA,PermB,PermC:TPerm;
  Start,Finish:TDateTime;

Procedure ReadArr(Var A:TArr);
Var
  I,J:Integer;
Begin
  For I:=1 To N Do
    For J:=1 To N Do Read(A[I,J]);
End;

Procedure Load;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N);
  ReadArr(AB);
  ReadArr(BC);
  ReadArr(CA);
  Close(Input);
End;

Function Calculate:Integer;
Var
  R,I:Integer;
Begin
  R:=0;
  For I:=1 To N Do
    Inc(R,AB[PermA[I],PermB[I]]+BC[PermB[I],PermC[I]]+CA[PermC[I],PermA[I]]);
  Calculate:=R;
End;

Procedure MakeRandomPerm(Var P:TPerm);
Var
  I,J,T:Integer;
Begin
  For I:=1 To N Do P[I]:=I;
  For I:=1 To N-1 Do Begin
    J:=I+Random(N-I+1);
    If I<>J Then Begin
      T:=P[I];
      P[I]:=P[J];
      P[J]:=T;
    End;
  End;
End;

Procedure RandomStart;
Begin
  MakeRandomPerm(PermA);
  MakeRandomPerm(PermB);
  MakeRandomPerm(PermC);
  Cur:=Calculate;
End;

Procedure Optimize;
Begin
End;

Procedure Solve;
Var
  I:Integer;
Begin
  Best:=-1;
  For I:=1 To NumTries Do Begin
    Finish:=Start+I/NumTries*TimeLimit;
    Repeat
      RandomStart;
      Optimize;
      If Cur>Best Then Begin
        Best:=Cur;
        BPermA:=PermA;
        BPermB:=PermB;
        BPermC:=PermC;
      End;
    Until Now>Finish;
  End;
  WriteLn(Best);
End;

Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To N Do
    WriteLn(BPermA[I],' ',BPermB[I],' ',BPermC[I]);
  Close(Output);
End;

Begin
  Start:=Now;
  RandSeed:=543819581;
  Load;
  Solve;
  Save;
End.
