{$A+,B-,D+,E-,F-,G+,I+,L+,N-,O-,P-,Q+,R+,S-,T-,V+,X+,Y+}
program macro;
uses sysutils;
const MaxN = 50;  MaxQ = 2000;
{ king starts at (1,1), queen - at (2,N); king moves first }

type typeA = array [1..2*2+1, 1..MaxN*2+1] of boolean;
     typeBI = array [1..2, 1..MaxN] of integer;
     ptypeBI = ^typeBI;
     typeB = array [1..2, 1..MaxN] of ptypeBI;
     queueE = record x1, y1, x2, y2, f : integer end;
const KSZ = 8;
type  ct0 = array [1..KSZ] of integer;
const vx : ct0 = (1, 1, 0,-1,-1,-1, 0, 1);
      vy : ct0 = (0, 1, 1, 1, 0,-1,-1,-1);

var
  A      : ^typeA;
  B, C   : typeB;
  N      : integer;
  Changes : boolean;
  opt     : integer;

procedure setres1 (x1,y1,x2,y2,r : integer); { sets result for king }
begin
  assert (b[x1, y1]^[x2, y2]=0);
  assert (r<>0);
  B[x1,y1]^[x2,y2] := r;
  Changes := true;
end;

procedure setres2 (x1,y1,x2,y2,r : integer); { sets result for queen }
begin
  assert (c[x1, y1]^[x2, y2]=0);
  assert (r<>0);
  C[x1,y1]^[x2,y2] := r;
  Changes := true;
end;

procedure anmove1i (x1,y1,x2,y2,vx,vy : integer);
var r : integer;
begin
  if A^[x1*2+vx, y1*2+vy] then exit; { wall }
  inc (x1, vx);  inc (y1, vy);
  r := C[x1,y1]^[x2,y2];
  if r*opt>0 then begin
    if r<opt then opt:=r;
  end else
  if (r>=0) and (opt<0) then opt:=r else
  if (opt=0) and (r>0) then opt:=r;
end;

procedure anmove2i (x1,y1,x2,y2,vx,vy : integer);
var r : integer;
begin
  while not A^[x2*2+vx, y2*2+vy] do begin
    inc (x2, vx);  inc (y2, vy);
    r := B[x1,y1]^[x2,y2];
    if r*opt>0 then begin
      if r<opt then opt:=r;
    end else
    if (r>=0) and (opt<0) then opt:=r
    else
    if (opt=0) and (r>0) then opt:=r
  end;
end;

procedure anmove1 (x1,y1,x2,y2 : integer); { analyse king's moves }
var k : integer;
begin
  if B[x1,y1]^[x2,y2] <> 0 then exit;
//  if (x1=1) and (y1=1) and (x2=2) and (y2=5) then asm int 3 end;
  opt := -1;
//  if (x1=1) and (y1=2) and (x2=2) and (y2=1) then asm int 3 end;
  for k := 1 to KSZ do anmove1i (x1,y1,x2,y2,vx[k],vy[k]);
  if opt>0 then setres1 (x1, y1, x2, y2, -opt-1) else
  if opt<0 then setres1 (x1,y1,x2,y2,-opt+1)
end;

procedure anmove2 (x1,y1,x2,y2 : integer); { analyse queens's moves }
var k : integer;
begin
  if C[x1,y1]^[x2,y2] <> 0 then exit;
//  if (x1=1) and (y1=1) and (x2=1) and (y2=2) then asm int 3 end;
  opt := -1;
  for k := 1 to KSZ do anmove2i (x1,y1,x2,y2,vx[k],vy[k]);
  if opt= -maxlongint then setres2 (x1, y1, x2, y2, 1) else
  if opt>0 then setres2 (x1, y1, x2, y2, -opt-1) else
  if opt<0 then setres2 (x1,y1,x2,y2,-opt+1)
end;


var
  M, i, k, f, x1, y1, x2, y2, x, y, dx, dy : integer;
begin
  new (A);  fillchar (A^, sizeof(A^), 0);
  assign (input, 'king.in');  reset (input);
  assign (output, 'king.out');  rewrite (output);
  read (N, M);
  if (N <= 0) or (N > MaxN) then runerror (239);
  for x := 1 to 2 do
    for y := 1 to N do
      begin new(B[x,y]); fillchar(B[x,y]^, sizeof(typeBI), 0);
            new(C[x,y]); fillchar(C[x,y]^, sizeof(typeBI), 0) end;
  for i := 1 to M do begin
    read (x1, y1);
    if (x1 <= 0) or (x1 > 2) or (y1 <= 0) or (y1 > N) then runerror (239);
    read (x2, y2);
    if (x2 <= 0) or (x2 > 2) or (y2 <= 0) or (y2 > N) then runerror (239);
    if abs(x1-x2) + abs(y1-y2) <> 1 then runerror (239);
    x := x1+x2;  y := y1+y2;
    A^[x, y] := true;
    dx := x2-x1;  dy := y2-y1;
    A^[x+dy, y+dx] := true;
    A^[x-dy, y+dx] := true;
    A^[x+dy, y-dx] := true;
    A^[x-dy, y-dx] := true;
  end;
  for x := 1 to 2*2+1 do
    begin A^[x,1] := true;  A^[x,N*2+1] := true end;
  for y := 1 to N*2+1 do
    begin A^[1,y] := true;  A^[2*2+1,y] := true end;
  for x := 1 to 2 do
    for y := 1 to N do
      begin setres1 (x,y,x,y,2); setres2(x,y,x,y,2) end;
  { king starts at (1,1), queen - at (2,N); king moves first }
  repeat
    Changes := false;
    for x1 := 1 to 2 do
      for y1 := 1 to N do
        for x2 := 1 to 2 do
          for y2 := 1 to N do
            anmove1 (x1, y1, x2, y2);
    for x1 := 1 to 2 do
      for y1 := 1 to N do
        for x2 := 1 to 2 do
          for y2 := 1 to N do
            anmove2 (x1, y1, x2, y2);
    for x1 := 1 to 2 do
      for y1 := 1 to N do
        for x2 := 1 to 2 do
          for y2 := 1 to N do
            anmove1 (x1, y1, x2, y2);
    for x1 := 1 to 2 do
      for y1 := 1 to N do
        for x2 := 1 to 2 do
          for y2 := 1 to N do
            anmove2 (x1, y1, x2, y2);
  until not Changes;
  f := B[1,1]^[2,N];
  if f=3 then f:=5 else
  if f=-3 then f:=-5;
  if f = 0 then writeln ('draw') else
  if f < 0 then writeln ('king wins'#13#10, -f-4) else
  if f > 0 then writeln ('queen wins'#13#10, f-4) else
end.
