program h;

{$APPTYPE CONSOLE}
{$H+}

uses
  SysUtils, Classes;

Const
  TaskID='quest';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxRooms=10;
  MaxDoors=MaxRooms*MaxRooms;
  MaxFeature=202;

Var
  NRooms,NDoors:Integer;
  Rooms:TStringList;
  RoomPrev:Array[0..MaxRooms-1]Of Integer;
  Doors:Array[1..MaxDoors]Of Record
    A,B:Integer;
    Key:String;
  End;
  Floor:Array[0..MaxRooms-1]Of TStringList;
  NObjs:Integer;
  Objs:Array[1..MaxFeature]Of Record
    At:Integer;
    Name:String;
    Needs,Gives:TStringList;
    Kind:Integer;
    Used:Boolean;
  End;
  Start,Finish:Integer;
  WeHave:TStringList;
  NowAt:Integer;

Procedure ReadLnCommaSeparatedList(Var L:TStringList);
Var
  St:String;
Begin
  L:=TStringList.Create;
  ReadLn(St);
  St:=St+',';
  While St<>'' Do Begin
    L.Add(Trim(Copy(St,1,Pos(',',St)-1)));
    Delete(St,1,Pos(',',St));
  End;
End;

Procedure Load;
Var
  I,J:Integer;
  NC,NO,NF:Integer;
  St:String;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  ReadLn(NRooms);
  Rooms:=TStringList.Create;
  For I:=1 To NRooms Do Begin
    ReadLn(St);
    Rooms.Add(Trim(St));
  End;
  ReadLn(NDoors);
  For I:=1 To NDoors Do With Doors[I] Do Begin
    Read(A,B);
    Dec(A);
    Dec(B);
    ReadLn(Key);
    Key:=Trim(Key);
  End;
  NObjs:=0;
  For I:=0 To NRooms-1 Do Begin
    ReadLn(NC,NO,NF);
    For J:=1 To NC+NO Do Begin
      Inc(NObjs);
      With Objs[NObjs] Do Begin
        If J<=NC Then Kind:=1 Else Kind:=2;
        At:=I;
        ReadLn(Name);
        ReadLnCommaSeparatedList(Needs);
        ReadLnCommaSeparatedList(Gives);
        Used:=False;
      End;
    End;
    Floor[I]:=TStringList.Create;
    For J:=1 To NF Do Begin
      ReadLn(St);
      Floor[I].Add(Trim(St));
    End;
  End;
  ReadLn(St);
  Start:=Rooms.IndexOf(St);
  ReadLn(St);
  Finish:=Rooms.IndexOf(St);
  Close(Input);
  WeHave:=TStringList.Create;
End;

Procedure PickUp(RoomID:Integer);
Var
  I:Integer;
Begin
  For I:=0 To Floor[RoomID].Count-1 Do Begin
    WriteLn('pick ',Floor[RoomID][I]);
    WeHave.Add(Floor[RoomID][I])
  End;
End;

Procedure Otkat(A:Integer);
Begin
  If A=NowAt Then Exit;
  Otkat(RoomPrev[A]);
  WriteLn('go to ',Rooms[A]);
  NowAt:=A;
End;

Procedure WalkTo(A:Integer);
Begin
  If NowAt=A Then Exit;
  While NowAt<>Start Do Begin
    WriteLn('go to ',Rooms[RoomPrev[NowAt]]);
    NowAt:=RoomPrev[NowAt];
  End;
  Otkat(A);
End;

Function FormatList(Const A:TStringList):String;
Var
  I:Integer;
Begin
  Result:='';
  For I:=0 To A.Count-1 Do Begin
    Case I Of
      0:;
      1:Result:=' and '+Result;
      Else Result:=', '+Result;
    End;
    Result:=A[I]+Result;
  End;
End;

Function IsSubset(Const A,B:TStringList):Boolean;
Var
  I:Integer;
Begin
  IsSubset:=False;
  For I:=0 To A.Count-1 Do
    If B.IndexOf(A[I])<0 Then Exit;
  IsSubset:=True;
End;

Procedure Solve;
Var
  Over:Boolean;
  I:Integer;
  CA,CB:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To NRooms Do RoomPrev[I]:=-1;
  RoomPrev[Start]:=Start;
  PickUp(Start);
  NowAt:=Start;
  Repeat
    Over:=True;
    For I:=1 To NDoors Do With Doors[I] Do If ((RoomPrev[A]<0) Xor (RoomPrev[B]<0)) And (WeHave.IndexOf(Key)>=0) Then Begin
      If RoomPrev[A]<0 Then Begin CA:=B; CB:=A; End Else Begin CA:=A; CB:=B; End;
      WalkTo(CA);
      WriteLn('open door to ',Rooms[CB]);
      WriteLn('go to ',Rooms[CB]);
      NowAt:=CB;
      PickUp(CB);
      RoomPrev[CB]:=CA;
      If CB=Finish Then Begin
        WriteLn('save princess');
        Close(Output);
        Exit;
      End;
      Over:=False;
    End;
    For I:=1 To NObjs Do With Objs[I] Do If Not Used And (RoomPrev[At]>=0) And IsSubset(Needs,WeHave) Then Begin
      WalkTo(At);
      Used:=True;
      Case Kind Of
        1:Begin
          WriteLn('talk to ',Name);
          WriteLn('give ',FormatList(Needs),' to ',Name);
          WriteLn('take ',FormatList(Gives),' from ',Name);
        End;
        2:Begin
          WriteLn('use ',FormatList(Needs),' on ',Name);
          WriteLn('take ',FormatList(Gives),' from ',Name);
        End;
      End;
      WeHave.AddStrings(Gives);
      Over:=False;
    End;
  Until Over;
  ReWrite(Output);
  WriteLn('dead princess');
  Close(Output);
End;

Procedure Save;
Begin
End;

begin
  Load;
  Solve;
  Save;
end.
