{$I+,Q+,R+,O-}
program macro;
var 
  S : string; 
  P : integer;
  G : array [0..25, 0..25] of integer;

{
<tree> ::= <node> | <node> "->" <chain>
<node> ::= <letter> | "(" <tree> ")"
<letter> ::= A | B | ... | Z
<chain> ::= <node> | <node> "->" <chain> | "(" <list> ")"
<list> ::= <tree> | <tree> "," <list>
}

procedure syntax (const T : string);
var i : integer;
begin
  writeln (S);
  for i := 1 to P - 1 do if S[i] = #9 then write (S[i]) else write (' ');
  writeln ('^');
  writeln (T);
  halt (239)
end;

procedure expect (C : char);
begin
  if S[P] <> C then begin
    if C = #0 then syntax ('Extra characters on line')
    	      else syntax ('`'+ C + ''' expected')
  end else inc (P)
end;

function rtree : integer; forward;

function rnode : integer;
var T : integer;
begin
  rnode := -1;
  if S[P] = '(' then begin inc(P);  rnode := rtree;  expect (')') end
  else if S[P] in ['A'..'Z'] then begin
    T := ord(S[P]) - 65;  inc (P);
    G[T,T] := 0;  rnode := T
  end else syntax ('node id expected')
end;

procedure rchain (Z : integer);
var i, Y, W : integer;
begin
  if S[P] = '(' then begin
    inc (P);
    Y := rtree;
    W := 1 shl Y;
    if (S[P] = ')') and (S[P+1] = '-') and (S[P+2] = '>') then begin
      inc (P, 3);
      rchain (Y)
    end else begin
      while S[P] = ',' do begin inc(P);  W := W or (1 shl rtree) end;
      expect (')')
    end
  end else begin
    Y := rtree;
    if (S[P] = '-') and (S[P+1] = '>') then begin
      inc (P, 2);
      rchain (Y)
    end;
    W := 1 shl Y
  end;
  for i := 0 to 25 do if odd (W shr i) and (i <> Z) then 
    begin {write (chr(65+Z), chr(65+i),' ');} G[i,Z] := 1;  G[Z,i] := 1 end;
end;

function rtree : integer;
var T : integer;
begin
  T := rnode;
  if (S[P] = '-') and (S[P+1] = '>') then begin
    inc (P, 2);
    rchain (T);
  end;
  rtree := T;
end;

var _, R, i, j, k : integer;
begin
  assign (input, 'dist.in');  reset (input);
  assign (output, 'dist.out');  rewrite (output);
  _ := 0;
  repeat
    if _ > 0 then writeln;  inc (_);
    readln (S);  S := S + #0;  P := 1;
    fillchar (G, sizeof(G), $3f);
    R := rtree;
    expect (#0);
    for k := 0 to 25 do
      for i := 0 to 25 do
        for j := 0 to 25 do
          if G[i,k]+G[k,j] < G[i,j] then G[i,j] := G[i,k] + G[k,j];
    for i := 0 to 25 do
      if G[R,i] < 100 then writeln (chr(65+i), ' ', G[R,i])
  until seekeof
end.
