/* by Michael R. Mirzayanov
 */
   
#include <iostream>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <deque>
#include <map>
#include <set>
#include <functional>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (n); i++)

#define NMAX 1001
#define HBASE 100000000
#define HBASELEN 8
#define HLEN 5

typedef int thuge[HLEN + 1];

int n = 0, m = 0;
int data[NMAX];

int ans = 0;
thuge t[NMAX][NMAX];
int lx[NMAX][NMAX];

void huge_add_mul(thuge &h, int k, thuge &a) // h += k * a
{
    int max_len = (h[0] > a[0] ? h[0] : a[0]), r = 0;
    h[0] = max_len;
    for (int i = 1; i <= max_len; i++)
    {
        h[i] += r + a[i] * k;
        r = h[i] / HBASE;
        h[i] = h[i] % HBASE;
    }
    while (r > 0)
        h[++h[0]] = r % HBASE,
        r /= HBASE;
    while (h[0] > 1 && h[h[0]] == 0)
        h[0]--;
}

void huge_print(const thuge &t)
{
    printf("%d", t[t[0]]);
    for (int i = t[0] - 1; i > 0; i--)
    {
        char c[HBASELEN + 1];
        sprintf(c, "%d", t[i]);
        int k = 0;
        while (k + strlen(c) < HBASELEN)
        {
            k++;
            printf("0");
        }
        printf("%s", c);
    }
}

int main(int argc, char* argv[])
{
    freopen("young.in", "rt", stdin);
    freopen("young.out", "wt", stdout);

    scanf("%d", &n);
    assert(n >= 1 && n <= 1000);

    int counter[NMAX];
    memset(counter, 0, sizeof(counter));
    
    forn(i, n)
    {
        scanf("%d", &data[i]);
        assert(data[i] >= 1 && data[i] <= 1000);
        counter[data[i]]++;
    }

    forn(i, n)
        assert(counter[i + 1] == 1);

    memset(lx, 0, sizeof(lx));

    for (int l = n - 1; l >= 0; l--)
        for (int r = n - 1; r >= l; r--)
            if (data[l] >= data[r])
                lx[l][r] = 0;
            else
                lx[l][r] = 1 + (l + 1 != n && r + 1 != n &&
                    data[l] < data[l + 1] && data[r] < data[r + 1]
                    ? lx[l + 1][r + 1] : 0);

    memset(t, 0, sizeof(t));

    thuge line[NMAX];
    for (int l = n - 1; l >= 0; l--)
    {
        int s_last = 0;
        for (int r = l; r < n && s_last < data[r]; s_last = data[r++])
            if (r + 1 < n)
            {
                int max_len = (lx[l][r + 1] < r - l + 1 ?
                    lx[l][r + 1] : r - l + 1);
                huge_add_mul(t[l][r], 1, t[r + 1][max_len]);
            }
            else
                t[l][r][0] = t[l][r][1] = 1;
        memset(line, 0, sizeof(line));
        for (int len = 0; len < n - l; len++)
        {
            memmove(line[len + 1], line[len], sizeof(thuge));
            huge_add_mul(line[len + 1], 1, t[l][l + len]);
        }
        forn(i, n + 1)
            memmove(t[l][i], line[i], sizeof(thuge));
    }

    huge_print(t[0][n]);

    return 0;
}