#include <iostream>
#include <cmath>
#include <string>
#include <sstream>
#include <vector>
#include <deque>
#include <map>
#include <set>
#include <functional>
#include <algorithm>
#include <cassert>

using namespace std;

#ifdef __GNUC__
typedef long long i64; typedef unsigned long long u64;
#endif

#ifndef __GNUC__
typedef __int64 i64; typedef unsigned __int64 u64;
#endif

typedef long double real;

typedef vector<int> VI;  typedef vector<VI> VVI; 
typedef vector<string> VS;  typedef vector<VS> VVS; 

#define forn(i, n) for(int i = 0; i < (n); i++)
#define fors(i, s) forn(i, s.length())
#define forv(i, v) forn(i, v.size())

#define pb push_back
#define all(v) v.begin(), v.end()

#define NMAX 1000
#define HBASE 100000000
#define HBASELEN 8
#define HLEN 5

typedef int thuge[HLEN + 1];

int n = 0, m = 0;
int data[NMAX];

int ans = 0;
thuge t[NMAX][NMAX];
int lx[NMAX][NMAX];

void huge(thuge &h, int a)
{
    memset(h, 0, sizeof(h));
    while (a > 0)
        h[++h[0]] = a % HBASE,
        a /= HBASE;
    h[0] = (h[0] == 0 ? 1 : h[0]);
}

void huge_add_mul(thuge &h, int k, thuge &a) // h += k * a
{
    int max_len = (h[0] > a[0] ? h[0] : a[0]), r = 0;
    h[0] = max_len;
    for (int i = 1; i <= max_len; i++)
    {
        h[i] += r + a[i] * k;
        r = h[i] / HBASE;
        h[i] = h[i] % HBASE;
    }
    while (r > 0)
        h[++h[0]] = r % HBASE,
        r /= HBASE;
    while (h[0] > 1 && h[h[0]] == 0)
        h[0]--;
}

void huge_print(const thuge &t)
{
    printf("%d", t[t[0]]);
    for (int i = t[0] - 1; i > 0; i--)
    {
        char c[HBASELEN + 1];
        sprintf(c, "%d", t[i]);
        int k = 0;
        while (k + strlen(c) < HBASELEN)
        {
            k++;
            printf("0");
        }
        printf("%s", c);
    }
}

int main(int argc, char* argv[])
{
    freopen("input.txt", "rt", stdin);

    scanf("%d", &n);
    forn(i, n)
        scanf("%d", &data[i]);

    // lx[idx1][idx1] = length len, that substring(idx1, len) << substring(idx1, len)

    memset(lx, 0, sizeof(lx));

    for (int l = n - 1; l >= 0; l--)
        for (int r = n - 1; r >= l; r--)
            if (data[l] >= data[r])
                lx[l][r] = 0;
            else
                lx[l][r] = 1 + (l + 1 != n && r + 1 != n &&
                    data[l] < data[l + 1] && data[r] < data[r + 1]
                    ? lx[l + 1][r + 1] : 0);

    // t[l][r] = answer for data[l], data[l + 1], ..., data[n - 1] if
    // there is data[l]...data[r] in the first line of young table
    // t[l][r] = SUM t[r + 1][i] * [...]

    memset(t, 0, sizeof(t));

    for (int l = n - 1; l >= 0; l--)
    {
        int s_last = 0;
        for (int r = l; r < n && s_last < data[r]; r++)
        {
            s_last = data[r];
            int last = 0;
            if (r + 1 < n)
                for (int rr = r + 1; r - l >= rr - r - 1 &&
                    rr - r - 1 < lx[l][r + 1]; rr++)
                {
                    last = data[rr];
                    huge_add_mul(t[l][r], 1, t[r + 1][rr]);
                }
            else
                huge(t[l][r], 1);
        }
    }

    thuge answer;
    huge(answer, 0);

    forn(i, n)
        huge_add_mul(answer, 1, t[0][i]);

    huge_print(answer);

    return 0;
}
