{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S+,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}
uses sysutils;                               
const
  inf = $77777777;
  eps = 1e-10;
  p2: array[1 .. 12] of longint = (1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048);
  md2 = 300;
type
  int = longint;
  ppr = ^tpr;
  tpr = record
    na: array[0 .. md2] of int;
    a, v: array[0 .. md2, 1 .. md2] of int;
  end;
  tmatr = array[0 .. md2, 0 .. md2] of int;
  tvect = array[0 .. md2] of int;
var
  m, m1, m2: int;
  am, bm, au, aul: tmatr;
  cm: array[0 .. md2, 0 .. md2] of int64;

procedure gen_profiles_transition(w: int; var p, pl: tpr);
var
  t, d, i, j: int;
  u, v: array[0 .. 10] of boolean;

  procedure gen(x: int);
  begin
    if (x = w + 1) then begin
      inc(au[i, d]);
      exit;
    end;
    if ((x = w) and (u[w])) then
      inc(aul[i, d]);
    if (u[x] and u[x + 1] and v[x]) then begin
      u[x] := false;
      u[x + 1] := false;
      v[x] := false;
      inc(d, p2[x]);
      gen(x + 2);
      dec(d, p2[x]);
      u[x] := true;
      u[x + 1] := true;
      v[x] := true;
    end;
    if (u[x] and u[x + 1] and v[x + 1]) then begin
      u[x] := false;
      u[x + 1] := false;
      v[x + 1] := false;
      inc(d, p2[x + 1]);
      gen(x + 2);
      dec(d, p2[x + 1]);
      u[x] := true;
      u[x + 1] := true;
      v[x + 1] := true;
    end;
    if (u[x] and v[x] and v[x - 1]) then begin
      u[x] := false;
      v[x] := false;
      v[x - 1] := false;
      inc(d, p2[x]);
      inc(d, p2[x - 1]);
      gen(x + 1);
      dec(d, p2[x]);
      dec(d, p2[x - 1]);
      u[x] := true;
      v[x] := true;
      v[x - 1] := true;
    end;
    if (u[x] and v[x] and v[x + 1]) then begin
      u[x] := false;
      v[x] := false;
      v[x + 1] := false;
      inc(d, p2[x]);
      inc(d, p2[x + 1]);
      gen(x + 1);
      dec(d, p2[x]);
      dec(d, p2[x + 1]);
      u[x] := true;
      v[x] := true;
      v[x + 1] := true;
    end;
    if (not u[x]) then begin
      gen(x + 1);
    end;
  end;
begin
  m := 1 shl w - 1;
  for i := 0 to m do
    for d := 0 to m do
      au[i, d] := 0;
  for i := 0 to m do
    for d := 0 to m do
      aul[i, d] := 0;
  for i := 0 to m do begin
    t := i;
    u[0] := false;
    for d := 1 to w do begin
      u[d] := (t and 1 = 0);
      t := t shr 1;
    end;
    u[w + 1] := false;
    v[0] := false;
    for d := 1 to w do
      v[d] := true;
    v[w + 1] := false;
    d := 0;
    gen(1);
  end;
  fillchar(p.na, sizeof(p.na), 0);
  for i := 0 to m do
    for j := 0 to m do
      if (au[i, j] > 0) then begin
        inc(p.na[i]);
        p.a[i, p.na[i]] := j;
        p.v[i, p.na[i]] := au[i, j];
      end;
  fillchar(pl.na, sizeof(pl.na), 0);
  for i := 0 to m do
    for j := 0 to m do
      if (aul[i, j] > 0) then begin
        inc(pl.na[i]);
        pl.a[i, pl.na[i]] := j;
        pl.v[i, pl.na[i]] := aul[i, j];
      end;
end;

function mmul(const a, b: tmatr): tmatr;
var
  im, jm, km: int;
begin
  for im := 0 to m do
    for jm := 0 to m do begin
      cm[im, jm] := 0;
      for km := 0 to m do
        inc(cm[im, jm], a[im, km] * b[km, jm]);
      result[im, jm] := cm[im, jm];
    end;
end;

procedure count_rect(w, l: int; const pt: tpr; var ans: tvect);
var
  i, j: int;
begin
  for i := 0 to m do
    for j := 0 to m do
      am[i, j] := 0;
  m := 1 shl w - 1;
  for i := 0 to m do
    am[i, i] := 1;
  fillchar(bm, sizeof(bm), 0);
  for i := 0 to m do
    for j := 1 to pt.na[i] do
      bm[i, pt.a[i, j]] := pt.v[i, j];
  j := l;
  while (j > 0) do begin
    if (j and 1 = 1) then begin
      am := mmul(am, bm);
      dec(j);
    end;
    bm := mmul(bm, bm);
    j := j shr 1;
  end;
  for i := 0 to m do
    ans[i] := am[0, i];
end;
procedure count_small_rect(w1, w2: int; const pts, ptl: tpr; var anst: tmatr);
var
  i, j, k, dl, l: int;
  enz: array[0 .. 300] of boolean;
begin
  m1 := 1 shl w1 - 1;
  m2 := 1 shl w2 - 1;
  for i := 0 to m1 do
    for j := 0 to m2 do
      am[i, j] := 0;
  am[0, 0] := 1;
  for i := 0 to m1 shr 1 do
    enz[i] := false;
  for i := m1 shr 1 + 1 to m do
    enz[i] := true;

  for k := 1 to w2 - 1 do begin
    dl := p2[k];
    for i := 0 to m1 do
      for j := 0 to m2 do
        cm[i, j] := 0;
    for i := 0 to m1 do begin
      for j := 1 to pts.na[i] do
        for l := 0 to m - dl do
          inc(cm[pts.a[i, j], l + dl], pts.v[i, j] * am[i, l]);
      for j := 1 to ptl.na[i] do
        for l := 0 to m do
          inc(cm[ptl.a[i, j], l], ptl.v[i, j] * am[i, l]);
    end;
    for i := 0 to m1 do
      for j := 0 to m2 do
        am[i, j] := cm[i, j];
  end;
  for i := 0 to m1 do
    for j := 0 to m2 do
      anst[i, j] := am[i, j];
end;
var
  l1, w1, l2, w2, i, j, ia1, ia2, ib1, ib2: int;
  ans1, ans2: tvect;
  pt1, pt2, pts, ptl: tpr;
  ansv: int64;
begin
  assign(input, 'angle.in');
  reset(input);
  assign(output, 'angle.out');
  rewrite(output);

  read(ia1, ib1, ia2, ib2);
  l1 := ib1;
  l2 := ib2;
  w1 := ia1 - ib1;
  w2 := ia2 - ib2;

  gen_profiles_transition(w1, pt1, ptl);
  gen_profiles_transition(w2, pt2, ptl);
  if (l1 = 0) then begin
    count_rect(w1, w2 + l2, pt1, ans1);
    write(ans1[0]);
  end else if (l2 = 0) then begin
    count_rect(w2, w1 + l1, pt2, ans1);
    write(ans1[0]);
  end else begin
    count_rect(w1, l2 - 1, pt1, ans1);
    count_rect(w2, l1 - 1, pt2, ans2);
    gen_profiles_transition(w1 + 1, pts, ptl);
    count_small_rect(w1 + 1, w2 + 1, pts, ptl, bm);
    m1 := m1 shr 1;
    m2 := m2 shr 1;
    ansv := 0;
    for i := 0 to m1 do
      for j := 0 to m2 do begin
        inc(ansv, ans1[i] * ans2[j] * bm[m1 - i, m2 - j]);
      end;
    write(ansv);
  end;

end.