  {$I-,Q-,R-,S-}
  {$M 60000000}
type ttree=^ptree;
     ptree=record x,y,len:longint; l,r:ttree; end;
var n,sum,num,l1,r1,l2,r2:longint;
    t:ttree;
    bo:boolean;

Procedure init;
begin
     assign(input,'painter.in');
     reset(input);
     assign(output,'painter.out');
     rewrite(output);
     read(n);
end;

Function readchar:char;
var ch:char;
begin
     read(ch);
     while not (ch in ['W','B']) do read(ch);
     readchar:=ch;
end;

Procedure split(const T:ttree; const x:longint; var L,R:TTREE);
begin
     if T=nil then
     begin
          l:=nil;
          r:=nil;
          exit;
     end;
     if x>T^.x then
     begin
          split(T^.r,x,t^.r,r);
          l:=t;
     end else
     begin
          split(T^.l,x,l,t^.l);
          r:=t;
     end;
end;

Function merge(L,R:ttree):ttree;
begin
     if L=nil then merge:=r else
     if R=nil then merge:=l else
     begin
          if l^.y>r^.y then
          begin
               l^.r:=merge(l^.r,r);
               merge:=l;
          end else
          begin
               r^.l:=merge(l,r^.l);
               merge:=r;
          end;
     end;
end;

Procedure insert(var t:ttree; x,y,len:longint);
var t1:ttree;
begin
     if t=nil then
     begin
          new(t);
          t^.l:=nil;
          t^.r:=nil;
          t^.x:=x;
          t^.y:=y;
          t^.len:=len;
          exit;
     end;
     if y>=T^.y then
     begin
          new(t1);
          split(t,x,t1^.l,t1^.r);
          t1^.x:=x;
          t1^.y:=y;
          t1^.len:=len;
          t:=t1;
     end else
     begin
          if x<t^.x then
          begin
               insert(t^.l,x,y,len);
          end else
          begin
               insert(t^.r,x,y,len);
          end;
     end;
end;

Procedure delete(var t:ttree; x:longint);
var t1:ttree;
begin
     t1:=t;
     if x<t^.x then delete(T^.l,x) else
     if x>t^.x then delete(T^.r,x) else
     begin
          t:=merge(T^.l,T^.r);
          dispose(t1);
     end;
end;

Procedure error;
begin
     writeln('error');
     close(input);
     close(output);
     halt;
end;

Procedure dob(var t:ttree; var l,r:longint);
begin
     if t=nil then exit;
     if (t^.x>l+r) then dob(t^.l,l,r) else
     if (t^.x+t^.len<l) then dob(t^.r,l,r) else
     if (l>=t^.x)and(l<=t^.x+t^.len) then
     begin
          if (l+r>=t^.x)and(l+r<=t^.x+t^.len) then
          begin
               l:=t^.x;
               r:=t^.len;
               dec(sum,r);
               dec(num);
               delete(t,l);
               exit;
          end;
          r:=r+(l-t^.x);
          l:=t^.x;
          sum:=sum-t^.len;
          dec(num);
          delete(t,l);
          dob(t,l,r);
     end else
     if (l+r>=t^.x)and(l+r<=t^.x+t^.len) then
     begin
          r:=t^.x+t^.len-l;
          sum:=sum-t^.len;
          dec(num);
          delete(t,t^.x);
          dob(t,l,r);
     end else
     begin
          sum:=sum-t^.len;
          dec(num);
          delete(t,t^.x);
          dob(t,l,r);
     end;
end;

Procedure dow(var t:ttree; const l,r:longint);
begin
     if t=nil then exit;
     if (l<=t^.x)and(l+r>=t^.x+t^.len) then
     begin
          dec(num);
          dec(sum,t^.len);
          delete(t,t^.x);
          dow(t,l,r);
     end else
     if (l+r<=t^.x) then dow(t^.l,l,r) else
     if (l>=t^.x+t^.len) then dow(t^.r,l,r) else
     if (l>t^.x)and(l<t^.x+t^.len)and(l+r>=t^.x+t^.len) then
     begin
          dec(sum,t^.len-(l-t^.x));
          t^.len:=l-t^.x;
          dow(t^.r,l,r);
     end else
     if (l+r<t^.x+t^.len)and(l+r>t^.x)and(l<=t^.x) then
     begin
          dec(sum,(l+r)-t^.x);
          t^.len:=t^.len-((l+r)-t^.x);
          t^.x:=r+l;
          dow(t^.l,l,r);
     end else
     begin
          dec(sum,t^.len);
          dec(num);
          bo:=true;
          l1:=t^.x;
          r1:=l-t^.x;
          l2:=(l+r);
          r2:=(t^.x+t^.len)-(l+r);
          delete(t,t^.x);
          dow(t,l,r);
     end;
end;

Procedure solve;
var i,l,r,y:longint;
    ch:char;
begin
     t:=nil;
     randomize;
     for i:=1 to n do
     begin
          ch:=readchar;
          read(l,r);
          if ch='B' then
          begin
               dob(t,l,r);
               y:=random(maxlongint);
               insert(t,l,y,r);
               inc(num);
               inc(sum,r);
               writeln(num,' ',sum);
          end else
          begin
               bo:=false;
               dow(t,l,r);
               if bo then
               begin
                    inc(num,2);
                    inc(sum,r1+r2);
                    y:=random(maxlongint);
                    insert(t,l1,y,r1);
                    y:=random(maxlongint);
                    insert(t,l2,y,r2);
               end;
               writeln(num,' ',sum);
          end;
     end;
end;

begin
     init;
     solve;
     close(input);
     close(output);
end.
