{$I-,Q-,R-,S-}
program CartesianTreeAndItsApplications;
const infile = 'painter.in';
      outfile = 'painter.out';
      inf = MAXLONGINT;
type
int = longint;
ptree = ^ttree;
ttree = record
  x1, x2, y : int;
  L, R, P : ptree;
end;
var Tree : ptree;
    N, nbl1, nbl2 : int;

procedure Split(T : ptree; x1 : int; var L, R : ptree);
begin
  if T = nil then begin L:=nil; R:=nil; end
  else begin
    if x1 > T^.x1 then begin Split(T^.R, x1, T^.R, R); L:=T; end;
    if x1 < T^.x1 then begin Split(T^.L, x1, L, T^.L); R:=T; end;
  end;
end;

function Merge(L, R : ptree) : ptree;
begin
  if L = nil then begin Merge:=R; exit; end;
  if R = nil then begin Merge:=L; exit; end;
  if L^.y > R^.y then begin
    L^.R:=Merge(L^.R, R); Merge:=L;
    if L^.R<>nil then L^.R^.P:=L;
    if L^.L<>nil then L^.L^.P:=L;
  end else
  if R^.y > L^.y then begin
    R^.L:=Merge(L, R^.L); Merge:=R;
    if R^.R<>nil then R^.R^.P:=R;
    if R^.L<>nil then R^.L^.P:=R;
  end;
end;

function TreeMin(T : ptree) : ptree;
var Tmp : ptree;
begin
  Tmp:=T;
  while Tmp^.L <> nil do Tmp:=Tmp^.L;
  TreeMin:=Tmp;
end;

function TreeSucc(T : ptree) : ptree;
var Tmp, y : ptree;
begin
  Tmp:=T;
  if T^.R <> nil then begin TreeSucc:=TreeMin(T^.R); exit; end;
  y:=Tmp^.P;
  while (y<>nil)and(Tmp=y^.R) do
  begin
    Tmp:=y; y:=y^.P;
  end;
  TreeSucc:=y;
end;

function Search1(T : ptree; x  : int) : ptree;
begin
  if T=nil then begin Search1:=nil; exit; end;
  if (x<=T^.x2) then
    if (T^.L=nil)or(x>T^.L^.x2) then Search1:=T else Search1:=Search1(T^.L, x);
  if (x>T^.x2) then Search1:=Search1(T^.R, x);
end;

function Search2(T : ptree; x : int) : ptree;
begin
  if T=nil then begin Search2:=nil; exit; end;
  if (x>=T^.x1) then
    if (T^.R=nil)or(x<T^.R^.x1) then Search2:=T else Search2:=Search2(T^.R, x);
  if (x<T^.x1) then Search2:=Search2(T^.L, x);
end;

procedure Insert(var T : ptree; x1, x2, y : int);
var T1 : ptree;
begin
  if (T = nil) or (y > T^.y) then begin
    new(T1);
    Split(T, x1, T1^.L, T1^.R); T1^.x1:=x1; T1^.x2:=x2; T1^.y:=y; T:=T1;
    if T^.R<>nil then T^.R^.P:=T;
    if T^.L<>nil then T^.L^.P:=T;
    inc(nbl1); inc(nbl2, x2-x1);
{    dispose(T1);}
  end
  else if x1 < T^.x1 then
  begin
    Insert(T^.L, x1, x2, y);
    T^.L^.P:=T;
  end else begin Insert(T^.R, x1, x2, y); T^.R^.P:=T; end;
end;

procedure Delete(var T : ptree; x1 : int);
var T1 : ptree;
begin
  if x1 < T^.x1 then delete(T^.L, x1)
  else if x1 > T^.x1 then delete(T^.R, x1)
  else begin
    new(T1);
    T1:=Merge(T^.L, T^.R); dec(nbl1); dec(nbl2, T^.x2-T^.x1); T:=T1;
{    dispose(T1); }
  end;
end;

procedure DisTree(var T : ptree);
begin
  if T=nil then exit;
  DisTree(T^.L);
  DisTree(T^.R);
  dispose(T); T:=nil;
end;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  readln(N);
end;

procedure Solve;
var i, x1, l, x2, xl, xr : int;
    col : char;
    v1, v2, p : ptree;
begin
  Tree := nil; randseed:=248539;
  for i:=1 to N do
  begin
    read(col); readln(x1, l); x2:=x1+l;
    v1:=Search1(Tree, x1); v2:=search2(Tree, x2);
    if col = 'B' then begin
      if (v1=nil)or(v2=nil)or(v1^.x1>=v2^.x2) then begin
        Insert(Tree, x1, x2, random(inf));
      end else begin
        p:=v1; xl:=v1^.x1; xr:=v2^.x2;
        while p<>v2 do
        begin
          v1:=TreeSucc(p);
          Delete(Tree, p^.x1); if Tree<>nil then Tree^.P:=nil;
          p:=v1;
        end;
        delete(Tree, v2^.x1); if Tree<>nil then Tree^.P:=nil;
        if xl<x1 then x1:=xl;
        if xr>x2 then x2:=xr;
        Insert(Tree, x1, x2, random(inf));
      end;
      writeln(nbl1, ' ', nbl2); continue;
    end;
      if (v1=nil)or(v2=nil)or(v1^.x1>=v2^.x2) then begin writeln(nbl1, ' ', nbl2); continue; end;
      p:=v1; xl:=v1^.x1; xr:=v2^.x2;
      while p<>v2 do
      begin
        v1:=TreeSucc(p);
        Delete(Tree, p^.x1); if Tree<>nil then Tree^.P:=nil;
        p:=v1;
      end;
      delete(Tree, v2^.x1); if Tree<>nil then Tree^.P:=nil;
      if xl<x1 then Insert(Tree, xl, x1, random(inf));
      if xr>x2 then Insert(Tree, x2, xr, random(inf));
      writeln(nbl1, ' ', nbl2);
  end;

  DisTree(Tree);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
