{$I-,Q-,R-,S-}
program Temp;
const infile = 'octagons.in';
      outfile = 'octagons.out';
      MAXN = 500;
      inf = MAXLONGINT;
      dt = 1e-4;
type
TPoint = record
  x, y : double;
end;
var maxx, maxy, minx, miny : longint;
    oct : array[1..MAXN, 1..9] of TPoint;
    s : array[1..MAXN] of double;
    N, K : longint;

function eq(r1, r2 : double) : boolean;
begin
  eq:=abs(r1-r2)<dt;
end;

function inside(x, y, t : longint) : boolean;
var ta : double;
    p : integer;
begin
  ta:=0;
  for p:=1 to 8 do
    ta:=abs(ta)+abs(x*oct[t, p].y-oct[t, p].x*y+oct[t, p].x*oct[t, p+1].y-oct[t, p+1].x*oct[t, p].y+oct[t, p+1].x*y-oct[t, p+1].y*x);
  ta:=abs(ta)/2;
  inside:=eq(ta, s[t]);
end;

procedure ReadData;
var i, j : longint;
    tx, ty, tr : double;
    mxx, mxy, mnx, mny : double;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  mxx:=-inf; mxy:=-inf; mnx:=inf; mny:=inf;
  read(N);
  for i:=1 to n do begin
    read(tx, ty, tr);
    s[i]:=2*sqrt(2)*tr*tr;
    for j:=1 to 9 do
    begin
      oct[i, j].x:=tx+tr*cos((j-1)*pi/4+pi/8);
      oct[i, j].y:=ty+tr*sin((j-1)*pi/4+pi/8);
      if oct[i, j].x>mxx then mxx:=oct[i, j].x;
      if oct[i, j].y>mxy then mxy:=oct[i, j].y;
      if oct[i, j].x<mnx then mnx:=oct[i, j].x;
      if oct[i, j].y<mny then mny:=oct[i, j].y;
    end;
  end;
  read(K);
  maxx:=trunc(mxx+0.5); maxy:=trunc(mxy+0.5);
  minx:=trunc(mnx-0.5); miny:=trunc(mny-0.5);
end;

procedure Solve;
var x, y, t, res, tr : longint;
begin
  res:=0;
  for x:=minx to maxx do
    for y:=miny to maxy do
    begin
      tr:=0;
      for t:=1 to N do
      begin
        if inside(x, y, t) then inc(tr);
        if tr>=k then break;
      end;
      if tr>=k then inc(res);
    end;
  write(res);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
