{$A-,B-,D-,E-,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 16384,0,655360}

Const MaxN=550;

Const INPUTFILE='octagons.in';
      OUTPUTFILE='octagons.out';
Const EPS=1E-7;

Type Real=Double;
     RPoint=record
     x,y:Real;
     end;

var a:Array[1..MaxN,1..3] of Integer;
    v:Array[1..MaxN,1..9] of RPoint;
    S:Array[1..MaxN] of Real;
    MinX,MinY,MaxX,MaxY:Integer;
    N,K:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for i:=1 to N do
  Read(a[i,1],a[i,2],a[i,3]);
Read(K);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writeln(Answer);
Close(Output);
Halt;
end;

Procedure Init;
var SQRT2D2:Real;
begin
MinX:=4000;
MinY:=4000;
MaxX:=-MinX;
MaxY:=-MinY;

for i:=1 to N do
begin
  if a[i,1]-a[i,3]<MinX then MinX:=a[i,1]-a[i,3];
  if a[i,2]-a[i,3]<MinY then MinY:=a[i,2]-a[i,3];
  if a[i,1]+a[i,3]>MaxX then MaxX:=a[i,1]+a[i,3];
  if a[i,2]+a[i,3]>MaxY then MaxY:=a[i,2]+a[i,3];
end;

SQRT2D2:=Sqrt(2)/2;
for i:=1 to N do
begin
  v[i,1].x:=Cos(Pi/8)*a[i,3];
  v[i,1].y:=Sin(Pi/8)*a[i,3];
  for j:=2 to 8 do
  begin
    v[i,j].x:=SQRT2D2*(v[i,j-1].x-v[i,j-1].y);
    v[i,j].y:=SQRT2D2*(v[i,j-1].x+v[i,j-1].y);
  end;
  for j:=1 to 8 do
  begin
    v[i,j].x:=v[i,j].x+a[i,1];
    v[i,j].y:=v[i,j].y+a[i,2];
  end;

  v[i,9]:=v[i,1];
  S[i]:=Sin(Pi/4)*a[i,3];
end;
end;

Procedure Solve;
var g,h:Longint;
    x,y:Integer;
    f:Boolean;
    t1:Real;
begin
Init;

g:=0;
for x:=MinX to MaxX do
for y:=MinY to MaxY do
begin
  h:=0;
  for i:=1 to N do
  begin
    f:=False;
    for j:=1 to 8 do
    begin
      t1:=Abs((x-v[i,j].x)*(y-v[i,j+1].y)-(x-v[i,j+1].x)*(y-v[i,j].y)+(x-a[i,1])*(y-v[i,j].y)-(x-v[i,j].x)*(y-a[i,2])+
      (x-a[i,1])*(y-v[i,j+1].y)-(x-v[i,j+1].x)*(y-a[i,2]));
      if Abs(t1-S[i])<EPS then
      begin
        f:=true;
        Break;
      end;
    end;
    if f then Inc(h);
    if h=K then
    begin
      Inc(g);
      Break;
    end;
    if i>N-K+h+1 then Break;
  end;
end;

FWrite(g);
end;

begin
FRead;
Solve;
end.