uses Math;
const
     FileIn='painter.in';
     FileOut='painter.out';
     MaxN=100000;
type
    TOperation=record
                     Color: Char;
                     X, L: LongInt;
               end;
    PRange=^TRange;
    TRange=record
                 X, L: LongInt;
                 Next: PRange;
           end;
    TAnswerItem=record
                      Count, BlackCount: LongInt;
                end;
var
   N: LongInt;
   Operations: array [1..MaxN] of TOperation;
   First: PRange;
   Count, BlackCount: LongInt;
   Answer: array [1..MaxN] of TAnswerItem;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=1 to N
         do with Operations [NItem]
                 do Readln (F, Color, X, L);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NItem:=1 to N
         do with Answer [NItem]
                 do Writeln (F, Count, #32, BlackCount);
     Close (F);
end;

function NewRange (aX, aL: LongInt): PRange;
var
   Range: PRange;
begin
     Range:=New (PRange);
     Range^.X:=aX;
     Range^.L:=aL;
     NewRange:=Range;
end;

procedure Merge;
var
   Range, Next: PRange;
begin
     Range:=First;
     while Assigned (Range) and Assigned (Range^.Next)
           do begin
              Next:=Range^.Next;
              if Range^.X+Range^.L>=Next^.X
                 then begin
                      Range^.L:=Max (Next^.X+Next^.L-Range^.X, Range^.L);
                      Range^.Next:=Next^.Next;
                 end
                 else Range:=Range^.Next;
           end;
end;

procedure AddRange (aX, aL: LongInt);
var
   Range, Prev: PRange;
begin
     Range:=First;
     Prev:=nil;
     while Assigned (Range)
           do begin
              if Range^.X>aX
                 then Break;
              Prev:=Range;
              Range:=Range^.Next;
           end;
     if Assigned (Prev)
        then begin
             Prev^.Next:=NewRange (aX, aL);
             Prev^.Next^.Next:=Range;
        end
        else begin
             First:=NewRange (aX, aL);
             First^.Next:=Range;
        end;
     Merge;
end;

procedure DelRange (aX, aL: LongInt);
var
   Range, Prev, OldNext: PRange;
   Start, Finish, aStart, aFinish, NewStart, NewFinish: LongInt;
begin
     Range:=First;
     Prev:=nil;

     aStart:=aX;
     aFinish:=aX+aL-1;
     while Assigned (Range)
           do begin
              Start:=Range^.X;
              Finish:=Start+Range^.L-1;
              if (aStart<=Start) and (aFinish>=Start)
                 then Start:=aFinish+1;
              if (aStart<=Finish) and (Finish<=aFinish)
                 then Finish:=aStart-1;
              if (aStart>=Start) and (aFinish<=Finish)
                 then begin
                      NewStart:=aFinish+1;
                      NewFinish:=Finish;

                      Finish:=aStart-1;

                      OldNext:=Range^.Next;
                      Range^.Next:=NewRange (NewStart, NewFinish-NewStart+1);
                      Range^.Next^.Next:=OldNext;
                 end;
              Range^.X:=Start;
              Range^.L:=Finish-Start+1;
              if Range^.L<=0
                 then if Assigned (Prev)
                         then Prev^.Next:=Range^.Next
                         else First:=Range^.Next
                 else Prev:=Range;
              Range:=Range^.Next;
           end;
end;

procedure Solve;
var
   NItem: LongInt;
   Range: PRange;
begin
     First:=nil;
     for NItem:=1 to N
         do with Operations [NItem]
                 do begin
                    case Operations [NItem].Color of
                         'B': AddRange (X, L);
                         'W': DelRange (X, L);
                    end;
                    Count:=0;
                    BlackCount:=0;
                    Range:=First;
                    while Assigned (Range)
                          do begin
                             Inc (Count);
                             Inc (BlackCount, Range^.L);
                             Range:=Range^.Next;
                          end;
                    Answer [NItem].Count:=Count;
                    Answer [NItem].BlackCount:=BlackCount;
                 end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
