{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_c;
const
  inpfile='queen.in';
  outfile='queen.out';
  dx : array [0..7] of LongInt = (1,1,0,-1,-1,-1,0,1);
  dy : array [0..7] of LongInt = (0,1,1,1,0,-1,-1,-1);
  km : array [1..4] of LongInt = (0,2,4,6);
  hmax=10000;
  win=2;
  lose=3;
  draw=4;
  unknown=5;
  nm=55;
type
  Wall = array [0..7] of Boolean;
var
  a : array [1..2,1..nm] of Wall;
  qu,ku : array [1..2,1..nm,1..2,1..nm] of Byte;
  qn,kn : array [1..2,1..nm,1..2,1..nm] of LongInt;
  u : array [1..2,1..nm] of LongInt;
  n,m : LongInt;
{}
Procedure FindWalls(x,y,xx,yy : LongInt);
var
  i : LongInt;
begin
  if xx<>0 then begin
    for i:=0 to 7 do
      if dx[i]=xx then begin
        a[x,y,i]:=false;
        if (x+dx[i]>0) and (x+dx[i]<3) and (y+dy[i]>0) and (y+dy[i]<n+1) then
          a[x+dx[i],y+dy[i],(i+4) mod 8]:=false;
      end;
  end else begin
    for i:=0 to 7 do
      if dy[i]=yy then begin
        a[x,y,i]:=false;
        if (x+dx[i]>0) and (x+dx[i]<3) and (y+dy[i]>0) and (y+dy[i]<n+1) then
          a[x+dx[i],y+dy[i],(i+4) mod 8]:=false;
      end;
  end;
end;
{}
Procedure Inp;
var
  i,j : LongInt;
  x1,y1,x2,y2 : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m);
  for i:=1 to m do begin
    read(x1,y1,x2,y2);
    FindWalls(x1,y1,x2-x1,y2-y1);
    FindWalls(x2,y2,x1-x2,y1-y2);
  end;
end;
{}
Procedure Out;
var
  i,j,k,t : LongInt;
begin
  assign(output,outfile);
  rewrite(output);
  if ku[1,1,2,n]=win then begin
    writeln('king wins');
    writeln(kn[1,1,2,n]);
  end else
  if ku[1,1,2,n]=lose then begin
    writeln('queen wins');
    writeln(kn[1,1,2,n]);
  end else writeln('draw');

  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),true);
  fillchar(qu,sizeof(qu),0);
  fillchar(ku,sizeof(ku),0);
  fillchar(qn,sizeof(qn),0);
  fillchar(kn,sizeof(kn),0);
  fillchar(u,sizeof(u),0);
end;
{}
Function Sn(x : LongInt) : LongInt;
begin
  if x>0 then Sn:=1
  else if x<0 then Sn:=-1
  else Sn:=0;
end;
{}
Function Min(q,w : LongInt) : LongInt;
begin
  if q<w then min:=q else min:=w;
end;
{}
Function Max(q,w : LongInt) : LongInt;
begin
  if q>w then max:=q else max:=w;
end;
{}
Function King(x1,y1,x2,y2,h : LongInt) : Byte; forward;
{}
Function KingAble(x1,y1 : LongInt; var x2,y2 : LongInt) : Boolean;
var
  i,j : LongInt;
  xx,yy : LongInt;
begin
  if (x1<1) or (x1>2) or (y1<1) or (y1>n) then begin
    KingAble:=false;
    exit;
  end;
  xx:=x2-x1; yy:=y2-y1;
  if (abs(xx)<>abs(yy)) and (xx<>0) and (yy<>0) then KingAble:=true
  else begin
    xx:=Sn(xx); yy:=Sn(yy);
    for i:=0 to 7 do
      if (xx=dx[i]) and (yy=dy[i]) then begin
        j:=i; break;
      end;

    while (x1<>x2) or (y1<>y2) do begin
      if not a[x1,y1,j] then begin
        KingAble:=true; exit;
      end;
      inc(x1,xx); inc(y1,yy);
      if (x1<1) or (x1>2) or (y1<1) or (y1>n) then begin
        KingAble:=true;
        exit;
      end;
    end;
    KingAble:=false;
  end;
end;
{}
Function QueenAble(x1,y1,x2,y2 : LongInt) : Boolean;
var
  i : LongInt;
begin
  QueenAble:=true;
  for i:=1 to 4 do
    if a[x1,y1,km[i]] and (x1+dx[km[i]]=x2) and (y1+dy[km[i]]=y2) then QueenAble:=false;
end;
{}
Function Queen(x1,y1,x2,y2,h : LongInt) : Byte;
var
  i,j,k : LongInt;
  x,y,hn : LongInt;
begin
  if qu[x1,y1,x2,y2]>1 then Queen:=qu[x1,y1,x2,y2]
  else if qu[x1,y1,x2,y2]=1 then begin
    Queen:=draw;
  end else
  if h=0 then begin
    Queen:=draw;
  end else begin
    qu[x1,y1,x2,y2]:=1; hn:=h-1;
    for i:=0 to 7 do begin
      x:=x2+dx[i]; y:=y2+dy[i];
      while (x>0) and (x<3) and (y>0) and (y<n+1) and a[x-dx[i],y-dy[i],i] do begin
        if QueenAble(x1,y1,x,y) then begin
          k:=King(x1,y1,x,y,hn);

          if k=lose then begin
            if (qu[x1,y1,x2,y2]=1) or (qu[x1,y1,x2,y2]=draw) then begin
              qn[x1,y1,x2,y2]:=kn[x1,y1,x,y]+1;
              hn:=qn[x1,y1,x2,y2]-1;
            end else begin
              qn[x1,y1,x2,y2]:=min(qn[x1,y1,x2,y2],kn[x1,y1,x,y]+1);
              hn:=qn[x1,y1,x2,y2]-1;
            end;
            qu[x1,y1,x2,y2]:=win;
          end else
          if (qu[x1,y1,x2,y2]=1) and (k=draw) then begin
            qu[x1,y1,x2,y2]:=draw;
          end else
          if qu[x1,y1,x2,y2]=1 then begin
            qn[x1,y1,x2,y2]:=max(qn[x1,y1,x2,y2],
                                 kn[x1,y1,x,y]+1);
          end;
        end;
        x:=x+dx[i]; y:=y+dy[i];
      end;

    end;

    if qu[x1,y1,x2,y2]=1 then qu[x1,y1,x2,y2]:=lose;
    Queen:=qu[x1,y1,x2,y2];
  end;
end;
{}
Function King(x1,y1,x2,y2,h : LongInt) : Byte;
var
  i,q,hn : LongInt;
begin
  if ku[x1,y1,x2,y2]>1 then King:=ku[x1,y1,x2,y2]
  else if ku[x1,y1,x2,y2]=1 then begin
    King:=draw;
  end else
  if h=0 then begin
    King:=draw;
  end else begin
    ku[x1,y1,x2,y2]:=1; hn:=h-1;

    for i:=1 to 4 do
      if a[x1,y1,km[i]] and KingAble(x1+dx[km[i]],y1+dy[km[i]],x2,y2) then begin
        q:=Queen(x1+dx[km[i]],y1+dy[km[i]],x2,y2,hn);

        if q=lose then begin
          if (ku[x1,y1,x2,y2]=1) or (ku[x1,y1,x2,y2]=draw) then begin
            kn[x1,y1,x2,y2]:=qn[x1+dx[km[i]],y1+dy[km[i]],x2,y2]+1;
            hn:=kn[x1,y1,x2,y2]-1;
          end else begin
            kn[x1,y1,x2,y2]:=min(kn[x1,y1,x2,y2],
                                 qn[x1+dx[km[i]],y1+dy[km[i]],x2,y2]+1);
            hn:=kn[x1,y1,x2,y2]-1;
          end;
          ku[x1,y1,x2,y2]:=win;
        end else
        if (ku[x1,y1,x2,y2]=1) and (q=draw) then begin
          ku[x1,y1,x2,y2]:=draw;
        end else
        if ku[x1,y1,x2,y2]=1 then begin
          kn[x1,y1,x2,y2]:=max(kn[x1,y1,x2,y2],
                               qn[x1+dx[km[i]],y1+dy[km[i]],x2,y2]+1);
        end;
      end;

    if ku[x1,y1,x2,y2]=1 then ku[x1,y1,x2,y2]:=lose;
    King:=ku[x1,y1,x2,y2];
  end;
end;
{}
Procedure Dfs(x,y,h : LongInt);
var
  i : LongInt;
begin
  if (x<1) or (x>2) or (y<1) or (y>n) then exit;
  if u[x,y]>0 then exit;
  u[x,y]:=h;
  for i:=1 to 4 do
    if a[x,y,km[i]] then Dfs(x+dx[km[i]],y+dy[km[i]],h+1);
end;
{}
Procedure Solve;
var
  i,j : LongInt;
begin
  King(1,1,2,n,hmax);


  if ku[1,1,2,n]=draw then begin
    Dfs(1,1,1);
    if u[2,n]>0 then begin
      if odd(u[2,n]) then begin
        ku[1,1,2,n]:=lose;
        kn[1,1,2,n]:=(u[2,n]-2)*2;
      end else begin
        ku[1,1,2,n]:=win;
        kn[1,1,2,n]:=u[2,n]-3;
        if odd(kn[1,1,2,n] div 2) then kn[1,1,2,n]:=2*kn[1,1,2,n]-1
                                  else kn[1,1,2,n]:=2*kn[1,1,2,n]+1;
      end;
    end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.