program Temp;
const infile = 'thruput.in';
      outfile = 'thruput.out';
      osn = 1 shl 18;
      inf = 1000000000;
      MAXN = 100000;
type
int = longint;
rec1 = record
  val, v : int;
end;
TEdge = record
  A, B, c : int;
end;
var N, cur : int;
    Rmq : array[1..2*osn] of rec1;
    R, h, p, ed, GA : array[1..MAXN] of int;
    GB : array[1..MAXN*2] of TEdge;
    vis : array[1..MAXN] of boolean;
    L, E : array[1..2*MAXN] of int;

function max(a, b : int) : int;
begin
  if a>b then max:=a else max:=b;
end;

function min(a, b : int) : int;
begin
  if a<b then min:=a else min:=b;
end;

function getmin(a, b : rec1) : rec1;
begin
  if a.val > b.val then getmin:=b else getmin:=a;
end;

procedure buildtree(n : int);
var i : int;
begin
  for i:=1 to osn*2 do Rmq[i].val:=inf;
  for i:=1 to n do
  begin
    Rmq[i+osn-1].val:=L[i];
    Rmq[i+osn-1].v:=i;
  end;
  for i:=osn-1 downto 1 do
  begin
    Rmq[i]:=getmin(Rmq[i*2], Rmq[i*2+1]);
  end;
end;

function query(st, fin : int) : rec1;
var ans : rec1;
    i, j : int;
begin
  ans.v:=0; ans.val:=inf;
  i:=st+osn-1; j:=fin+osn-1;
  while i<=j do
  begin
    ans:=getmin(ans, Rmq[i]);
    ans:=getmin(ans, Rmq[j]);
    i:=(i+1) div 2;
    j:=(j-1) div 2;
  end;
  query:=ans;
end;

function LCA(u, v : int) : int;
var ans : rec1;
begin
  ans:=query(min(R[u], R[v]), max(R[u], R[v]));
  LCA:=E[ans.v];
end;

procedure EulerTour(u, he : int);
var j : int;
begin
  inc(cur); E[cur]:=u; h[u]:=he; vis[u]:=true; j:=GA[u];
  while j<>0 do
  begin
    if not vis[GB[j].A] then begin
      EulerTour(GB[j].A, he+1);
      inc(cur); E[cur]:=u; p[GB[j].A]:=u; ed[GB[j].A]:=j;
    end;
    j:=GB[j].B;
  end;
end;

procedure ReadData;
var i, u, v, c, tm : int;
    l : array[1..MAXN] of int;

procedure add(u, v, c : int);
begin
  inc(tm); GB[tm].A:=v; GB[tm].B:=0; GB[tm].c:=c;
  if l[u]=0 then GA[u]:=tm else GB[l[u]].B:=tm;
  l[u]:=tm;
end;

begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N);
  fillchar(l, sizeof(l), 0); tm:=0;
  for i:=1 to N-1 do
  begin
    read(u, v, c);
    add(u, v, c);
    add(v, u, c);
  end;
end;

function GetPath(u, v : int) : int;
var ans : int;
begin
  ans:=-inf;
  while v<>u do
  begin
    ans:=max(ans, GB[ed[v]].c);
    v:=p[v];
  end;
  GetPath:=ans;
end;

procedure ChangeKey(e, val : int);
var te : int;
begin
  if e mod 2=1 then te:=e+1 else te:=e-1;
  GB[e].c:=val; GB[te].c:=val;
end;

procedure Solve;
var i, lc, u, v : int;
    ch : char;
begin
  fillchar(vis, sizeof(vis), false); cur:=0;
  fillchar(R, sizeof(R), 0);
  EulerTour(1, 0);
  for i:=1 to N*2-1 do L[i]:=h[E[i]];
  for i:=1 to N*2-1 do if R[E[i]]=0 then R[E[i]]:=i;
  buildtree(2*N-1);
  repeat
    read(ch);
    if ch = 'C' then begin
      for i:=1 to 5 do read(ch);
      read(u, v); ChangeKey(u, v);
    end;
    if ch = 'Q' then begin
      for i:=1 to 4 do read(ch);
      read(u, v); lc:=LCA(u, v);
      if lc = u then i:=GetPath(u, v)
      else if lc = v then i:=GetPath(v, u)
      else i:=max(GetPath(lc, u), GetPath(lc, v));
      writeln(i);
    end;
  until ch = 'D';
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
