program Temp;
uses Sysutils;
const infile = 'triples.in';
      outfile = 'triples.out';
      TLIMIT = 0.1875;
      MAXN = 100;
type int = longint;
var oldt : TDateTime;
    b, d, g : array[1..MAXN, 1..MAXN] of longint;
    ab, ad, ag, fd : array[1..MAXN] of longint;
    ar, art1, art2 : array[1..MAXN*MAXN] of longint;
    N : longint;

function tl : boolean;
begin
  tl:=(now-oldt)*3600>=TLIMIT;
end;

procedure ReadData;
var i, j : longint;
begin
  oldt:=now;
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N);
  for i:=1 to N do
    for j:=1 to N do read(b[i, j]);
  for i:=1 to N do
    for j:=1 to N do read(d[i, j]);
  for i:=1 to N do
    for j:=1 to N do read(g[i, j]);
end;

procedure swap(var A, B : int);
var t : int;
begin
  t:=A; A:=B; B:=t;
end;

procedure Heapify(i, hs : int);
var l, r, largest : int;
begin
  repeat
    l:=2*i; r:=2*i+1; largest:=i;
    if (l<=hs)and(ar[l]<ar[largest]) then largest:=l;
    if (r<=hs)and(ar[r]<ar[largest]) then largest:=r;
    if largest=i then break;
    swap(ar[i], ar[largest]);
    swap(art1[i], art1[largest]);
    swap(art2[i], art2[largest]);
    i:=largest;
  until false;
end;

procedure HeapSort;
var i : int;
begin
  for i:=(N*N div 2) downto 1 do Heapify(i, N*N);
  for i:=N*N downto 2 do
  begin
    swap(ar[i], ar[1]);
    swap(art1[i], art1[1]);
    swap(art2[i], art2[1]);
    Heapify(1,i-1);
  end;
end;

procedure find(var a, b : int);
var i, j : longint;
    ta, tb : longint;
begin
  ta:=0; tb:=0;
  for i:=1 to N do
    for j:=1 to N do
    begin
      if i=j then continue;
      if d[i, ad[i]]+g[ad[i], fd[i]]+d[j, ad[j]]+g[ad[j], fd[j]] < d[i, ad[j]]+g[ad[j], fd[i]]+d[j, ad[i]]+g[ad[i], fd[j]] then
      begin ta:=i; tb:=j; end;
    end;
  a:=ta; b:=tb;
end;

procedure Solve;
var i, j, t : int;
begin
  for i:=1 to N do
    for j:=1 to N do
      begin ar[(i-1)*N+j]:=b[i, j]; art1[(i-1)*N+j]:=i; art2[(i-1)*N+j]:=j; end;
  HeapSort;
  fillchar(ab, sizeof(ab), 0);
  fillchar(ad, sizeof(ad), 0);
  for i:=1 to N*N do
    if (ab[art1[i]]=0)and(ad[art2[i]]=0) then
      begin ab[art1[i]]:=art2[i]; ad[art2[i]]:=art1[i]; fd[art2[i]]:=art1[i]; end;

  for i:=1 to N do
    for j:=1 to N do
      begin ar[(i-1)*N+j]:=d[i, j]; art1[(i-1)*N+j]:=i; art2[(i-1)*N+j]:=j; end;
  HeapSort;
  fillchar(ad, sizeof(ad), 0);
  fillchar(ag, sizeof(ag), 0);
  for i:=1 to N*N do
    if (ad[art1[i]]=0)and(ag[art2[i]]=0) then
      begin ad[art1[i]]:=art2[i]; ag[art2[i]]:=art1[i]; end;

  while true do begin
    if tl then break;
    find(i, j); if (i=0)or(j=0) then break;
    t:=ad[j]; ad[j]:=ad[i]; ad[i]:=t;
  end;

  for i:=1 to N do
    writeln(i, ' ', ab[i], ' ', ad[ab[i]]);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
