{$A-,B-,D-,E-,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-,Y-}
{$M 16384,0,655360}

Const MaxN=100;
Const STOPNUM100=1950000;
      C=0.97;
      CT=3.5;

Const INPUTFILE='triples.in';
      OUTPUTFILE='triples.out';

Type Real=Double;
     State=Array[1..MaxN,1..3] of Byte;
var a:Array[1..MaxN,1..MaxN,1..3] of Word;
    T0:Real;
    Ans:State;
    WMax:Longint;
    BaseState,S,NextS:State;

    N:Longint;

    i,j,k:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N);
for k:=1 to 3 do
for i:=1 to N do
for j:=1 to N do
  Read(a[i,j,k]);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
for i:=1 to N do
begin
  for j:=1 to 3 do
    Write(Ans[i,j],' ');
  Writeln;
end;
Close(Output);
Halt;
end;

Function Weight(var S:State):Longint;
var i,j,k,g:Longint;
begin
g:=0;
for i:=1 to N do
  Inc(g,a[S[i,1],S[i,2],1]+a[S[i,2],S[i,3],2]+a[S[i,3],S[i,1],3]);
Weight:=g;
end;

Procedure BurnIt;
var T,y,Alpha,P:Real;
    OneDiv3N:Real;
    dE:Longint;
    b:Array[1..MaxN] of Byte;
    H,NextH:Array[1..MaxN,1..3] of byte;
    i,j,k,l,g:Longint;
    Num,Stay,STOPNUM:Longint;
    f:Boolean;
begin
{Randomizer}
g:=N;
for k:=1 to 3 do
for i:=1 to N do
for j:=1 to N do
begin
  Inc(g,a[i,j,k]);
  if a[i,j,k]>T0 then T0:=a[i,j,k];
end;
RandSeed:=g;
{Base state}
OneDiv3N:=1/(3*N);
T0:=T0*CT;
STOPNUM:=Round((STOPNUM100 div N)*(0.75+0.0025*N));
for k:=1 to 3 do
for i:=1 to N do
  BaseState[i,k]:=i;

S:=BaseState;
for k:=1 to 3 do
begin
  for i:=N downto 1 do
  begin
    j:=Random(i)+1;
    g:=S[i,k];
    S[i,k]:=S[j,k];
    S[j,k]:=g;
    H[i,k]:=j;
  end;
end;
WMax:=Weight(S);
Ans:=S;
T:=T0;
K:=0;
Num:=0;
{The burn itself}
Repeat
  Stay:=0;
  Repeat
    {Generate new state}
    NextS:=BaseState;
    for j:=1 to 3 do
    for i:=N downto 1 do
    begin
      Alpha:=Random;
      y:=T*(Exp(Ln(1+1/T)*Abs(2*Alpha-1))-1);
      if Alpha<0.5 then y:=-y;
      g:=Round(y*(N-1)+H[i,j]);
      if g<1 then g:=1;
      if g>N then g:=N;
      NextH[i,j]:=g;
      l:=NextS[i,j];
      NextS[i,j]:=NextS[g,j];
      NextS[g,j]:=l;
    end;

    {Should we change our current state?}
    g:=0;
    l:=0;
    for i:=1 to N do
    begin
      Inc(g,a[NextS[i,1],NextS[i,2],1]+a[NextS[i,2],NextS[i,3],2]+a[NextS[i,3],NextS[i,1],3]);
      Inc(l,a[S[i,1],S[i,2],1]+a[S[i,2],S[i,3],2]+a[S[i,3],S[i,1],3]);
    end;
    dE:=g-l;
    P:=Exp(dE/T){+0.1*Stay/(Num+1)}; {Special for ultrafast burn}
    f:=False;
    if Random<P then
    begin
      S:=NextS;
      H:=NextH;
      l:=g;
      f:=True;
    end;
    Inc(Num);
  Until (f) OR (Num=STOPNUM);
  if WMax<l then
  begin
    Ans:=S;
    WMax:=l;
  end;
  Inc(K);
  {Ultrafast burn}
  T:=T0*Exp(-C*Exp(Ln(K)*OneDiv3N));
Until Num=STOPNUM;
end;

Procedure Solve;
var g,h:Longint;
begin
BurnIt;
FWrite(1543);
end;

begin
FRead;
Solve;
end.