uses Math;
const
     FileIn='thruput.in';
     FileOut='thruput.out';
     MaxN=100000;
     MaxActions=100000;
     MaxQueries=MaxActions;
     atQuery=0;
     atChange=1;
     atDone=2;
type
    PLink=^TLink;
    TLink=record
                Id: LongInt;
                Destination: LongInt;
                Next: PLink;
          end;
    TNode=record
                First, Last: PLink;
          end;
    TEdge=record
                T: LongInt;
          end;
    TAction=record
                  ActionType: Byte;
                  Param1, Param2: LongInt;
            end;
var
   N: LongInt;
   Nodes: array [1..MaxN] of TNode;
   Edges: array [1..MaxN-1] of TEdge;
   ActionsCount: LongInt;
   Actions: array [1..MaxActions] of TAction;
   ResponsesCount: LongInt;
   Responses: array [1..MaxQueries] of LongInt;

procedure AddLink (aNode: LongInt; aDestination: LongInt; aId: LongInt);
begin
     with Nodes [aNode]
          do begin
             if Assigned (Last)
                then begin
                     New (Last^.Next);
                     Last:=Last^.Next;
                end
                else begin
                     New (Last);
                     First:=Last;
                end;
             with Last^
                  do begin
                     Id:=aId;
                     Destination:=aDestination;
                     Next:=nil;
                  end;
          end;
end;

procedure ReadData;
var
   F: Text;
   NEdge: LongInt;
   U, V, T: LongInt;
   Ch: Char;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NEdge:=1 to N-1
         do begin
            Readln (F, U, V, T);
            Edges [NEdge].T:=T;
            AddLink (U, V, NEdge);
            AddLink (V, U, NEdge);
         end;
     ActionsCount:=0;
     while not EOF (F)
           do begin
              Inc (ActionsCount);
              Read (F, Ch);
              with Actions [ActionsCount]
                   do begin
                      case Ch of
                           'Q': ActionType:=atQuery;
                           'C': ActionType:=atChange;
                           'D': ActionType:=atDone;
                      end;
                      case ActionType of
                           atQuery, atChange: begin
                                                   repeat
                                                         Read (F, Ch);
                                                   until Ch=#32;
                                                   Readln (F, Param1, Param2);
                                              end;
                           atDone: begin
                                        Readln (F);
                                        Break;
                                   end;
                      end;
                   end;
           end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NResponse: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NResponse:=1 to ResponsesCount
         do Writeln (F, Responses [NResponse]);
     Close (F);
end;

type
    TFIFOItem=record
                    Node, From: LongInt;
                    Value: LongInt;
              end;
var
   FIFO: array [1..MaxN] of TFIFOItem;
   FIFOLen, FIFOItem: LongInt;

procedure BFS (aStartNode, aFinishNode: LongInt);
var
   Link: PLink;
   Stop: Boolean;
begin
     FIFOLen:=1;
     with FIFO [FIFOLen]
          do begin
             Node:=aStartNode;
             From:=0;
             Value:=0;
          end;
     FIFOItem:=0;
     Stop:=false;
     while (FIFOItem<FIFOLen) and (not Stop)
           do begin
              Inc (FIFOItem);
              Link:=Nodes [FIFO [FIFOItem].Node].First;
              while Assigned (Link)
                    do begin
                       if Link^.Destination<>FIFO [FIFOItem].From
                          then begin
                               Inc (FIFOLen);
                               FIFO [FIFOLen].Node:=Link^.Destination;
                               FIFO [FIFOLen].From:=FIFO [FIFOItem].Node;
                               FIFO [FIFOLen].Value:=Max (FIFO [FIFOItem].Value, Edges [Link^.Id].T);
                               if Link^.Destination=aFinishNode
                                  then begin
                                       Stop:=true;
                                       Break;
                                  end;
                          end;
                       Link:=Link^.Next;
                    end;
           end;
end;

procedure Solve;
var
   NAction: LongInt;
begin
     for NAction:=1 to ActionsCount
         do with Actions [NAction]
                 do case ActionType of
                         atQuery: begin
                                       BFS (Param1, Param2);
                                       Inc (ResponsesCount);
                                       Responses [ResponsesCount]:=FIFO [FIFOLen].Value;
                                  end;
                         atChange: Edges [Param1].T:=Param2;
                         atDone: Break;
                    end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
