const
     FileIn='triples.in';
     FileOut='triples.out';
     MaxN=100;
type
    TTriple=record
                  Boy, Girl, Dog: Byte;
                  Value: LongInt;
            end;
var
   N: LongInt;
   A, B, C: array [1..MaxN, 1..MaxN] of LongInt;
   TriplesCount: LongInt;
   Triples: array [1..MaxN*MaxN*MaxN] of TTriple;
   UsedGirls, UsedBoys, UsedDogs: array [1..MaxN] of Boolean;
   AnswerLength: LongInt;
   Answer: array [1..MaxN] of LongInt;

procedure ReadData;
var
   F: Text;
   i, j: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for i:=1 to N
         do for j:=1 to N
                do Read (F, A [i, j]);
     for i:=1 to N
         do for j:=1 to N
                do Read (F, B [i, j]);
     for i:=1 to N
         do for j:=1 to N
                do Read (F, C [i, j]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NItem:=1 to AnswerLength
         do with Triples [Answer [NItem]]
                 do Writeln (F, Boy, #32, Dog, #32, Girl);
     Close (F);
end;

procedure Swap (var aA, aB: TTriple);
var
   Temp: TTriple;
begin
     Temp:=aA;
     aA:=aB;
     aB:=Temp;
end;

procedure QSort (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   MiddleValue: LongInt;
begin
     i:=aLeft;
     j:=aRight;
     MiddleValue:=Triples [(aLeft+aRight) shr 1].Value;
     repeat
           while Triples [i].Value<MiddleValue
                 do Inc (i);
           while MiddleValue<Triples [j].Value
                 do Dec (j);
           if i<=j
              then begin
                   Swap (Triples [i], Triples [j]);
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSort (aLeft, j);
     if i<aRight
        then QSort (i, aRight);
end;

procedure Solve;
var
   i, j, k: LongInt;
begin
     TriplesCount:=0;
     for i:=1 to N
         do for j:=1 to N
                do for k:=1 to N
                       do begin
                          Inc (TriplesCount);
                          with Triples [TriplesCount]
                               do begin
                                  Boy:=i;
                                  Girl:=j;
                                  Dog:=k;
                                  Value:=A [Boy, Dog]+B [Dog, Girl]+C [Girl, Boy];
                               end;
                       end;
     QSort (1, TriplesCount);
     FillChar (UsedBoys, SizeOf (UsedBoys), false);
     FillChar (UsedGirls, SizeOf (UsedGirls), false);
     FillChar (UsedDogs, SizeOf (UsedDogs), false);
     AnswerLength:=0;
     for i:=TriplesCount downto 1
         do with Triples [i]
                 do if not (UsedBoys [Boy] or UsedGirls [Girl] or UsedDogs [Dog])
                       then begin
                            Inc (AnswerLength);
                            Answer [AnswerLength]:=i;
                            UsedBoys [Boy]:=true;
                            UsedGirls [Girl]:=true;
                            UsedDogs [Dog]:=true;
                       end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
