{$H+}
const
     FileIn='quest.in';
     FileOut='quest.out';
     MaxN=8;
     MaxItems=200;
     MaxM=MaxN*MaxN;
type
    TItemList=record
                    Count: LongInt;
                    Items: array [1..MaxItems] of LongInt;
              end;
    TPerson=record
                  Name: LongInt;
                  Give: TItemList;
                  Take: TItemList;

                  Used: Boolean;
            end;
    TObject=TPerson;
    TRoom=record
                Name: LongInt;
                PersonsCount: LongInt;
                Persons: array [1..MaxItems] of TPerson;
                ObjectsCount: LongInt;
                Objects: array [1..MaxItems] of TObject;
                Garbage: TItemList;

                FirstTimeHere: Boolean;
                State: Byte;
          end;
    TDoor=record
                Room1, Room2: LongInt;
                Key: LongInt;

                Opened: Boolean;
          end;
var
   N, M: LongInt;
   Rooms: array [1..MaxN] of TRoom;
   Doors: array [1..MaxM] of TDoor;
   StartRoom, PrincessRoom: LongInt;

   StringsCount: LongInt;
   Strings: array [1..MaxN*100] of string;

   F: Text;

   Own: TItemList;

function Normalize (aString: string): string;
var
   Start, Finish: LongInt;
begin
     for Start:=1 to Length (aString)
         do if aString [Start]<>#32
               then Break;
     for Finish:=Length (aString) downto 1
         do if aString [Finish]<>#32
               then Break;
     Normalize:=Copy (aString, Start, Finish-Start+1);
end;

function GetStringId (aString: string): LongInt;
var
   NItem: LongInt;
begin
     for NItem:=1 to StringsCount
         do if Strings [NItem]=aString
               then begin
                    GetStringId:=NItem;
                    Exit;
               end;
     Inc (StringsCount);
     Strings [StringsCount]:=aString;
     GetStringId:=StringsCount;
end;

function GetRoomId (aRoom: LongInt): LongInt;
var
   NItem: LongInt;
begin
     for NItem:=1 to N
         do if Rooms [NItem].Name=aRoom
               then begin
                    GetRoomId:=NItem;
                    Exit;
               end;
end;

procedure DelFromItemList (var aItemList: TItemList; aIndex: LongInt);
begin
     with aItemList
          do begin
             Items [aIndex]:=Items [Count];
             Dec (Count);
          end;
end;

procedure AddToItemList (var aItemList: TItemList; aValue: LongInt);
begin
     with aItemList
          do begin
             Inc (Count);
             Items [Count]:=aValue;
          end;
end;

procedure ReadData;

procedure ParseItemList (aString: string; var aItemList: TItemList);
var
   NChar: LongInt;
   Buf: string;

procedure FlushBuf;
begin
     Buf:=Normalize (Buf);
     if Length (Buf)>0
        then begin
             AddToItemList (aItemList, GetStringId (Buf));
             Buf:='';
        end;
end;

begin
     with aItemList
          do begin
             Count:=0;
             Buf:='';
             for NChar:=1 to Length (aString)
                 do if aString [NChar]=','
                       then FlushBuf
                       else Buf:=Buf+aString [NChar];
             FlushBuf;
          end;
end;

procedure ReadPerson (var aPerson: TPerson);
var
   S: string;
begin
     with aPerson
          do begin
             Readln (F, S);
             Name:=GetStringId (S);
             Readln (F, S);
             ParseItemList (S, Give);
             Readln (F, S);
             ParseItemList (S, Take);
             Used:=false;
          end;
end;

procedure ReadObject (var aObject: TObject);
begin
     ReadPerson (aObject);
end;

var
   NRoom, NDoor, NPerson, NObject, NGarbage: LongInt;
   S: string;
begin
     StringsCount:=0;

     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NRoom:=1 to N
         do begin
            Readln (F, S);
            Rooms [NRoom].Name:=GetStringId (S);
            Rooms [NRoom].State:=0;
            Rooms [NRoom].FirstTimeHere:=true;
         end;
     Readln (F, M);
     for NDoor:=1 to M
         do with Doors [NDoor]
                 do begin
                    Readln (F, Room1, Room2, S);
                    Key:=GetStringId (Normalize (S));
                    Opened:=false;
                 end;
     for NRoom:=1 to N
         do with Rooms [NRoom]
                 do begin
                    Readln (F, PersonsCount, ObjectsCount, Garbage.Count);
                    for NPerson:=1 to PersonsCount
                        do ReadPerson (Persons [NPerson]);
                    for NObject:=1 to ObjectsCount
                        do ReadObject (Objects [NObject]);
                    for NGarbage:=1 to Garbage.Count
                        do begin
                           Readln (F, S);
                           Garbage.Items [NGarbage]:=GetStringId (S);
                        end;
                 end;
     Readln (F, S);
     StartRoom:=GetRoomId (GetStringId (S));
     Readln (F, S);
     PrincessRoom:=GetRoomId (GetStringId (S));
     Close (F);
end;

function FormatItemList (const aItemList: TItemList): string;
var
   NItem: LongInt;
   Formatted: string;
begin
     with aItemList
          do if Count=0
                then Formatted:=''
                else begin
                     Formatted:=Strings [Items [1]];
                     for NItem:=2 to Count-1
                         do Formatted:=Formatted+', '+Strings [Items [NItem]];
                     if Count>1
                        then Formatted:=Formatted+' and '+Strings [Items [Count]];
                end;
     FormatItemList:=Formatted;
end;

function SearchInItemList (aItem: LongInt; aItemList: TItemList): LongInt;
var
   NItem: LongInt;
begin
     for NItem:=1 to aItemList.Count
         do if aItemList.Items [NItem]=aItem
               then begin
                    SearchInItemList:=NItem;
                    Exit;
               end;
     SearchInItemList:=0;
end;

function UseObject (var aObject: TObject): Boolean;
var
   NItem: LongInt;
begin
     if aObject.Used
        then begin
             UseObject:=false;
             Exit;
        end;
     for NItem:=1 to aObject.Give.Count
         do if SearchInItemList (aObject.Give.Items [NItem], Own)=0
               then begin
                    UseObject:=false;
                    Exit;
               end;
     Writeln (F, 'use ', FormatItemList (aObject.Give), ' on ', Strings [aObject.Name]);
     for NItem:=1 to aObject.Take.Count
         do begin
            Inc (Own.Count);
            Own.Items [Own.Count]:=aObject.Take.Items [NItem];
         end;
     Writeln (F, 'take ', FormatItemList (aObject.Take), ' from ', Strings [aObject.Name]);
     aObject.Used:=true;
     UseObject:=true;
end;

function UsePerson (var aPerson: TPerson): Boolean;
var
   NItem: LongInt;
begin
     if aPerson.Used
        then begin
             UsePerson:=false;
             Exit;
        end;
     for NItem:=1 to aPerson.Give.Count
         do if SearchInItemList (aPerson.Give.Items [NItem], Own)=0
               then begin
                    UsePerson:=false;
                    Exit;
               end;
     Writeln (F, 'talk to ', Strings [aPerson.Name]);
     Writeln (F, 'give ', FormatItemList (aPerson.Give), ' to ', Strings [aPerson.Name]);
     for NItem:=1 to aPerson.Give.Count
         do DelFromItemList (Own, SearchInItemList (aPerson.Give.Items [NItem], Own));
     for NItem:=1 to aPerson.Take.Count
         do begin
            Inc (Own.Count);
            Own.Items [Own.Count]:=aPerson.Take.Items [NItem];
         end;
     Writeln (F, 'take ', FormatItemList (aPerson.Take), ' from ', Strings [aPerson.Name]);
     aPerson.Used:=true;
     UsePerson:=true;
end;

function OpenDoor (var aDoor: TDoor): Boolean;
var
   Index: LongInt;
begin
     if not aDoor.Opened
        then begin
             Index:=SearchInItemList (aDoor.Key, Own);
             if Index>0
                then begin
                     DelFromItemList (Own, Index);
                     aDoor.Opened:=true;
                     OpenDoor:=true;
                     Exit;
                end;
        end;
     OpenDoor:=false;
end;

function DevelopRoom (aRoomName: LongInt): Boolean;
var
   Id: LongInt;
   Changed: Boolean;
   NObject, NPerson, NGarbage, NDoor, NewRoom: LongInt;
   GoodDoor: Boolean;
begin
     if aRoomName=PrincessRoom
        then begin
             Writeln (F, 'save princess');
             Close (F);
             Halt (0);
        end;
     Id:=GetRoomId (aRoomName);
     Rooms [Id].State:=1;
     DevelopRoom:=false;
     repeat
           Changed:=false;
           if Rooms [Id].FirstTimeHere
              then begin
                   for NGarbage:=1 to Rooms [Id].Garbage.Count
                       do begin
                          Writeln (F, 'pick ', Strings [Rooms [Id].Garbage.Items [NGarbage]]);
                          AddToItemList (Own, Rooms [Id].Garbage.Items [NGarbage]);
                          Changed:=true;
                       end;
                   Rooms [Id].FirstTimeHere:=false;
              end;
           for NObject:=1 to Rooms [Id].ObjectsCount
               do if UseObject (Rooms [Id].Objects [NObject])
                     then Changed:=true;
           for NPerson:=1 to Rooms [Id].PersonsCount
               do if UsePerson (Rooms [Id].Persons [NPerson])
                     then Changed:=true;
           NDoor:=0;
           while NDoor<M
                 do begin
                    Inc (NDoor);
                    GoodDoor:=false;
                    if Doors [NDoor].Room1=Id
                       then begin
                            NewRoom:=Doors [NDoor].Room2;
                            GoodDoor:=true;
                       end
                       else begin
                            NewRoom:=Doors [NDoor].Room1;
                            GoodDoor:=Doors [NDoor].Room2=Id;
                       end;
                    if GoodDoor
                       then begin
                            if OpenDoor (Doors [NDoor])
                               then Writeln (F, 'open door to ', Strings [Rooms [NewRoom].Name]);
                            if (Doors [NDoor].Opened) and (Rooms [NewRoom].State=0)
                               then begin
                                    Writeln (F, 'go to ', Strings [Rooms [NewRoom].Name]);
                                    if DevelopRoom (Rooms [NewRoom].Name)
                                       then Changed:=true;
                                    Writeln (F, 'go to ', Strings [aRoomName]);
                               end;
                       end
                 end;
           if Changed
              then DevelopRoom:=true;
     until not Changed;
     Rooms [Id].State:=0;
end;

procedure Solve;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Own.Count:=0;
     DevelopRoom (StartRoom);
     Close (F);
     Rewrite (F);
     Writeln (F, 'dead princess');
     Close (F);
end;

begin
     ReadData;
     Solve;
end.
