{$LONGSTRINGS ON}
program zzz;

const
  modulo = 10193;

type
  phash = ^thash;
  thash = record
    next: phash;
    st: string;
  end;

var
  buf: phash;
  r: array[1..300] of Longint;
  uspers,usroom,usobj: array[1..200] of Boolean;
  nroom,ndoors,sco,scp,nitem,stroom,finroom,scpers,scobj: Longint;
  nameobj: array[1..200] of string;
  nobj: array[1..200] of Longint;
  lobj: array[1..200] of phash;
  l1obj: array[1..200] of phash;
  namepers: array[1..200] of string;
  npers: array[1..200] of Longint;
  lpers: array[1..200] of phash;
  l1pers: array[1..200] of phash;
  item: array[1..200] of phash;
  room: array[1..8] of String;
  null: phash;
  curroom,i,j,k,n,m: Longint;
  progress: Boolean;
  useroom: array[1..8] of Boolean;
  open: array[1..8,1..8] of Boolean;
  kneed: array[1..8,1..8] of string;
  vis1,vis: array[1..8,1..200] of Boolean;
  vs: array[1..8] of Boolean;
  st: string;
  h: array[0..modulo] of phash;

procedure delspace(var st: string);
begin
  while st[1] = ' ' do delete(st,1,1);
  while st[length(st)] = ' ' do delete(st,length(st),1);
end;

function gethash(st: string): Longint;
var i,j: longint;
begin
  j := 0;
  for i := 1 to length(st) do begin
    j := (j + r[i] * ord(st[i])) mod modulo;
  end;
  gethash := j;
end;

function readword(var st: string): Boolean;
var ch: char;
begin
  st := '';
  if eoln then begin
    readword := false;
    exit;
  end;
  readword := true;
  while true do begin
    if eoln(input) then break;
    read(ch);
    if (ch = ',') then break;
    st := st + ch;
  end;
end;

procedure hashadd(st: string);
var hf: Longint;
    buf: phash;
begin
  hf := gethash(st);
  new(buf);
  buf^.next := h[hf];
  h[hf] := buf;
  buf^.st := st;
end;

function hsearch(st: string): Boolean;
var hf: Longint;
    buf: phash;
begin
  hf := gethash(st);
  buf := h[hf];
  hsearch := true;
  while buf <> null do begin
    if buf^.st = st then exit;
    buf := buf^.next;
  end;
  hsearch := false;
end;

procedure hashdel(st: string);
var cur,buf: phash;
    hf: Longint;
begin
  hf := gethash(st);
  cur := h[hf];
  buf := cur;
  if cur^.st = st then begin
    h[hf] := cur^.next;
    exit;
  end;
  while hf <> 0 do begin
    buf := buf^.next;
    if buf^.st = st then begin
      cur^.next := cur^.next^.next;
    end;
  end;
end;

function checkpers(num: Longint): Boolean;
var buf: phash;
begin
  buf := lpers[num];
  checkpers := false;
  while buf <> null do begin
    if not hsearch(buf^.st) then exit;
    buf := buf^.next;
  end;
  checkpers := true;
end;

function checkobj(num: Longint): BOolean;
begin
  buf := lpers[num];
  checkobj := false;
  buf := lobj[num];
  while buf <> null do begin
    if not hsearch(buf^.st) then exit;
    buf := buf^.next;
  end;
  checkobj := true;
end;

procedure useobj(num: Longint);
var buf: phash;
begin
  buf := lobj[num];
  write('use ');
  while buf <> null do begin
    write(buf^.st);
    if buf^.next^.next <> null then begin
      write(', ');
    end else begin
      if buf^.next <> null then write(' and ');
    end;
    buf := buf^.next;
  end;
  writeln(' on ',nameobj[num]);
  buf := l1obj[num];
  usobj[num] := true;
  write('take ');
  while buf <> null do begin
    hashadd(buf^.st);
    write(buf^.st);
    if buf^.next^.next <> null then begin
      write(', ');
    end else begin
      if buf^.next <> null then write(' and ');
    end;
    buf := buf^.next;
  end;
  writeln(' from ',nameobj[num]);
end;

procedure getitem(num: Longint);
var buf: phash;
begin
  usroom[num] := true;
  buf := item[num];
  while buf <> null do begin
    writeln('pick ',buf^.st);
    hashadd(buf^.st);
    buf := buf^.next;
  end;
end;

procedure usepers(num: Longint);
var buf: phash;
begin
  writeln('talk to ',namepers[num]);
  buf := lpers[num];
  write('give ');
  while buf <> null do begin
    write(buf^.st);
    if buf^.next^.next <> null then begin
      write(', ');
    end else begin
      if buf^.next <> null then write(' and ');
    end;
    hashdel(buf^.st);
    buf := buf^.next;
  end;
  writeln(' to ',namepers[num]);
  buf := l1pers[num];
  uspers[num] := true;
  write('take ');
  while buf <> null do begin
    hashadd(buf^.st);
    write(buf^.st);
    if buf^.next^.next <> null then begin
      write(', ');
    end else begin
      if buf^.next <> null then write(' and ');
    end;
    buf := buf^.next;
  end;
  writeln(' from ',namepers[num]);
end;

function cmove(fin,st: Longint): Boolean;
var i: Longint;
begin
  if st = fin then begin
    cmove := true;
    exit;
  end;
  cmove := false;
  if vs[st] then exit;
  cmove := true;
  vs[st] := true;
  for i := 1 to nroom do begin
    if i = st then continue;
    if kneed[st,i] = '' then continue;
    if hsearch(kneed[st,i]) then begin
      if cmove(fin,i) then begin
        if not open[st,i] then begin
          open[st,i] := true;
          open[i,st] := true;
          writeln('open door to ',room[st]);
        end;
        writeln('go to ',room[st]);
        exit;
      end;
    end;
  end;
  cmove := false;
end;

begin
  randseed := 49103414;
  for i := 1 to 300 do r[i] := random(100000);
  new(null);
  null^.next := null;
  for i := 0 to modulo do begin
    h[i] := null;
  end;
  for i := 1 to 200 do begin
    lpers[i] := null;
    l1pers[i] := null;
    lobj[i] := null;
    l1obj[i] := null;
    item[i] := null;
  end;
  assign(input,'quest.in'); reset(input);
  readln(nroom);
  for i := 1 to nroom do begin
    readln(room[i]);
    delspace(room[i]);
  end;
  readln(ndoors);
  for i := 1 to ndoors do begin
    read(k,j);
    readln(st);
    delspace(st);
    kneed[k,j] := st;
    kneed[j,k] := st;
  end;
  for i := 1 to nroom do begin
    readln(scpers,scobj,nitem);
    for j := 1 to scpers do begin
      inc(scp);
      readln(namepers[scp]);
      delspace(namepers[scp]);
      npers[scp] := i;
      while true do begin
        if not readword(st) then break;
        delspace(st);
        new(buf);
        buf^.st := st;
        buf^.next := lpers[scp];
        lpers[scp] := buf;
      end;
      readln;
      while true do begin
        if not readword(st) then break;
        delspace(st);
        new(buf);
        buf^.st := st;
        buf^.next := l1pers[scp];
        l1pers[scp] := buf;
      end;
      readln;
    end;
    for j := 1 to scobj do begin
      inc(sco);
      readln(nameobj[sco]);
      delspace(nameobj[sco]);
      nobj[sco] := i;
      while true do begin
        if not readword(st) then break;
        delspace(st);
        new(buf);
        buf^.st := st;
        buf^.next := lobj[sco];
        lobj[sco] := buf;
      end;
      readln;
      while true do begin
        if not readword(st) then break;
        delspace(st);
        new(buf);
        buf^.st := st;
        buf^.next := l1obj[sco];
        l1obj[sco] := buf;
      end;
      readln;
    end;
    for j := 1 to nitem do begin
      readln(st);
      delspace(st);
      new(buf);
      buf^.st := st;
      buf^.next := item[i];
      item[i] := buf;
    end;
  end;
  readln(st);
  delspace(st);
  for i := 1 to nroom do begin
    if st = room[i] then break;
  end;
  stroom := i;
  readln(st);
  delspace(st);
  for i := 1 to nroom do begin
    if st = room[i] then break;
  end;
  finroom := i;
  curroom := stroom;
  assign(output,'quest.out'); rewrite(output);
  while true do begin
    progress := false;
    for i := 1 to nroom do begin
      if not usroom[i] then begin
        fillchar(vs,sizeof(vs),false);
        if cmove(curroom,i) then begin
          progress := true;
          getitem(i);
          curroom := i;
        end;
      end;
    end;
    for i := 1 to sco do begin
      if not usobj[i] then
      if checkobj(i) then begin
        fillchar(vs,sizeof(vs),false);
        if cmove(curroom,nobj[i]) then begin
          progress := true;
          useobj(i);
          curroom := nobj[i];
        end;
      end;
    end;
    for i := 1 to scp do begin
      if not uspers[i] then
      if checkpers(i) then begin
        if cmove(curroom,npers[i]) then begin
          progress := true;
          usepers(i);
          curroom := npers[i];
        end;
      end;
    end;
    if cmove(curroom,finroom) then begin
      writeln('save princess');
      close(input);
      close(output);
      halt(0);
    end;
    if not progress then break;
  end;
  close(output);
  assign(output,'quest.out'); rewrite(output);
  writeln('dead princess');
  close(input);
  close(output);
end.
