{$I-,Q-,R-,S-}
const
  MAXN = 10;
  MAXM = 81;
  MAXC = 205;
type
  TString = String[100];
  TPredmet = record
    Name: TString;
    NotExists: Boolean;
  end;
  TPerson = record
    Name: TString;
    CIn, COut: Integer;
    InP: array[1..MAXC] of TString;
    OutP: array[1..MAXC] of TString;
    Used: Boolean;
  end;
  TObj = record
    Name: TString;
    CIn, COut: Integer;
    InP: array[1..MAXC] of TString;
    OutP: array[1..MAXC] of TString;
    Used: Boolean;
  end;
  TRoom = record
    Name: TString;
    c, o, p: Integer;
    Persons: array[1..MAXC] of TPerson;
    Objects: array[1..MAXC] of TObj;
    Predmets: array[1..MAXC] of TPredmet;
  end;
  TDoor = record
    v1, v2: Integer;
    Key: TString;
    Opened: Boolean;
  end;
var
  Rooms: array[1..MAXN] of TRoom;
  Doors: array[1..MAXM] of TDoor;
  MyPred: array[1..MAXC] of TPredmet;
  Changes: Boolean;
  FirstRoom, LastRoom: TString;
  CurrentRoom: Integer;
  n, m, uk, Finish: Integer;
  NNew: array[1..MAXN] of Boolean;

procedure Trim(var s: String);
var i: Integer;
begin
  if s = '' then Exit;
  i := 1;
  while (s[i]= ' ') and (i <= Length(s)) do Inc(i);
  Delete(s, 1, i - 1);
  if s = '' then Exit;
  i := Length(s);
  while (s[i]= ' ') and (i > 0) do Dec(i);
  Delete(s, i + 1, Length(s) - i);
end;

function ReadName(var s: String): Boolean;
var Ch: Char;
begin
  s := '';
  Read(Ch);
  while (Ch = ' ') do Read(Ch);
  if Ch in [#10, #13] then
  begin
    ReadName := False;
    Exit;
  end;
  while not (Ch in [#10, #13, ',']) do
  begin
    s := s + Ch;
    Read(Ch);
  end;
  Trim(s);
  ReadName := True;
end;

procedure Init();
var i, j, t: Integer;
    s: TString;
begin
  Assign(Input, 'quest.in');
  Reset(Input);
  Assign(Output, 'quest.out');
  Rewrite(Output);

  Readln(n);
  for i := 1 to n do
  begin
    Readln(Rooms[i].Name);
    Trim(Rooms[i].Name);
  end;
  Readln(m);
  for i := 1 to m do with Doors[i] do
  begin
    Read(v1, v2);
    Readln(Key);
    Trim(Key);
  end;
  for i := 1 to n do with Rooms[i] do
  begin
    Readln(c, o, p);
    for j := 1 to c do with Persons[j] do
    begin
      Readln(Name);
      Trim(Name);
      t := 0;
      while ReadName(s) do
      begin
        Inc(t);
        InP[t] := s;
      end;
      Cin := t;
      t := 0;
      while ReadName(s) do
      begin
        Inc(t);
        OutP[t] := s;
      end;
      COut := t;
    end;
    for j := 1 to o do with Objects[j] do
    begin
      Readln(Name);
      Trim(Name);
      t := 0;
      while ReadName(s) do
      begin
        Inc(t);
        InP[t] := s;
      end;
      Cin := t;
      t := 0;
      while ReadName(s) do
      begin
        Inc(t);
        OutP[t] := s;
      end;
      COut := t;
    end;
    for j := 1 to p do with Predmets[j] do
    begin
      Readln(Name);
      Trim(Name);
    end;
  end;
  Readln(FirstRoom);
  trim(FirstRoom);
  Readln(LastRoom);
  Trim(LastRoom);
end;

function GetroomId(const s: String): Integer;
var i: Integer;
begin
  for i := 1 to n do if Rooms[i].Name = s then
  begin
    GetRoomId := i;
    Exit;
  end;
  GetRoomId := 0;
end;

function GoToRoom(const k: Integer): Boolean;
var i: Integer;
begin
  for i := 1 to m do with Doors[i] do
    if (((v1 = CurrentRoom) and (v2  = k)) or ((v2 = CurrentRoom) and (v1 = k)))
      and Doors[i].Opened then
      begin
        GoToRoom := True;
        Writeln('go to ' + Rooms[k].Name);
        CurrentRoom := k;
        Exit;
      end;
  GoToRoom := False;
end;

function UsePerson(var Per: TPerson): Boolean;
var Pred: array[1..MAXC] of Integer;
    Must, i, j: Integer;
begin
  Must := 0;
  for i := 1 to Per.CIn do
    for j := 1 to Uk do if (Per.InP[i] = MyPred[j].Name)
      and not MyPred[j].NotExists then
    begin
      Pred[i] := j;
      Inc(Must);
    end;
  if Must = Per.Cin then
  begin
    writeln('talk to ' + Per.Name);
    Write('give ');
    for i := 1 to Must do
    begin
      Write(MyPred[Pred[i]].Name);
      if i < Must - 1 then write(', ') else if i = Must - 1 then Write(' and ');
      MyPred[Pred[i]].NotExists := True;
    end;
    Write(' to ');
    writeln(Per.Name);

    write('take ');
    for i := 1 to Per.COut do
    begin
      Inc(uk);
      MyPred[Uk].Name := Per.OutP[i];
      write(Per.OutP[i]);
      if i < Per.COut - 1 then Write(', ') else if i = Per.Cout - 1 then Write(' and ' );
    end;
    write(' from ');
    Writeln(Per.name);
    UsePerson := True;
    Per.Used := true;
  end else UsePerson := false;
end;

function UseObject(var Obj: TObj): Boolean;
var
  Pred: array[1..MAXC] of Integer;
  Must, i, j: Integer;
begin
  Must := 0;
  for i := 1 to Obj.CIn do
    for j := 1 to Uk do if (Obj.InP[i] = MyPred[j].Name)
      and not MyPred[j].NotExists then
    begin
      Pred[i] := j;
      Inc(Must);
    end;
  if Must = Obj.Cin then
  begin
    Write('use ');
    for i := 1 to Must do
    begin
      Write(MyPred[Pred[i]].Name);
      if i < Must - 1 then write(', ') else if i = Must - 1 then Write(' and ');
    end;
    Write(' on ');
    writeln(Obj.Name);

    write('take ');
    for i := 1 to Obj.COut do
    begin
      Inc(uk);
      MyPred[Uk].Name := Obj.OutP[i];
      write(Obj.OutP[i]);
      if i < Obj.COut - 1 then Write(', ') else if i = Obj.Cout - 1 then Write(' and ' );
    end;
    write(' from ');
    Writeln(Obj.name);
    UseObject := True;
    Obj.Used := True;
  end else UseObject := false;
end;

procedure ShareRoom(const k: Integer);
var i, j: Integer;
    Zero: Boolean;
    lc, Tmp: Boolean;
begin
  if k <> CurrentRoom then if not GoToRoom(k) then Exit;

  if k = finish then
  begin
    Writeln('save princess');
    Close(Input);
    Close(Output);
    Halt;
  end;

  lc := True;
  while lc do
  begin
  lc := False;
  {Pick all predmets}
  for i := 1 to Rooms[k].p do
  begin
    Changes := True;
    lc := True;
    Inc(Uk);
    MyPred[Uk] := Rooms[k].Predmets[i];
    Writeln('pick ' + MyPred[Uk].Name);
  end;
  Rooms[k].p := 0;

  {Use all persons}
  Zero := true;
  for i := 1 to Rooms[k].c do if not Rooms[k].Persons[i].Used then
  begin
    Zero := False;
    Tmp := UsePerson(Rooms[k].Persons[i]);
    Changes := Changes or Tmp;
    Lc := Lc or Tmp;
  end;
  if Zero then Rooms[k].c := 0;

  {Use all objects}
  Zero := true;
  for i := 1 to Rooms[k].o do if not Rooms[k].Objects[i].Used then
  begin
    Zero := False;
    Tmp := UseObject(Rooms[k].Objects[i]);
    Changes := Changes or Tmp;
    Lc := Lc or Tmp;
  end;
  if Zero then Rooms[k].o := 0;

  {open all door}
  for i := 1 to m do with Doors[i] do
    if ((v1 = k) or (v2 = k)) and not Opened then
    begin
      for j := 1 to Uk do if MyPred[j].Name = Doors[i].Key then
      begin
        Doors[i].Opened := true;
        Changes := True;
        Lc := True;
        write('open door to ');
        if v1 = k then Writeln(Rooms[v2].Name) else Writeln(Rooms[v1].Name);
        MyPred[j].NotExists := true;
        Break;
      end;
    end;
  end;
end;

procedure dfs(const k: Integer);
var i: Integer;
begin
  NNew[k] := True;
  ShareRoom(k);
  for i := 1 to m do
  begin
    if (Doors[i].Opened) and (Doors[i].v1 = k) then if not NNew[Doors[i].v2] then Dfs(Doors[i].v2);
    if (Doors[i].Opened) and (Doors[i].v2 = k) then if not NNew[Doors[i].v1] then Dfs(Doors[i].v1);
  end;
end;

procedure Solve();
var i: Integer;
begin
  Changes := True;
  finish := GetRoomId(Lastroom);
  Currentroom := GetRoomId(FirstRoom);
  while Changes do
  begin
    Changes := False;
    Fillchar(Nnew, Sizeof(Nnew), 0);
    Dfs(CurrentRoom);
  end;
end;

procedure Done();
begin
  Rewrite(output);
  Writeln('dead princess');
  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
