const
     FileIn='sumcubes.in';
     FileOut='sumcubes.out';
     MaxUsedCubesCount=8;
var
   N: LongInt;
   Possible: Boolean;
   AnswerLength: LongInt;
   Answer: array [0..MaxUsedCubesCount] of LongInt;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Possible
        then begin
             for NItem:=1 to AnswerLength-1
                 do Write (F, Answer [NItem], #32);
             Writeln (F, Answer [AnswerLength]);
        end
        else Writeln (F, 'IMPOSSIBLE');
     Close (F);
end;

const
     MaxCubesCount=1500;
var
   CubesCount: LongInt;
   Cubes: array [1..MaxCubesCount] of LongInt;

procedure InitCubes;
var
   Number, Cube: LongInt;
begin
     for Number:=1 to MaxCubesCount
         do begin
            Cube:=Number*Number*Number;
            if Cube<=N
               then Cubes [Number]:=Cube
               else Break;
         end;
     CubesCount:=Number-1;
end;

function Search (aMaxValue: LongInt; aMaxIndex: LongInt): LongInt;
var
   Index: LongInt;
   Delta: LongInt;
begin
     Index:=1;
     Delta:=aMaxIndex shr 1;
     repeat
           if (Index+Delta<=aMaxIndex) and (Cubes [Index+Delta]<=aMaxValue)
              then Index:=Index+Delta
              else Delta:=Delta shr 1;
     until Delta=0;
     Search:=Index;
end;

function Recursion (aLevel: LongInt; aValue: LongInt): Boolean;
var
   Number: LongInt;
begin
     if aValue=0
        then begin
             AnswerLength:=aLevel-1;
             Recursion:=true;
             Exit;
        end;
     if aLevel>MaxUsedCubesCount
        then Exit;
     for Number:=Search (aValue, Answer [aLevel-1]) downto 1
         do begin
            Answer [aLevel]:=Number;
            if Recursion (aLevel+1, aValue-Cubes [Number])
               then begin
                    Recursion:=true;
                    Exit;
               end;
         end;
     Recursion:=false;
end;

{Define Check}
{$IfDef Check}
procedure Check;
var
   NItem: LongInt;
   Value: LongInt;
begin
     if not Possible
        then begin
             Writeln ('Impossible');
             Exit;
        end;
     Value:=0;
     for NItem:=1 to AnswerLength
         do Value:=Value+Answer [NItem]*Answer [NItem]*Answer [NItem];
     if Value<>N
        then Writeln ('ALARM!!!')
        else Writeln ('OK');
end;
{$EndIf}

procedure Solve;
var
   i: LongInt;
begin
     InitCubes;

     Answer [0]:=CubesCount;
     Possible:=Recursion (1, N);

     {$IfDef Check}
     Check;
     {$EndIf}
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
