program Temp;
const infile = 'dist.in';
      outfile = 'dist.out';
      MAXL = 256;
      MAXN = 200;
      MAXK = 255;
      MAXP = 1000;
      inf = 1000000000;
type
TConn = record
  A : char;
  B : integer;
end;
TVertex = record
  A : char;
  p : longint;
end;
TLexem = (_Letter, _Open, _Close, _Commar, _Arrow, _End);
TList = record
  a : array[1..MAXK] of longint;
  len : longint;
end;

var expr : array[1..MAXL] of char;
    nd : array['A'..'Z'] of boolean;
    tm, ps, mb, len : integer;
    tr : array[1..MAXP] of TVertex;
    Cur : TLexem;
    val, av : char;
    GA, l, d : array['A'..'Z'] of longint;
    GB : array[1..MAXP] of TConn;

function tree : longint; forward;
function forest : TList; forward;
function list : TList; forward;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output); len:=0; tm:=0; ps:=0; mb:=0;
  while not eoln(input) do begin inc(len); read(expr[len]); end;
  inc(len); expr[len]:=#255;
end;

procedure add(u, v : char);
begin
  inc(tm); GB[tm].A:=v; GB[tm].B:=0;
  if l[u]=0 then GA[u]:=tm else GB[l[u]].B:=tm; l[u]:=tm;
end;

procedure next;
begin
  inc(ps);
  case expr[ps] of
    'A'..'Z' : begin Cur:=_Letter; val:=expr[ps]; end;
    #255 : Cur:=_End;
    '(' : Cur:=_Open;
    ')' : Cur:=_Close;
    ',' : Cur:=_Commar;
    '-' : begin inc(ps); Cur:=_Arrow; end;
  end;
end;

function list : TList;
var res : TList;
begin
  res.len:=1; res.a[1]:=tree;
  while (cur = _Commar) do
  begin
    next; inc(res.len); res.a[res.len]:=tree;
  end;
  list:=res;
end;

function islist(i : integer) : boolean;
var j, raz : integer;
begin
  raz:=0; islist:=false;
  for j:=i to len do
  begin
    if expr[j]='(' then inc(raz);
    if expr[j]=')' then dec(raz);
    if (expr[j]=',')and(raz=1) then islist:=true;
    if raz=0 then break;
  end;
end;

function forest : TList;
var res : TList;
begin
  if cur=_Open then begin
    if islist(ps) then begin next; res:=list; next; end else begin res.len:=1; res.a[1]:=tree; end;
  end else begin res.len:=1; res.a[1]:=tree; end;
  forest:=res;
end;

function tree : longint;
var c, m, k : longint;
    res : TList;
begin
  if Cur=_Letter then
  begin
    inc(mb); c:=mb;
    tr[c].A:=val; tr[c].p:=0; next;
    if Cur=_Arrow then begin
      next; res:=forest;
      for k:=1 to res.len do tr[res.a[k]].p:=c;
    end;
  end
  else if Cur=_Open then
  begin
    next; m:=tree(); next; c:=m;
    if Cur=_Arrow then begin
      next; res:=forest;
      for k:=1 to res.len do tr[res.a[k]].p:=c;
    end;
  end;
  tree:=c;
end;

procedure BFS(ch : char);
var c, Cur : char;
    Q : array[1..MAXN] of char;
    Ql, Qr : integer;
    j : longint;
begin
  for c:='A' to 'Z' do d[c]:=inf; d[ch]:=0; Ql:=1; Qr:=1; Q[1]:=ch;
  while Qr>=Ql do
  begin
    Cur:=Q[Ql]; inc(Ql);
    j:=GA[Cur];
    while j<>0 do
    begin
      if d[GB[j].A]=inf then begin
        d[GB[j].A]:=d[Cur]+1; inc(Qr); Q[Qr]:=GB[j].A;
      end;
      j:=GB[j].B;
    end;
  end;
end;

procedure Solve;
var i : longint;
    ch : char;
begin
  next; av:=tr[tree].A;
  fillchar(nd, sizeof(nd), false);
  fillchar(l, sizeof(l), 0);
  for i:=1 to mb do nd[tr[i].A]:=true;
  for i:=1 to mb do
    if tr[i].p<>0 then begin
      add(tr[i].A, tr[tr[i].p].A);
      add(tr[tr[i].p].A, tr[i].A);
    end;
  BFS(av);
  for ch:='A' to 'Z' do
    if nd[ch] then writeln(ch, ' ', d[ch]);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
