const
     FileIn='dist.in';
     FileOut='dist.out';
var
   Scheme: string;
   ExistsChar: array ['A'..'Z'] of Boolean;
   Distances: array ['A'..'Z'] of LongInt;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, Scheme);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Ch: Char;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for Ch:='A' to 'Z'
         do if ExistsChar [Ch]
               then Writeln (F, Ch, #32, Distances [Ch]);
     Close (F);
end;

var
   Matrix: array ['A'..'Z', 'A'..'Z'] of LongInt;
   Root: Char;
   StackLevel: LongInt;
   Stack: array [1..26] of Char;

procedure ParseScheme;
var
   NChar: LongInt;

procedure ReadTree; forward;

procedure ReadList;
begin
     ReadTree;
     while Scheme [NChar]=','
           do begin
              Inc (NChar);
              ReadTree;
           end;
end;

procedure ReadForest;
begin
     if Scheme [NChar]='('
        then begin
             Inc (NChar);
             ReadList;
             Inc (NChar);
        end
        else ReadTree;
end;

procedure ReadTree;
begin
     Inc (StackLevel);
     if Scheme [NChar] in ['A'..'Z']
        then begin
             Stack [StackLevel]:=Scheme [NChar];
             ExistsChar [Scheme [NChar]]:=true;
             if StackLevel>1
                then begin
                     Matrix [Stack [StackLevel-1], Stack [StackLevel]]:=1;
                     Matrix [Stack [StackLevel], Stack [StackLevel-1]]:=1;
                end
                else Root:=Scheme [NChar];
             Inc (NChar);
        end
        else if Scheme [NChar]='('
                then begin
                     Inc (NChar);
                     Dec (StackLevel);
                     ReadTree;
                     Inc (NChar);
                     Inc (StackLevel);
                end;
     if Scheme [NChar]='-'
        then begin
             Inc (NChar, 2);
             ReadForest;
        end;
     Dec (StackLevel);
end;

begin
     NChar:=1;
     StackLevel:=0;
     FillChar (Matrix, SizeOf (Matrix), 0);
     ReadTree;
end;

var
   States: array ['A'..'Z'] of Byte;

procedure Dijkstra;
var
   BestNode, Node: Char;
begin
     Distances [Root]:=0;
     FillChar (States, SizeOf (States), 0);
     States [Root]:=1;
     repeat
           for BestNode:='A' to 'Z'
               do if States [BestNode]=1
                     then Break;
           if States [BestNode]=1
              then begin
                   for Node:=Chr (Ord (BestNode)+1) to 'Z'
                       do if (States [Node]=1) and (Distances [Node]<Distances [BestNode])
                             then BestNode:=Node;
                   for Node:='A' to 'Z'
                       do if (Matrix [BestNode, Node]>0) and ((States [Node]=0) or (Distances [BestNode]+1<Distances [Node]))
                             then begin
                                  Distances [Node]:=Distances [BestNode]+1;
                                  States [Node]:=1;
                             end;
                   States [BestNode]:=2;
              end
              else Break;
     until false;
end;

procedure Solve;
begin
     ParseScheme;
     Dijkstra;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
