{$I-,Q-,R-,S-}
{$m 3000000,3000000}
type
  Integer = Longint;
  TTree = record
    m: array['A'..'Z', 'A'..'Z'] of Integer;
    p: Char;
  end;
  PForest = ^TForest;
  TForest = record
    t: TTree;
    Next: PForest;
  end;
var
  a: TTree;
  tl: (_let, _sko, _skz, _sled, _end, _zap);
  UseLet: array['A'..'Z'] of Boolean;
  Curlet: Char;

procedure ReadTree(var a: TTree); forward;

procedure Nl();
var Ch: Char;
begin
  if EOF then
  begin
    tl := _end;
    Exit;
  end;

  Read(Ch);

  case Ch of
    'A'..'Z':
    begin
      tl := _let;
      Curlet := Ch;
      UseLet[Ch] := True;
    end;
    '(':
    begin
      tl := _sko;
    end;
    ')':
    begin
      tl := _skz;
    end;
    '-':
    begin
      tl := _sled;
      Read(Ch);
    end;
    ',':
    begin
      tl := _zap;
    end else
    begin
      tl := _end;
    end;
  end;
end;

procedure ReadForest(var a: TForest);
var b: TTree;
    Issk: boolean;
    uk: PForest;
begin
  Nl();
  IsSk := False;
  if tl = _sko then
  begin
    nL();
    Issk := True;
  end;

  ReadTree(b);
  a.t := b;
  a.Next := nil;
  uk := @a;
  while (Tl = _zap) and (IsSk) do
  begin
    New(uk^.Next);
    Nl();
    ReadTree(uk^.Next^.t);
    uk^.Next^.Next := nil;

    uk := uk^.Next;
  end;

  if IsSk then Nl();
end;

procedure UnionTree(var a: TTree; const b: TTree);
var i, j: Char;
begin
  for i := 'A' to 'Z' do
    for j := 'A' to 'Z' do if b.m[i, j] = 1 then
    begin
      a.m[i, j] := 1;
    end;
  a.m[a.p, b.p] := 1;
  a.m[b.p, a.p] := 1;
end;

procedure Union(var a: TTree; const b: TForest);
var Cur: PForest;
begin
  Cur := @b;
  while Cur <> nil do
  begin
    UnionTree(a, Cur^.t);
    Cur := Cur^.Next;
  end;
end;

procedure ReadTree(var a: TTree);
var b: TTree;
    c: TForest;
    IsSk: Boolean;
begin
  fillchar(a, sizeof(a), 0);
  fillchar(b, sizeof(b), 0);
  IsSk := False;
  if tl = _sko then
  begin
    Nl();
    ReadTree(b);
    IsSk :=True;
  end else b.p := CurLet;
  Nl();
  if tl = _sled then
  begin
    Readforest(c);
    Union(b, c);
  end;
  a := b;
end;

procedure Init();
begin
  Assign(Input, 'dist.in');
  Reset(Input);
  Assign(Output, 'dist.out');
  Rewrite(Output);

  Nl();
  ReadTree(a);
end;

procedure FindPaths();
var i, j, k: Char;
begin
  {Floyd}
  for i := 'A' to 'Z' do
    for j := 'A' to 'Z' do if a.m[i, j] = 0 then if i <> j then a.m[i, j] := 100000000;

  for k := 'A' to 'Z' do
    for i := 'A' to 'Z' do
      for j := 'A' to 'Z' do if a.m[i, j] > a.m[i, k] + a.m[k, j] then
        a.m[i, j] := a.m[i, k] + a.m[k, j];
end;

procedure Solve();
begin
  FindPaths();
end;

procedure Done();
var i: Char;
begin
  for i := 'A' to 'Z' do if UseLet[i] then Writeln(i, ' ', a.m[a.p, i]);
  close(input);
  close(output);
end;

begin
  Init();
  Solve();
  Done();
end.
