const
     FileIn='horse.in';
     FileOut='horse.out';
     MaxM=100;
     MaxN=100;
type
    TCell=record
                State: Byte;
                Value: LongInt;
                From: LongInt;
          end;
    TFIFOItem=record
                    X, Y: LongInt;
              end;
var
   M, N, P, Q, X1, Y1, X2, Y2: LongInt;
   Matrix: array [1..MaxM, 1..MaxN] of TCell;
   Possible: Boolean;
   AnswerLength: LongInt;
   Answer: array [1..MaxM*MaxN+1] of LongInt;
   FIFO: array [1..MaxN*MaxM+1] of TFIFOItem;
   FIFOLen: LongInt;
   NFIFOItem: LongInt;


procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, M, N, P, Q, X1, Y1, X2, Y2);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Possible
        then begin
             Writeln (F, Matrix [X2, Y2].Value);
             for NItem:=AnswerLength downto 1
                 do Writeln (F, FIFO [Answer [NItem]].X, #32, FIFO [Answer [NItem]].Y);
        end
        else Writeln (F, -1);
     Close (F);
end;

procedure BFS;

procedure TryToGo (aX, aY: LongInt);
begin
     if (1<=aX) and (aX<=M) and (1<=aY) and (aY<=N)
        then with Matrix [aX, aY]
                  do if State=0
                        then begin
                             State:=1;
                             Value:=Matrix [FIFO [NFIFOItem].X, FIFO [NFIFOItem].Y].Value+1;
                             From:=NFIFOItem;
                             Inc (FIFOLen);
                             with FIFO [FIFOLen]
                                  do begin
                                     X:=aX;
                                     Y:=aY;
                                  end;
                        end;
end;

begin
     FillChar (FIFO, SizeOf (FIFO), 0);
     FIFOLen:=1;
     with FIFO [FIFOLen]
          do begin
             X:=X1;
             Y:=Y1;
          end;
     NFIFOItem:=1;
     Matrix [X1, Y1].Value:=0;
     Matrix [X1, Y1].State:=1;
     Matrix [X1, Y1].From:=0;
     while NFIFOItem<=FIFOLen
           do with FIFO [NFIFOItem]
                   do begin
                      TryToGo (X+P, Y+Q);
                      TryToGo (X+P, Y-Q);
                      TryToGo (X-P, Y-Q);
                      TryToGo (X-P, Y+Q);
                      Matrix [X, Y].State:=2;
                      Inc (NFIFOItem);
                   end;
end;

procedure FindAnswer;
var
   NItem: LongInt;
begin
     Possible:=false;
     for NItem:=FIFOLen downto 1
         do if (FIFO [NItem].X=X2) and (FIFO [NItem].Y=Y2)
               then begin
                    Possible:=true;
                    Break;
               end;
     if Possible
        then begin
             AnswerLength:=0;
             repeat
                   Inc (AnswerLength);
                   Answer [AnswerLength]:=NItem;
                   NItem:=Matrix [FIFO [NItem].X, FIFO [NItem].Y].From;
             until NItem=0;
        end;
end;

procedure Solve;
begin
     BFS;
     FindAnswer;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
