{$I-,Q-,R-,S-}

const
  coutfile = 'brides.out';
  cinfile = 'brides.in';

  nmax = 230;
  mmax = 2300;

  inf = maxlongint shr 1;

type
  int = longint;
  real = extended;

  list = ^tlist;
  tlist = record
            v : int;
            z, no : int;
            prev, next : list;
          end;

  rebro = record
            u, v : int;
            z : int;
          end;

var
  n, k, m : int;
  ans : real;
  okc : boolean;

  r : array [1..mmax] of rebro;

  g : array [1..nmax] of list;
  u : array [1..nmax] of boolean;
  u2 : array [1..mmax] of boolean;
  d, p : array [1..nmax] of int;
  pr : array [1..nmax] of list;

  t : array [1..nmax] of list;

  c : array [0..nmax] of int;

procedure push(var gx : list; y, z, no : int);
var
  q : list;
begin
  new(q); q^.prev:= nil;
  q^.next:= gx; if gx <> nil then gx^.prev:= q;
  q^.v:= y; q^.z:= z; q^.no:= no;
  gx:= q;
end;

procedure del(c : int; x : list);
begin
  if x^.prev <> nil then x^.prev^.next:= x^.next;
  if x^.next <> nil then x^.next^.prev:= x^.prev;
  if x^.prev = nil then g[c]:= g[c]^.next;
  dispose(x);
end;

procedure delt(c : int; x : list);
begin
  if x^.prev <> nil then x^.prev^.next:= x^.next;
  if x^.next <> nil then x^.next^.prev:= x^.prev;
  if x^.prev = nil then t[c]:= t[c]^.next;
  dispose(x);
end;

procedure deep(v : int);
var
  i : int;
begin
  if v = n then
  begin
    write(c[0],' ');
    for i:= 1 to c[0]-1 do write(c[i],' ');
    writeln(c[c[0]]);
    exit;
  end;
  inc(c[0]);
  c[c[0]]:= t[v]^.no;
  i:= t[v]^.v;
  delt(v,t[v]);
  deep(i);
end;

procedure outdata;
var
  i, j : int;
  x : list;
begin
  if not okc then writeln(-1) else
  begin
    for i:= 1 to n do
    begin
      fillchar(u2,sizeof(u2),0);
      x:= g[i];
      while x <> nil do
      begin
        if not u2[x^.no] then u2[x^.no]:= true else
        begin
          push(t[x^.v],i,r[x^.no].z,x^.no);
          ans:= ans + r[x^.no].z;
        end;
        x:= x^.next;
      end;
    end;
    writeln(ans/k:0:5);
    for i:= 1 to k do
    begin
      c[0]:= 0;
      deep(1);
    end;
  end;
end;

function dijkstra : boolean;

  procedure init;
  var
    i : int;
  begin
    fillchar(u,sizeof(u),0);
    fillchar(pr,sizeof(pr),0);
    fillchar(p,sizeof(p),0);
    d[1]:= 0;
    for i:= 2 to n do d[i]:= inf;
  end;
var
  min, c, i : int;
  x : list;

begin
  init;
  while true do
  begin
    min:= inf;
    c:= 0;
    for i:= 1 to n do
      if not u[i] and (min > d[i]) then
      begin
        min:= d[i];
        c:= i;
      end;
    if c = 0 then break;
    u[c]:= true;
    x:= g[c];
    while x <> nil do
    begin
      if not u[x^.v] and (d[x^.v] > d[c] + x^.z) then
      begin
        d[x^.v]:= d[c] + x^.z;
        p[x^.v]:= c;
        pr[x^.v]:= x;
      end;
      x:= x^.next;
    end;
  end;
  if not u[n] then
  begin
    dijkstra:= false;
    exit;
  end;
  dijkstra:= true;
  for i:= 1 to n do
  begin
    x:= g[i];
    while x <> nil do
    begin
      x^.z:= x^.z + d[i] - d[x^.v];
      x:= x^.next;
    end;
  end;
  c:= n;
  while p[c] <> 0 do
  begin
    push(g[c],p[c],pr[c]^.z,pr[c]^.no);
    del(p[c],pr[c]);
    c:= p[c];
  end;
end;

procedure solve;
var
  i, j : int;
begin
  okc:= true;
  for i:= 1 to k do
    if not dijkstra then
    begin
      okc:= false;
      break;
    end;
end;

procedure readdata;
var
  i, j : int;
  x, y, z : int;
begin
  fillchar(g,sizeof(g),0);
  read(n,m,k);
  for i:= 1 to m do
  begin
    read(x,y,z);
    push(g[x],y,z,i);
    push(g[y],x,z,i);
    r[i].u:= x; r[i].v:= y; r[i].z:= z;
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.