{$I-,Q-,R-,S-}

const
  coutfile = 'dfs.out';
  cinfile = 'dfs.in';

  nmax = 10100;

type
  int = longint;
  real = extended;

  list = ^tlist;
  tlist = record
            v : int;
            lca : int;
            next : list;
          end;

  list2 = ^tlist2;
  tlist2 = record
             v : int;
             reb : list;
             next : list2;
           end;

  list3 = ^tlist3;
  tlist3 = record
             u, v : int;
             next : list3;
           end;

var
  n, k, m : int;

  ans : array [1..nmax] of list;

  p : array [1..nmax] of int;
  g, t : array [1..nmax] of list;
  lc : array [1..nmax] of list2;
  ls : array [1..nmax] of boolean;

  rank, prev, inf : array [1..nmax] of int;
  u : array [1..nmax] of int;
  s : array [0..nmax] of int;

  color : array [1..nmax] of int;

  time : int;
  tin, tout : array [1..nmax] of int;

  por : array [1..nmax] of list3;

  st : array [1..nmax] of list;
  stepen : array [1..nmax] of int;

  kol : int;
  c : array [1..nmax] of int;

procedure push(var gu : list; v : int);
var
  x : list;
begin
  new(x);
  x^.next:= gu;
  x^.v:= v; x^.next:= gu;
  gu:= x;
end;

procedure push2(var gu : list2; v : int; q : list);
var
  x : list2;
begin
  new(x);
  x^.next:= gu;
  x^.v:= v; x^.reb:= q; x^.next:= gu;
  gu:= x;
end;

procedure push3(var gu : list3; u, v : int);
var
  x : list3;
begin
  new(x);
  x^.next:= gu;
  x^.u:= u; x^.v:= v; x^.next:= gu;
  gu:= x;
end;

function find(x : int) : int;
var
  y, z : int;
begin
  y:= x;
  while y <> prev[y] do y:= prev[y];
  find:= y;
  while x <> prev[x] do
  begin
    z:= x;
    x:= prev[x];
    prev[z]:= y;
  end;
end;

procedure union(x, y, z : int);
begin
  x:= find(x);
  y:= find(y);
  if rank[x] > rank[y] then
  begin
    prev[y]:= x;
    inf[x]:= z;
    exit;
  end;
  if rank[x] < rank[y] then
  begin
    prev[x]:= y;
    inf[y]:= z;
    exit;
  end;
  prev[x]:= y;
  inf[y]:= z;
  inc(rank[y]);
end;

procedure outdata;
var
  i, j : int;
  x : list;
begin
  writeln('YES');
  for i:= 1 to n do
  begin
    write(stepen[i],' ');
    x:= ans[i];
    while x <> nil do
    begin
      write(x^.v,' ');
      x:= x^.next;
    end;
    writeln;
  end;
end;

procedure lca(v : int);
var
  x : list;
  y : list2;
begin
  inc(time);
  tin[v]:= time;
  color[v]:= 1;
  x:= t[v];
  while x <> nil do
  begin
    lca(x^.v);
    union(v,x^.v,v);
    x:= x^.next;
  end;
  y:= lc[v];
  while y <> nil do
  begin
    if color[y^.v] = 2 then
      y^.reb^.lca:= inf[find(y^.v)];
    y:= y^.next;
  end;
  color[v]:= 2;
  inc(time);
  tout[v]:= time;
end;

procedure dfs(v : int);
var
  x : list;
  y : list3;
  i : int;

  procedure go(vs : int);
  var
    q : list;
  begin
    if u[vs] = 1 then
    begin
      writeln('NO');
      close(output);
      halt(0);
    end;
    if u[vs] = 2 then exit;
    u[vs]:= 1;
    q:= st[vs];
    while q <> nil do
    begin
      go(q^.v);
      q:= q^.next;
    end;
    u[vs]:= 2;
    inc(kol);
    c[kol]:= vs;
  end;

begin
  color[v]:= 1;
  x:= t[v];
  while x <> nil do
  begin
    u[x^.v]:= 0;
    dfs(x^.v);
    x:= x^.next;
  end;
  x:= g[v];
  while x <> nil do
  begin
    if color[x^.v] <> 1 then
      push3(por[x^.lca],v,x^.v);
    x:= x^.next;
  end;
  y:= por[v];
  while y <> nil do
  begin
    push(st[inf[find(y^.u)]],y^.v);
    y:= y^.next;
  end;
  kol:= 0;
  x:= t[v];
  while x <> nil do
  begin
    union(v,x^.v,v);
    go(x^.v);
    x:= x^.next;
  end;
  x:= g[v];
  while x <> nil do
  begin
    push(ans[v],x^.v);
    x:= x^.next;
  end;
  for i:= kol downto 1 do push(ans[v],c[i]);
  color[v]:= 2;
end;

procedure solve;
var
  i, j : int;
begin
  fillchar(t,sizeof(t),0);
  for i:= 2 to n do push(t[p[i]],i);
  fillchar(u,sizeof(u),0);
  fillchar(ls,sizeof(ls),0);
  fillchar(color,sizeof(color),0);
  time:= 0;
  fillchar(tin,sizeof(tin),0);
  fillchar(tout,sizeof(tout),0);
  for i:= 1 to n do ls[i]:= t[i] = nil;
  for i:= 1 to n do
  begin
    prev[i]:= i;
    inf[i]:= i;
    rank[i]:= 0;
  end;
  lca(1);
  for i:= 1 to n do
  begin
    prev[i]:= i;
    inf[i]:= i;
    rank[i]:= 0;
  end;
  fillchar(u,sizeof(u),0);
  fillchar(color,sizeof(color),0);
  fillchar(por,sizeof(por),0);
  fillchar(ans,sizeof(ans),0);
  dfs(1);
end;

procedure readdata;
var
  i, j : int;
  x, kl : int;
begin
  fillchar(g,sizeof(g),0);
  read(n);
  for i:= 1 to n-1 do read(p[i+1]);
  for i:= 1 to n do
  begin
    read(kl);
    stepen[i]:= kl;
    for j:= 1 to kl do
    begin
      read(x);
      if p[x] <> i then
      begin
        push(g[i],x);
        push2(lc[i],x,g[i]);
        push2(lc[x],i,g[i]);
      end;
    end;
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.