program AMinCostFlowProblemSupportedByPowerfulIdeasOfMaxBabenko;
const infile = 'brides.in';
      outfile = 'brides.out';
      MAXN = 200;
      MAXM = 4000;
      inf = 1000000000;
type TEdge = record
  v0, A, B, cost, f, c : longint;
end;
var N, M, K, np : integer;
    GA : array[1..MAXN] of longint;
    GB, GBf : array[1..MAXM] of TEdge;
    path : array[1..1000] of longint;
    cf : longint;

procedure ReadData;
var l : array[1..MAXN] of longint;
    cur, u, v, cost, i : longint;

procedure add(u, v, cost : longint);
begin
  inc(cur); GB[cur].v0:=u; GB[cur].A:=v; GB[cur].B:=0; GB[cur].cost:=cost; GB[cur].f:=0; GB[cur].c:=1;
  if l[u]=0 then GA[u]:=cur else GB[l[u]].B:=cur;
  l[u]:=cur;
end;

begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N, M, K);
  fillchar(l, sizeof(l), 0); cur:=0;
  for i:=1 to M do
  begin
    read(u, v, cost);
    add(u, v, cost);
    add(v, u, cost);
  end;
end;

procedure BuildGf;
var i : longint;
begin
  GBf:=GB;
  for i:=1 to M*2 do GBf[i].c:=GB[i].c-GB[i].f;
end;

procedure SearchPath(i, k : longint);
var pass : array[1..MAXN] of boolean;
    d, fr : array[1..MAXN] of longint;
    Cur, j : longint;

procedure Relax(u, j : longint);
begin
  if d[u]+GBf[j].cost<d[GBf[j].A] then
  begin
    d[GBf[j].A]:=d[u]+GBf[j].cost;
    fr[GBf[j].A]:=j;
  end;
end;

begin
  fillchar(pass, sizeof(pass), false);
  for j:=1 to N do d[j]:=inf; d[i]:=0; Cur:=i;
  repeat
    pass[Cur]:=true;
    j:=GA[Cur];
    while j<>0 do
    begin
      if GBf[j].c>0 then Relax(Cur, j);
      j:=GBf[j].B;
    end;
    Cur:=0;
    for j:=1 to N do if (not pass[j])and((Cur=0)or(d[j]<d[Cur])) then Cur:=j;
  until Cur=0; np:=0;
  if d[k]=inf then exit;
  Cur:=k;
  while Cur<>i do
  begin
    j:=fr[Cur];
    inc(np); path[np]:=j;
    Cur:=GBf[j].v0;
  end; cf:=inf;
  for j:=1 to np do if GBf[path[j]].c<cf then cf:=GBf[path[j]].c;
end;

procedure UpdateNetwork;
var i, j : longint;
begin
  for i:=1 to np do
  begin
    if path[i] mod 2=0 then j:=path[i]-1 else j:=path[i]+1;
    GB[path[i]].f:=GB[path[i]].f+cf;
    Gb[j].f:=-GB[path[i]].f;
  end;
end;

procedure outno;
begin
  write(-1);
  close(input);
  close(output);
  halt(0);
end;

procedure DFS(i : longint);
var Cur, wn, j :longint;
    p : array[1..MAXN] of longint;
begin
  Cur:=i; wn:=0;
  while Cur<>N do
  begin
    inc(wn);
    j:=GA[Cur];
    while j<>0 do
    begin
      if GB[j].f>0 then break;
      j:=GB[j].B;
    end;
    GB[j].f:=0; p[wn]:=j div 2 + j mod 2;
    Cur:=GB[j].A;
  end;
  write(wn, ' ');
  for j:=1 to wn do write(p[j], ' ');
end;

procedure Solve;
var i, ans : longint;
begin
  i:=0;
  while true do begin
    BuildGf;
    SearchPath(1, N);
    if np=0 then outno;
    UpdateNetwork;
    inc(i);
    if i=K then break;
  end;
  ans:=0;
  for i:=1 to 2*M do
    if GB[i].f>0 then ans:=ans+GB[i].cost;
  writeln(ans/k:0:5);
  for i:=1 to K do begin DFS(1); writeln; end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.