{$I-,Q-,R-,S-}

const
  coutfile = 'minister.out';
  cinfile = 'minister.in';

  nmax = 4010;
  mmax = 100010;

  slist = 1 shl 12;
  inf = maxlongint shr 1;

type
  int = longint;
  real = extended;

  list = ^tlist;
  tlist = record
            v : int;
            no : int;
            next : list;
          end;

  rebro = record
            u, v : int;
            z : int;
          end;

var
  n, k, m : int;
  ans : int;

  g : array [1..nmax] of list;
  r : array [1..mmax] of rebro;

  pd, d : array [1..nmax] of int;
  p : array [1..nmax] of int;
  u : array [1..nmax] of boolean;

  tree : array [1..slist shl 1] of int;

procedure outdata;
var
  i, j : int;
begin
  if ans = -1 then writeln(-1) else
  begin
    writeln(ans);
    for i:= 1 to m do writeln(r[i].z);
  end;
end;

procedure init;
var
  i : int;
begin
  for i:= 1 to nmax do d[i]:= inf;
  for i:= 1 to slist shl 1 do tree[i]:= inf;
  fillchar(u,sizeof(u),0);
  fillchar(p,sizeof(p),0);
end;

procedure change(v, b : int);
begin
  v:= v + slist - 1;
  tree[v]:= b;
  while v > 1 do
  begin
    v:= v shr 1;
    tree[v]:= tree[v shl 1 + 1];
    if tree[v] > tree[v shl 1] then tree[v]:= tree[v shl 1];
  end;
end;

function findmin : int;
var
  v : int;
begin
  v:= 1;
  while v < slist do
  begin
    v:= v shl 1;
    if tree[v] > tree[v + 1] then inc(v);
  end;
  findmin:= v - slist + 1;
end;

procedure dijkstra;
var
  c : int;
  x : list;
begin
  init;
  d[1]:= 0;
  change(1,0);
  while tree[1] < inf do
  begin
    c:= findmin;
    change(c,inf);
    u[c]:= true;
    if d[c] > pd[c] then
    begin
      dec(r[p[c]].z,d[c]-pd[c]);
      if r[p[c]].z < 0 then
      begin
        ans:= -1;
        exit;
      end;
      inc(ans,d[c]-pd[c]);
    end;
    x:= g[c];
    while x <> nil do
    begin
      if not u[x^.v] and (d[x^.v] > d[c] + r[x^.no].z) then
      begin
        d[x^.v]:= d[c] + r[x^.no].z;
        if d[x^.v] < pd[x^.v] then
        begin
          inc(r[x^.no].z,pd[x^.v]-d[x^.v]);
          inc(ans,pd[x^.v]-d[x^.v]);
          d[x^.v]:= pd[x^.v];
        end;
        p[x^.v]:= x^.no;
        change(x^.v,d[x^.v]);
      end;
      x:= x^.next;
    end;
  end;
end;

procedure solve;
var
  i, j : int;
begin
  if pd[1] = 0 then dijkstra else ans:= -1;
end;

procedure push(u, v, no : int);
var
  x : list;
begin
  new(x);
  x^.next:= g[u];
  x^.v:= v; x^.no:= no; x^.next:= g[u];
  g[u]:= x;
end;

procedure readdata;
var
  i, j : int;
  x, y, z : int;
begin
  fillchar(g,sizeof(g),0);
  read(n,m);
  for i:= 1 to n do read(pd[i]);
  for i:= 1 to m do
  begin
    read(x,y,z);
    r[i].u:= x; r[i].v:= y; r[i].z:= z;
    push(x,y,i);
    push(y,x,i);
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.