const
     FileIn='brides.in';
     FileOut='brides.out';
     MaxN=200;
     MaxM=2000;
     MaxK=100;
type
    PLink=^TLink;
    TLink=record
                Next: PLink;
                Id: LongInt;
                Node: LongInt;
          end;
    TNode=record
                State: Byte;
                Time: LongInt;
                ReachedFrom, ReachedBy: LongInt;
                First, Last: PLink;
          end;
    TEdge=record
                Deleted: Boolean;
                Time: LongInt;
          end;
    TAnswerItem=record
                      Count: LongInt;
                      Items: array [1..MaxM] of LongInt;
                end;
var
   N, M, K: LongInt;
   Edges: array [1..MaxM] of TEdge;
   Nodes: array [1..MaxN] of TNode;
   Possible: Boolean;
   AnswerTime: Extended;
   Answer: array [1..MaxK] of TAnswerItem;

procedure AddEdge (aA, aB, aIndex: LongInt);
begin
     with Nodes [aA]
          do begin
             if Assigned (Last)
                then begin
                     New (Last^.Next);
                     Last:=Last^.Next;
                end
                else begin
                     New (Last);
                     First:=Last;
                end;
                with Last^
                     do begin
                        Id:=aIndex;
                        Node:=aB;
                        Next:=nil;
                     end;
          end;
end;

procedure ReadData;
var
   F: Text;
   NEdge: LongInt;
   A, B, T: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, M, K);
     for NEdge:=1 to M
         do begin
            Readln (F, A, B, T);
            AddEdge (A, B, NEdge);
            AddEdge (B, A, NEdge);
            Edges [NEdge].Deleted:=false;
            Edges [NEdge].Time:=T;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NSon, NEdge: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Possible
        then begin
             Writeln (F, Trunc (AnswerTime*100000)/100000:0:5);
             for NSon:=1 to K
                 do with Answer [NSon]
                         do begin
                            Write (F, Count);
                            for NEdge:=Count downto 1
                                do Write (F, #32, Items [NEdge]);
                            Writeln (F);
                         end;
        end
        else Writeln (F, -1);
     Close (F);
end;

procedure Dijkstra;
var
   BestNode, NNode: LongInt;
   Link: PLink;
begin
     with Nodes [1]
          do begin
             State:=1;
             Time:=0;
             ReachedFrom:=0;
          end;
     repeat
           for BestNode:=1 to N
               do if Nodes [BestNode].State=1
                     then Break;
           if Nodes [BestNode].State=1
              then begin
                   for NNode:=BestNode+1 to N
                       do if (Nodes [NNode].State=1) and (Nodes [NNode].Time<Nodes [BestNode].Time)
                             then BestNode:=NNode;
                   Link:=Nodes [BestNode].First;
                   while Assigned (Link)
                         do begin
                            if (not Edges [Link^.Id].Deleted) and
                               ((Nodes [Link^.Node].State=0) or
                               ((Nodes [Link^.Node].State=1) and
                               (Nodes [Link^.Node].Time>Nodes [BestNode].Time+Edges [Link^.Id].Time)))
                               then begin
                                    Nodes [Link^.Node].State:=1;
                                    Nodes [Link^.Node].Time:=Nodes [BestNode].Time+Edges [Link^.Id].Time;
                                    Nodes [Link^.Node].ReachedFrom:=BestNode;
                                    Nodes [Link^.Node].ReachedBy:=Link^.Id;
                               end;
                            Link:=Link^.Next;
                         end;
                   Nodes [BestNode].State:=2;
              end
              else Break;
     until false;
end;

procedure Solve;
var
   NNode, NSon: LongInt;
begin
     Possible:=true;
     AnswerTime:=0;
     for NSon:=1 to K
         do begin
            for NNode:=2 to N
                do Nodes [NNode].State:=0;
            Dijkstra;
            if Nodes [N].State=2
               then begin
                    with Answer [NSon]
                         do begin
                            NNode:=N;
                            Count:=0;
                            while NNode<>1
                                  do begin
                                     Inc (Count);
                                     Items [Count]:=Nodes [NNode].ReachedBy;
                                     Edges [Nodes [NNode].ReachedBy].Deleted:=true;
                                     NNode:=Nodes [NNode].ReachedFrom;
                                  end;
                         end;
                    AnswerTime:=AnswerTime+Nodes [N].Time;
               end
               else begin
                    Possible:=false;
                    Exit;
               end;
         end;
     AnswerTime:=AnswerTime/K;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
