const
     FileIn='dfs.in';
     FileOut='dfs.out';
     MaxN=10000;
     MaxEdgesCount=500000;
type
    TNode=record
                Count: LongInt;
                First: LongInt;
                State: LongInt;
                Parent: LongInt;
                WIndex: LongInt;
                Moved: Boolean;
          end;
var
   N: LongInt;
   Parents: array [2..MaxN] of LongInt;
   Edges: array [1..MaxEdgesCount] of LongInt;
   Nodes: array [1..MaxN] of TNode;
   Possible: Boolean;

procedure ReadData;
var
   F: Text;
   NItem, NNode, Index: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NItem:=2 to N
         do Read (F, Parents [NItem]);
     Index:=1;
     for NNode:=1 to N
         do begin
            Read (F, Nodes [NNode].Count);
            Nodes [NNode].First:=Index;
            for NItem:=1 to Nodes [NNode].Count
                do begin
                   Read (F, Edges [Index]);
                   Inc (Index);
                end;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NNode, Index: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Possible
        then begin
             Writeln (F, 'YES');
             for NNode:=1 to N
                 do begin
                    Write (F, Nodes [NNode].Count);
                    for Index:=Nodes [NNode].First to Nodes [NNode].First+Nodes [NNode].Count-1
                        do Write (F, #32, Edges [Index]);
                    Writeln (F);
                 end;
        end
        else Writeln (F, 'NO');
     Close (F);
end;

var
   IndexesCount: LongInt;
   Indexes: array [1..MaxN] of LongInt;

procedure DFS;

procedure DFSVisit (aNode: LongInt);
var
   Index: LongInt;
begin
     Nodes [aNode].State:=1;
     for Index:=Nodes [aNode].First to Nodes [aNode].First+Nodes [aNode].Count-1
         do case Nodes [Edges [Index]].State of
                 0: begin
                         Nodes [Edges [Index]].Parent:=aNode;
                         DFSVisit (Edges [Index]);
                    end;
            end;
     Nodes [aNode].State:=2;
     Inc (IndexesCount);
     Indexes [IndexesCount]:=aNode;
end;

var
   NNode: LongInt;
begin
     IndexesCount:=0;
     for NNode:=1 to N
         do Nodes [NNode].State:=0;
     DFSVisit (1);
end;

procedure Swap (var aA, aB: LongInt);
var
   Temp: LongInt;
begin
     Temp:=aA;
     aA:=aB;
     aB:=Temp;
end;

procedure MoveToFront (aNode: LongInt);
var
   Index: LongInt;
begin
     if Nodes [aNode].Moved
        then Exit;
     with Nodes [Parents [aNode]]
          do for Index:=First to First+Count-1
                 do if Edges [Index]=aNode
                       then begin
                            Swap (Edges [Index], Edges [WIndex]);
                            Inc (WIndex);
                       end;
     Nodes [aNode].Moved:=true;
     if Parents [aNode]<>1
        then MoveToFront (Parents [aNode]);
end;

procedure DoSwaps;
var
   Index: LongInt;
begin
     for Index:=1 to N
         do begin
            Nodes [Index].WIndex:=Nodes [Index].First;
            Nodes [Index].Moved:=false;
         end;
     for Index:=1 to N-1
         do MoveToFront (Indexes [Index]);
end;

procedure Solve;
var
   NNode: LongInt;
begin
     DFS;
     DoSwaps;
     DFS;
     Possible:=true;
     for NNode:=2 to N
         do if Nodes [NNode].Parent<>Parents [NNode]
               then begin
                    Possible:=false;
                    Exit;
               end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
