const MAXN=4010;MAXM=100010;
var rl,need:array[0..MAXN]of longint;
    patr:array[1..MAXN,1..MAXN]of byte;
    begedg:array[1..MAXN+10]of longint;
    edges:array[1..MAXM+1,1..4]of longint;
    n,m:longint;

procedure Qsort(be,en:longint);
var x,t,l,r,e1,e2:longint;
begin
     x:=edges[(be+en)div 2,1];
     l:=be;
     r:=en;
     while l<r do begin
           while edges[l,1]<x do inc(l);
           while edges[r,1]>x do dec(r);
           if l<=r then begin
              t:=edges[l,1];
              edges[l,1]:=edges[r,1];
              edges[r,1]:=t;
              t:=edges[l,2];
              edges[l,2]:=edges[r,2];
              edges[r,2]:=t;
              t:=edges[l,3];
              edges[l,3]:=edges[r,3];
              edges[r,3]:=t;
              t:=edges[l,4];
              edges[l,4]:=edges[r,4];
              edges[r,4]:=t;
              inc(l);
              dec(r);
           end;
     end;
     if r>be then Qsort(be,r);
     if l<en then Qsort(l,en);
end;

procedure Load;
var i,ws,us:longint;
begin
     read(n,m);
     for i:=1 to n do read(need[i]);
     FOR I:=1 TO M DO BEGIN
         read(edges[i,1],edges[i,2],edges[i,3]);
         edges[i,4]:=i;
     END;
     Qsort(1,m);
     ws:=1;
     us:=1;
     for i:=2 to m+1 do begin
         if edges[i,1]<>us then begin
            begedg[us]:=ws;
            ws:=i;
            us:=edges[i,1];
         end;
     end;
     begedg[n+1]:=m+1;
     for i:=n downto 2 do begin
         if begedg[i+1]=0 then begedg[i+1]:=begedg[i];
     end;
end;

var ledg,path:array[0..MAXN]of longint;
    was:array[0..MAXN]of byte;

procedure Dejkstra;
var i,j,cur,min:longint;
begin
     for i:=1 to n do begin
         was[i]:=0;
         path[i]:=0;
         ledg[i]:=0;
     end;
     rl[0]:=2000000010;
     cur:=1;
     rl[1]:=0;
     was[cur]:=1;
     for i:=1 to n do begin
         for j:=begedg[cur] to begedg[cur+1]-1 do begin
             if was[edges[j,2]]=1 then continue;
             if rl[edges[j,2]]>rl[edges[j,1]]+edges[j,3] then begin
                rl[edges[j,2]]:=rl[edges[j,1]]+edges[j,3];
                path[edges[j,2]]:=edges[j,1];
                ledg[edges[j,2]]:=j;
             end;
         end;
         min:=0;
         for j:=1 to n do begin
             if was[j]=1 then continue;
             if rl[j]<rl[min] then min:=j;
         end;
         cur:=min;
         was[cur]:=1;
     end;
     for i:=1 to n do begin
         cur:=path[j];
         while cur<>1 do begin
               patr[j,cur]:=1;
               cur:=path[cur];
         end;
         patr[j,1]:=1;
     end;
end;

var alldf:longint;

procedure ProcessVer(ver:longint);
var df,i:longint;
begin
     df:=need[ver]-rl[ver];
     inc(edges[ledg[ver],3],df);
     inc(rl[ver],df);
     inc(alldf,abs(df));
     for i:=1 to n do begin
         if patr[i,ver]=1 then inc(rl[i],df);
     end;
end;

procedure UnQsort(be,en:longint);
var t,l,r,x:longint;
begin
     x:=edges[(be+en)div 2,4];
     l:=be;
     r:=en;
     while l<r do begin
           while edges[l,4]<x do inc(l);
           while edges[r,4]>x do dec(r);
           if l<=r then begin
              t:=edges[l,3];
              edges[l,3]:=edges[r,3];
              edges[r,3]:=t;
              t:=edges[l,4];
              edges[l,4]:=edges[r,4];
              edges[r,4]:=t;
              inc(l);
              dec(r);
           end;
     end;
     if r>be then UnQsort(be,r);
     if l<en then UnQsort(l,en);
end;

procedure Solve;
var i,j,good:longint;
begin
     for i:=1 to n do begin
         for j:=1 to n do begin
             patr[i,j]:=0;
         end;
         rl[i]:=2000000100;
     end;
     Dejkstra;
     alldf:=0;
     for i:=2 to n do begin
         ProcessVer(i);
     end;
     good:=0;
     for i:=1 to n do if (need[i]-rl[i]<>0)then good:=1;
     if good=1 then write('-1')
     else begin
          UnQsort(1,m);
          write(alldf);
          for i:=1 to m do begin
              writeln;
              write(edges[i,3]);
              if edges[i,3]<0 then begin
                 close(output);
                 rewrite(Output);
                 write('-1');
                 exit;
              end;
          end;
     end;
end;

begin
     assign(input,'minister.in');
     assign(output,'minister.out');
     reset(input);
     rewrite(output);
     Load;
     Solve;
     close(input);
     close(output);
end.
