{$I-,Q-,R-,S-}
const
  MAXN = 205;
  MAXM = 2005;
  MAXK = 105;

  INFINITE = 10000000;
type
  Integer = Longint;

  TRoad = record
    v1, v2, m: Integer;
    Used: Boolean;
  end;
var
  a, Rad: array[1..MAXN, 1..MAXN] of Integer;
  Roads: array[1..MAXM] of TRoad;
  c, b: array[1..MAXN] of Integer;
  n, k, m: Integer;
  Sum: Double;
  Ans: array[1..MAXK, 0..MAXM] of Integer;

procedure Init();
var i: Integer;
begin
  Assign(Input, 'brides.in');
  Reset(Input);
  Assign(Output, 'brides.out');
  Rewrite(Output);

  Read(n, m, k);
  for i := 1 to m do with Roads[i] do
  begin
    Read(v1, v2, m);
    Used := False;
  end;
end;

procedure AddToMatrix();
var i, j, t, Min, Numroad: Integer;
begin
  for i := 1 to n do
    for j := i + 1 to n do
    begin
      Min := INFINITE;
      NumRoad := 0;
      for t := 1 to m do with Roads[t] do
        if not Used and (((v1 = i) and (v2 = j)) or ((v1 = j) and (v2 = i))) and (m < Min) then
        begin
          Min := Roads[t].m;
          NumRoad := t;
        end;

      Rad[i, j] := NumRoad;
      Rad[j, i] := NumRoad;
      a[i, j] := Min;
      a[j, i] := Min;
    end;
end;

procedure FindMinPath();
var
  NNew: array[1..MAXN] of Boolean;
  i, NumMin, Min: Integer;
  IsEnd: Boolean;
begin
  {Deykstra}
  for i := 1 to n do
  begin
    b[i] := a[1, i];
    c[i] := 1;
  end;
  Fillchar(NNew, Sizeof(NNew), 0);
  NNew[1] := True;
  IsEnd := False;

  while not IsEnd do
  begin
    IsEnd := True;
    Min := INFINITE;
    NumMin := 1;
    for i := 1 to n do if not NNew[i] and (b[i] < Min) then
    begin
      IsEnd := False;
      Min := b[i];
      NumMin := i;
    end;
    NNew[NumMin] := True;
    for i := 1 to n do if not NNew[i] then
      if Min + a[NumMin, i] < b[i] then
      begin
        b[i] := Min + a[NumMin, i];
        c[i] := NumMin;
      end;
  end;
end;

procedure DeleteRoads(const k, i: Integer);
begin
  if c[k] = k then Exit;
  Roads[Rad[c[k], k]].Used := True;
  Inc(Ans[i][0]);
  Ans[i][Ans[i][0]] := Rad[c[k], k];
  DeleteRoads(c[k], i);
end;

procedure Done(const IsOk: Boolean);
var i, j: Integer;
begin
  if IsOk then
  begin
    Writeln(Sum / k:0:8);
    for i := 1 to k do
    begin
      Write(Ans[i][0],' ');
      for j := Ans[i][0] downto 1 do Write(Ans[i][j],' ');
      Writeln('');
    end;
  end else
  begin
    Writeln(-1);
  end;
  Close(Input);
  Close(Output);
  Halt;
end;

procedure Solve();
var i: Integer;
begin
  Sum := 0;
  for i := 1 to k do
  begin
    AddToMatrix();
    FindMinPath();
    if b[n] = INFINITE then Done(False);
    Sum := Sum + b[n];
    DeleteRoads(n, i);
  end;
end;

begin
  Init();
  Solve();
  Done(True);
end.
