{$I-,Q-,R-,S-}
const
  MAXN = 10005;
  MAXM = 500005;
type
  Integer = Longint;
var
  n, uk: Integer;
  Tree: array[1..MAXN] of Integer;
  List, lb, le, List2: array[1..MAXM] of Integer;
  NNew: array[1..MAXN] of Boolean;

procedure Init();
var i, Count, v, j: Integer;
begin
  Assign(Input, 'dfs.in');
  Reset(Input);
  Assign(Output, 'dfs.out');
  Rewrite(Output);
  Read(n);
  for i := 2 to n do Read(Tree[i]);
  for i := 1 to n do
  begin
    Read(Count);
    Lb[i] := Uk + 1;
    for j := 1 to Count do
    begin
      Read(v);
      Inc(Uk);
      List[Uk] := v;
    end;
    Le[i] := Uk;
  end;
  List2 := List;
end;

procedure Sort(const l,r: longint; const k: Integer);
var
  i,j,y: longint;
  x: Boolean;
begin
  i := l;
  j := r;
  x := Tree[List2[(l+r) div 2]] = k;
  repeat
    while (Tree[List2[i]] = k) > x do inc(i);
    while x > (Tree[List2[j]] = k) do dec(j);
    if not(i>j) then
    begin
      y:=List2[i];
      List2[i]:=List2[j];
      List2[j]:=y;

      inc(i);
      j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j, k);
  if i<r then sort(i,r, k);
end;


function OnPath(const a: Integer; b: Integer): Boolean;
begin
  while b <> 0 do
  begin
    if b = a then
    begin
      OnPath := True;
      Exit;
    end;
    b := Tree[b];
  end;
  OnPath := False;
end;

procedure FindPred(const a: Integer; b: Integer; var k, ka, kb: Integer);
var
  Lm: array[1..MAXN] of Boolean;
  ta, p: Integer;
begin
  Fillchar(Lm, Sizeof(Lm), 0);
  ta := a;
  while ta <> 0 do
  begin
    Lm[ta] := True;
    ta := Tree[Ta];
  end;

  while b <> 0 do
  begin
    if Lm[b] then
    begin
      k := b;
      kb := p;
    end;
    p := b;
    b := Tree[b];
  end;

  ta := a;
  while Tree[ta] <> 0 do
  begin
    if Lm[Tree[ta]] then ka := ta;
    ta := Tree[Ta];
  end;
end;

procedure Swap(var a, b: Integer);
var t: Integer;
begin
  t := a;
  a := b;
  b := t;
end;

procedure Remove(const k, kl, lr: Integer);
var li, ri, i: Integer;
begin
  for i := Lb[k] to Le[k] do
  begin
    if List2[i] = kl then ri := i;
    if List2[i] = lr then li := i;
  end;
  if ri > li then Swap(List2[ri], List2[li]);
end;

procedure Dfs(const k: Integer);
var i, p, tp, kp: Integer;
begin
  NNew[k] := True;

  for i := lb[k] to le[k] do
  begin
    if Tree[List[i]] <> k then
    begin
      if not OnPath(Tree[List[i]], k) then
      begin
        FindPred(Tree[List[i]], k, p, tp, kp);
        Remove(p, tp, kp);
      end;
    end else if Not NNew[List[i]] then Dfs(List[i]);
  end;
end;

procedure Dfs2(const k: Integer);
var i: Integer;
begin
  NNew[k] := True;
  for i := lb[k] to le[k] do if not NNew[List2[i]] then
  begin
    if Tree[List2[i]]<>k then
    begin
      Writeln('NO');
      Close(Input);
      Close(Output);
      Halt;
    end;
    Dfs2(List2[i]);
  end;
end;

procedure Solve();
var i: Integer;
begin
  for i := 1 to n do if Le[i] > Lb[i] then Sort(Lb[i], Le[i], i);
  Dfs(1);
  fillchar(NNew, Sizeof(NNew), 0);
  Dfs2(1);
  for i := 1 to n do if not NNew[i] then
  begin
    Writeln('NO');
    Close(Input);
    Close(Output);
    Halt;
  end;
end;

procedure Done();
var i, j: Integer;
begin
  Writeln('YES');

  for i := 1 to n do
  begin
    Write(Le[i] - Lb[i] + 1, ' ');
    for j := lb[i] to le[i] do Write(List2[j],' ');
    Writeln('');
  end;

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
