uses Balls;
const
     MaxN=24;
type
    TMask=array [1..MaxN] of LongInt;
var
   N, K: LongInt;
   States, Mask: TMask;
   NumberOf: array [0..2] of LongInt;

procedure ReadData;
begin
     Init (N, K);
end;

procedure WriteData;
begin
     Finish (States);
end;

procedure UpdateState (aItem: LongInt; aState: Byte);
begin
     Dec (NumberOf [States [aItem]]);
     Inc (NumberOf [aState]);
     States [aItem]:=aState;
end;

procedure Fill (aState: Byte; aStart, aFinish: LongInt);
var
   NItem: LongInt;
begin
     for NItem:=aStart to aFinish
         do UpdateState (NItem, aState);
end;

function IsBad (aLeft, aRight: LongInt): Boolean;
var
   NItem: LongInt;
begin
     for NItem:=1 to aLeft-1
         do Mask [Nitem]:=0;
     for NItem:=aLeft to aRight
         do Mask [NItem]:=1;
     for NItem:=aRight+1 to N
         do Mask [Nitem]:=0;
     IsBad:=IsRadioactive (Mask);
end;

procedure Solve;
var
   Index, Delta: LongInt;
begin
     FillChar (NumberOf, SizeOf (NumberOf), 0);
     for Index:=1 to N
         do States [Index]:=2;
     NumberOf [2]:=N;
     Index:=1;
     Delta:=0;
     repeat
           if NumberOf [2]=K-NumberOf [1]
              then begin
                   Fill (1, Index, N);
                   Break;
              end
              else if NumberOf [1]=K
                      then begin
                           Fill (0, Index, N);
                           Break;
                      end;
           if Index+Delta>N
              then Delta:=N-Index;
           if IsBad (Index, Index+Delta)
              then if Delta=0
                      then begin
                           UpdateState (Index, 1);
                           Inc (Index);
                      end
                      else Delta:=Delta shr 1
              else begin
                   Fill (0, Index, Index+Delta);
                   Inc (Delta);
                   Inc (Index, Delta);
              end;
     until false;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
