const
     FileIn='princess.in';
     FileOut='princess.out';
     MaxM=50;
     MaxN=50;
     MaxK=2*(MaxM+MaxN);
type
    TExit=record
                X, Y: LongInt;
                D: Char;
          end;
    TDirection=record
                     DX, DY: LongInt;
                     I: Char;
               end;
    THCell=record
                 Present: Boolean;
                 X, Y: LongInt;
           end;
    TPoint=record
                 X, Y: LongInt;
           end;
    TCell=record
                State: Byte;
                Value: LongInt;
                From: LongInt;
          end;
var
   Directions: array ['A'..'Z'] of TDirection;

   M, N, K, Z: LongInt;
   Exits: array [1..MaxK*2] of TExit;
   MMatrix: array [0..MaxM+1, 0..MaxN+1] of LongInt;
   Cells: array [0..MaxM, 0..MaxN, 'A'..'Z'] of Boolean;
   HMatrix: array [0..MaxM+1, 0..MaxN+1] of THCell;
   StartX, StartY, PrincessX, PrincessY: LongInt;
   Matrix: array [0..MaxM+1, 0..MaxN+1, false..true] of TCell;
   Possible: Boolean;
   AnswerLength: LongInt;
   Answer: array [1..50*MaxM*MaxN] of TPoint;

procedure ReadData;
var
   F: Text;
   NExit, NMonster, NSystem, NHole: LongInt;
   Ch, D: Char;
   S: string;
   X, Y: Longint;
   Holes: array [1..MaxM*MaxN] of TPoint;
   P, L, W: LongInt;
begin
     with Directions ['L']
          do begin
             DX:=-1;
             DY:=0;
             I:='R';
          end;
     with Directions ['R']
          do begin
             DX:=1;
             DY:=0;
             I:='L';
          end;
     with Directions ['U']
          do begin
             DX:=0;
             DY:=-1;
             I:='D';
          end;
     with Directions ['D']
          do begin
             DX:=0;
             DY:=1;
             I:='U';
          end;
     with Directions ['S']
          do begin
             DX:=0;
             DY:=0;
             I:='S';
          end;

     Assign (F, FileIn);
     Reset (F);
     Readln (F, M, N, K);
     for NExit:=1 to K
         do with Exits [NExit]
                 do Read (F, X, Y, Ch, D);
     for NExit:=1 to K
         do begin
            Exits [K+NExit].X:=Exits [NExit].X+Directions [Exits [NExit].D].DX;
            Exits [K+NExit].Y:=Exits [NExit].Y+Directions [Exits [NExit].D].DY;
            Exits [K+NExit].D:=Directions [Exits [NExit].D].I;
         end;
     K:=K*2;
     Readln (F, Z);
     FillChar (MMatrix, SizeOf (MMatrix), 0);
     for NMonster:=1 to Z
         do begin
            Readln (F, X, Y, Ch, S);
            if S='P'
               then Inc (MMatrix [X, Y], 2)
               else if S='MT'
                       then Inc (MMatrix [X, Y], 4)
                       else if S='AM'
                               then Inc (MMatrix [X, Y], 6)
                               else if S='BA'
                                       then Inc (MMatrix [X, Y], 8)
                                       else if S='BU'
                                               then Inc (MMatrix [X, Y], 10);
         end;
     FillChar (Cells, SizeOf (Cells), true);
     Readln (F, W);
     for NExit:=1 to W
         do begin
            Read (F, X, Y, Ch, D);
            Cells [X, Y, D]:=false;
            X:=Directions [D].DX+X;
            Y:=Directions [D].DY+Y;
            Cells [X, Y, Directions [D].I]:=false;
         end;
     Readln (F, L);
     for NSystem:=1 to L
         do begin
            Read (F, P);
            for NHole:=1 to P
                do Read (F, Holes [NHole].X, Holes [NHole].Y);
            for NHole:=1 to P
                do with HMatrix [Holes [NHole].X, Holes [NHole].Y]
                        do begin
                           Present:=true;
                           X:=Holes [(NHole mod P)+1].X;
                           Y:=Holes [(NHole mod P)+1].Y;
                        end;
         end;
     Readln (F, StartX, StartY);
     Readln (F, PrincessX, PrincessY);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Possible
        then begin
             Writeln (F, Matrix [Answer [1].X, Answer [1].Y, true].Value);
             for NItem:=AnswerLength downto 1
                 do Writeln (F, Answer [NItem].X, #32, Answer [NItem].Y);
        end
        else Writeln (F, -1);
     Close (F);
end;

type
    TFIFOItem=record
                    X, Y: LongInt;
                    Bride: Boolean;
                    From: LongInt;
                    Skip: Boolean;
                    Value: LongInt;
              end;
var
   FIFO: array [1..MaxN*MaxM*1000] of TFIFOItem;
   NFIFOItem, FIFOLen: LongInt;

procedure Wave;

procedure Push (aX, aY: LongInt; aBride: Boolean; aValue: LongInt; aFrom: LongInt; aSkip: Boolean);
begin
     Inc (FIFOLen);
     with FIFO [FIFOLen]
          do begin
             X:=aX;
             Y:=aY;
             Value:=aValue;
             From:=aFrom;
             Bride:=aBride;
             Skip:=aSkip;
          end;
end;

procedure TryToGo (aDirection: Char);
var
   X, Y: LongInt;
   Bride: Boolean;
   NewValue: LongInt;
begin
     X:=FIFO [NFIFOItem].X+Directions [aDirection].DX;
     Y:=FIFO [NFIFOItem].Y+Directions [aDirection].DY;
     if (1<=X) and (X<=M) and (1<=Y) and (Y<=N) and (Cells [FIFO [NFIFOItem].X, FIFO [NFIFOItem].Y, aDirection])
        then begin
             if (X=1) and (Y=3) and (FIFO [NFIFOItem].X=1) and (FIFO [NFIFOItem].Y=2)
                then Write;
             Bride:=FIFO [NFIFOItem].Bride or ((X=PrincessX) and (Y=PrincessY));
             NewValue:=FIFO [NFIFOItem].Value+MMatrix [X, Y];
             if ((Matrix [X, Y, Bride].State=0) or ((Matrix [X, Y, Bride].State=1) and (NewValue<Matrix [X, Y, Bride].Value)))
                then begin
                     Push (X, Y, Bride, NewValue, NFIFOItem, HMatrix [X, Y].Present);
                     Matrix [X, Y, Bride].Value:=NewValue;
                     Matrix [X, Y, Bride].State:=1;
                     Matrix [X, Y, Bride].From:=FIFOLen;
                     if HMatrix [X, Y].Present
                        then Push (HMatrix [X, Y].X, HMatrix [X, Y].Y, Bride, NewValue, FIFOLen, false);
                end;
        end;
end;

begin
     FillChar (Matrix, SizeOf (Matrix), 0);

     FIFOLen:=0;
     Push (StartX, StartY, (StartX=PrincessX) and (StartY=PrincessY), 0, 0, true);
     NFIFOItem:=FIFOLen;
     TryToGo ('S');
     NFIFOItem:=FIFOLen;
     while NFIFOItem<=FIFOLen
           do begin
              if not FIFO [NFIFOItem].Skip
                 then begin
                      TryToGo ('S');
                      TryToGo ('L');
                      TryToGo ('R');
                      TryToGo ('U');
                      TryToGo ('D');
                 end;
              Inc (NFIFOItem);
           end;
end;

procedure FindAnswer;
var
   NExit, NItem: LongInt;
begin
     Possible:=false;
     for NItem:=1 to K
         do if Matrix [Exits [NItem].X, Exits [NItem].Y, true].State=1
               then begin
                    Possible:=true;
                    Break;
               end;
     if not Possible
        then Exit;
     for NExit:=1 to K
         do if (Matrix [Exits [NExit].X, Exits [NExit].Y, true].State=1) and
               (Matrix [Exits [NExit].X, Exits [NExit].Y, true].Value<
                Matrix [Exits [NItem].X, Exits [NItem].Y, true].Value)
               then NItem:=NExit;
     NExit:=NItem;
     NItem:=Matrix [Exits [NExit].X, Exits [NExit].Y, true].From;
     AnswerLength:=0;
     while NItem<>1
           do begin
              if (AnswerLength=0) or (Answer [AnswerLength].X<>FIFO [NItem].X) or (Answer [AnswerLength].Y<>FIFO [NItem].Y)
                 then begin
                      Inc (AnswerLength);
                      Answer [AnswerLength].X:=FIFO [NItem].X;
                      Answer [AnswerLength].Y:=FIFO [NItem].Y;
                 end;
              NItem:=FIFO [NItem].From;
           end;
end;

procedure Solve;
begin
     Wave;
     FindAnswer;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
