{$I-,Q-,R-,S-}
type
  t2dla=array[1..50,1..50] of longint;
  t2dba=array[1..50,1..50] of byte;
  tbola=array[1..50,1..50] of boolean;

const
  vx:array[0..3] of shortint = (1,0,-1,0);
  vy:array[0..3] of shortint = (0,-1,0,1);
  alot=1000000;

var
  d,i,j,m,n,x0,y0,xp,yp,x,y:byte;
  e:tbola;
  k,z:integer;
  a:t2dla;
  w:array[1..50,1..50,0..3] of boolean;
  hx,hy:t2dba;
  hc,hc1:integer;
  holesx,holesy:array[1..2500] of byte;
  dm,pm,ep:t2dla;
  dmx,dmy,pmx,pmy,epx,epy:t2dba;
  dmh,pmh,eph:tbola;
  sm,best:longint;
  lastx,lasty:byte;
  circle:array[1..50,1..50] of integer;

procedure out(x,y:byte);
begin
  if (x=lastx) and (y=lasty) then
    exit;
  writeln(x,' ',y);
  lastx:=x;
  lasty:=y;
end;

procedure nosol;
begin
  write(-1);
  close(input);
  close(output);
  halt(0);
end;

function readmonsterbulletscount:byte;
var
  c:char;
begin
  c:=' ';
  while c=' ' do
    read(c);
  case c of
    'K':readmonsterbulletscount:=0;
    'P':readmonsterbulletscount:=1;
    'M':readmonsterbulletscount:=2;
    'A':readmonsterbulletscount:=3;
    'B':begin
      read(c);
      if c='A' then
        readmonsterbulletscount:=4
      else
        readmonsterbulletscount:=5;
    end;
  end;
end;

function readdirection:byte;
var
  c:char;
begin
  c:=' ';
  while c=' ' do
    read(c);
  case c of
    'R':readdirection:=0;
    'U':readdirection:=1;
    'L':readdirection:=2;
    'D':readdirection:=3;
  end;
end;

procedure dijkstra(var d:t2dla;var fromx,fromy:t2dba;var byh:tbola);
var
  z,i,j,x,y:byte;
  h:array[1..2500] of record
    x,y:byte;
  end;
  hsize:integer;
  p:array[1..50,1..50] of integer;

function parent(x:integer):integer;
begin
  parent:=x shr 1;
end;

function left(x:integer):integer;
begin
  left:=x shl 1;
end;

function right(x:integer):integer;
begin
  right:=(x shl 1)+1;
end;

procedure swap(a,b:integer);
var
  i1,j1,i2,j2:byte;
begin
  i1:=h[a].x;
  j1:=h[a].y;
  i2:=h[b].x;
  j2:=h[b].y;
  p[i1,j1]:=b;
  p[i2,j2]:=a;
  h[a].x:=i2;
  h[a].y:=j2;
  h[b].x:=i1;
  h[b].y:=j1;
end;

function less(a,b:integer):boolean;
begin
  less:=d[h[a].x,h[a].y]<d[h[b].x,h[b].y];
end;

procedure siftup(a:integer);
var
  p:integer;

begin
  if a=1 then
    exit;
  p:=parent(a);
  if less(a,p) then begin
    swap(a,p);
    siftup(p);
  end;
end;

procedure siftdown(a:integer);
var
  l,r:integer;
begin
  l:=left(a);
  if l>hsize then
    exit;
  r:=right(a);
  if r<=hsize then
    if less(r,l) then
      l:=r;
  if less(l,a) then begin
    swap(l,a);
    siftdown(l);
  end;
end;

procedure insert(i,j:byte);
begin
  inc(hsize);
  h[hsize].x:=i;
  h[hsize].y:=j;
  p[i,j]:=hsize;
  siftup(hsize);
end;

procedure extractmin(var i,j:byte);
begin
  i:=h[1].x;
  j:=h[1].y;
  swap(1,hsize);
  dec(hsize);
  siftdown(1);
end;

procedure relax(i,j,i0,j0:byte;bh:boolean;l1:longint);
begin
  if (d[i,j]>l1) or ((d[i,j]=l1) and (byh[i,j]>bh)) then begin
    d[i,j]:=l1;
    byh[i,j]:=bh;
    fromx[i,j]:=i0;
    fromy[i,j]:=j0;
    siftup(p[i,j]);
  end;
end;

begin
  hsize:=0;
  for i:=1 to m do
    for j:=1 to n do
      insert(i,j);
  while hsize>0 do begin
    extractmin(x,y);
//    if byh[x,y] or ((hx[x,y]=x) and (hy[x,y]=y)) then begin
      for z:=0 to 3 do begin
        if not w[x,y,z] then begin
          i:=x+vx[z];
          j:=y+vy[z];
          relax(i,j,x,y,false,d[x,y]+a[x,y]);
        end;
      end;
//    end;
    if not ((hx[x,y]=x) and (hy[x,y]=y)) then begin
      i:=hx[x,y];
      j:=hy[x,y];
      relax(i,j,x,y,true,d[x,y]+a[x,y]);
    end;
  end;
end;

procedure outcircle(x1,y1,x2,y2:byte);
var
  i,j,x,y:byte;
begin
  out(x1,y1);
  i:=hx[x1,y1];
  j:=hy[x1,y1];
  while (i<>x2) or (j<>y2) do begin
    out(i,j);
    x:=i;
    y:=j;
    i:=hx[x,y];
    j:=hy[x,y];
  end;
  out(x2,y2);
end;

procedure outnpath(const fromx,fromy:t2dba;const byh:tbola;x2,y2:byte);
var
  sx,sy:array[1..100000] of byte;
  z,sc:longint;
  x,y,i,j:byte;

procedure add(x,y:byte);
begin
  inc(sc);
  sx[sc]:=x;
  sy[sc]:=y;
end;

begin
  x:=x2;
  y:=y2;
  sc:=0;
  while (fromx[x,y]<>0) and (fromy[x,y]<>0) do begin
    add(x,y);
    i:=x;
    j:=y;
    x:=fromx[i,j];
    y:=fromy[i,j];
  end;
  add(x,y);
  for z:=sc downto 2 do begin
    x:=sx[z];
    y:=sy[z];
    i:=sx[z-1];
    j:=sy[z-1];
    if (not byh[x,y]) and (not byh[i,j]) then
      outcircle(x,y,x,y)
    else
      out(x,y);
  end;
  outcircle(sx[1],sy[1],sx[1],sy[1]);
end;

procedure outbpath(const fromx,fromy:t2dba;const byh:tbola;x2,y2:byte);
var
  x,y,i,j:byte;

begin
  x:=x2;
  y:=y2;
  i:=fromx[x,y];
  j:=fromy[x,y];
  outcircle(x,y,x,y);
  while (i<>0) and (j<>0) do begin
    if circle[i,j]=circle[x,y] then
      outcircle(x,y,i,j)
    else
      out(i,j);
    x:=i;
    y:=j;
    i:=fromx[x,y];
    j:=fromy[x,y];
  end;
end;

begin
  assign(input,'princess.in');
  reset(input);
  assign(output,'princess.out');
  rewrite(output);

  fillchar(e,sizeof(e),false);
  readln(m,n);


  {Exits}

  readln(k);
  for z:=1 to k do begin
    readln(i,j);
    e[i,j]:=true;
  end;
  fillchar(a,sizeof(a),0);


  {Monsters}

  read(z);
  for k:=1 to z do begin
    read(i,j);
    inc(a[i,j],readmonsterbulletscount);
  end;

  {Walls}

  fillchar(w,sizeof(w),false);
  for i:=1 to m do begin
    w[i,1,1]:=true; {up}
    w[i,n,3]:=true; {down}
  end;
  for j:=1 to n do begin
    w[1,j,2]:=true; {left}
    w[m,j,0]:=true; {right}
  end;

  readln;
  read(z);
  for k:=1 to z do begin
    read(i,j);
    d:=readdirection;
    w[i,j,d]:=true;
    x:=i+vx[d];
    y:=j+vy[d];
    if (x>0) and (y>0) and (x<=m) and (y<=n) then begin
      d:=(d+2) mod 4;
      w[x,y,d]:=true;
    end;
  end;


  {Holes}

  fillchar(circle,sizeof(circle),0);
  for i:=1 to m do
    for j:=1 to n do begin
      hx[i,j]:=i;
      hy[i,j]:=j;
    end;
  read(z);
  for k:=1 to z do begin
    read(hc1);
    for hc:=1 to hc1 do begin
      read(holesx[hc],holesy[hc]);
      circle[holesx[hc],holesy[hc]]:=k;
    end;
    for hc:=1 to hc1-1 do begin
      i:=holesx[hc];
      j:=holesy[hc];
      hx[i,j]:=holesx[hc+1];
      hy[i,j]:=holesy[hc+1];
    end;
    i:=holesx[hc1];
    j:=holesy[hc1];
    hx[i,j]:=holesx[1];
    hy[i,j]:=holesy[1];
  end;

  read(x0,y0);
  read(xp,yp);

  sm:=a[x0,y0]+a[xp,yp];
  a[x0,y0]:=0;
  a[xp,yp]:=0;

  fillchar(dmx,sizeof(dmx),0);
  fillchar(dmy,sizeof(dmy),0);
  fillchar(pmx,sizeof(pmx),0);
  fillchar(pmy,sizeof(pmy),0);
  fillchar(epx,sizeof(epx),0);
  fillchar(epy,sizeof(epy),0);
  fillchar(dmh,sizeof(dmh),false);
  fillchar(pmh,sizeof(pmh),false);
  fillchar(eph,sizeof(eph),false);
  for i:=1 to m do begin
    for j:=1 to n do begin
      dm[i,j]:=alot;
      pm[i,j]:=alot;
      if e[i,j] then
        ep[i,j]:=0
      else
        ep[i,j]:=alot;
    end;
  end;
  dm[x0,y0]:=0;
  pm[xp,yp]:=0;

  dijkstra(dm,dmx,dmy,dmh);
  dijkstra(pm,pmx,pmy,pmh);
  dijkstra(ep,epx,epy,eph);

  x:=0;
  y:=0;
  best:=alot;
  for i:=1 to m do begin
    for j:=1 to n do begin
      if best>dm[i,j]+pm[i,j]+ep[i,j]+a[i,j]+sm then begin
        best:=dm[i,j]+pm[i,j]+ep[i,j]+a[i,j]+sm;
        x:=i;
        y:=j;
      end;
    end;
  end;
  if best>=alot then
    nosol;

  writeln(best*2);
  lastx:=0;
  lasty:=0;
  outcircle(x0,y0,x0,y0);
  outnpath(dmx,dmy,dmh,x,y);
  outbpath(pmx,pmy,pmh,x,y);
  outnpath(pmx,pmy,pmh,x,y);
  outbpath(epx,epy,eph,x,y);

  close(input);
  close(output);
end.
