{$I-,Q-,R-,S-}
const
  MAXN = 66;
type
  Integer = Longint;
  TArray = array[0..MAXN] of Integer;
  TMatrix = array[0..MAXN] of TArray;
var
  Mask, Mask2, WhiteSum, BlackSum, AnsMask, Seg, Link, CSeg: TMatrix;
  Exists, Last, TmpLast, lTmp: array[1..MAXN] of Integer;
  Nach, Links, Points, Color: TArray;
  n, m, k: Integer;

procedure Init();
var
  i, j: Integer;
  Ch: Char;
begin
  Assign(Input, 'masterpiece.in');
  Reset(Input);
  Assign(Output, 'masterpiece.out');
  Rewrite(Output);

  Readln(n, m, k);
  for i := 1 to n do
  begin
    for j := 1 to m do
    begin
      Read(Ch);
      Mask[i, j] := Ord(Ch) - 48;
      AnsMask[i, j] := 2;
    end;
    Readln;
  end;

  for i := 1 to n do Last[i] := m;
end;

procedure SetSums();
var i, j: Integer;
begin
  for i := 1 to n do
    for j := 1 to m do
    begin
      BlackSum[i, j] := BlackSum[i, j - 1] + Ord(Mask[i, j] = 1);
      WhiteSum[i, j] := WhiteSum[i, j - 1] + Ord(Mask[i, j] = 0);
    end;
end;

function GetSum(const i, k1, k2, c: Integer): Integer;
begin
  if c = 0 then GetSum := WhiteSum[i, k2] - WhiteSum[i, k1 - 1] else
    GetSum := BlackSum[i, k2] - BlackSum[i, k1 - 1];
end;

procedure FillMask(var Mask: TMatrix; const i, k1, k2, c: Integer);
var j: Integer;
begin
  for j := k1 to k2 do Mask[i, j] := c;
end;

procedure Swap(var a, b: Integer);
var t: Integer;
begin
  t := a;
  a := b;
  b := t;
end;

procedure Sort(const l,r: longint; const k: Integer);
var
  i,j,y, x: longint;
begin
  i := l;
  j := r;
  x := Seg[k][(l+r) div 2];
  repeat
    while Seg[k][i] > x do inc(i);
    while x > Seg[k][j] do dec(j);
    if not(i>j) then
    begin
      Swap(Seg[k][i], Seg[k][j]);
      Swap(CSeg[k][i], CSeg[k][j]);
      Swap(Link[k][i], Link[k][j]);

      inc(i);
      j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j, k);
  if i<r then sort(i,r, k);
end;

procedure Sort2(const l,r: longint);
var
  i,j,y, x: longint;
begin
  i := l;
  j := r;
  x := Nach[(l+r) div 2];
  repeat
    while Nach[i] < x do inc(i);
    while x < Nach[j] do dec(j);
    if not(i>j) then
    begin
      Swap(Nach[i], Nach[j]);
      Swap(Links[i], Links[j]);

      inc(i);
      j:=j-1;
    end;
  until i>j;
  if l<j then sort2(l,j);
  if i<r then sort2(i,r);
end;

procedure FindSegments();
var i, j, l, c, q: Integer;
begin
  for i := 1 to n do
  begin
    j := 1;
    l := 1;
    q := 1;
    c := Mask[i, 1];
    while (j <= m) do
    begin
      while (j < m) and (Mask[i, j + 1] = c) do
      begin
        Inc(l);
        Inc(j);
      end;
      Inc(Seg[i][0]);
      Seg[i][Seg[i][0]] := l;
      Link[i][Seg[i][0]] := q;
      CSeg[i][Seg[i][0]] := c;

      q := j + 1;
      Inc(j);
      l := 1;
      c := Mask[i, j];
    end;
  end;

  for i := 1 to n do Sort(1, Seg[i][0], i);
end;

function FindPoint(const l, r, lc, rc, i1: Integer): Integer;
var Min, sl, sr, p: Integer;
begin
    Min := MAXLONGINT;
    for p := l to r do
    begin
      sl := GetSum(i1, l, p, rc);
      sr := GetSum(i1, p + 1, r, lc);
      if sl + sr < Min then
      begin
        Min := sl + sr;
        FindPoint := p;
      end;
    end;
end;

function GetBad(const i1, l: Integer): Integer;
var s0, s1, sl0, sr0, sl1, sr1, Min, p, j, t, Sum: Integer;
begin
  if l = 1 then
  begin
    s0 := GetSum(i1, 1, m, 0);
    s1 := GetSum(i1, 1, m, 1);
    if s0 < s1 then
    begin
      GetBad := s0;
      FillMask(Mask2, i1, 1, m, 1);
    end else
    begin
      GetBad := s1;
      FillMask(Mask2, i1, 1, m, 0);
    end;
    Exit;
  end;
  if l = 2 then
  begin
    Min := MAXLONGINT;
    for p := 1 to m - 1 do
    begin
      sl0 := GetSum(i1, 1, p, 0);
      sr1 := GetSum(i1, p + 1, m, 1);
      sl1 := GetSum(i1, 1, p, 1);
      sr0:= GetSum(i1, p + 1, m, 0);
      if sl0 + sr1 < Min then
      begin
        Min := sl0 + sr1;
        FillMask(Mask2, i1, 1, p, 1);
        FillMask(Mask2, i1, p + 1, m, 0);
      end;
      if sl1 + sr0 < Min then
      begin
        Min := sl1 + sr0;
        FillMask(Mask2, i1, 1, p, 0);
        FillMask(Mask2, i1, p + 1, m, 1);
      end;
    end;
    GetBad := Min;
    Exit;
  end;

  for j := 1 to l do
  begin
    Nach[j] := Link[i1][j];
    Links[j] := j;
  end;
  Sort2(1, l);

  for t := 1 to l - 1 do
  begin
    if (CSeg[i1][Links[t]] <> CSeg[i1][Links[t + 1]])
      and (Link[i1][Links[t]] + Seg[i1][Links[t]] < Link[i1][Links[t + 1]])
        then
        begin
          Points[t] :=
            FindPoint(Link[i1][Links[t]] + Seg[i1][Links[t]],
              Link[i1][Links[t + 1]] - 1, CSeg[i1][Links[t]], CSeg[i1][Links[t + 1]], i1);
          Color[t] := CSeg[i1][Links[t + 1]];
        end else
        begin
          Points[t] := Link[i1][Links[t]] + Seg[i1][Links[t]] - 1;
          Color[t] := CSeg[i1][Links[t + 1]];
        end;
  end;
  Points[0] := 0;
  Points[l] := m;
  Color[0] := CSeg[i1][Links[1]];

  Sum := 0;
  for t := 0 to l - 1 do
  begin
    for j := Points[t] + 1 to Points[t + 1] do if Mask[i1][j] <> Color[t] then Inc(Sum);
    FillMask(Mask2, i1, Points[t] + 1, Points[t + 1], Color[t]);
  end;
  GetBad := Sum;
end;

procedure Solve();
var Max, i, t, Tmp, Nm, j, Min, MinN, r: Integer;
    IsMan, IsEnd: Boolean;
begin
  SetSums();
  FindSegments();

  for t := 1 to k do
  begin
    Max := 0;
    IsMan := False;
    for i := 1 to n do
    begin
      Tmp := GetBad(i, Exists[i] + 1);
      if (Last[i] - Tmp > Max) then
      begin
        IsMan := True;
        Max := Last[i] - Tmp;
        Nm := i;
        TmpLast[i] := Tmp;
      end;
    end;
    if IsMan then
    begin
      Inc(Exists[Nm]);
      Last[Nm] := TmpLast[Nm];
      for j := 1 to m do AnsMask[Nm, j] := Mask2[Nm, j];
    end else
    begin
      {trouble tormoz}
      IsEnd := True;
      for r := 1 to n do if Last[r] > 0 then
      begin
        IsEnd := False;
        Break;
      end;
      if Isend then Exit;
      Min := MAXLONGINT;
      for r := 1 to n do if Exists[r] < Min then
      begin
        Min := Exists[r];
        Minn := r;
      end;
      Inc(Exists[Minn]);
    end;
  end;
end;

procedure Done();
var Sum, i, j, q: Integer;
begin
  Sum := 0;
  for i := 1 to n do Inc(Sum, Last[i]);
  for i := 1 to n do
  begin
    q := 0;
    for j := 1 to m do Inc(q, Ord(AnsMask[i, j] = 2));
    if q > Last[i] then Inc(Sum, Last[i] - q);
  end;
  Writeln(Sum);

  for i := 1 to n do
  begin
    for j := 1 to m do Write(AnsMask[i, j]);
    Writeln;
  end;

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.