{$o-,q+,r+}
program dvd;

uses
    sysutils, math;

const
    maxn = 2000;

type
    tperm = array [1..5] of longint;

var
    a: tperm;
    u: array [1..5] of boolean;
    pc: array [1..5] of longint;
    perm: array [1..5, 1..120] of tperm;

procedure gen(j: longint; p: longint);
var
    i: longint;
begin
    if p > j then
    begin
        inc(pc[j]);
        perm[j][pc[j]] := a;
        exit;
    end;
    for i := 1 to 5 do
        if not u[i] then
        begin
            a[p] := i;
            u[i] := true;
            gen(j, p + 1);
            u[i] := false;
        end;
end;

function readname: string;
var
    c: char;
    r: string;
begin
    read(c);
    assert(c = '"');
    read(c);
    r := '"';
    while c <> '"' do
    begin
        r := r + c;
        read(c);
    end;
    r := r + '"';
    readname := r;
end;

var
    miny, maxy: longint;
    i, j, k, n, p, q, o: longint;
    l, from: array [1870..2004, 1..5, 1..5, 0..4] of longint;
    c: array [1870..2004, 1..5] of longint;
    ans: array [1869..2004, 1..5, 0..5] of longint;
    fa: array [1869..2004, 1..5, 0..5] of record p, r, q: longint end;
    y, r: array [1..maxn] of longint;
    s: array [1..maxn] of string;
    flag: boolean;
    sum: longint;
    answer: longint;
    besti, bestj: longint;

procedure outp(year, reg, chg: longint);
var
    p, q, o, pind, i, j: longint;
begin
    if year < miny then
    begin
        assert(chg = 0);
        exit;
    end;

    p := fa[year][reg][chg].p;
    if p = 0 then
    begin
        outp(year - 1, reg, chg);
        exit;
    end;

    q := fa[year][reg][chg].q;

    if p < 0 then
    begin
        p := -p;
        o := fa[year][reg][chg].r;
        outp(year - 1, o, chg - q - 1);
    end else begin
        outp(year - 1, p, chg - q);
    end;

    pind := from[year][p][reg][q];
    for j := 1 to q + 1 do
        for i := 1 to n do
            if (y[i] = year) and (r[i] = perm[q + 1][pind][j]) then
                writeln(s[i]);
end;

begin
    assign(input, 'dvd.in');
    reset(input);
    assign(output, 'dvd.out');
    rewrite(output);

    readln(n);
    miny := 2004;
    maxy := 1870;
    for i := 1 to n do
    begin
        s[i] := readname;
        read(y[i]);
        readln(r[i]);

        inc(c[y[i]][r[i]]);

        if y[i] < miny then
            miny := y[i];
        if y[i] > maxy then
            maxy := y[i];
    end;

    for j := 1 to 5 do
    begin
        gen(j, 1);
    end;

    for i := miny to maxy do
    begin
        for j := 1 to 5 do
        begin
            for k := 1 to pc[j] do
            begin
                sum := 0;
                flag := true;
                for p := 1 to j do
                begin
                    if c[i][perm[j][k][p]] = 0 then
                        flag := false;
                    sum := sum + c[i][perm[j][k][p]];
                end;
                if flag and (sum > l[i][perm[j][k][1]][perm[j][k][j]][j - 1]) then
                begin
                    l[i][perm[j][k][1]][perm[j][k][j]][j - 1] := sum;
                    from[i][perm[j][k][1]][perm[j][k][j]][j - 1] := k;
                end;
            end;
        end;
    end;

    for i := 1 to 5 do
        ans[miny - 1][i][0] := 1;

    for i := miny to maxy do
    begin
        for j := 1 to 5 do
            for k := 0 to 5 do
            begin
                ans[i][j][k] := ans[i - 1][j][k];
                fa[i][j][k].p := 0;
                
                for p := 1 to 5 do
                    for q := 0 to min(k, 4) do
                    begin
                        if l[i][p][j][q] > 0 then
                        begin
                            if ans[i - 1][p][k - q] > 0 then
                            begin
                                if ans[i - 1][p][k - q] + l[i][p][j][q] > ans[i][j][k] then
                                begin
                                    ans[i][j][k] := ans[i - 1][p][k - q] + l[i][p][j][q];
                                    fa[i][j][k].p := p;
                                    fa[i][j][k].q := q;
                                end;
                            end;

                            for o := 1 to 5 do if (o <> p) and (q <> k) then
                                if ans[i - 1][o][k - q - 1] > 0 then
                                begin
                                    if ans[i - 1][o][k - q - 1] + l[i][p][j][q] > ans[i][j][k] then
                                    begin
                                        ans[i][j][k] := ans[i - 1][o][k - q - 1] + l[i][p][j][q];
                                        fa[i][j][k].p := -p;
                                        fa[i][j][k].r := o;
                                        fa[i][j][k].q := q;
                                    end;
                                end;
                        end;
                    end;
            end;

    end; 

    answer := 0;
    besti := 0;
    bestj := 0;
    for i := 1 to 5 do
        for j := 0 to 5 do 
        begin
            if ans[maxy][i][j] > answer then
            begin
                answer := ans[maxy][i][j];
                besti := i;
                bestj := j;
            end;
        end;

    writeln(answer - 1);
    outp(maxy, besti, bestj);

    close(input);
    close(output);
end.