{$APPTYPE CONSOLE}
program e;

Uses SysUtils;


Const
  TaskID='grlex';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxLen=20;
  MaxSum=MaxLen*9;
  Infinity=High(int64) div 2;

Var
  N,K:Int64;
  NS,KS:String;
  AmNear:Array[0..MaxLen,0..MaxSum]Of Int64;
  AmTable:Array[0..MaxLen,0..MaxSum]Of Int64;

Procedure Load;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,K);
  NS:=IntToStr(N);
  KS:=IntToStr(K);
  Close(Input);
End;

Procedure FillAmTable;
Var
  I,J,K:Integer;
Begin
  FillChar(AmTable,SizeOf(AmTable),0);
  AmTable[0,0]:=1;
  For I:=1 To Length(NS) Do
    For J:=0 To MaxSum Do
      For K:=0 To 9 Do If K<=J Then Begin
        Inc(AmTable[I,J],AmTable[I-1,J-K]);
        If AmTable[I,J]>Infinity Then AmTable[I,J]:=Infinity;
      End;
End;

Procedure FillAmNear;
Var
  I,J,K,KK,MinKK:Integer;
Begin
  FillChar(AmNear,SizeOf(AmNear),0);
  AmNear[Length(NS),0]:=1;
  For I:=Length(NS)-1 DownTo 0 Do
    For J:=0 To MaxSum Do Begin
      K:=Ord(NS[I+1])-Ord('0');
      If I=0 Then MinKK:=1 Else MinKK:=0;
      For KK:=MinKK To K-1 Do If KK<=J Then Begin
        Inc(AmNear[I,J],AmTable[Length(NS)-I-1,J-KK]);
        If AmNear[I,J]>Infinity Then AmNear[I,J]:=Infinity;
      End;
      If K<=J Then Begin
        Inc(AmNear[I,J],AmNear[I+1,J-K]);
        If AmNear[I,J]>Infinity Then AmNear[I,J]:=Infinity;
      End;
    End;
End;

Function CalcAmount(Prefix:String; Sum:Integer):Int64;
Var
  Start:String;
  R:Int64;
  I,MLen:Integer;
Begin
  Start:=Copy(NS,1,Length(Prefix));
  R:=0;
  If Start<Prefix Then Begin
    MLen:=Length(NS)-Length(Prefix)-1;
  End Else If Start>Prefix Then Begin
    MLen:=Length(NS)-Length(Prefix);
  End Else Begin
    MLen:=Length(NS)-Length(Prefix)-1;
    R:=AmNear[Length(Prefix),Sum];
  End;
  For I:=0 To MLen Do Begin
    Inc(R,AmTable[I,Sum]);
    If Prefix='' Then
      If I=0 Then
        Dec(R,AmTable[I,Sum])
      Else
        Dec(R,AmTable[I-1,Sum]);
    If R>Infinity Then R:=Infinity;
  End;
  CalcAmount:=R;
End;

Function Kth(K:Int64):Int64;
Var
  CPrefix:String;
  I,Sum,CPrefSum:Integer;
  CAm:Int64;
Begin
  CPrefix:='';
  CPrefSum:=0;
  For I:=1 To MaxSum Do Begin
    CAm:=CalcAmount(CPrefix,I);
    Dec(K,CAm);
    If K<=0 Then Break;
  End;
  Inc(K,CAm);
  Sum:=I;
  While True Do Begin
    CPrefix:=CPrefix+'0';
    For I:=0 To 9 Do Begin
      If (Length(CPrefix)>1) Or (I>0) Then Begin
        If (CPrefSum=Sum) Then Begin
          If K=1 Then Begin
            Kth:=StrToInt64(CPrefix);
            Exit;
          End Else Dec(K);
        End;
        CAm:=CalcAmount(CPrefix,Sum-CPrefSum);
        Dec(K,CAm);
        If K<=0 Then Break;
      End;
      Inc(CPrefix[Length(CPrefix)]);
      Inc(CPrefSum);
    End;
    Inc(K,CAm);
  End;
End;

Function WhereIs(K:Int64):Int64;
Var
  I,J,Sum,CDig:Integer;
  R:Int64;
  CPrefix:String;
  CPrefSum:Integer;
Begin
  Sum:=0;
  For I:=1 To Length(KS) Do
    Inc(Sum,Ord(KS[I])-Ord('0'));
  R:=0;
  CPrefix:='';
  CPrefSum:=0;
  For I:=1 To Sum-1 Do
    Inc(R,CalcAmount(CPrefix,I));
  For I:=1 To Length(KS) Do Begin
    CDig:=Ord(KS[I])-Ord('0');
    For J:=0 To CDig-1 Do Begin
      If (I>1) Or (J>0) Then Begin
        Inc(R,CalcAmount(CPrefix+Chr(Ord('0')+J),Sum-CPrefSum));
      End;
      Inc(CPrefSum);
    End;
    If CPrefSum=Sum Then Inc(R);
    CPrefix:=CPrefix+KS[I];
  End;
  WhereIs:=R;
End;

Procedure Solve;
Begin
End;

Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(WhereIs(K));
  WriteLn(Kth(K));
  Close(Output);
End;

Begin
  Load;
  FillAmTable;
  FillAmNear;
  Solve;
  Save;
end.
