{$apptype console}

{$M 30000000,30000000}

{$R+,S+,I+,Q+,O-}

program template;
const
 Highest = 20;
 pmax = 100;
 nmax = 30;
 NonOperation :set of char = ['a'..'z','0'..'9','=','(',')'];
 standartOperation :set of char = ['+','-','*','/'];
 cinfile = 'calc.in';
 coutfile = 'calc.out';
type
 int = integer;
 real = extended;
 optype = (_absent,_unary,_binary);
 tptr = ^ttree;
 ttree = record
  operation :char;
  l,r :tptr;
  finalVar :char;
  finalValue :int;
 end;
 ttable = array [-1..pmax,-1..pmax] of int;
var
 n,m,p :int;
 operations :array [1..nmax] of char;
 op :array [#33..#127] of tptr;
 priority :array [#33..#127] of int;
 tp :array [#33..#127] of optype;
 variables :array ['a'..'z'] of int;
 inverse :array [0..pmax] of int;
 results :array [#33..#127] of ^ttable;
 currentChar :char;
 ans :int;

procedure init;
begin
 ans := 0;
 fillchar (op,sizeof(op),0);
 fillchar (tp,sizeof(tp),0);
 fillchar (variables,sizeof(variables),0);
 fillchar (operations,sizeof(operations),0);
 fillchar (inverse,sizeof(inverse),0);
 fillchar (results,sizeof(results),0);
 fillchar (priority,sizeof(priority),0);
 priority['+'] := 5;
 priority['-'] := 5;
 priority['*'] := 15;
 priority['/'] := 15;
 tp['+'] := _binary;
 tp['-'] := _binary;
 tp['*'] := _binary;
 tp['/'] := _binary;
end;

function isOperation (c :char):boolean;
begin
 isOperation := not (c in nonOperation);
end;

function getChar :char;
var c :char;
begin
 read (c);
 getChar := c;
end;

function getNumber (res :int) :int;
begin
 repeat
  currentChar := getChar;
  if currentChar in ['0'..'9'] then
   res := res*10 + ord(currentChar) - ord('0');
 until not (currentChar in ['0'..'9']);
 getNumber := res;
end;

function rec (level :int):tptr;
var res :tptr;
    t,argument :tptr;
    lastOperation :char;
begin
 res := nil;
 lastOperation := #0;
 while not ((CurrentChar = ' ') or (ord(CurrentChar) <= 32) or (CurrentChar = ')')) do
  begin
   if not IsOperation(currentChar) then
    begin
     if level = highest then
      begin
       new(res);
       res^.operation := #0;
       if currentChar in ['a'..'z'] then
        begin
         res^.finalVar := currentChar;
         read (currentChar);
        end
       else
        if currentChar in ['0'..'9'] then
         res^.finalValue := getNumber (ord(CurrentChar) - ord('0'))
       else
        if currentChar = '(' then
         begin
          read(currentChar);
          res := rec (1);
          read(currentChar);
         end;
      end
     else
      begin
       argument := rec (level+1);
       if lastOperation = #0 then
        res := argument
       else
        begin
         new (t);
         t^.operation := lastOperation;
         t^.l := res;
         t^.r := argument;
         res := t;
        end;
      end; {if level = highest}
    end {if not IsOperation}
   else
    begin
     if priority[currentChar] = level then
      begin
       if level = highest then
        begin
         new (res);
         res^.operation := currentChar;
         read (currentchar);
         res^.l := rec (level);
        end
       else
        begin
         lastOperation := currentChar;
         read (currentChar);
        end;
      end {if it is current priority}
     else
      begin
       if tp[currentChar] = _unary then
        begin
         argument := rec (level+1);
         if lastOperation = #0 then
          res := argument
         else
          begin
           new (t);
           t^.operation := lastOperation;
           t^.l := res;
           t^.r := argument;
           res := t;
          end;
        end
       else
        break;
      end;
    end; {if isOperation}
  end;
 rec := res;
end;

function parse (level :int):int;
var res :int;
    argument :int;
    lastOperation :char;
begin
 res := 0;
 lastOperation := #0;
 while not ((CurrentChar = ' ') or (ord(CurrentChar) <= 32) or (CurrentChar = ')')) do
  begin
   if not IsOperation(currentChar) then
    begin
     if level = highest then
      begin
       if currentChar in ['a'..'z'] then
        begin
         res := variables[currentChar];
         currentChar := getchar;
        end
       else
        if currentChar in ['0'..'9'] then
         res := getNumber (ord(CurrentChar) - ord('0'))
       else
        if currentChar = '(' then
         begin
          currentChar := getChar;
          res := parse (1);
          currentChar := getChar;
         end;
      end
     else
      begin
       argument := parse (level+1);
       if lastOperation = #0 then
        res := argument
       else
        res := results[lastOperation]^[res][argument];
      end; {if level = highest}
    end {if not IsOperation}
   else
    begin
     if priority[currentChar] = level then
      begin
       if level = highest then
        begin
         lastOperation := currentChar;
         currentChar := getChar;
         argument := parse(level);
         res := results[lastOperation]^[argument][0]
        end
       else
        begin
         lastOperation := currentChar;
         currentChar := getChar;
        end;
      end {if it is current priority}
     else
      begin
       if tp[currentChar] = _unary then
        begin
         argument := parse(level+1);
         if lastOperation = #0 then
          res := argument
         else
          res := results[lastOperation]^[res][argument]; 
        end
       else
        break;
      end;
    end; {if isOperation}
  end;
 parse := res;
end;

procedure readUnary (number :int);
var c,c_ :char;
begin
 repeat
  read (c);
 until not (c = ' ');
 read (c_);
 read (c_);
 priority[c] := Highest;
 tp[c] := _unary;
 read (CurrentChar);
 op[c] := rec (1);
 readln;
 operations[number] := c;
end;

procedure readBinary (number :int);
var c,c_ :char;
    pr :int;
begin
 read (pr);
 repeat
  read (c);
 until not (c = ' ');
 read (c);
 read (c_);
 read (c_);
 priority[c] := pr;
 tp[c] := _binary;
 read (CurrentChar);
 op[c] := rec (1);
 readln;
 operations[number] := c;
end;

procedure readVariable;
var c,c_ :char;
begin
 read (c);
 read (c_);
 readln (variables[c]);
end;

procedure readdata;
var i,j :int;
    c :char;
begin
 assign (input,cinfile);
 reset (input);
 readln (p);
 readln (n);
 for i := 1 to n do
  begin
   read (c);
   if c = 'U' then
    readUnary (i)
   else
    readBinary (i);
  end;
 readln (m);
 for i := 1 to m do
  readVariable;
end;

procedure outdata;
var i,j :int;
begin
 assign (output,coutfile);
 rewrite (output);
 writeln (ans);
 close (output);
end;

function power (a :int; k :int):int;
var res :int;
begin
 res := 1;
 while k > 0 do
  begin
   if k and 1 = 1 then
    begin
     res := (res*a) mod p;
     dec(k);
    end
   else
    begin
     a := a*a mod p;
     k := k shr 1;
    end;
  end;
 power := res;
end;

function calculate (p :tptr):int;
begin
 if p^.operation = #0 then
  begin
   if not (p^.finalVar = #0) then
    calculate := variables[p^.finalVar]
   else
    calculate := p^.finalValue;
  end
 else
  begin
   if tp[p^.operation] = _unary then
    calculate := results[p^.operation]^[calculate(p^.l),0]
   else
    calculate := results[p^.operation]^[calculate(p^.l),calculate(p^.r)];
  end;
end;

procedure solve;
var i,j :int;
    arg1,arg2 :int;
begin
 for i := 1 to p-1 do
  inverse[i] := power(i,p-2);
 inverse[0] := -1;  
 new (results['+']);
 new (results['-']);
 new (results['*']);
 new (results['/']);
 for arg1 := -1 to p-1 do
  for arg2 := -1 to p-1 do
   begin
    if not (arg1 = -1) and not (arg2 = -1) then
     begin
      results['+'][arg1][arg2] := (arg1 + arg2) mod p;
      results['-'][arg1][arg2] := (arg1 - arg2 + p) mod p;
      results['*'][arg1][arg2] := (arg1*arg2) mod p;
      if arg2 > 0 then
       results['/'][arg1][arg2] := (arg1*inverse[arg2]) mod p
      else
       results['/'][arg1][arg2] := -1;
     end
    else
     begin
      results['+'][arg1][arg2] := -1;
      results['-'][arg1][arg2] := -1;
      results['*'][arg1][arg2] := -1;
      results['/'][arg1][arg2] := -1;
     end;
   end;
 for i := 1 to n do
  begin
   new (results[operations[i]]);
   fillchar (results[operations[i]]^,sizeof(results[operations[i]]^),0);
   if tp[operations[i]] = _binary then
    for arg1 := -1 to p-1 do
     for arg2 := -1 to p-1 do
      begin
       variables['a'] := arg1;
       variables['b'] := arg2;
       if (arg1 > -1) and (arg2 > -1) then
        results[operations[i]]^[arg1][arg2] := calculate (op[operations[i]])
       else
        results[operations[i]]^[arg1][arg2] := -1;
      end
   else
    for arg1 := -1 to p-1 do
     begin
      variables['a'] := arg1;
      if arg1 >= 0 then
       results[operations[i]]^[arg1][0] := calculate (op[operations[i]])
      else
       results[operations[i]]^[arg1][0] := -1; 
     end;
  end;
 currentChar := getChar;
 ans := parse(1);
 close (input);
end;

begin
 init;
 readdata;
 solve;
 outdata;
end.