{$O-,Q+,R+}
program stable_sets;

const
    maxr = 100;
    maxn = 100;

var
    p, q, xp, xq, colp, colq, colrp, colrq: array [0..maxr] of longint;
    a, b: array [0..maxn] of longint;
    up, uq, vp, vq: array [0..maxr] of boolean;
    d: array [1..maxr, 1..maxr] of boolean;
    c, i, j, k, l, n, m, r, cp, cq, cnum: longint;
    wrong: array [0..maxr] of boolean;
    ans: array [0..maxr] of longint;

procedure dfsp(i, c: longint); forward;

procedure dfsq(j, c: longint);
var
    i: longint;
begin
    uq[j] := true;
    colq[j] := c;
    for i := 1 to cp do
        if d[i][j] and not up[i] then
            dfsp(i, c);
end;

procedure dfsp(i, c: longint);
var
    j: longint;
begin
    up[i] := true;
    colp[i] := c;
    for j := 1 to cq do
        if d[i][j] and not uq[j] then
            dfsq(j, c);
end;

begin
    assign(input, 'invar.in');
    reset(input);
    assign(output, 'invar.out');
    rewrite(output);

    read(r);
    read(n);
    for i := n downto 0 do
        read(a[i]);
    read(m);
    for i := m downto 0 do
        read(b[i]);

    for i := 0 to r - 1 do
    begin
        p[i] := 0;
        for j := n downto 0 do
            p[i] := (p[i] * i + a[j]) mod r;
        q[i] := 0;
        for j := m downto 0 do
            q[i] := (q[i] * i + b[j]) mod r;
    end;

    for i := 0 to r - 1 do
    begin
        fillchar(up, sizeof(up), 0);
        fillchar(uq, sizeof(uq), 0);
        if not up[i] then
        begin
            j := i;
            while not up[j] do
            begin
                up[j] := true;
                j := p[j];
            end;
            if not vp[j] then
            begin
                inc(cp);
                xp[cp] := j;
                j := i;
                while not vp[j] do
                begin
                    vp[j] := true;
                    j := p[j];
                end;
            end;
        end;
        if not uq[i] then
        begin
            j := i;
            while not uq[j] do
            begin
                uq[j] := true;
                j := q[j];
            end;
            if not vq[j] then
            begin
                inc(cq);
                xq[cq] := j;
                j := i;
                while not vq[j] do
                begin
                    vq[j] := true;
                    j := q[j];
                end;
            end;
        end;
    end;

    for i := 1 to cp do
        for j := 1 to cq do
        begin
            k := xp[i];
            repeat
                l := xq[j];
                repeat
                    if l = k then
                        d[i][j] := true;
                    l := q[l];
                until l = xq[j];
                k := p[k];
            until k = xp[i];
        end;

    fillchar(up, sizeof(up), 0);
    fillchar(uq, sizeof(uq), 0);
    k := 0;
    for i := 1 to cp do
    begin
        if not up[i] then 
        begin
            inc(k);
            dfsp(i, k);
        end;
    end;
    cnum := k;

    for i := 1 to cp do
    begin
        k := xp[i];
        repeat
            colrp[k] := colp[i];
            k := p[k];
        until k = xp[i];
    end;

    for i := 1 to cq do
    begin
        k := xq[i];
        repeat
            colrq[k] := colq[i];
            k := q[k];
        until k = xq[i];
    end;

    for i := 0 to r - 1 do
    begin
        if colrp[i] <> colrq[i] then
        begin
            if colrp[i] = 0 then wrong[colrq[i]] := true
            else if colrq[i] = 0 then wrong[colrp[i]] := true
            else runerror(239);
        end;
    end;

    j := 0;
    for i := 1 to cnum do
        if not wrong[i] then
            inc(j);

    ans[1] := 1;
    for i := 1 to j do
    begin
        c := 0;
        for k := 1 to maxr do
        begin
            c := c + ans[k] * 2;
            ans[k] := c mod 10;
            c := c div 10; 
        end;
    end;
    j := maxr;
    while ans[j] = 0 do dec(j);
    while (j > 0) do
    begin
        write(ans[j]);
        dec(j);
    end;
    writeln;

    close(input);
    close(output);
end.