program holidays;

uses
    sysutils;

const
    months: array [1..12] of string = (
        'January', 
        'February', 
        'March', 
        'April', 
        'May', 
        'June', 
        'July', 
        'August', 
        'September', 
        'October', 
        'November', 
        'December'
    );

    maxn = 100;
    maxy = 100;

type
    tdate = record
        m, d: longint;
    end;

function readword: string;
var
    r: string;
    c: char;
begin
    read(c);
    while not (c in ['0'..'9', 'A'..'Z', 'a'..'z']) do
        read(c);
    r := '';
    while (c in ['0'..'9', 'A'..'Z', 'a'..'z']) do
    begin
        r := r + c;
        read(c);
    end;
    readword := r;
end;

function readmonth: longint;
var
    s: string;
    i: longint;
begin
    s := readword;
    for i := 1 to 12 do
        if months[i] = s then
        begin
            readmonth := i;
            exit;
        end;
    readmonth := 0;
    assert(false);
end;

function readdate: tdate;
var
    t: tdate;
begin
    t.m := readmonth;
    t.d := strtoint(readword);
    readdate := t;
end;

function gt(d1, d2: tdate): boolean;
begin
    gt := (d1.m > d2.m) or ((d1.m = d2.m) and (d1.d > d2.d));
end;

function eq(d1, d2: tdate): boolean;
begin
    eq := (d1.m = d2.m) and (d1.d = d2.d);
end;

function isleap(y: longint): boolean;
begin
    isleap := ((y mod 4 = 0) and not (y mod 100 = 0)) or (y mod 400 = 0);
end;

procedure writedate(d: tdate);
begin
    write(months[d.m], ' ', d.d);
end;

var
    x, h: array [1..maxn] of tdate;
    c: array [1..maxn] of boolean;
    count, count29: array [0..maxn] of longint;
    a, f: array [0..maxy, 0..maxn] of longint;
    i, j, k, l, n, t: longint;
    sy, fy: longint;
    act: string;

procedure outp(i, j: longint);
var
    k, l: longint;
begin
    k := f[i][j];
    if i > 0 then
        outp(i - 1, k);
    for l := k + 1 to j do
    begin
        writedate(x[l]);
        write(' ', sy + i - 1);
        if c[l] then
            write(', added ')
        else
            write(', removed ');
        writedate(h[l]);
        writeln;
    end;
end;

begin
    assign(input, 'holidays.in');
    reset(input);
    assign(output, 'holidays.out');
    rewrite(output);

    read(sy, fy);
    assert(sy <= fy);
    assert(fy - sy <= maxy);
    read(n);
    for i := 1 to n do
    begin
        x[i] := readdate;
        act := readword;
        if act = 'added' then
        begin
            c[i] := true;
        end else if act = 'removed' then begin
            c[i] := false;
        end else
            assert(false);
        h[i] := readdate;
    end;

    count[0] := 0;
    count29[0] := 0;
    for i := 1 to n do
    begin
        count[i] := count[i - 1];
        count29[i] := count29[i - 1];
        if (h[i].m = 2) and (h[i].d = 29) then
        begin
            if c[i] then
                count29[i] := count29[i - 1] + 1
            else
                count29[i] := count29[i - 1] - 1;
        end else begin
            if c[i] then
                count[i] := count[i - 1] + 1
            else
                count[i] := count[i - 1] - 1;
        end;
    end;

    for j := 1 to n do
        a[0][j] := -1;
    a[0][0] := 0;

    for i := 1 to fy - sy + 1 do
    begin
        a[i][0] := 0;
        for j := 1 to n do
        begin
            if a[i - 1][j] >= 0 then
            begin
                a[i][j] := a[i - 1][j] + count[j];
                if isleap(sy + i - 1) then
                    a[i][j] := a[i][j] + count29[j];

                f[i][j] := j;
            end else begin
                a[i][j] := -1;
            end;

            if isleap(sy + i - 1) or (x[j].m <> 2) or (x[j].d <> 29) then
            begin
                for k := j - 1 downto 0 do
                begin
                    if a[i - 1][k] >= 0 then
                    begin
                        t := count[k];
                        if isleap(sy + i - 1) then
                            t := t + count29[k];

                        for l := k + 1 to j do
                        begin
                            if not c[l] and gt(h[l], x[l]) then
                            begin
                                if isleap(sy + i - 1) or (h[l].m <> 2) or (h[l].d <> 29) then
                                    dec(t);
                            end;
                            if c[l] and gt(h[l], x[l]) then
                            begin
                                if isleap(sy + i - 1) or (h[l].m <> 2) or (h[l].d <> 29) then
                                    inc(t);
                            end;
                        end;

                        if (a[i][j] = -1) or (a[i - 1][k] + t > a[i][j]) then
                        begin
                            a[i][j] := a[i - 1][k] + t;
                            f[i][j] := k;
                        end;
                        
                    end;
                    if (k > 0) and ((not gt(x[k + 1], x[k])) or 
                        ((not isleap(sy + i - 1)) and (x[k].m = 2) and (x[k].d = 29))) then
                    begin
                        break;
                    end;
                end;
            end;
        end;
    end;

    writeln(a[fy - sy + 1][n]);
    if a[fy - sy + 1][n] <> -1 then
        outp(fy - sy + 1, n);

    close(input);
    close(output);
end.