{$Q+,R+,O-}

program maps;

uses
    math, sysutils;

var
    x11, y11, x12, y12, x13, y13, x14, y14,
    x21, y21, x22, y22, x23, y23, x24, y24,
    x21s, y21s, x22s, y22s, x23s, y23s, x24s, y24s,
    x31, y31, x32, y32, x33, y33, x34, y34: extended;
    s1, s2, s3: extended;
    a11, a12, a21, a22: extended;
    d: extended;
    x0, y0: extended;
    xs, ys: extended;
    a1, b1, a2, b2, a3, b3: extended;
    found: boolean;

const
    eps = 1e-6;

function checkrect(x1, y1, x2, y2, x3, y3, x4, y4, a, b: extended): boolean;
var
    flag: boolean;
begin
    flag := true;

    flag := flag and (abs(hypot(x2 - x1, y2 - y1) - a) < eps);
    flag := flag and (abs(hypot(x3 - x2, y3 - y2) - b) < eps);
    flag := flag and (abs(hypot(x4 - x3, y4 - y3) - a) < eps);
    flag := flag and (abs(hypot(x1 - x4, y1 - y4) - b) < eps);

    flag := flag and ((x2 - x1) * (y3 - y2) - (y2 - y1) * (x3 - x2) > 0);
    flag := flag and ((x3 - x2) * (y4 - y3) - (y3 - y2) * (x4 - x3) > 0);
    flag := flag and ((x4 - x3) * (y1 - y4) - (y4 - y3) * (x1 - x4) > 0);
    flag := flag and ((x1 - x4) * (y2 - y1) - (y1 - y4) * (x2 - x1) > 0);

    flag := flag and (abs((x2 - x1) * (x3 - x2) + (y3 - y2) * (y2 - y1)) < eps);
    flag := flag and (abs((x3 - x2) * (x4 - x3) + (y4 - y3) * (y3 - y2)) < eps);
    flag := flag and (abs((x4 - x3) * (x1 - x4) + (y1 - y4) * (y4 - y3)) < eps);
    flag := flag and (abs((x1 - x4) * (x2 - x1) + (y2 - y1) * (y1 - y4)) < eps);

    checkrect := flag;
end;

function inside2(x, y: extended): boolean;
begin
    inside2 :=
        (((x - x21) * (y22 - y21) - (x22 - x21) * (y - y21)) <= eps) and
        (((x - x22) * (y23 - y22) - (x23 - x22) * (y - y22)) <= eps) and
        (((x - x23) * (y24 - y23) - (x24 - x23) * (y - y23)) <= eps) and
        (((x - x24) * (y21 - y24) - (x21 - x24) * (y - y24)) <= eps);
end;

function ok: boolean;
begin
    ok := false;

    if (x21 < -eps) or (x21 > x13 + eps) then exit;
    if (x22 < -eps) or (x22 > x13 + eps) then exit;
    if (x23 < -eps) or (x23 > x13 + eps) then exit;
    if (x24 < -eps) or (x24 > x13 + eps) then exit;
    if (y21 < -eps) or (y21 > y13 + eps) then exit;
    if (y22 < -eps) or (y22 > y13 + eps) then exit;
    if (y23 < -eps) or (y23 > y13 + eps) then exit;
    if (y24 < -eps) or (y24 > y13 + eps) then exit;

    ok :=
        inside2(x31, y31) and
        inside2(x32, y32) and
        inside2(x33, y33) and
        inside2(x34, y34);
end;

procedure trythis;
begin
    if ok then
    begin
        found := true;
        x21s := x21;
        x22s := x22;
        x23s := x23;
        x24s := x24;
        y21s := y21;
        y22s := y22;
        y23s := y23;
        y24s := y24;
    end;
end;

procedure createrect(alpha, a, b, ac, bc: extended; var x1, y1, x2, y2, x3, y3, x4, y4: extended);
var
    beta: extended;
    d: extended;
begin
    beta := arctan2(bc * b, ac * a);
    d := hypot(a * ac, b * bc);
    x1 := x0 - d * cos(alpha + beta);
    y1 := y0 - d * sin(alpha + beta);
    x2 := x1 + a * cos(alpha);
    y2 := y1 + a * sin(alpha);
    x3 := x2 - (y2 - y1) * b / a;
    y3 := y2 + (x2 - x1) * b / a;
    x4 := x3 - (y3 - y2) * a / b;
    y4 := y3 + (x3 - x2) * a / b;
end;

procedure analyze2(xp, yp, xs, ys, a2, b2: extended; var x21, y21, x22, y22, x23, y23, x24, y24: extended);
var
    s, delta, gamma: extended;
begin
   s := hypot(xp - x0, yp - y0);
   if (s >= ys * b2) then
    begin
        delta := arctan2(y0 - yp, x0 - xp);
        gamma := arcsin(ys * b2 / s);
        createrect(delta - gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
        createrect(pi + delta + gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
    end;
end;

procedure analyze1(xs, ys, a2, b2: extended; var x21, y21, x22, y22, x23, y23, x24, y24: extended);
var
    di: extended;
    beta, gamma: extended;
begin
    di := hypot(xs * a2, ys * b2);
    beta := arctan2(ys * b2, xs * a2);
    if di >= y0 then
    begin
        gamma := arccos(y0 / di);
        createrect(pi/2 - beta - gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
        createrect(pi/2 - beta + gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
    end;

    if di >= a1 - x0 then
    begin
        gamma := arccos((a1 - x0) / di);
        createrect(pi/2 + pi/2 - beta - gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
        createrect(pi/2 + pi/2 - beta + gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
    end;

    if di >= b1 - y0 then
    begin
        gamma := arccos((b1 - y0) / di);
        createrect(pi + pi/2 - beta - gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
        createrect(pi + pi/2 - beta + gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
    end;

    if di >= x0 then
    begin
        gamma := arccos(x0 / di);
        createrect(3 * pi / 2 + pi/2 - beta - gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
        createrect(3 * pi / 2 + pi/2 - beta + gamma, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
        trythis;
    end;

    analyze2(x31, y31, xs, ys, a2, b2, x21, y21, x22, y22, x23, y23, x24, y24);
    analyze2(x32, y32, xs, ys, a2, b2, x21, y21, x22, y22, x23, y23, x24, y24);
    analyze2(x33, y33, xs, ys, a2, b2, x21, y21, x22, y22, x23, y23, x24, y24);
    analyze2(x34, y34, xs, ys, a2, b2, x21, y21, x22, y22, x23, y23, x24, y24);
end;


begin
    assign(input, 'maps.in');
    reset(input);
    assign(output, 'maps.out');
    rewrite(output);

    read(s1, x13, y13);
    x11 := 0;
    y11 := 0;
    x12 := x13;
    y12 := 0;
    x14 := 0;
    y14 := y13;
    a1 := x13;
    b1 := y13;

    read(s2);
    read(s3, x31, y31, x32, y32, x33, y33, x34, y34);
    a3 := a1 * s3 / s1;
    b3 := b1 * s3 / s1;

    assert((0.01 <= s1) and (s1 <= 100.0));
    assert((0.01 <= s2) and (s2 <= 100.0));
    assert((0.01 <= s3) and (s3 <= 100.0));
    assert(0.01 <= s1 - s2);
    assert(0.01 <= s2 - s3);

    assert(checkrect(x31, y31, x32, y32, x33, y33, x34, y34, x13 * s3 / s1, y13 * s3 / s1));

    a11 := - x32 + x31 + x13;
    a12 := - x33 + x32;
    a21 := - y32 + y31;
    a22 := - y33 + y32 + y13;

    d := a11 * a22 - a12 * a21;

    xs := (x31 * a22 - y31 * a12) / d;
    ys := (y31 * a11 - x31 * a21) / d;

    x0 := x13 * xs;
    y0 := y13 * ys;

    a2 := s2 * x13 / s1;
    b2 := s2 * y13 / s1;

    analyze1(    xs,     ys, a2, b2, x21, y21, x22, y22, x23, y23, x24, y24);
    analyze1(    ys, 1 - xs, b2, a2, x22, y22, x23, y23, x24, y24, x21, y21);
    analyze1(1 - xs, 1 - ys, a2, b2, x23, y23, x24, y24, x21, y21, x22, y22);
    analyze1(1 - ys,     xs, b2, a2, x24, y24, x21, y21, x22, y22, x23, y23);

{    createrect(pi, a2, b2, xs, ys, x21, y21, x22, y22, x23, y23, x24, y24);
    trythis;}

    if found then
    begin
        writeln(
            x21s :0 :10, ' ', y21s :0 :10, ' ',
            x22s :0 :10, ' ', y22s :0 :10, ' ',
            x23s :0 :10, ' ', y23s :0 :10, ' ',
            x24s :0 :10, ' ', y24s :0 :10);
    end else begin
        writeln('impossible');
    end;

    close(input);
    close(output);
end.