{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O-,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$APPTYPE CONSOLE}
program ackerman;

uses
    math;

const
    maxn = 100;
    maxr = 100;

label
    found;

var
    n, m, r: longint;
    t, l, i, j, k, q: longint;
    ack: array [1..maxn, 1..2 * maxr] of longint;
    a: array [1..maxr, 1..maxn, 1..2 * maxr] of longint;
    prd, per: array [1..maxr, 1..maxn] of longint;
    f: boolean;

begin
    assign(input, 'ackerman.in');
    reset(input);
    assign(output, 'ackerman.out');
    rewrite(output);

    read(r);

    for j := 1 to 2 * r do
    begin
        ack[1][j] := 2 * j;
    end;

    for i := 2 to maxn do
    begin
        ack[i][1] := 2;
        for j := 2 to 2 * r do
        begin
            if (ack[i][j - 1] > 0) and (ack[i][j - 1] <= 2 * r) then
                ack[i][j] := ack[i - 1][ack[i][j - 1]];
        end;
    end;

    fillchar(a, sizeof(a), 0);

    for i := 1 to maxn do
    begin
        prd[1][i] := 0;
        per[1][i] := 1;
        prd[2][i] := 0;
        per[2][i] := 1;
    end;

    for l := 3 to r do
    begin
        for j := 1 to max(2 * r, maxn) do
            a[l][1][j] := (2 * j) mod l;
        prd[l][1] := 0;
        per[l][1] := l;
        if l mod 2 = 0 then
            per[l][1] := per[l][1] div 2;

        for i := 2 to maxn do
        begin
            for j := 1 to max(2 * r, maxn) do
            begin
                if ack[i][j] > 0 then
                begin
                    a[l][i][j] := ack[i][j] mod l
                end else if (ack[i][j - 1] > 0) and (ack[i][j - 1] <= prd[l][i - 1]) then begin
                    a[l][i][j] := a[l][i - 1][ack[i][j-1]];
                end else begin
                    t := a[per[l][i-1]][i][j-1];
                    t := t - prd[l][i-1];
                    while t <= 0 do
                        t := t + per[l][i-1];
                    t := t + prd[l][i-1];
                    a[l][i][j] := a[l][i-1][t];
                end;
            end;

            for j := 1 to r do
            begin
                for k := 1 to r do
                begin
                    f := true;
                    for q := 0 to k - 1 do
                        if a[l][i][j + q] <> a[l][i][j + q + k] then
                        begin
                            f := false;
                            break
                        end;
                    if f then
                    begin
                        prd[l][i] := j - 1;
                        per[l][i] := k;
                        goto found;
                    end;
                end;
            end;
            
            runerror(240);

            found:
        end;
    end;

{    for i := 1 to maxn do
    begin
        for j := 1 to maxn do
            write(a[r][i][j], ' ');
        writeln;
    end;}


    t := 0;
    while true do begin
        inc(t);
        read(n, m);
        if (n = 0) and (m = 0) then break;
        writeln('Case ', t, ': ', a[r][n][m]);
    end;

    close(input);
    close(output);
end.