#define ONLINE
#include <stdio.h>

#define HEAP_SIZE 102400

class THeap {
  private:
    long*data,*head;
    long count;
    void heapify(void);
  public:
    THeap(void);
    ~THeap();
    void clear(void);
    void add(const long);
    void deletemin(void);
    long getmin(void) { return(*head); }
};

long n_nums,n_sums,c_good;
long*nums,*sums;
THeap heap;

int main(void) {
  #ifdef ONLINE
  freopen("seq.in","rt",stdin);
  freopen("seq.out","wt",stdout);
  #endif
  long i_num,i_sum;
  scanf("%ld",&n_nums);
  n_sums=(n_nums<<1)+1;
  nums=new long[n_nums]; sums=new long[n_sums];
  for (i_num=0; i_num<n_nums; i_num++) scanf("%ld",&nums[i_num]);
  *sums=0;
  for (i_sum=1,i_num=0; i_sum<n_sums; i_sum++,i_num=(i_num+1)%n_nums)
    sums[i_sum]=sums[i_sum-1]+nums[i_num];
  c_good=0;
  for (i_sum=1; i_sum<=n_nums; i_sum++) heap.add(sums[i_sum]);
  for (i_num=0; i_num<n_nums; i_num++) {
    if (heap.getmin()>sums[i_num]) c_good++;
    heap.deletemin();
    heap.add(sums[i_sum++]);
  }
  printf("%ld\n",c_good);
  delete[]nums; delete[]sums;
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
}


THeap::THeap(void) {
  data=new long[HEAP_SIZE];
  clear();
}
THeap::~THeap() {
  delete[]data;
}
void THeap::clear(void) {
  head=&data[HEAP_SIZE];
  count=0;
}
void THeap::add(const long arg) {
  *(--head)=arg; count++;
  heapify();
}
void THeap::deletemin(void) {
  head++; count--;
}
void THeap::heapify(void) {
  long i,j; long z;
  i=0; j=1;
  if ((j+1<count)&&(head[j]>head[j+1])) j++;
  z=head[i];
  while ((j<count)&&(z>head[j])) {
    head[i]=head[j];
    i=j; j=(j<<1)+1;
    if ((j+1<count)&&(head[j]>head[j+1])) j++;
  }
  head[i]=z;
}


