{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
Program Snow;
Const
     InFile = 'snow.in';
     OutFile = 'snow.out';
     NMax = 100;
Type
    TArray = Array [0..NMax] Of LongInt;
    TMatrix = Array [0..NMax] Of TArray;
Var
   K,M,N : LongInt;
   A,B,NRA,NRB : TMatrix;

 Procedure ReadData;
  Var
     I,J,U,V : LongInt;
  Begin
    Assign (Input,InFile); ReSet (Input);
    Read (N,M,K);
    For I:= 1 To N Do
      For J:= 1 To N Do A[I,J]:= -1;
    For I:= 1 To N Do A[I,I]:= 0;
    For I:= 1 To M Do Begin
      Read (U,V);
      Read (A[U,V]);
      A[V,U]:= A[U,V];
    End;
    Close (Input);
  End;

 Procedure Floyd (A,NRA : TMatrix; Var B,NR : TMatrix);
  Var
     I,J,K : LongInt;
   Begin
     B:= A;
     NRB:= NRA;
     For K:= 1 To N Do
       For I:= 1 To N Do
         For J:= 1 To N Do
           If (I <> J) And (J <> K) Then
            If (B[I,K] <> -1) And (B[K,J] <> -1) Then
             If (B[I,J] = -1) Or (B[I,J] > B[I,K] + B[K,J])
              Then Begin
               B[I,J]:= B[I,K] + B[K,J];
               NR[I,J]:= NR[I,K] + NR[K,J];
              End;
   End;

 Procedure Sort (Var C,P,NR : TArray; N : LongInt);

  Procedure Swap (I,J : LongInt);
   Begin
     C[0]:= C[I]; C[I]:= C[J]; C[J]:= C[0];
     P[0]:= P[I]; P[I]:= P[J]; P[J]:= P[0];
     NR[0]:= NR[I]; NR[I]:= NR[J]; NR[J]:= NR[0];
   End;

  Procedure QSort (L,R : LongInt);
   Var
      I,J,CM,NRM : LongInt;
   Begin
     I:= L; J:= R; CM:= C[(L + R) Div 2]; NRM:= NR[(L + R) Div 2];
     Repeat
       While (C[I] < CM) Or (CM = -1) Or
              ((C[I] = CM) And (NR[I] < NRM)) Do Inc (I);
       While (C[J] > CM) Or (C[J] = -1) Or
              ((C[J] = CM) And (NR[J] > NRM)) Do Dec (J);
       If I <= J Then Begin
        Swap (I,J);
        Inc (I); Dec (J);
       End;
     Until I > J;
     If J > L Then QSort (L,J);
     If I < R Then QSort (I,R);
   End;

  Begin
    QSort (1,N);
  End;

 Procedure Solve;
  Var
     C,NR,P : TArray;
     I,J,Last : LongInt;

    Begin
     For I:= 1 To N Do
       For J:= 1 To N Do
         If A[I,J] <= 0 Then NRA[I,J]:= 0 Else NRA[I,J]:= 1;
     Floyd (A,NRA,B,NRB);
     If B[1,N] = -1 Then Exit;
     For I:= 1 To N Do Begin
       For J:= 1 To I - 1 Do Begin
         If (B[I,J] = -1) Or (B[J,N] = -1)
          Then C[J]:= -1
          Else C[J]:= A[I,J] + B[J,N];
         If C[J] <> -1 Then NR[J]:= NRB[J,N] + 1; P[J]:= J;
       End;
       For J:= I + 1 To N Do Begin
         If (B[I,J] = -1) Or (B[J,N] = -1)
          Then C[J - 1]:= -1
          Else C[J - 1]:= A[I,J] + B[J,N];
         If C[J - 1] <> -1 Then NR[J - 1]:= NRB[J,N] + 1; P[J - 1]:= J;
       End;
       Sort (C,P,NR,N - 1);
       If N - 1 > K Then Last:= K Else Last:= N - 1;
       For J:= 1 To Last Do
         If B[I,P[J]] <> -1 Then B[I,P[J]]:= B[I,P[J]] * 2;
     End;
     Floyd (B,NRB,A,NRA);
  End;

 Procedure WriteData;
  Var
     I,J : LongInt;
   Begin
     Assign (Output,OutFile); ReWrite (Output);
     Write (A[1,N]);
     Close (Output);
   End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.
