const
     FileIn='snow.in';
     FileOut='snow.out';
     MaxN=100;
type
    TNode=record
                State: Byte;
                Value: LongInt;
                EdgesCount: LongInt;
                Edges: array [1..MaxN] of LongInt;
                Times: array [1..MaxN] of LongInt;
          end;
var
   N, M, K: LongInt;
   Nodes: array [1..MaxN] of TNode;

   Matrix: array [1..MaxN, 1..MaxN] of LongInt;

   Keys: array [1..MaxN] of LongInt;

   Answer: LongInt;

procedure ReadData;
var
   F: Text;
   NNode, NEdge: LongInt;
   a, b, t: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, M, K);
     for NNode:=1 to N
         do with Nodes [NNode]
                 do begin
                    State:=0;
                    EdgesCount:=0;
                 end;
     for NEdge:=1 to M
         do begin
            Readln (F, a, b, t);
            with Nodes [a]
                 do begin
                    Inc (EdgesCount);
                    Edges [EdgesCount]:=b;
                    Times [EdgesCount]:=t;
                 end;
            with Nodes [b]
                 do begin
                    Inc (EdgesCount);
                    Edges [EdgesCount]:=a;
                    Times [EdgesCount]:=t;
                 end;
            Matrix [a, b]:=t;
            Matrix [b, a]:=t;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

procedure Floyd;
var
   i, j, k: LongInt;
begin
     for k:=1 to N
         do for i:=1 to N
                do for j:=1 to N
                       do if Matrix [i, j]>Matrix [i, k]+Matrix [k, j]
                             then Matrix [i, j]:=Matrix [i, k]+Matrix [k, j];
     for i:=1 to N
         do Keys [i]:=Matrix [i, N];
end;

procedure QSort (aNode: LongInt; aLeft, aRight: LongInt);
var
   i, j: LongInt;
   M, E: LongInt;
begin
     i:=aLeft;
     j:=aRight;
     M:=Keys [Nodes [aNode].Edges [(i+j) div 2]];
     repeat
           while Keys [Nodes [aNode].Edges [i]]<M
                 do Inc (i);
           while M<Keys [Nodes [aNode].Edges [j]]
                 do Dec (j);
           if i<=j
              then begin
                   E:=Nodes [aNode].Edges [i];
                   Nodes [aNode].Edges [i]:=Nodes [aNode].Edges [j];
                   Nodes [aNode].Edges [j]:=E;
                   E:=Nodes [aNode].Times [i];
                   Nodes [aNode].Times [i]:=Nodes [aNode].Times [j];
                   Nodes [aNode].Times [j]:=E;
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSort (aNode, aLeft, j);
     if i<aRight
        then QSort (aNode, aRight, i);
end;

procedure Slow;
var
   i, j, Last: LongInt;
begin
     for i:=1 to N
         do QSort (i, 1, Nodes [i].EdgesCount);
     for i:=1 to N
         do begin
            Last:=Nodes [i].EdgesCount;
            if K<Last
               then Last:=K;
            for j:=1 to Last
                do Nodes [i].Times [j]:=Nodes [i].Times [j]*2;
         end;
end;

procedure Dejkstra;

function ExtractMin: LongInt;
var
   NNode, NBestNode: LongInt;
begin
     for NNode:=1 to N
         do if Nodes [NNode].State=1
               then Break;
     if Nodes [NNode].State<>1
        then begin
             ExtractMin:=0;
             Exit;
        end;
     NBestNode:=NNode;
     for NNode:=NNode+1 to N
         do if (Nodes [NNode].State=1) and (Nodes [NNode].Value<Nodes [NBestNode].Value)
               then NBestNode:=NNode;
     Nodes [NBestNode].State:=2;
     ExtractMin:=NBestNode;
end;

var
   MinIndex, NEdge: LongInt;
begin
     Nodes [1].State:=1;
     Nodes [1].Value:=0;
     repeat
           MinIndex:=ExtractMin;
           if MinIndex=0
              then Break;
           with Nodes [MinIndex]
                do for NEdge:=1 to EdgesCount
                       do case Nodes [Edges [NEdge]].State of
                               0: begin
                                       Nodes [Edges [NEdge]].State:=1;
                                       Nodes [Edges [NEdge]].Value:=Value+Times [NEdge];
                                  end;
                               1: if Value+Times [NEdge]<Nodes [Edges [NEdge]].Value
                                     then Nodes [Edges [NEdge]].Value:=Value+Times [NEdge]
                       end;
     until MinIndex=0;
end;

procedure Solve;
begin
     Floyd;
     Slow;
     Dejkstra;
     if Nodes [N].State=0
        then Answer:=-1
        else Answer:=Nodes [N].Value;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
