const
     FileIn='dvd.in';
     FileOut='dvd.out';
     MaxN=2000;
     RegionsCount=5;
     MaxChanges=RegionsCount;
     MaxFIFOLen=MaxN*RegionsCount*10;
type
    TFilm=record
                Name: string;
                Year: LongInt;
                Region: LongInt;
          end;
    TFIFOItem=record
                    LastFilm: LongInt;
                    Changes: LongInt;
                    Done: packed array [1..MaxN] of Boolean;
                    Count: LongInt;
                    From: LongInt;
              end;
var
   N: LongInt;
   Films: array [1..MaxN] of TFilm;
   AnswerCount: LongInt;
   Answer: array [1..MaxN] of LongInt;

procedure ReadData;
var
   F: Text;
   NFilm: LongInt;
   QuotesCount: LongInt;
   Ch: Char;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NFilm:=1 to N
         do begin
            Films [NFilm].Name:='';
            QuotesCount:=0;
            while QuotesCount<2
                  do begin
                     Read (F, Ch);
                     if Ch='"'
                        then Inc (QuotesCount);
                     Films [NFilm].Name:=Films [NFilm].Name+Ch;
                  end;
            Readln (F, Films [NFilm].Year, Films [NFilm].Region);
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, AnswerCount);
     for NItem:=1 to AnswerCount
         do Writeln (F, Films [Answer [NItem]].Name);
     Close (F);
end;

var
   FIFOLen: LongInt;
   FIFO: array [1..MaxFIFOLen] of TFIFOItem;

procedure Solve;
var
   NFilm, NItem, NBestItem: LongInt;
begin
     FIFOLen:=0;
     for NFilm:=1 to N
         do begin
            Inc (FIFOLen);
            with FIFO [FIFOLen]
                 do begin
                    LastFilm:=N;
                    Changes:=0;
                    Done [NFilm]:=true;
                    FillChar (Done, SizeOf (Done), 0);
                    Count:=1;
                    From:=0;
                 end;
         end;
     NItem:=1;
     while NItem<=FIFOLen
           do with FIFO [NItem]
                   do begin
                      for NFilm:=1 to N
                          do if (not Done [NFilm]) and (Films [NFilm].Year>=Films [LastFilm].Year) and
                                ((Films [LastFilm].Region=Films [NFilm].Region) or (Changes<MaxChanges))
                                then begin
                                     Inc (FIFOLen);
                                     FIFO [FIFOLen].LastFilm:=NFilm;
                                     FIFO [FIFOLen].Changes:=Changes+Byte (Films [LastFilm].Region<>Films [NFilm].Region);
                                     FIFO [FIFOLen].Done:=FIFO [NItem].Done;
                                     FIFO [FIFOLen].Done [NFilm]:=true;
                                     FIFO [FIFOLen].Count:=Count+1;
                                     FIFO [FIFOLen].From:=NItem;
                                end;
                      Inc (NItem);
                   end;
     NBestItem:=1;
     for NItem:=2 to FIFOLen
         do if FIFO [NBestItem].Count<FIFO [NItem].Count
               then NBestItem:=NItem;
     AnswerCount:=FIFO [NBestItem].Count;
     NItem:=NBestItem;
     while NItem<>0
           do begin
              Answer [FIFO [NItem].Count]:=FIFO [NItem].LastFilm;
              NItem:=FIFO [NItem].From;
           end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
