{$N+}
program TaskF;
const MAXN=200;
    dt=1e-5;
type t1 = record
  x, y:double;
end;
     t2 = record
  i, j:integer;
  t:double;
end;
const infile = 'f.in';
      outfile = 'f.out';
var pt:array[1..MAXN]of t1;
    g:array[1..MAXN, 1..MAXN]of double;
    pn, pi:integer;
    mint:double;

function _(x, y:double):integer;
var i:integer;
begin
  for i:=1 to pn do
    if (abs(pt[i].x-x)<=dt)and(abs(pt[i].y-y)<=dt) then begin _:=i; exit; end;
  _:=-1;
end;

function max(a, b:double):double;
begin
  if a>b then max:=a else max:=b;
end;

function min(a, b:double):double;
begin
  if a<b then min:=a else min:=b;
end;

procedure inp;
var i, N, j, k, l:integer;
    x, y:double;
    otr:array[1..MAXN, 1..2, 1..2]of double;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  read(N); pn:=0;
  fillchar(g, sizeof(g), 0);
  for i:=1 to N do
  begin
    read(x, y); j:=_(x, y); otr[i][1][1]:=x; otr[i][1][2]:=y;
    if j=-1 then begin inc(pn); j:=pn; pt[j].x:=x; pt[j].y:=y; end;
    read(x, y); k:=_(x, y); otr[i][2][1]:=x; otr[i][2][2]:=y;
    if k=-1 then begin inc(pn); k:=pn; pt[k].x:=x; pt[k].y:=y; end;
    read(x); g[j, k]:=x; g[k, j]:=x;
  end;
  for i:=1 to N do
    for j:=i+1 to N do
      if (abs(max(otr[i][1][1], otr[i][2][1])-max(otr[j][1][1], otr[j][2][1]))<dt) and
         (abs(min(otr[i][1][1], otr[i][2][1])-min(otr[j][1][1], otr[j][2][1]))<dt) and
         (abs(max(otr[i][1][2], otr[i][2][2])-max(otr[j][1][2], otr[j][2][2]))<dt) and
         (abs(min(otr[i][1][2], otr[i][2][2])-min(otr[j][1][2], otr[j][2][2]))<dt) then
         begin
           k:=_(otr[i][1][1], otr[i][1][2]); l:=_(otr[i][2][1], otr[i][2][2]);
           inc(pn);
           pt[pn].x:=(otr[i][1][1]+otr[i][2][1])/2;
           pt[pn].y:=(otr[i][1][2]+otr[i][2][2])/2;
           g[k, pn]:=g[k, l]/2; g[pn, k]:=g[k, pn];
           g[pn, l]:=g[pn, k]; g[l, pn]:=g[k, pn];
           g[k, l]:=0; g[l, k]:=0;

           k:=_(otr[j][1][1], otr[j][1][2]); l:=_(otr[j][2][1], otr[j][2][2]);
           g[k, pn]:=g[k, l]/2; g[pn, k]:=g[k, pn];
           g[pn, l]:=g[pn, k]; g[l, pn]:=g[k, pn];
           g[k, l]:=0; g[l, k]:=0;
         end;
end;

function burn(i:integer):double;
var q:array[1..MAXN]of t2;
    qn, j, k:integer;
    pr:array[1..MAXN]of boolean;
    tmp, r:double;

function fm:integer;
var i, j:integer;
begin
  j:=1;
  for i:=1 to qn do if q[i].t<q[j].t then j:=i;
  fm:=j;
end;

procedure del(i:integer);
begin
  dec(qn); if i=qn+1 then exit;
  q[i]:=q[qn+1];
end;

function ft(i, j:integer):integer;
var k:integer;
begin
  ft:=-1;
  for k:=1 to qn do
    if (q[k].i=i)and(q[k].j=j) then begin ft:=k; exit; end;
end;

procedure process(i:integer);
var j, k:integer;
begin
  pr[i]:=true;
  for j:=1 to pn do
  begin
    if g[i, j]<dt then continue;
    if not pr[j] then
    begin
      inc(qn); q[qn].i:=i; q[qn].j:=j; q[qn].t:=g[i, j];
    end;
    if pr[j] then
    begin
      k:=ft(j, i); if k>0 then q[k].t:=q[k].t/2;
    end;
  end;
end;

begin
  fillchar(pr, sizeof(pr), false);
  qn:=1; q[1].i:=i; q[1].j:=i; q[1].t:=0; tmp:=0;
  while qn<>0 do
  begin
    j:=fm; r:=q[j].t; tmp:=tmp+r;
    for k:=1 to qn do q[k].t:=q[k].t-r;
    for k:=qn downto 1 do
      if q[k].t<dt then
      begin
        if not pr[q[k].i] then process(q[k].i);
        if not pr[q[k].j] then process(q[k].j);
        del(k);
      end;
  end;
  burn:=tmp;
end;

procedure run;
var i:integer;
    t:double;
begin
  mint:=MAXLONGINT;
  for i:=1 to pn do if (frac(pt[i].x)<=dt)and(frac(pt[i].y)<=dt) then
  begin
    t:=burn(i);
    if t<mint then begin mint:=t; pi:=i; end;
  end;
end;

procedure outp;
begin
  writeln(pt[pi].x:0:0, ' ', pt[pi].y:0:0);
  write(mint:0:2);
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
