{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'f.out';
  cinfile = 'f.in';

  hmax = 15713;
  vmax = 121;

  inf = 1e+20;
  eps = 1e-5;

type
  int = longint;
  real = extended;

  point = record
            x, y : real;
          end;

  list = ^tlist;
  tlist = record
            x, y : real;
            no : int;
            next : list;
          end;

var
  n, k : int;

  ans : real;
  ansp : int;

  h : array [0..hmax] of list;

  no : int;
  po : array [1..vmax] of point;

  g : array [1..vmax,1..vmax] of real;
  gs : array [1..vmax,0..vmax] of int;

  t : array [1..vmax] of real;
  time : real;

procedure outdata;
var
  i, j : int;
begin
  writeln(po[ansp].x:0:0,' ',po[ansp].y:0:0);
  writeln(ans:0:2);
end;

procedure go(v : int);
var
  i, j : int;
  fired : boolean;

  mt : real;
  mi, mj : int;

  procedure findmin;
  var
    i, j : int;
    tc : real;
  begin
    for i:= 1 to n do
    begin
      if time < t[i] then continue;
      for j:= 1 to gs[i,0] do
      begin
        if time < t[gs[i,j]] then
        begin
          tc:= g[i,gs[i,j]] - (time - t[i]);
          if tc > -eps then
          begin
            fired:= false;
            if mt > tc then
            begin
              mt:= tc;
              mi:= i;
              mj:= gs[i,j];
            end;
          end;
        end else
        begin
          tc:= (g[i,gs[i,j]] - (2*time - t[i] - t[gs[i,j]]))/2;
          if tc > eps then
          begin
            fired:= false;
            if mt > tc then
            begin
              mt:= tc;
              mi:= i;
              mj:= gs[i,j];
            end;
          end;
        end;
      end;
    end;
  end;

begin
  time:= 0;
  for i:= 1 to n do t[i]:= inf;
  t[v]:= 0;
  while true do
  begin
    fired:= true;
    mt:= inf;
    findmin;
    if fired then break;
    time:= time + mt;
    for i:= 1 to n do
    begin
      if time < t[i]-eps then continue;
      for j:= 1 to gs[i,0] do
      begin
        if time > t[gs[i,j]]+eps then continue;
        if time > t[i] + g[i,gs[i,j]] - eps then t[gs[i,j]]:= time;
      end;
    end;
  end;
  if ans > time then
  begin
    ans:= time;
    ansp:= v;
  end;
end;

procedure solve;
var
  i, j : int;
begin
  n:= no;{!}
  ans:= inf;
  fillchar(gs,sizeof(gs),0);
  for i:= 1 to n do
    for j:= 1 to n do
      if g[i,j] < inf/4 then
      begin
        inc(gs[i,0]);
        gs[i,gs[i,0]]:= j;
      end;
  for i:= 1 to n do
    if (abs(round(po[i].x) - po[i].x) < eps) and
      (abs(round(po[i].y) - po[i].y) < eps) then go(i);
end;

procedure init;
var
  i, j : int;
begin
  for i:= 1 to vmax do
    for j:= 1 to vmax do g[i,j]:= inf;
  fillchar(h,sizeof(h),0);
end;

function hesh(x, y : real) : int;
begin
  hesh:= abs(round(15485863*x+7368787*y)) mod hmax;
end;

procedure push(x, y : real; no : int);
var
  q : list;
  hs : int;
begin
  hs:= hesh(x,y);
  new(q);
  q^.next:= h[hs];
  q^.x:= x;
  q^.y:= y;
  q^.no:= no;
  h[hs]:= q;
end;

function find(x, y : real) : int;
var
  hs : int;
  q : list;
begin
  hs:= hesh(x,y);
  q:= h[hs];
  while q <> nil do
  begin
    if (abs(x-q^.x) < eps) and (abs(y-q^.y) < eps) then
    begin
      find:= q^.no;
      exit;
    end;
    q:= q^.next;
  end;
  find:= 0;
end;

function number(x, y : real) : int;
var
  c : int;
begin
  c:= find(x,y);
  if c = 0 then
  begin
    inc(no);
    push(x,y,no);
    number:= no;
    po[no].x:= x;
    po[no].y:= y;
  end else number:= c;
end;

procedure readdata;
var
  i, j : int;
  x, y, x1, y1, t : int;
  n1, n2, nm : int;
begin
  no:= 0;
  init;
  read(n);
  for i:= 1 to n do
  begin
    read(x, y, x1, y1, t);
    if (x = x1) or (y = y1) then
    begin
      n1:= number(x,y);
      n2:= number(x1,y1);
      g[n1,n2]:= t;
      g[n2,n1]:= t;
    end else
    begin
      n1:= number(x,y);
      n2:= number(x1,y1);
      nm:= number((x+x1)/2,(y+y1)/2);
      g[n1,nm]:= t/2;
      g[n2,nm]:= t/2;
      g[nm,n1]:= t/2;
      g[nm,n2]:= t/2;
    end;
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
