{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const MaxN = 81;

Type TPoint = Record
                X, Y: Real;
              End;
     TSpichka = Record
                  A, B: TPoint;
                  T: Real;
                  R, C: Byte;
                End;
     THeapElement = Record
                      N, E: Byte;
                      T: Real;
                    End;

Var I, J, K, N: Integer;
    HS: Byte;
    Mid, Temp: TPoint;
    Time, MinTime: Extended;
    S: array[1..MaxN] of TSpichka;
    H: array[1..MaxN] of THeapElement;
    A: array[1..MaxN, 1..MaxN] of Shortint;

Procedure SwapPoint(var A, B: TPoint);
Var C: TPoint;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure SwapByte(var A, B: Byte);
Var C: Byte;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure SwapReal(var A, B: Real);
Var C: Real;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure Orient(var X: TSpichka);
Begin
  If (X.A.X > X.B.X) or ((X.A.X = X.B.X) and (X.A.Y > X.B.Y)) Then
    SwapPoint(X.A, X.B);
End;

Function IntCoor(A: TPoint): Boolean;
Begin
  IntCoor := (Frac(A.X) = 0) and (Frac(A.Y) = 0);
End;

Function Diagonal(X: TSpichka): Boolean;
Begin
  Diagonal := IntCoor(X.A) and IntCoor(X.B) and
              (X.A.X <> X.B.X) and (X.A.Y <> X.B.Y);
End;

Function Cross(X, Y: TSpichka): Boolean;
Begin
  Cross := ((X.A.X < Y.B.X) and (Y.A.X < X.B.X)) and
          (((X.A.Y < Y.A.Y) and (X.B.Y > Y.B.Y)) or
           ((X.A.Y > Y.A.Y) and (X.B.Y < Y.B.Y)));
End;

Function Equil(A, B: TPoint): Boolean;
Begin
  Equil := (A.X = B.X) and (A.Y = B.Y);
End;

Function Touch(X, Y: TSpichka): Shortint;
Begin
  If Equil(X.A, Y.A)
  Then
    Touch := 0
  Else
    If Equil(X.B, Y.A)
    Then
      Touch := 1
    Else
     If Equil(X.A, Y.B)
     Then
       Touch := 2
     Else
       If Equil(X.B, Y.B) Then Touch := 3
                          Else Touch := - 1;
End;

Procedure SwapHeapElement(var X: Byte; Y: Byte);
Begin
  SwapByte(S[H[X].N].R, S[H[Y].N].R);
  SwapByte(H[X].N, H[Y].N);
  SwapByte(H[X].E, H[Y].E);
  SwapReal(H[X].T, H[Y].T);
  X := Y;
End;

Procedure MoveUp(K: Byte);
Begin
  While (K > 1) and (H[K].T < H[K shr 1].T) do
    SwapHeapElement(K, K shr 1);
End;

Procedure MoveDown(K: Byte);
Var Min: Byte;
Begin
  While (K shl 1 <= HS) do Begin
    Min := K shl 1;
    If Min < HS Then
      If H[Min + 1].T < H[Min].T Then Inc(Min);
    If H[K].T > H[Min].T
    Then
      SwapHeapElement(K, Min)
    Else
      Break;
  End;
End;

Procedure UpDate(K: Byte);
Begin
  If (K > 1) and (H[K shr 1].T > H[K].T) Then MoveUp(K)
                                         Else MoveDown(K);
End;

Procedure AddHeapElement(N: Byte; T: Real; E: Byte);
Begin
  Inc(HS);
  H[HS].N := N;
  H[HS].E := E;
  H[HS].T := T;
  S[N].R := HS;
  S[N].C := 1;
  UpDate(HS);
End;

Procedure DeleteHeapElement(K: Byte);
Var Ka: Byte;
Begin
  Ka := K;
  SwapHeapElement(K, HS);
  Dec(HS);
  UpDate(Ka);
End;

Procedure FireAt(F: THeapElement);
Var I: Byte;
Begin
  For I := 1 to N do
    If (S[I].C < 2) and (A[F.N, I] >= 0) and
       (F.E and (1 shl (A[F.N, I] and 1)) > 0) Then Begin
      If S[I].C = 0
      Then
        AddHeapElement(I, S[I].T, 1 shl ((A[F.N, I] and 2) shr 1))
      Else
        If H[S[I].R].E and (1 shl ((A[F.N, I] and 2) shr 1)) = 0 Then Begin
          H[S[I].R].E := 3;
          H[S[I].R].T := H[S[I].R].T / 2;
          UpDate(S[I].R);
        End;
    End;
End;

Procedure Burn;
Var I: Byte;
Begin
  FireAt(H[1]);
  While HS > 0 do Begin
    S[H[1].N].C := 2;
    Time := Time + H[1].T;
    For I := HS downto 1 do
      H[I].T := H[I].T - H[1].T;
    If H[1].E < 3 Then Begin
      H[1].E := 3 - H[1].E;
      FireAt(H[1]);
    End;
    DeleteHeapElement(1);
  End;
End;

Procedure InitBurn(I: Byte; A: TPoint; E: Byte);
Var J: Integer;
Begin
  For J := 1 to N do
    S[J].C := 0;
  If not IntCoor(A) Then Exit;
  HS := 0;
  Time := 0;
  AddHeapElement(I, S[I].T, E);
  Burn;
  If Time < MinTime Then Begin
    MinTime := Time;
    Temp := A;
  End;
End;

Begin
  Assign(Input, 'f.in');
  Assign(Output, 'f.out');
  Reset(Input);
  Rewrite(Output);
  Read(K);
  For I := 1 to K do Begin
    Inc(N);
    Read(S[N].A.X, S[N].A.Y, S[N].B.X, S[N].B.Y, S[N].T);
    Orient(S[N]);
    If Diagonal(S[N]) Then
      For J := 1 to N - 1 do
        If Diagonal(S[J]) and (Cross(S[N], S[J])) Then Begin
          Mid.X := (S[N].A.X + S[N].B.X) / 2;
          Mid.Y := (S[N].A.Y + S[N].B.Y) / 2;
          Temp := S[J].B;
          S[J].B := Mid;
          S[J].T := S[J].T / 2;
          Inc(N);
          S[N].A := Mid;
          S[N].B := Temp;
          S[N].T := S[J].T;
          Temp := S[N - 1].B;
          S[N - 1].B := Mid;
          S[N - 1].T := S[N - 1].T / 2;
          Inc(N);
          S[N].A := Mid;
          S[N].B := Temp;
          S[N].T := S[N - 2].T;
        End;
  End;
  For I := 1 to N do
    For J := 1 to N do
      If I <> J
      Then
        A[I, J] := Touch(S[I], S[J])
      Else
        A[I, J] := - 1;
  MinTime := 1e10;
  For I := 1 to N do Begin
    InitBurn(I, S[I].A, 1);
    InitBurn(I, S[I].B, 2);
  End;
  Writeln(Temp.X:0:0, ' ', Temp.Y:0:0);
  Write(MinTime:0:3);
  Close(Input);
  Close(Output);
End.