{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const MaxN = 3001;

Type TWalker = Record
                 A, B: Integer;
                 H: Boolean;
               End;
     TMoment = Record
                 P: Longint;
                 R, L: Integer;
               End;

Var I, J, N, K, R, Left, Right, Max: Integer;
    W: array[1..MaxN] of TWalker;
    T: array[1..MaxN shl 2] of TMoment;
    Ans: array[0..MaxN shl 1] of Longint;

Procedure Swap(var A, B: TMoment);
Var C: TMoment;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure Hoar(Left, Right: Integer);
Var I, J: Integer;
    X: Longint;
Begin
  I := Left;
  J := Right;
  X := T[Random(J - I + 1) + I].P;
  While I < J do Begin
    While T[I].P < X do Inc(I);
    While T[J].P > X do Dec(J);
    If I <= J Then Begin
      Swap(T[I], T[J]);
      Inc(I);
      Dec(J);
    End;
  End;
  If Left < J Then Hoar(Left, J);
  If I < Right Then Hoar(I, Right);
End;

Procedure InitMoments;
Begin
  R := 1;
  For I := 1 to K do
    If T[I].P <> T[R].P Then Begin
      Inc(R);
      T[R].P := T[I].P;
    End;
  J := R;
  K := R shl 1 - 1;
  For I := K downto 1 do Begin
    T[I].P := T[J].P;
    If I and 1 = 1 Then Dec(J)
                   Else Inc(T[I].P);
  End;
  T[K + 1].P := T[K].P + 1;
  For I := 1 to K do
    T[I].L := T[I + 1].P - T[I].P;
End;

Function FindPos(X: Integer): Integer;
Var Left, Right, Middle: Integer;
Begin
  Left := 1;
  Right := K;
  While Left < Right do Begin
    Middle := (Left + Right) shr 1;
    If T[Middle].P < X Then Left := Middle + 1;
    If T[Middle].P > X Then RIght := Middle - 1;
    If T[Middle].P = X Then Break;
  End;
  FindPos := Middle;
End;

Procedure InitReitings;
Var X: Integer;
Begin
  For I := 1 to N do Begin
    X := FindPos(W[I].A);
    While (X > 1) and (T[X - 1].P = W[I].A) do Dec(X);
    While (X <= K) and (T[X].P <= W[I].B) do Begin
      Inc(T[X].R);
      Inc(X);
    End;
  End;
End;

Begin
  Assign(Input, 'g.in');
  Assign(Output, 'g.out');
  Reset(Input);
  Rewrite(Output);
  Read(N);
  For I := 1 to N do Begin
    Read(W[I].A, W[I].B);
    Inc(K);
    T[K].P := W[I].A;
    Inc(K);
    T[K].P := W[I].B;
  End;
  Hoar(1, K);
  InitMoments;
  InitReitings;
  Repeat
    Max := 1;
    For I := 1 to K do
      If (T[I].L > 0) and (T[I].R > T[Max].R) Then Max := I;
    If T[Max].R = 0 Then Break;
    Dec(T[Max].L);
    For I := 1 to N do Begin
      Left := FindPos(W[I].A);
      While (Left > 1) and (T[Left - 1].P = W[I].A) do Dec(Left);
      Right := FindPos(W[I].B);
      While (Right < K) and (T[Right + 1].P = W[I].B) do Inc(Right);
      If (Left <= Max) and (Max <= Right) Then
        If W[I].H
        Then
          For J := Left to Right do
            Dec(T[J].R)
        Else
          W[I].H := True;
    End;
    Inc(Ans[0]);
    Ans[Ans[0]] := T[Max + 1].P - T[Max].L - 1;
  Until False;
  Writeln(Ans[0]);
  For I := 1 to Ans[0] - 1 do
    For J := I + 1 to Ans[0] do
      If Ans[I] > Ans[J] Then Begin
        K := Ans[I];
        Ans[I] := Ans[J];
        Ans[J] := K;
      End;
  For I := 1 to Ans[0] do
    Write(Ans[I], ' ');
  Close(Input);
  Close(Output);
End.