#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>

#define NN 1000100
#define eps 1e-1

struct POINT {
  long long x,y;
};

FILE *fi, *fo;
double a[NN];
POINT first,second;
POINT cur;
POINT prev_1, prev_2;
POINT va, vb;
int n;
bool flag_1;
bool flag_2;
double ma,mb;
long long res_vp;

int getcc()
{
  int c;
  c=getc(fi);
  while((c==' ')||(c=='\n')||(c=='\r')||(c=='\t'))
    c=getc(fi);
  return c;
}

double l(POINT p)
{
  long long arg;
  arg=p.x*p.x+p.y*p.y;
  return sqrt(arg);
}

long long read_long()
{
  long long res;
  int c;
  res=0;
  c=getcc();
  while(isdigit(c))
  {
    res=res*10LL+(long long)c-'0';
    c=getc(fi);
  }
  return res;
}

void read_point(POINT *p)
{
  p->x=read_long();
  p->y=read_long();
}

long long vp()
{
  POINT a,b;
  long long ans;
  a.x=prev_1.x-prev_2.x;
  a.y=prev_1.y-prev_2.y;
  b.x=cur.x-prev_1.x;
  b.y=cur.y-prev_1.y;
  ans=a.x*b.y-b.x*a.y;
  ma=l(a);
  mb=l(b);
  va=a;
  vb=b;
  return ans;
}

int sign(long long arg)
{
  if(arg==0LL)
    return 0;
  if(arg<0LL)
    return -1;
  return 1;
}

double gsin()
{
  double res;
  res=res_vp;
  res/=ma;
  res/=mb;
  return res;
}

double get_sum()
{
  int l;
  int i;
  l=n;
  while(l>1)
  {
    for(i=0;i<l;i+=2)
    {
      a[i/2]=a[i];
      if(i+1<l)
        a[i/2]+=a[i+1];
    }
    l=(l+1)/2;
  }
  return a[0];
}

double get_ang()
{
  double res;
  double ang_a,ang_b;
  ang_a=atan2(va.x,va.y);
  ang_b=atan2(vb.x,vb.y);
  res=fabs(ang_a-ang_b);
  if(res>M_PI)
    res=2*M_PI-res;
  return res;
}

int main()
{
  int tst, num_tst;
  int i,j;
  long long f;
  double tn;
  fi=fopen("convex.in","rt");
  fo=fopen("convex.out","wt");

  fscanf(fi,"%d",&num_tst);
  for(tst=0;tst<num_tst;tst++)
  {
    flag_1=true;
    flag_2=true;
    fscanf(fi,"%d",&n);
    read_point(&prev_1);
    read_point(&cur);
    first=prev_1;
    second=cur;
    n--;
    for(i=2;i<n;i++)
    {
      prev_2=prev_1;
      prev_1=cur;
      read_point(&cur);
      res_vp=vp();
      j=sign(res_vp);
      if(j<0)
        flag_1=false;
      if(j>0)
        flag_2=false;
/*      a[i-2]=asin(gsin());
      if(a[i-2]<0)
        a[i-2]=-a[i-2];*/
      a[i-2]=get_ang();
    }
    prev_2=prev_1;
    prev_1=cur;
    read_point(&cur);
    if((cur.x!=first.x)||(cur.y!=first.y))
    {
      flag_1=false;
      flag_2=false;
    }
    cur=first;
    res_vp=vp();
    j=sign(res_vp);
    if(j<0)
      flag_1=false;
    if(j>0)
      flag_2=false;
    a[n-2]=get_ang();
    prev_2=prev_1;
    prev_1=cur;
    cur=second;
    res_vp=vp();
    j=sign(res_vp);
    if(j<0)
      flag_1=false;
    if(j>0)
      flag_2=false;
    a[n-1]=get_ang();
    if(flag_1&&flag_2)
    {
      fprintf(fo,"NO\n");
    }
    else
    {
      if((!flag_1)&&(!flag_2))
      {
        fprintf(fo,"NO\n");
      }
      else
      {
        tn=get_sum();
        if(flag_1)
        {
          if(tn<4*M_PI-eps)
            fprintf(fo,"YES\n");
          else
            fprintf(fo,"NO\n");
        }
        else
        {
          if(tn<4*M_PI-eps)
            fprintf(fo,"YES\n");
          else
            fprintf(fo,"NO\n");
        }
      }
    }
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
