{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'convex.out';
  cinfile = 'convex.in';

  eps = 1e-8;

type
  int = longint;
  real = extended;

  point = record
            x, y : int;
          end;

var
  n, k : int;
  ans : int;

procedure outdata;
var
  i, j : int;
begin
  if ans = 0 then writeln('YES') else writeln('NO');
end;

procedure vector(var v : point; b, e : point);
begin
  v.x:= e.x-b.x;
  v.y:= e.y-b.y;
end;

function sign(x : real) : int;
begin
  if x < -eps then sign:= -1 else
    if x > eps then sign:= 1 else sign:= 0;
end;

function vmul(v1, v2 : point) : real;
begin
  vmul:= (v1.x/1)*v2.y-(v2.x/1)*v1.y;
end;

procedure no;
var
  i : int;
  p : point;
begin
  ans:= -1;
  for i:= 1 to n do read(p.x,p.y);
end;

function dv(v : point) : real;
begin
  dv:= sqrt((v.x/1)*v.x+(v.y/1)*v.y);
end;

function arccos(c : real) : real;
var
  u : real;
begin
  if c = 0 then arccos:= pi/2 else
  begin
    u:= arctan(sqrt(abs(1-c*c))/c);
    if c < -eps then u:= u + pi;
    arccos:= u;
  end;
end;

procedure solve;
var
  i, j : int;
  p1, p2, p3, p, sp : point;
  v12, v23 : point;
  so, sc : int;
  u : real;
  nr : int;
begin
  nr:= n;
  ans:= 0;
  if n < 4 then
  begin
    no;
    exit;
  end;
  read(p1.x,p1.y);
  p:= p1;
  read(p2.x,p2.y);
  sp:= p2;
  read(p3.x,p3.y);
  vector(v12,p1,p2);
  vector(v23,p2,p3);
  u:= arccos(-((v12.x/1)*v23.x+(v12.y/1)*v23.y)/dv(v12)/dv(v23));
  so:= sign(vmul(v12,v23));
  dec(n,3);
  while (so = 0) and (n > 0) do
  begin
    p1:= p2;
    p2:= p3;
    read(p3.x,p3.y);
    vector(v12,p1,p2);
    vector(v23,p2,p3);
    u:= u + arccos(-((v12.x/1)*v23.x+(v12.y/1)*v23.y)/dv(v12)/dv(v23));
    so:= sign(vmul(v12,v23));
    dec(n);
    if (so = 0) and (v12.x*v23.x+v12.y*v23.y < 0) then
    begin
      no;
      exit;
    end;
  end;
  while n > 0 do
  begin
    dec(n);
    p1:= p2;
    p2:= p3;
    read(p3.x,p3.y);
    vector(v12,p1,p2);
    vector(v23,p2,p3);
    u:= u + arccos(-((v12.x/1)*v23.x+(v12.y/1)*v23.y)/dv(v12)/dv(v23));
    sc:= sign(vmul(v12,v23));
    if sc*so < 0 then
    begin
      no;
      exit;
    end;
    if (sc = 0) and (v12.x*v23.x+v12.y*v23.y < 0) then
    begin
      no;
      exit;
    end;
  end;
  vector(v12,p2,p3);
  vector(v23,p3,sp);
  u:= u + arccos(-((v12.x/1)*v23.x+(v12.y/1)*v23.y)/dv(v12)/dv(v23));
  if (p.x <> p3.x) or (p.y <> p3.y) or (abs(u-pi*(nr-3)) > eps) then
  begin
    no;
    exit;
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
end;

var
  c, ii : int;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  read(c);
  for ii:= 1 to c do
  begin
    readdata;
    solve;
    outdata;
  end;
  close(input);
  close(output);
end.