{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_c;
const
  inpfile='convex.in';
  outfile='convex.out';
  eps=1e-5;
  inf=1e20;
  nm=2000005;
type
  Coord = record
    x,y : Extended;
  end;
var
  a : array [0..nm] of Coord;
  n,tnum : LongInt;
{}
Procedure Inp;
begin
  assign(input,inpfile);
  reset(input);
  read(tnum);
end;
{}
Procedure Out;
begin
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  assign(output,outfile);
  rewrite(output);
end;
{}
Function Eq(q,w : Coord) : Boolean;
begin
  if (abs(q.x-w.x)<eps) and (abs(q.y-w.y)<eps) then Eq:=true
                                               else Eq:=false;
end;
{}
Function Vc(p1,p2,p3,p4 : Coord) : Extended;
begin
  Vc:=(p2.x-p1.x)*(p4.y-p3.y)-(p4.x-p3.x)*(p2.y-p1.y);
end;
{}
Function Len(q,w : Coord) : Extended;
begin
  Len:=sqr(q.x-w.x)+sqr(q.y-w.y);
end;
{}
Procedure Solve;
var
  i,j,k,s : LongInt;
  way : Byte;
  v : Extended;
  ans,ok : Boolean;
begin
  a[0].y:=inf; a[0].x:=inf;
  for k:=1 to tnum do begin
    ans:=true; ok:=false;
    

    read(n);
    for i:=1 to n do read(a[i].x,a[i].y);

    if not Eq(a[1],a[n]) then begin
      writeln('NO'); ans:=false;
      continue;
    end;

    dec(n);
    for i:=n+1 to 2*n do a[i]:=a[i-n];

    s:=0;
    for i:=1 to n do
      if (a[i].y<a[s].y-eps) or (abs(a[i].y-a[s].y)<eps)
      and (a[i].x>a[s].x+eps) then s:=i;

    a[s+n]:=a[s]; way:=0;

    for i:=s+1 to s+n do begin

      v:=Vc(a[i-1],a[i],a[i],a[i+1]);

      if way=0 then begin
        if v>eps then way:=1 else
        if v<-eps then way:=2 else begin
          if Len(a[i-1],a[i])+eps>Len(a[i-1],a[i+1]) then begin
            ans:=false; break;
          end;
        end;

      end else if way=1 then begin

        if (v<-eps) or (abs(v)<eps) and
        (Len(a[i-1],a[i])+eps>Len(a[i-1],a[i+1])) then begin
          ans:=false; break;
        end;

        if v>eps then ok:=true;
      end else begin
        if (v>eps) or (abs(v)<eps) and
        (Len(a[i-1],a[i])+eps>Len(a[i-1],a[i+1])) then begin
          ans:=false; break;
        end;

        if v<-eps then ok:=true;
       end;
    end;

    if (not ans) or (not ok) then writeln('NO')
                             else writeln('YES');
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.