{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
Program Problem;
Const
     InFile = 'convex.in';
     OutFile = 'convex.out';
     NMax = 1000000;
Type
    TArray = Array [0..NMax + 1] Of LongInt;
Var
   K,KK : LongInt;
   M,N,Top : LongInt;
   SX,SY,X,Y,XX,YY : TArray;
   Answer : String;

 Procedure Init;
  Begin
    Assign (Input,InFile); ReSet (Input);
    Assign (Output,OutFile); ReWrite (Output);
  End;

 Procedure Swap (I,J : LongInt);
  Begin
    X[0]:= X[I]; X[I]:= X[J]; X[J]:= X[0];
    Y[0]:= Y[I]; Y[I]:= Y[J]; Y[J]:= Y[0];
  End;

 Function SignCrPr (X0,Y0,X1,Y1,X2,Y2 : Extended) : ShortInt;
  Begin
    If 1.0 * (X1 - X0) * (Y2 - Y0) - 1.0 * (X2 - X0) * (Y1 - Y0) > 0 Then SignCrPr:= 1
    Else
     If 1.0 * (X1 - X0) * (Y2 - Y0) - 1.0 * (X2 - X0) * (Y1 - Y0) < 0 Then SignCrPr:= -1
     Else SignCrPr:= 0;
  End;

 Function SqrDist (X1,Y1,X2,Y2 : LongInt) : Extended;
  Begin
    SqrDist:= 1.0 * (X1 - X2) * (X1 - X2) + 1.0 * (Y1 - Y2) * (Y1 - Y2);
  End;

 Procedure QSort (L,R : LongInt);
  Var
     I,J,XM,YM : LongInt;
  Begin
    I:= L; J:= R;
    XM:= X[(L + R) Div 2]; YM:= Y[(L + R) Div 2];
    Repeat
      While (SignCrPr (X[1],Y[1],X[I],Y[I],XM,YM) > 0) Or
             ((SignCrPr (X[1],Y[1],X[I],Y[I],XM,YM) = 0) And
              (SqrDist (X[1],Y[1],X[I],Y[I]) < SqrDist(X[1],Y[1],XM,YM)))
        Do Inc (I);
      While (SignCrPr (X[1],Y[1],X[J],Y[J],XM,YM) < 0) Or
             ((SignCrPr (X[1],Y[1],X[J],Y[J],XM,YM) = 0) And
              (SqrDist (X[1],Y[1],X[J],Y[J]) > SqrDist(X[1],Y[1],XM,YM)))
        Do Dec (J);
      If I <= J Then Begin
       Swap (I,J);
       Inc (I); Dec (J);
      End;
    Until I > J;
    If J > L Then QSort (L,J);
    If I < R Then QSort (I,R);
  End;

 Procedure ReXXYY;
  Var
     XXT,YYT : TArray;
     I : LongInt;
  Begin
    FillChar (XXT,SizeOf(XXT),0); FillChar (YYT,SizeOf(YYT),0);
    M:= 2;
    XXT[1]:= XX[1]; YYT[1]:= YY[1];
    XXT[2]:= XX[2]; YYT[2]:= YY[2];
    For I:= 3 To N Do Begin
      While (SignCrPr (XXT[M - 1],YYT[M - 1],XXT[M],YYT[M],XX[I],YY[I]) = 0) And
             (M > 1)
        Do Dec (M);
      Inc (M);
      XXT[M]:= XX[I]; YYT[M]:= YY[I];
    End;
    XX:= XXT; YY:= YYT;
  End;

 Function Eq1 : Boolean;
  Var
     I,J : LongInt;
   Begin
     Eq1:= False;
     For I:= 1 To M Do
       If (XX[I] <> SX[I]) Or (YY[I] <> SY[I]) Then Exit;
     Eq1:= True;
   End;

  Function Eq2 : Boolean;
   Var
      I : LongInt;
    Begin
      Eq2:= False;
      If M <> Top Then Exit;
      For I:= 1 To M Do
        If (XX[I] <> SX[M - I + 2]) Or (YY[I] <> SY[M - I + 2]) Then Exit;
      Eq2:= True;
    End;

 Procedure Shift (I0 : LongInt);
  Var
     I,II : LongInt;

  Begin
    I:= I0;
    For II:= 1 To N Do Begin
      XX[II]:= X[I]; YY[II]:= Y[I];
      If I < N Then Inc (I) Else I:= 1;
    End;
  End;

 Procedure Check;
  Var
     I,I1 : LongInt;

   Procedure Push (X,Y : LongInt);
    Begin
      Inc (Top);
      SX[Top]:= X; SY[Top]:= Y;
    End;

   Begin
     If (X[1] <> X[N]) Or (Y[1] <> Y[N]) Then Begin
      Answer:= 'NO';
      Exit;
     End;
     Dec (N);
     I1:= 1;
     For I:= 2 To N Do
       If (Y[I] < Y[I1]) Or ((Y[I] = Y[I1]) And (X[I] < X[I1]))
        Then I1:= I;
     Shift (I1);
     Swap (1,I1);
     QSort (2,N);
     If SignCrPr (X[1],Y[1],X[2],Y[2],X[N],Y[N]) = 0 Then Begin
      Answer:= 'NO';
      Exit;
     End;
     FillChar (SX,SizeOf(SX),0); FillChar (SY,SizeOf(SY),0);
     Top:= 0;
     For I:= 1 To 2 Do Push (X[I],Y[I]);
     For I:= 3 To N Do Begin
       While (SignCrPr (SX[Top - 1],SY[Top - 1],SX[Top],SY[Top],X[I],Y[I]) <= 0) And
              (Top > 1)
         Do Dec (Top);
       Push (X[I],Y[I]);
     End;
     ReXXYY;
     {WriteLn ('convex hull: ');
     For I:= 1 To Top Do WriteLn (SX[I],' ',SY[I]);
     WriteLn;

     WriteLn ('polygon: ');
     For I:= 1 To M Do WriteLn (XX[I],' ',YY[I]);
     WriteLn;}

     If Eq1 Or Eq2 Then Answer:= 'YES' Else Answer:= 'NO';
   End;

 Procedure Solve;
  Var
     I,I1 : LongInt;
   Begin
     Read (K);
     For KK:= 1 To K Do Begin
       Read (N);
       For I:= 1 To N Do Read (X[I],Y[I]);
       Check;
       WriteLn (Answer);
     End;
   End;

 Procedure Done;
  Begin
    Close (Input);
    Close (Output);
  End;

 BEGIN
   Init;
   Solve;
   Done;
 END.

