{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 50000,0,655360}

Const INPUTFILE='convex.in';
      OUTPUTFILE='convex.out';

Const MaxN=1001000;
Const EPS=1E-6;

Type Real=Double;
     Point=record
     x,y:Longint;
     end;
     RPoint=record
     x,y:Real;
     end;

Function REqual(a,b:Real):Boolean;
begin
REqual:=Abs(a-b)<EPS;
end;

Function RMore(a,b:Real):Boolean;
begin
RMore:=(a-b)>EPS;
end;

Function RLess(a,b:Real):Boolean;
begin
RLess:=(b-a)>EPS;
end;

var a:Array[1..MaxN+1] of Point;
    P:Longint;
    N:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(P);
Assign(Output,OUTPUTFILE);
Rewrite(Output);

end;


Function Polar(x,y:Real):Real;
var p:Real;
begin
  if REqual(x,0) then
    p:=Pi/2+Pi*Ord(RLess(y,0))
  else
  begin
    p:=ArcTan(y/x)+Pi;
    if RMore(x,0) then
    begin
      if RLess(y,0)=False then
        p:=p-Pi
      else
        p:=p+Pi;
    end;
  end;
Polar:=p;
end;

Procedure Solve;
var g,h:Longint;
    k:Longint;
    CosA,SinA,TanA,Al,Sc,Vec:Real;
    Sum:Real;
    t1,t2,t3:Real;
    v1,v2:RPoint;
    Sgn:Shortint;
begin
for k:=1 to P do
begin
  Read(N);
  for i:=1 to N do
    Read(a[i].x,a[i].y);
  a[N+1]:=a[2];
  g:=1;
  Repeat
    if (a[1].x<>a[N].x) OR (a[1].y<>a[N].y) then
    begin
      g:=0;
      Break;
    end;

  Sum:=0;
  Sgn:=0;
  for i:=1 to N-1 do
  begin
    v1.x:=a[i+1].x-a[i].x;
    v1.y:=a[i+1].y-a[i].y;
    v2.x:=a[i+2].x-a[i+1].x;
    v2.y:=a[i+2].y-a[i+1].y;
    Sc:=(v1.x*v2.x+v1.y*v2.y);
    Vec:=v1.x*v2.y-v2.x*v1.y;
    if Sgn=0 then
    begin
      if RMore(Vec,0) then
        Sgn:=1
      else if RLess(Vec,0) then
        Sgn:=-1;
    end
    else
    begin
      if ((RMore(Vec,0)) AND (Sgn<>1))
      OR ((RLess(Vec,0)) AND (Sgn<>-1)) then
      begin
        g:=0;
        Break;
      end;

    end;
    t1:=sqrt((sqr(v1.x)+sqr(v1.y))*(sqr(v2.x)+sqr(v2.y)));
    CosA:=Sc/t1;
    SinA:=Vec/t1;
    if REqual(CosA,0) then
      Al:=Pi/2
    else
    begin
      TanA:=Abs(SinA)/CosA;
      Al:=ArcTan(TanA);
    end;
    if RLess(Al,0) then Al:=Al+Pi;
    Sum:=Sum+{Abs(}Al{)};
  end;
  if REqual(Sum,2*Pi)=False then
  begin
    g:=0;
    Break;
  end;

  Until True;
  if g=1 then
    Writeln('YES')
  else
    Writeln('NO');
end;

Close(Input);
Close(Output);
end;

begin
FRead;
Solve;
end.