const
     FileIn='square.in';
     FileOut='square.out';
     MaxN=30000+4;
var
   N, W, H: LongInt;
   X, Y: array [1..MaxN] of LongInt;
   XIndexes, YIndexes: array [1..MaxN] of LongInt;
   Answer: LongInt;

procedure ReadData;
var
   F: Text;
   NPoint: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, W, H);
     for NPoint:=1 to N
         do Read (F, X [NPoint], Y [NPoint]);
     Inc (N);
     X [N]:=0;
     Y [N]:=0;
     Inc (N);
     X [N]:=W;
     Y [N]:=0;
     Inc (N);
     X [N]:=0;
     Y [N]:=H;
     Inc (N);
     X [N]:=W;
     Y [N]:=H;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

procedure QSortX (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   M, T: LongInt;
begin
     i:=aLeft;
     j:=aRight;
     M:=X [XIndexes [(aLeft+aRight) div 2]];
     repeat
           while X [XIndexes [i]]<M
                 do Inc (i);
           while M<X [XIndexes [j]]
                 do Dec (j);
           if i<=j
              then begin
                   T:=XIndexes [i];
                   XIndexes [i]:=XIndexes [j];
                   XIndexes [j]:=T;
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSortX (aLeft, j);
     if i<aRight
        then QSortX (i, aRight);
end;

procedure QSortY (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   M, T: LongInt;
begin
     i:=aLeft;
     j:=aRight;
     M:=Y [YIndexes [(aLeft+aRight) div 2]];
     repeat
           while Y [YIndexes [i]]<M
                 do Inc (i);
           while M<Y [YIndexes [j]]
                 do Dec (j);
           if i<=j
              then begin
                   T:=YIndexes [i];
                   YIndexes [i]:=YIndexes [j];
                   YIndexes [j]:=T;
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSortY (aLeft, j);
     if i<aRight
        then QSortY (i, aRight);
end;

function SearchX (aX: LongInt): LongInt;
var
   Left, Right, Middle: LongInt;
   MiddleKey: LongInt;
begin
     Left:=1;
     Right:=N;
     repeat
           Middle:=(Left+Right) shr 1;
           MiddleKey:=X [XIndexes [Middle]];
           if MiddleKey<aX
              then Left:=Middle+1
              else if MiddleKey>aX
                      then Right:=Middle-1
                      else begin
                           Left:=Right+1;
                           Right:=Middle;
                      end;
     until Left>=Right;
     if Right<1
        then Right:=1;
     SearchX:=Right;
end;

function SearchY (aY: LongInt): LongInt;
var
   Left, Right, Middle: LongInt;
   MiddleKey: LongInt;
begin
     Left:=1;
     Right:=N;
     repeat
           Middle:=(Left+Right) shr 1;
           MiddleKey:=Y [YIndexes [Middle]];
           if MiddleKey<aY
              then Left:=Middle+1
              else if MiddleKey>aY
                      then Right:=Middle-1
                      else begin
                           Left:=Right+1;
                           Right:=Middle;
                      end;
     until Left>=Right;
     if Right<1
        then Right:=1;
     SearchY:=Right;
end;

procedure InitIndexes;
var
   Index: LongInt;
begin
     for Index:=1 to N
         do begin
            XIndexes [Index]:=Index;
            YIndexes [Index]:=Index;
         end;
     QSortX (1, N);
     QSortY (1, N);
end;

function Min (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Min:=aA
        else Min:=aB;
end;

function Max (aA, aB: LongInt): LongInt;
begin
     if aA>aB
        then Max:=aA
        else Max:=aB;
end;

function Test (aLeft, aTop: LongInt; aA: LongInt): Boolean;
var
   Index: LongInt;
   LocX, LocY: LongInt;
begin
     if (aLeft+aA>W) or (aTop+aA>H)
        then begin
             Test:=false;
             Exit;
        end;
     if (aLeft<0) or (aLeft>W) or (aTop<0) or (aTop>H)
        then begin
             Test:=false;
             Exit;
        end;
     Index:=SearchX (aLeft);
     while (Index<=N) and (X [XIndexes [Index]]<aLeft+aA)
           do begin
              if X [XIndexes [Index]]>aLeft
                 then begin
                      LocY:=Y [XIndexes [Index]];
                      if (LocY>aTop) and (LocY<aTop+aA)
                         then begin
                              Test:=false;
                              Exit;
                         end;
                 end;
              Inc (Index);
           end;
     Index:=SearchY (aTop);
     while (Index<=N) and (Y [YIndexes [Index]]<aTop+aA)
           do begin
              if Y [YIndexes [Index]]>aTop
                 then begin
                      LocX:=X [YIndexes [Index]];
                      if (LocX>aLeft) and (LocX<aLeft+aA)
                         then begin
                              Test:=false;
                              Exit;
                         end;
                 end;
              Inc (Index);
           end;
     Test:=true;
end;

procedure Solve;
var
   Index1, Index2: LongInt;
   RealIndex1, RealIndex2: LongInt;
   X1, Y1, X2, Y2, Left, Top, A: LongInt;
begin
     InitIndexes;
     Answer:=0;
     for Index1:=1 to N
         do for Index2:=Index1+1 to N
                do begin
                   RealIndex1:=Index1;
                   RealIndex2:=Index2;
                   A:=Max (Abs (X [RealIndex1]-X [RealIndex2]), Abs (Y [RealIndex1]-Y [RealIndex2]));
                   if (A>Answer) or (Answer=0)
                      then begin
                           Left:=Min (X [RealIndex1], X [RealIndex2]);
                           Top:=Min (Y [RealIndex1], Y [RealIndex2]);
                           if Test (Left, Top, A)
                              then Answer:=A
                              else begin
                                   Left:=Max (X [RealIndex1], X [RealIndex2])-A;
                                   Top:=Max (Y [RealIndex1], Y [RealIndex2])-A;
                                   if Test (Left, Top, A)
                                      then Answer:=A;
                              end;
                      end;
                end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
