{$I-,Q-,R-,S-}
const
     FileIn='convex.in';
     FileOut='convex.out';
     MaxN=1000000;
type
    TCoorArray=array [1..MaxN] of LongInt;
var
   FIn, FOut: Text;
   N: LongInt;
   X, Y: TCoorArray;
   Answer: Boolean;

procedure ReadData;
var
   NItem: LongInt;
begin
     Read (FIn, N);
     for NItem:=1 to N
         do Read (FIn, X [NItem], Y [NItem]);
end;

procedure WriteData;
begin
     case Answer of
          false: Writeln (FOut, 'NO');
          true: Writeln (FOut, 'YES');
     end;
end;

function Prev (aIndex: LongInt): LongInt;
begin
     if aIndex>1
        then Prev:=aIndex-1
        else Prev:=N;
end;

function Next (aIndex: LongInt): LongInt;
begin
     if aIndex<N
        then Next:=aIndex+1
        else Next:=1;
end;

function Sign (aNumber: LongInt): LongInt;
begin
     if aNumber<0
        then Sign:=-1
        else if aNumber>0
                then Sign:=1
                else Sign:=0;
end;

function PackCoorArray (var A: TCoorArray): LongInt;
var
   RIndex, WIndex: LongInt;
begin
     WIndex:=1;
     for RIndex:=1 to N
         do if A [WIndex]<>A [RIndex]
               then begin
                    Inc (WIndex);
                    A [WIndex]:=A [RIndex];
               end;
     PackCoorArray:=WIndex;
end;

function CheckCoorArray (var A: TCoorArray): Boolean;
var
   Index: LongInt;
   MinFlag, MaxFlag: Boolean;
begin
     MinFlag:=false;
     MaxFlag:=false;
     for Index:=2 to PackCoorArray (A)-1
         do begin
            if (A [Index]<A [Index-1]) and (A [Index]<A [Index+1])
               then if MinFlag
                       then begin
                            CheckCoorArray:=false;
                            Exit;
                       end
                       else MinFlag:=true;
            if (A [Index-1]<A [Index]) and (A [Index+1]<A [Index])
               then if MaxFlag
                       then begin
                            CheckCoorArray:=false;
                            Exit;
                       end
                       else MaxFlag:=true;
         end;
     CheckCoorArray:=true;
end;

procedure Solve;
var
   IsSlim: Boolean;
   Index, BestIndex: LongInt;
   X1, Y1, X2, Y2, Z, DeltaX, DeltaY: LongInt;
   Signum: LongInt;
begin
     Answer:=(X [1]=X [N]) and (Y [1]=Y [N]);
     if Answer
        then begin
             Signum:=0;
             IsSlim:=true;
             for Index:=1 to N
                 do begin
                    X1:=X [Index]-X [Prev (Index)];
                    Y1:=Y [Index]-Y [Prev (Index)];
                    X2:=X [Next (Index)]-X [Index];
                    Y2:=Y [Next (Index)]-Y [Index];
                    Z:=X1*Y2-X2*Y1;
                    if Z<>0
                       then IsSlim:=false;
                    if Abs (Sign (Z)-Signum)>1
                       then begin
                            Answer:=false;
                            Break;
                       end
                       else if Signum=0
                               then Signum:=Sign (Z);
                 end;
             Answer:=Answer and (not IsSlim) and CheckCoorArray (X) and CheckCoorArray (Y);
        end;
end;

var
   TestsCount: LongInt;
   NTest: LongInt;
begin
     Assign (FIn, FileIn);
     Reset (FIn);
     Assign (FOut, FileOut);
     Rewrite (FOut);
     Readln (FIn, TestsCount);
     for NTest:=1 to TestsCount
         do begin
            ReadData;
            Solve;
            WriteData;
         end;
     Close (FIn);
     Close (FOut);
end.
