  {$I-,Q-,R-,S-}
const maxn=1000002;
type tpoint=record x,y:longint; end;
     ttype=record p:tpoint; ind:longint; end;
     mas=array[1..maxn] of ttype;
var n,m,cnt:longint;
    t0:tpoint;
    a:mas;

procedure init;
begin
     assign(input,'convex.in');
     reset(input);
     assign(output,'convex.out');
     rewrite(output);
     read(n);
end;

Function vp(const a,b:tpoint):extended;
var q,w:extended;
begin
     q:=(1.0*a.x)*b.y;
     w:=(1.0*b.x)*a.y;
     vp:=q-w;
end;

Function less(const a,b:tpoint):boolean;
var v1,v2:tpoint;
    z:extended;
begin
     v1.x:=a.x-t0.x;
     v1.y:=a.y-t0.y;
     v2.x:=b.x-t0.x;
     v2.y:=b.y-t0.y;
     z:=vp(v1,v2);
     less:=true;
     if abs(z)<0.0000001 then less:=false;
     if z>0 then less:=false;
end;

Procedure swap(var a,b:ttype);
var t:ttype;
begin
     t:=a;
     a:=b;
     b:=t;
end;

procedure qSort(l, r: longint);
var
  i, j, x: longint;
begin
  i := l; j := r; x := (l+r) DIV 2;
  repeat
    while less(a[x].p,a[i].p) do i := i + 1;
    while less(a[j].p,a[x].p) do j := j - 1;
    if i <= j then
    begin
      swap(a[i],a[j]);
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then qSort(l, j);
  if i < r then qSort(i, r);
end;

Function sp(const a,b:tpoint):extended;
var q,w:extended;
begin
     q:=(1.0*a.x)*b.x;
     w:=(1.0*a.y)*b.y;
     sp:=q+w;
end;

Function ononeline(const p,l,r:tpoint):boolean;
var v1,v2:tpoint;
begin
     v1.x:=l.x-p.x;
     v1.y:=l.y-p.y;
     v2.x:=r.x-p.x;
     v2.y:=r.y-p.y;
     if (round(sp(v1,v2))<0) and (round(vp(v1,v2))=0) then ononeline:=true else ononeline:=false;
end;

Function ononeline2(const p,l,r:tpoint):boolean;
var v1,v2:tpoint;
begin
     v1.x:=l.x-p.x;
     v1.y:=l.y-p.y;
     v2.x:=r.x-p.x;
     v2.y:=r.y-p.y;
     if vp(v1,v2)=0 then ononeline2:=true else ononeline2:=false;
end;

Function graham:boolean;
var i,j:longint;
    v1,v2:tpoint;
begin
     v1.x:=1;
     v1.y:=0;
     for i:=2 to cnt do
     begin
          if not((a[i].p.x=t0.x)and(a[i].p.y=t0.y)) then
          begin
          v2.x:=a[i].p.x-a[i-1].p.x;
          v2.y:=a[i].p.y-a[i-1].p.y;
          if vp(v1,v2)<0 then
          begin
               graham:=false;
               exit;
          end;
          v1:=v2;
          end;
     end;
     graham:=true;
end;

Function prov:boolean;
var i,j,max,min:longint;
    bbo,res1,res2:boolean;
begin
     bbo:=false;
     res1:=true;
     res2:=true;
     min:=a[1].ind;
     for i:=2 to cnt do
     begin
          if (a[i].ind<a[i-1].ind)and(not bbo) then
          begin
               bbo:=true;
          end else
          if (a[i].ind<a[i-1].ind)and(bbo) then
          begin
               res1:=false;
               break;
          end;
          if bbo and(a[i].ind>min) then
          begin
               res1:=false;
               break;
          end;
          if (a[i].ind<min)and(not bbo) then min:=a[i].ind;
     end;
     bbo:=false;
     max:=a[1].ind;
     for i:=2 to cnt do
     begin
          if (a[i].ind>a[i-1].ind)and(not bbo) then
          begin
               bbo:=true;
          end else
          if (a[i].ind>a[i-1].ind)and(bbo) then
          begin
               res2:=false;
               break;
          end;
          if bbo and (a[i].ind<max) then
          begin
               res2:=false;
               break;
          end;
          if (a[i].ind>max)and(not bbo) then max:=a[i].ind;
     end;
     prov:=res1 or res2;
end;

Procedure solve;
var i,j,qq,k:longint;
    afirst:tpoint;
    bores,bobores:boolean;
begin
     for i:=1 to n do
     begin
          read(m);
          cnt:=0;
          t0.x:=maxlongint;
          t0.y:=maxlongint;
          bobores:=true;
          for j:=1 to m do
          begin
               inc(cnt);
               read(a[cnt].p.x,a[cnt].p.y);
               if cnt=1 then afirst:=a[cnt].p;
               a[cnt].ind:=j;
               if a[cnt].p.y<t0.y then
               begin
                    t0:=a[cnt].p;
                    qq:=cnt;
               end else
               if (a[cnt].p.y=t0.y) then
               begin
                    if a[cnt].p.x>t0.x then
                    begin
                         t0:=a[cnt].p;
                         qq:=cnt;
                    end;
               end;
               if cnt>=3 then
               if ononeline2(a[cnt-1].p,a[cnt-2].p,a[cnt].p) then
               begin
                    if ononeline(a[cnt-1].p,a[cnt-2].p,a[cnt].p) then
                    begin
                         a[cnt-1]:=a[cnt];
                         if qq=cnt then dec(qq);
                         dec(cnt);
                    end else
                    begin
                         writeln('NO');
                         for k:=j+1 to m do read(a[1].p.x,a[1].p.y);
                         bobores:=false;
                         break;
                    end;
               end;
          end;
          if bobores then
          begin
          if (cnt=3)or(not bobores)or(a[cnt].p.x<>a[1].p.x)or(a[cnt].p.y<>a[1].p.y) then writeln('NO') else
          begin
               dec(cnt);
               if ononeline(a[1].p,a[2].p,a[cnt].p) then
               begin
                    swap(a[1],a[cnt]);
                    dec(cnt);
               end;
               swap(a[qq],a[1]);
               qsort(2,cnt);
               bores:=true;
               for j:=3 to cnt do
               begin
                    if (ononeline2(a[j-1].p,a[j-2].p,a[j].p))and not((a[j-1].p.x=afirst.x)and(a[j-1].p.y=afirst.y)) then
                    begin
                         writeln('N0');
                         bores:=false;
                         break;
                    end;
               end;
               if (ononeline2(a[1].p,a[cnt].p,a[2].p))and(bores)and not((a[j-1].p.x=afirst.x)and(a[j-1].p.y=afirst.y)) then
               begin
                    writeln('NO');
                    bores:=false;
                    break;
               end;
               if (ononeline2(a[cnt].p,a[cnt-1].p,a[1].p))and(bores)and not((a[j-1].p.x=afirst.x)and(a[j-1].p.y=afirst.y)) then
               begin
                    writeln('NO');
                    bores:=false;
                    break;
               end;
               if bores then
               begin
               if Graham then
               begin
                    if prov then
                    writeln('YES') else writeln('NO');
               end else writeln('NO');
               end;
          end;
          end;
     end;
end;

begin
     init;
     solve;
     close(input);
     close(output);
end.
