program zzz;

const
  maxn = 30000;
type
  TPoint = record
    x,y: Longint;
  end;

var
  o1,h,w,ans,l,r,i,j,k,n,m: Longint;
  a,b: array[1..maxn] of TPoint;
  c: array[1..50] of Longint;
  tr: array[1..1 shl 21] of Longint;

procedure update(pos,dx: Longint);
var i: Longint;
begin
  i := pos + o1;
  inc(tr[i],dx);
  while i <> 1 do begin
    i := i div 2;
    inc(tr[i],dx);
  end;
end;

function query(st,fin: Longint): Longint;
var i,j,ans: Longint;
begin
  ans := 0;
  i := st + o1;
  j := fin + o1;
  while i <= j do begin
    if i mod 2 = 1 then inc(ans,tr[i]);
    if j mod 2 = 0 then inc(ans,tr[j]);
    i := (i+1) div 2;
    j := (j-1) div 2;
    if ans > 0 then break;
  end;
  query := ans;
end;

procedure swapi(var a,b: Longint);
var i: Longint;
begin
  i := a;
  a := b;
  b := i;
end;

procedure swap(var a,b: TPoint);
var i: TPoint;
begin
  i := a;
  a := b;
  b := i;
end;

procedure qsort1(st,fin: Longint);
var i,j,key: Longint;
begin
  key := a[st+random(fin-st)].x;
  i := st;
  j := fin;
  while i <= j do begin
     while a[i].x < key do inc(i);
     while a[j].x > key do dec(j);
     if i <= j then begin
       swap(a[i],a[j]);
       inc(i);
       dec(J);
     end;
  end;
  if j > st then qsort1(st,j);
  if i < fin then qsort1(i,fin);
end;

procedure qsort2(st,fin: Longint);
var i,j,key: Longint;
begin
  key := b[st+random(fin-st)].y;
  i := st;
  j := fin;
  while i <= j do begin
     while b[i].y < key do inc(i);
     while b[j].y > key do dec(j);
     if i <= j then begin
       swap(b[i],b[j]);
       inc(i);
       dec(J);
     end;
  end;
  if j > st then qsort2(st,j);
  if i < fin then qsort2(i,fin);
end;

function searchr(st: Longint): Longint;
var i,j: Longint;
begin
  i := o1 + st;
  while tr[i] = 0 do i := (i+1) div 2;
  while i < o1 do begin
    if tr[i*2] <> 0 then i := i * 2 else i := i * 2 + 1;
  end;
  searchr := i - o1;
end;

function searchl(st: Longint): Longint;
var i,j: Longint;
begin
  i := o1 + st;
  while tr[i] = 0 do i := (i-1) div 2;
  while i < o1 do begin
    if tr[i*2+1] <> 0 then i := i * 2 + 1 else i := i * 2;
  end;
  searchl := i - o1;
end;

function min(a,b: Longint): Longint;
begin
  if a < b then min := a else min := b;
end;

procedure inittree();
var i,j: Longint;
begin
  for i := 1 to n do begin
    update(a[i].y,-tr[o1 + a[i].y]);
  end;
  for i := 1 to n do begin
    update(a[i].x,-tr[o1 + a[i].x]);
  end;
end;

function move1(sp: Longint): Boolean;
var pp,tt,i,j,k,l,r,sc1,sc2: Longint;
begin
  inittree();
  move1 := true;
  sc1 := 1;
  sc2 := 1;
  for i := 1 to n do begin
    if w - a[i].x < sp then break;
    while sc1 <= n do begin
      if a[sc1].x - a[i].x >= sp then break else begin
        update(a[sc1].y,1);
        inc(sc1);
      end;
    end;
    while sc2 <= n do begin
      if a[sc2].x > a[i].x then break else begin
        update(a[sc2].y,-1);
        inc(sc2);
      end;
    end;
    if query(0,a[i].y-1) = 0 then pp := 0 else pp := searchl(a[i].y-1);
    if query(a[i].y+1,h) = 0 then tt := h else tt := searchr(a[i].y+1);
    if tr[o1 + a[i].y] <> 0 then begin
      if (abs(pp-a[i].y) >= sp) or (abs(tt-a[i].y) >= sp) then exit;
    end else begin
      if abs(tt-pp) >= sp then exit;
    end;
  end;
  move1 := false;
end;

function move2(sp: Longint): Boolean;
var sc1,sc2,tt,pp,i,j,k: Longint;
    res: Boolean;
begin
  move2 := true;
  inittree();
  sc1 := n;
  sc2 := n;
  for i := n downto 1 do begin
    if a[i].x < sp then break;
    while sc1 >= 1 do begin
      if a[i].x - a[sc1].x >= sp then break else begin
        update(a[sc1].y,1);
        dec(sc1);
      end;
    end;
    while sc2 >= 1 do begin
      if a[sc2].x < a[i].x then break else begin
        update(a[sc2].y,-1);
        dec(sc2);
      end;
    end;
    if query(0,a[i].y-1) = 0 then pp := 0 else pp := searchl(a[i].y-1);
    if query(a[i].y+1,h) = 0 then tt := h else tt := searchr(a[i].y+1);
    if tr[o1 + a[i].y] <> 0 then begin
      if (abs(pp-a[i].y) >= sp) or (abs(tt-a[i].y) >= sp) then exit;
    end else begin
      if abs(tt-pp) >= sp then exit;
    end;
  end;
  move2 := false;
end;

function move3(sp: Longint): Boolean;
var sc1,sc2,tt,pp,i,j,k: Longint;
    res: Boolean;
begin
  move3 := true;
  inittree();
  sc1 := n;
  sc2 := n;
  for i := n downto 1 do begin
    if b[i].y < sp then break;
    while sc1 >= 1 do begin
      if b[i].y - b[sc1].y >= sp then break else begin
        update(b[sc1].x,1);
        dec(sc1);
      end;
    end;
    while sc2 >= 1 do begin
      if b[sc2].y < b[i].y then break else begin
        update(b[sc2].x,-1);
        dec(sc2);
      end;
    end;
    if query(0,b[i].x-1) = 0 then pp := 0 else pp := searchl(b[i].x-1);
    if query(b[i].x+1,w) = 0 then tt := w else tt := searchr(b[i].x+1);
    if tr[o1 + b[i].x] <> 0 then begin
      if (abs(pp-b[i].x) >= sp) or (abs(tt-b[i].x) >= sp) then exit;
    end else begin
      if abs(tt-pp) >= sp then exit;
    end;
  end;
  move3 := false;
end;

function move4(sp: Longint): Boolean;
var pp,tt,i,j,k,l,r,sc1,sc2: Longint;
begin
  inittree();
  move4 := true;
  sc1 := 1;
  sc2 := 1;
  for i := 1 to n do begin
    if h - b[i].y < sp then break;
    while sc1 <= n do begin
      if b[sc1].y - b[i].y >= sp then break else begin
        update(b[sc1].x,1);
        inc(sc1);
      end;
    end;
    while sc2 <= n do begin
      if b[sc2].y > b[i].y then break else begin
        update(b[sc2].x,-1);
        inc(sc2);
      end;
    end;
    if query(0,b[i].x-1) = 0 then pp := 0 else pp := searchl(b[i].x-1);
    if query(b[i].x+1,w) = 0 then tt := w else tt := searchr(b[i].x+1);
    if tr[o1 + b[i].x] <> 0 then begin
      if (abs(pp-b[i].x) >= sp) or (abs(tt-b[i].x) >= sp) then exit;
    end else begin
      if abs(tt-pp) >= sp then exit;
    end;
  end;
  move4 := false;
end;

begin
  assign(output,'square.out'); rewrite(Output);
  assign(input,'square.in'); reset(input);
  read(n,w,h);
  for i := 1 to n do begin
    read(a[i].x,a[i].y);
    b[i] := a[i];
  end;
  qsort1(1,n);
  qsort2(1,n);
  r := min(w,h);
  o1 := 1;
  for i := 1 to n do begin
    if (o1 > w) and (o1 > h) then begin
      break;
    end;
    o1 := o1 * 2;
  end;
  if n = 0 then begin
    writeln(r);
    close(input);
    close(output);
    halt(0);
  end;
  l := 1;
  while (r - l > 1) do begin
    ans := (l + r) div 2;
    if move1(ans) or move2(ans) or move3(ans) or move4(ans) then l := ans else r := ans;
  end;
  writeln(l);
  close(input);
  close(output);
end.
