{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Type Tip=LongInt;
  Const Inp='convex.in';
        Out='convex.out';
        MaxN=1000000;
  Var K,N : Tip;
      X,Y,XNow,YNow : Array [1..MaxN] Of Tip;
      NeedHelp,Len : Tip;

Procedure OpenFiles;
Begin
  Assign(Input,Inp);
  ReSet(Input);
  Assign(Output,Out);
  ReWrite(Output);
End;

Function Vect(COnst X1,Y1,X2,Y2 : Extended) : Extended;
Begin
  Vect :=X1*Y2-X2*Y1;
End;

Procedure Swap(Var A,B : Tip);
  Var C : Tip;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Function Dist2(Const I,J : Tip) : Extended;
  Var X1,Y1 : Extended;
Begin
  X1 :=X[I]-X[J];
  Y1 :=Y[I]-Y[J];
  Dist2 :=Sqr(X1)+Sqr(Y1);
End;

Function Less(Var I,J : Tip) : Boolean;
Begin
  If (Vect(X[I]-X[1],Y[I]-Y[1],X[J]-X[1],Y[J]-Y[1])<0) Or
    ((Vect(X[I]-X[1],Y[I]-Y[1],X[J]-X[1],Y[J]-Y[1])=0) And
    (Dist2(1,I)>Dist2(1,J))) Then Less :=True
    Else Less :=False;
End;

procedure Sort(l, r: Integer);
var
  i, j, Help : Tip;
begin
  i := l; j := r; Help :=(l+r) DIV 2;
  repeat
    while Less(I,Help) do i := i + 1;
    while Less(Help,j) do j := j - 1;
    if i <= j then
    begin
      NeedHelp := X[i]; X[i] := X[j]; X[j] := NeedHelp;
      NeedHelp := Y[i]; Y[i] := Y[j]; Y[j] := NeedHelp;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;


Procedure InitAndSolve;
  Var I,J,Znak,HelpFind,J2 : Tip;
      Answer,NotAtLine : Boolean;
      YMin,XMin,NumMin : Tip;
Begin
  Read(K);
  For J :=1 To K Do
    Begin
      Read(N);
      Answer :=True;
      YMin :=MaxLongInt;
      For I :=1 To N Do
        Begin
          ReadLn(X[I],Y[I]);
          If (Y[I]<YMin) Or ((Y[I]=NumMin) And (X[I]<XMin)) Then
            Begin
              YMin :=Y[I];
              XMin :=X[I];
              NumMin :=I;
            End;
        End;
      If (X[1]<>X[N]) Or (Y[1]<>Y[N]) Then
        Answer :=False
      Else
        Begin
          Swap(X[NumMin],X[1]);
          Swap(Y[NumMin],Y[1]);
          Len :=1;
          XNow[1] :=X[1];
          YNow[1] :=Y[1];
          Sort(2,N-1);
          I :=2;
          While Vect(X[I+1]-X[1],Y[I+1]-Y[1],X[2]-X[1],Y[2]-Y[1])=0 Do
            Begin
              Inc(Len);
              XNow[Len] :=X[I];
              YNow[Len] :=Y[I];
              Inc(I);
            End;
          Inc(Len);
          XNow[Len] :=X[I];
          YNow[Len] :=Y[I];
          Inc(Len);
          XNow[Len] :=X[I+1];
          YNow[Len] :=Y[I+1];
          For I :=I+2 To N Do
            Begin
              While Vect(XNow[Len]-XNow[Len-1],YNow[Len]-YNow[Len-1],X[I]-XNow[Len],Y[I]-YNow[Len])>0 Do
                Begin
                  Answer :=False;
                  Dec(Len);
                  Break;
                End;
              If Not Answer Then Break;
              Inc(Len);
              XNow[Len] :=X[I];
              YNow[Len] :=Y[I];
            End;
        End;
      If Not Answer Then WriteLn('NO')
      Else WriteLn('YES');
    End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  InitAndSolve;
  CloseFiles;
End.
