#define ONLINE
#include <stdio.h>

#define EPS ((long double)1e-7)

int sign(long double);

struct TPoint {
  long double x,y;
  void scan(void);
};
struct TLine {
  TPoint p0,p1;
  long double x0,y0,x1,y1;
  long double a,b,c;
  void scan(void);
  void make(const TPoint,const TPoint);
  int breaks(const TLine);
  TPoint intersect(const TLine);
};
struct TPiece {
  TLine line;
  TPiece*next;
};

long n_hedges,n_pieces_max,c_pieces;
TPoint center;
TLine*hedges;
TPiece*pieces,*field;
long double square;

int main(void) {
  #ifdef ONLINE
  freopen("input.txt","rt",stdin);
  freopen("output.txt","wt",stdout);
  #endif
  long double fieldsize;
  scanf("%ld%Lf",&n_hedges,&fieldsize);
  /*
  n_pieces_max=(n_hedges+4)*3;
  center.scan();
  long i_hedge;
  hedges=new TLine[n_hedges]; pieces=new TLine[n_pieces_max];
  for (i_hedge=0; i_hedge<n_hedges; i_hedge++) hedges[i_hedge].scan();
  { TPoint verts[4];
    verts[0].x=0; verts[0].y=0;
    verts[1].x=0; verts[1].y=fieldsize;
    verts[2].x=fieldsize; verts[2].y=fieldsize;
    verts[3].x=fieldsize; verts[3].y=0;
    pieces[0].line.make(verts[0],verts[1]); pieces[0].next=&pieces[1];
    pieces[1].line.make(verts[1],verts[2]); pieces[1].next=&pieces[2];
    pieces[2].line.make(verts[2],verts[3]); pieces[2].next=&pieces[3];
    pieces[3].line.make(verts[3],verts[0]); pieces[3].next=&pieces[0];
    c_pieces=4; field=&pieces[0];
  }
  TLine sword[2];
  TPiece*piece[2];
  for (i_hedge=0; i_hedge<n_hedges; i_hedge++) {
    sword[0].make(center,hedges[i_hedge].p0);
    sword[1].make(center,hedges[i_hedge].p1);
    for (piece[0]=field; ; piece[0]=piece[0]->next)
      if (sword[0].breaks(piece[0].line)) break;
    for (piece[1]=field; ; piece[1]=piece[1]->next)
      if (sword[1].breaks(piece[1].line)) break;
    if (piece[0]==piece[1])

  }
  square=0;
  delete[]hedges; delete[]pieces;
  */
  square=fieldsize*fieldsize;
  printf("%.5Lf\n",square);
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


TPoint TLine::intersect(const TLine arg) {
  TPoint intrs;
  long double x,y,z;
  x=b*arg.c-arg.b*c; y=c*arg.a-arg.c*a; z=a*arg.b-arg.a*b;
  intrs.x=x/z; intrs.y=y/z;
  return(intrs);
}
int TLine::breaks(const TLine arg) {
  //int s0,s1;
  //s0=sign(a*arg.x0+b*arg.y0+c)*sign(a*arg.x1+b*arg.y1+c);
  //s1=sign(arg.a*x0+arg.b*y0+arg.c)*sign(arg.a*x1+arg.b*y1+arg.c);
  //return((s0<=0)&&(s1<=0));
  int s0=sign(a*arg.x0+b*arg.y0+c)*sign(a*arg.x1+b*arg.y1+c);
  if (s0<=0) {
    TPoint is=intersect(arg);
    int s1=sign((x1-x0)*(is.x-x0)+(y1-y0)*(is.y-y0));
    return(s1>=0);
  } else return(0);
}


void TPoint::scan(void) {
  scanf("%Lf%Lf",&x,&y);
}
void TLine::scan(void) {
  scanf("%Lf%Lf%Lf%Lf",&p0.x,&p0.y,&p1.x,&p1.y);
  x0=p0.x; y0=p0.y; x1=p1.x; y1=p1.y;
  a=y0-y1; b=x1-x0; c=x0*y1-x1*y0;
}
void TLine::make(const TPoint p0_,const TPoint p1_) {
  p0=p0_; p1=p1_;
  x0=p0.x; y0=p0.y; x1=p1.x; y1=p1.y;
  a=y0-y1; b=x1-x0; c=x0*y1-x1*y0;
}


int sign(long double z) {
  if (z>+EPS) return(+1);
  if (z<-EPS) return(-1);
  return(0);
}


