#define ONLINE
//#define DEBUG
#include <stdio.h>
#include <string.h>

#define NUM_SIZE 64

#define STR_SIZE 22

class TNum {
  private:
    long*data;
    int len;
    static const int size;
  public:
    TNum(void);
    ~TNum();
    void print(void);
    TNum* set(const long=0);
    TNum* set(const TNum*);
    TNum* mul(const long);
    TNum* add(const TNum*);
};
const int TNum::size=NUM_SIZE;

char str[STR_SIZE];
short str_len,seq_len,n_matches,over_len;
TNum count,*cont[2],**table[2],**table_cur,**table_prev;

int main(void) {
  #ifdef ONLINE
  freopen("input.txt","rt",stdin);
  freopen("output.txt","wt",stdout);
  #endif
  short str_pos,seq_pos,c_matches;
  scanf("%s%hd%hd",str,&seq_len,&n_matches); str_len=strlen(str);
  cont[0]=new TNum[str_len*(n_matches+1)]; cont[1]=new TNum[str_len*(n_matches+1)];
  table[0]=new TNum*[n_matches+1]; table[1]=new TNum*[n_matches+1];
  for (c_matches=0,str_pos=0; c_matches<=n_matches; c_matches++,str_pos+=str_len)
  { table[0][c_matches]=&cont[0][str_pos]; table[1][c_matches]=&cont[1][str_pos]; }
  table_cur=table[0]; table_prev=table[1];
  for (over_len=str_len-1; over_len>0; over_len--)
    if (!strncmp(&str[str_len-over_len],str,over_len)) break;
  TNum z;
  for (c_matches=0; c_matches<=n_matches; c_matches++)
   for (str_pos=0; str_pos<str_len; str_pos++)
    table_cur[c_matches][str_pos].set();
  table_cur[0][0].set(1);
  for (seq_pos=0; seq_pos<seq_len; seq_pos++) {
    { TNum**z=table_prev; table_prev=table_cur; table_cur=z; }
    for (c_matches=0; c_matches<=n_matches; c_matches++) {
      for (str_pos=1; str_pos<str_len; str_pos++)
        table_cur[c_matches][str_pos].set(&table_prev[c_matches][str_pos-1]);
      table_cur[c_matches][0].set(&table_prev[c_matches][0]);
        table_cur[c_matches][0].mul(25);
      for (str_pos=1; str_pos<str_len; str_pos++) {
        z.set(&table_prev[c_matches][str_pos]);
        if (*str!=str[str_pos]) {
          table_cur[c_matches][1].add(&z);
          z.mul(24);
        } else z.mul(25);
        table_cur[c_matches][0].add(&z);
      }
      if (c_matches>0)
        table_cur[c_matches][over_len].add(&table_prev[c_matches-1][str_len-1]);
      #ifdef DEBUG
      for (str_pos=0; str_pos<str_len; str_pos++) {
        if (str_pos) printf(" ");
        table_cur[c_matches][str_pos].print();
      } printf("\n");
      #endif
    }
    #ifdef DEBUG
    printf("\n");
    #endif
  }
  count.set();
  for (str_pos=0; str_pos<str_len; str_pos++)
    count.add(&table_cur[n_matches][str_pos]);
  count.print(); printf("\n");
  delete[]table[0]; delete[]table[1];
  delete[]cont[0]; delete[]cont[1];
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


TNum::TNum(void) {
  data=new long[size];
}
TNum::~TNum() {
  delete[]data;
}
void TNum::print(void) {
  if (len>0) {
    int pos;
    printf("%ld",data[len-1]);
    for (pos=len-2; pos>=0; pos--) printf("%04ld",data[pos]);
  } else printf("0");
}
TNum* TNum::set(const long arg) {
  memset(data,0,sizeof(long)*size);
  if (arg) {
    *data=arg;
    len=1;
  } else len=0;
  return(this);
}
TNum* TNum::set(const TNum*arg) {
  memcpy(data,arg->data,sizeof(long)*size);
  len=arg->len;
  return(this);
}
TNum* TNum::mul(const long arg) {
  int pos;
  long reg=0;
  for (pos=0; ((pos<len)||(reg))&&(pos<size); pos++) {
    data[pos]=data[pos]*arg+reg;
    reg=data[pos]/10000;
    data[pos]%=10000;
  }
  for (len=pos; len>0; len--) if (data[len-1]) break;
  return(this);
}
TNum* TNum::add(const TNum*arg) {
  int pos;
  long reg=0;
  for (pos=0; ((pos<len)||(pos<arg->len)||(reg))&&(pos<size); pos++) {
    data[pos]+=arg->data[pos]+reg;
    reg=data[pos]/10000;
    data[pos]%=10000;
  }
  for (len=pos; len>0; len--) if (data[len-1]) break;
  return(this);
}


