{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'output.txt';
  cinfile = 'input.txt';

  nmax = 100000;

  inf = 1e+10;
  eps = 1e-8;

type
  int = longint;
  real = extended;

  point = record
            x, y : real;
          end;

  line = record
           a, b, c : real;
         end;

  z = record
        b, e : real;
        l : line;
      end;

var
  n, k : int;
  ans : real;

  h : array [1..nmax] of z;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans:0:5);
end;

function polyar(var p : point) : real;
var
  u : real;
begin
  if abs(p.x) < eps then u:= pi/2+ord(p.y < eps)*pi else
  begin
    u:= arctan(p.y/p.x) + pi;
    if p.x > eps then
      if p.y > -eps then u:= u - pi else u:= u + pi;
  end;
  polyar:= u;
end;

procedure makeline(var l : line;var p1, p2 : point);
begin
  l.a:= p1.y-p2.y;
  l.b:= p2.x-p1.x;
  l.c:= -p1.x*l.a-p1.y*l.b;
end;

procedure sift(l, r : int);
var
  i, j : int;
  zb : z;
begin
  zb:= h[l];
  i:= l;
  j:= i shl 1;
  if (j < r) and (h[j].b > h[j+1].b + eps) then inc(j);
  while (j <= r) and (h[j].b < zb.b - eps) do
  begin
    h[i]:= h[j];
    i:= j;
    j:= i shl 1;
    if (j < r) and (h[j].b > h[j+1].b + eps) then inc(j);
  end;
  h[i]:= zb;
end;

procedure delmin;
var
  i : int;
begin
  h[1]:= h[k];
  dec(k);
  sift(1,k);
end;

procedure push(var zb : z);
var
  i : int;
begin
  inc(k);
  h[k]:= zb;
  i:= k;
  while (i > 1) and (h[i shr 1].b > zb.b + eps) do
  begin
    h[i]:= h[i shr 1];
    i:= i shr 1;
  end;
  h[i]:= zb;
end;

procedure cross(var p : point;var l1, l2 : line);
begin
  p.x:= (l2.c*l1.b-l1.c*l2.b)/(l1.a*l2.b-l2.a*l1.b);
  p.y:= (l2.c*l1.a-l1.c*l2.a)/(l2.a*l1.b-l2.b*l1.a);
end;

function square(var l : line;var  ub, ue : real) : real;
var
  l2 : line;
  p1, p2 : point;
begin
  l2.a:= -sin(ub);
  l2.b:= cos(ub);
  l2.c:= 0;
  cross(p1,l,l2);
  l2.a:= -sin(ue);
  l2.b:= cos(ue);
  l2.c:= 0;
  cross(p2,l,l2);
  square:= abs((p1.x*p2.y-p1.y*p2.x)/2);
end;

procedure solve;
var
  i, j : int;
  z1, z2, zc : z;
begin
  ans:= 0;
  while k > 0 do
  begin
    z1:= h[1];
    delmin;
    if k = 0 then
    begin
      ans:= ans + square(z1.l,z1.b,z1.e);
      break;
    end;
    z2:= h[1];
    delmin;
    if (z1.e - z1.b) < eps then
    begin
      push(z2);
      continue;
    end;
    if (z2.e - z2.b) < eps then
    begin
      push(z1);
      continue;
    end;
    if z1.e < z2.b + eps then
    begin
      ans:= ans + square(z1.l,z1.b,z1.e);
      push(z2);
      continue;
    end;
    ans:= ans + square(z1.l,z1.b,z2.b);
    if z1.e > z2.e + eps then
    begin
      zc.l:= z1.l;
      zc.b:= z2.e;
      zc.e:= z1.e;
      push(zc);
      zc.b:= z2.b;
      zc.e:= z2.e;
      if square(z1.l,zc.b,zc.e) < square(z2.l,zc.b,zc.e) -eps then
        zc.l:= z1.l else zc.l:= z2.l;
      push(zc);
      continue;
    end;
    if z1.e < z2.e + eps then
    begin
      zc.l:= z2.l;
      zc.b:= z1.e;
      zc.e:= z2.e;
      push(zc);
      zc.b:= z2.b;
      zc.e:= z1.e;
      if square(z1.l,zc.b,zc.e) < square(z2.l,zc.b,zc.e) -eps then
        zc.l:= z1.l else zc.l:= z2.l;
      push(zc);
      continue;
    end;
  end;
end;

procedure init;
var
  i : int;
begin
  fillchar(h,sizeof(h),0);
  for i:= 1 to nmax do h[i].b:= inf;
end;

procedure add(bp, ep : point);
var
  b, e, x : real;
  l : line;
  zb : z;
begin
  makeline(l,bp,ep);
  zb.l:= l;
  b:= polyar(bp);
  e:= polyar(ep);
  if abs(b-e) < eps then exit;
  if b > e + eps then
  begin
    x:= b;
    b:= e;
    e:= x;
  end;
  if abs(e - b) > pi + eps then
  begin
    zb.b:= e;
    zb.e:= 2*pi;
    if abs(e-2*pi) > eps then push(zb);
    zb.b:= 0;
    zb.e:= b;
    if abs(b) > eps then push(zb);
  end else
  begin
    zb.b:= b;
    zb.e:= e;
    push(zb);
  end;
end;

procedure readdata;
var
  i, j : int;
  m : int;
  bp, ep : point;
  s : point;
begin
  init;
  read(n,m);
  read(s.x,s.y);
  k:= 0;
  for i:= 1 to n do
  begin
    read(bp.x,bp.y);
    read(ep.x,ep.y);
    bp.x:= bp.x-s.x;
    ep.x:= ep.x-s.x;
    bp.y:= bp.y-s.y;
    ep.y:= ep.y-s.y;
    add(bp,ep);
  end;
  bp.x:= -s.x;
  bp.y:= -s.y;
  ep.x:= m-s.x;
  ep.y:= -s.y;
  add(bp,ep);
  ep.x:= -s.x;
  ep.y:= m-s.y;
  add(bp,ep);
  bp.x:= m-s.x;
  bp.y:= -s.y;
  ep.x:= m-s.x;
  ep.y:= m-s.y;
  add(bp,ep);
  bp.x:= -s.x;
  bp.y:= m-s.y;
  add(bp,ep);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.