{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'output.txt';
  cinfile = 'input.txt';

  lmax = 25;
  kmax = 25;

  base = 100000000;
  dig = 8;

type
  int = longint;
  real = extended;

  thuge = array [0..500] of int;
  tmas = array [0..lmax,0..kmax] of thuge;

var
  n, k, l : int;
  {n - length(find), k - number of repeats}
  ans : thuge;

  a, an : tmas;
  s : string;
  q : array [1..lmax] of int;

  p : array [0..lmax,'a'..'z'] of int;

procedure writehuge(var a : thuge);
var
  i, j : int;
  s : string;
begin
  write(a[a[0]]);
  for i:= a[0]-1 downto 1 do
  begin
    str(a[i],s);
    for j:= length(s) to dig-1 do write('0');
    write(s);
  end;
  writeln;
end;

procedure outdata;
var
  i, j : int;
begin
  writehuge(ans);
end;

procedure prefix;
var
  i, k : int;
begin
  fillchar(q,sizeof(q),0);
  i:= 0;
  for k:= 2 to l do
  begin
    while (i > 0) and (s[i+1] <> s[k]) do i:= q[i];
    if s[i+1] = s[k] then inc(i);
    q[k]:= i;
  end;
end;

procedure genmatr;
var
  f, t : int;
  c : char;
begin
  fillchar(p,sizeof(p),0);
  for f:= 0 to l do
    for c:= 'a' to 'z' do
    begin
      t:= f;
      while (t > 0) and (s[t+1] <> c) do t:= q[t];
      if s[t+1] = c then inc(t);
      p[f,c]:= t;
    end;
end;

procedure addhuge(var a, b : thuge);
var
  i, r : int;
begin
  r:= 0;
  if a[0] < b[0] then a[0]:= b[0];
  for i:= 1 to a[0] do
  begin
    a[i]:= a[i]+b[i]+r;
    r:= a[i] div base;
    dec(a[i],r*base);
  end;
  while r > 0 do
  begin
    inc(a[0]);
    a[a[0]]:= r mod base;
    r:= r div base;
  end;
end;

procedure null(var a : tmas);
var
  i, j : int;
begin
  fillchar(a,sizeof(a),0);
  for i:= 0 to lmax do
    for j:= 0 to kmax do a[i,j][0]:= 1;
end;

procedure solve;
var
  i, f : int;
  kp : int;
  c : char;
begin
  l:= length(s);
  s:= s + '#';
  prefix;
  genmatr;
  null(a);
  a[0,0,0]:= 1;
  a[0,0,1]:= 1;
  for i:= 1 to n do
  begin
    null(an);
    for f:= 0 to l-1 do
      for c:= 'a' to 'z' do
        for kp:= 0 to k do addhuge(an[p[f,c],kp],a[f,kp]);
    f:= l;
    for c:= 'a' to 'z' do
      for kp:= 0 to k do addhuge(an[p[f,c],kp+1],a[f,kp]);
    a:= an;
  end;
  fillchar(ans,sizeof(ans),0);
  ans[0]:= 1;
  for f:= 0 to l-1 do addhuge(ans,a[f,k]);
  addhuge(ans,a[l,k-1]);
end;

procedure readdata;
var
  i, j : int;
begin
  read(s);
  read(n,k);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.