{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const infile = 'input.txt'; outfile = 'output.txt'; max = 20005;
      _behind = 1; _infront_b = 2; _infront_i = 3; _notcross = 4;
      eps = 0.000001; inf = 1000000000;
type pt = record x,y: extended; end;
     line = record a,b,c: extended; end;
     seg = array [1..2] of pt;
var f: array [1..max] of seg;
    pts: array [1..max*2+4] of pt;
    num: array [1..max*2+4] of longint;
    a: array [1..max*2+4] of extended;
    poly: array [1..max*2+4] of pt;
    nn,n,m,ww,ans: longint;
    g: pt;
    sq: extended;

    tmpa: extended;
    tmps: seg;
    tmpp: pt;
    tmpn: longint;

function sq_tr(p1,p2,p3: pt): extended;
begin
     sq_tr:=p1.x*p2.y-p2.x*p1.y+p2.x*p3.y-p3.x*p2.y+p3.x*p1.y-p1.x*p3.y;
end;

function eq(p1,p2: pt): boolean;
begin
     eq:=(abs(p1.x-p2.x) < eps)and(abs(p1.y-p2.y) < eps);
end;

function dist(p1,p2: pt): extended;
begin
     dist:=sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y));
end;

function dist_sq(p1,p2: pt): extended;
begin
     dist_sq:=sqr(p1.x-p2.x)+sqr(p1.y-p2.y);
end;

procedure get_line(t1,t2: pt; var l: line);
begin
     l.a:=t2.y-t1.y;
     l.b:=t1.x-t2.x;
     l.c:=-(t1.x*l.a+t1.y*l.b);
end;

function cross(l1,l2: line; var e: pt): boolean;
var st: extended;
begin
     st:=l1.a*l2.b-l2.a*l1.b;
     if abs(st) < eps then cross:=false
        else begin
             cross:=true;
             e.x:=-(l1.c*l2.b-l2.c*l1.b)/st;
             e.y:=(l2.a*l1.c-l1.a*l2.c)/st;
        end;
end;

function pr(t,p1,p2: pt): boolean;
begin
     pr:=abs(dist(t,p1)+dist(t,p2)-dist(p1,p2)) < eps
end;

function angle(p: pt): extended;
var ang: extended;
begin
     if (abs(p.x) < eps) then ang:=pi/2+pi*ord(p.y < -eps)
        else begin
             ang:=arctan(p.y/p.x)+pi;
             if (p.x > eps) then
                if (p.y > -eps) then ang:=ang-pi
                   else ang:=ang+pi;
        end;
     angle:=ang;
end;

function cls(t: pt; s: seg; var p: pt): byte;
var l,sl: line;
begin
     get_line(g,t,l);
     get_line(s[1],s[2],sl);
     if cross(l,sl,p) and pr(p,s[1],s[2]) then begin
        if pr(p,t,g) then cls:=_behind
           else begin
                if pr(t,p,g) then begin
                   if eq(p,s[1]) or eq(p,s[2]) then cls:=_infront_b
                      else cls:=_infront_i;
                end
                   else cls:=_notcross;
           end;
     end
        else cls:=_notcross;
end;

procedure init;
var i,j: longint;
    tmpl: line;
begin
     assign(input,infile);
     reset(input);
     read(n,m);
     read(g.x,g.y); i:=0;
     for j:=1 to n do begin
         inc(i);
         read(f[j,1].x,f[j,1].y,f[j,2].x,f[j,2].y);
         get_line(f[j,1],f[j,2],tmpl);
         if abs(tmpl.a*g.x+tmpl.b*g.y+tmpl.c) > eps then begin
            pts[i]:=f[j,1]; pts[i+1]:=f[j,2];
            num[i]:=j; num[i+1]:=j;
            inc(i);
         end
            else dec(i);
     end;
     nn:=i;
     pts[nn+1].x:=0; pts[nn+1].y:=0; num[nn+1]:=0;
     pts[nn+2].x:=m; pts[nn+2].y:=0; num[nn+2]:=0;
     pts[nn+3].x:=m; pts[nn+3].y:=m; num[nn+3]:=0;
     pts[nn+4].x:=0; pts[nn+4].y:=m; num[nn+4]:=0;
     f[n+1,1]:=pts[nn+1]; f[n+1,2]:=pts[nn+2];
     f[n+2,1]:=pts[nn+2]; f[n+2,2]:=pts[nn+3];
     f[n+3,1]:=pts[nn+3]; f[n+3,2]:=pts[nn+4];
     f[n+4,1]:=pts[nn+4]; f[n+4,2]:=pts[nn+1];
     ww:=nn+4; ans:=0;
     for i:=1 to ww do begin
         tmpp.x:=pts[i].x-g.x;
         tmpp.y:=pts[i].y-g.y;
         a[i]:=angle(tmpp);
     end;
     close(input);
end;

procedure sort_p(l,r: longint);
var i,j: longint;
    w: extended;
begin
     i:=l; j:=r; w:=a[(l+r) div 2];
     repeat
           while (a[i]-w < -eps) do inc(i);
           while (a[j]-w > eps) do dec(j);
           if i <= j then begin
              tmpp:=pts[i]; pts[i]:=pts[j]; pts[j]:=tmpp;
              tmpa:=a[i]; a[i]:=a[j]; a[j]:=tmpa;
              tmpn:=num[i]; num[i]:=num[j]; num[j]:=tmpn;
              inc(i); dec(j);
           end;
     until i > j;
     if i < r then sort_p(i,r);
     if l < j then sort_p(l,j);
end;

procedure add(t: pt);
begin
     inc(ans); poly[ans]:=t;
end;

procedure square;
var s: extended;
    i: longint;
begin
     s:=0;
     for i:=1 to ans do
         s:=s+poly[i].x*poly[i mod ans+1].y-poly[i mod ans+1].x*poly[i].y;
     sq:=abs(s)/2;
end;

procedure solve;
var i,j,tpr: longint;
    r,min_r,mx_r,second: pt;
    min,mx: extended;
    res: byte;
    ok,ch: boolean;
begin
     sort_p(1,ww);
     for i:=1 to ww do begin
         min:=inf; ok:=true;
         for j:=1 to n+4 do if (num[i] <> j)and(not((j > n)and(num[i] = 0))) then begin
             res:=cls(pts[i],f[j],r);
             if res = _infront_i then begin
                if (dist_sq(g,r)-min < -eps) then begin
                   min:=dist_sq(g,r); min_r:=r;
                end;
             end;
             if res = _behind then begin
                ok:=false; break;
             end;
         end;
         ch:=false;
         if ok then begin
            add(pts[i]);
            if abs(min-inf) > eps then begin ch:=true; add(min_r); end;
            if ch then begin
               if eq(f[num[i],1],pts[i]) then second:=f[num[i],2]
                  else second:=f[num[i],1];
               if sq_tr(g,second,pts[i]) < -eps then begin
                  tmpp:=poly[ans-1]; poly[ans-1]:=poly[ans]; poly[ans]:=tmpp;
               end;
            end;
         end;
     end;
     square;
end;

procedure done;
begin
     assign(output,outfile);
     rewrite(output);
     write(sq:0:5);
     close(output);
end;

begin
     init;
     solve;
     done;
end.