{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const MaxN = 40000;
      E = 1e-11;

Type TPoint = Record
                X, Y: Extended;
                N: Longint;
              End;
     TLine = Record
               A, B: TPoint;
             End;
     TStreight = Record
                   A, B, C: Extended;
                 End;

Var I, J, K, N, M, X0, Y0, Left, Kol, Cur, Next: Longint;
    Temp, Mid, RU, RD, LD, LU, Zero, Border: TPoint;
    S: Extended;
    A: array[1..MaxN] of TPoint;
    X: array[1..MaxN] of TLine;
    Use: array[1..MaxN] of Boolean;

Procedure Swap(var A, B: TPoint);
Var C: TPoint;
Begin
  C := A;
  A := B;
  B := C;
End;

Function Quater(A: TPoint): Byte;
Begin
  If A.X > 0
  Then
    If A.Y > 0 Then Quater := 1
               Else Quater := 2
  Else
    If A.X < 0
    Then
      If A.Y < 0 Then Quater := 3
                 Else Quater := 4
    Else
      If A.Y >= 0 Then Quater := 1
                  Else Quater := 3;
End;

Function More(A, B: TPoint): Boolean;
Var Q1, Q2: Byte;
Begin
  Q1 := Quater(A);
  Q2 := Quater(B);
  If Q1 <> Q2 Then More := Q1 > Q2
              Else More := A.X * B.Y - B.X * A.Y > 0;
End;

Procedure Hoar(Left, Right: Integer);
Var I, J: Integer;
    X: TPoint;
Begin
  I := Left;
  J := Right;
  X := A[Random(J - I + 1) + I];
  While I < J do Begin
    While More(X, A[I]) do Inc(I);
    While More(A[J], X) do Dec(J);
    If I <= J Then Begin
      Swap(A[I], A[J]);
      Inc(I);
      Dec(J);
    End;
  End;
  If Left < J Then Hoar(Left, J);
  If I < Right Then Hoar(I, Right);
End;

Function Len(A: TPoint): Extended;
Begin
  Len := Sqr(A.X) + Sqr(A.Y);
End;

Procedure HoarLen(Left, Right: Integer);
Var I, J: Integer;
    X: TPoint;
Begin
  I := Left;
  J := Right;
  X := A[Random(J - I + 1) + I];
  While I < J do Begin
    While Len(A[I]) < Len(X) do Inc(I);
    While Len(A[J]) > Len(X) do Dec(J);
    If I <= J Then Begin
      Swap(A[I], A[J]);
      Inc(I);
      Dec(J);
    End;
  End;
  If Left < J Then HoarLen(Left, J);
  If I < Right Then HoarLen(I, Right);
End;

Procedure CountStreight(var X: TStreight; A, B: TPoint);
Begin
  X.A := B.Y - A.Y;
  X.B := A.X - B.X;
  X.C := A.X * (A.Y - B.Y) + A.Y * (B.X - A.X);
End;

Procedure Cross(var P: TPoint; Q, R: TPoint);
Var A, B: TStreight;
Begin
  CountStreight(A, P, Zero);
  CountStreight(B, Q, R);
  If (B.B * A.A - B.A * A.B = 0) or (A.A = 0)
  Then
    P := R
  Else Begin
    P.Y := (B.A * A.C - A.A * B.C) / (B.B * A.A - B.A * A.B);
    P.X := - (A.C + A.B * P.Y) / A.A;
  End;
End;

Procedure Init;
Begin
  Read(K, M, X0, Y0);
  LU.X := - X0;
  LD.X := - X0;
  LU.Y := M - Y0;
  LD.Y := - Y0;
  RU.X := M - X0;
  RD.X := M - X0;
  RU.Y := M - Y0;
  RD.Y := - Y0;
  For I := 1 to K do Begin
    Inc(N, 2);
    Read(A[N - 1].X, A[N - 1].Y, A[N].X, A[N].Y);
    A[N - 1].X := A[N - 1].X - X0;
    A[N - 1].Y := A[N - 1].Y - Y0;
    A[N].X := A[N].X - X0;
    A[N].Y := A[N].Y - Y0;
    A[N - 1].N := N shr 1;
    A[N].N := N shr 1;
    Mid.X := 0;
    Mid.Y := RU.Y;
    If ((A[N].X < 0) and (A[N - 1].X >= 0)) or
       ((A[N].X >= 0) and (A[N - 1].X < 0)) Then Begin
      Cross(Mid, A[N - 1], A[N]);
      If Mid.Y > 0 Then Begin
        Temp := A[N];
        A[N] := Mid;
        A[N].N := N shr 1;
        Inc(N);
        A[N] := A[N - 1];
        A[N - 1].X := - E;
        Inc(A[N].N);
        Inc(N);
        A[N] := Temp;
        Inc(A[N].N);
        If More(A[N - 3], A[N - 2]) Then Swap(A[N - 3], A[N - 2]);
        X[A[N].N - 1].A := A[N - 3];
        X[A[N].N - 1].B := A[N - 2];
      End;
    End;
    If More(A[N - 1], A[N]) Then Swap(A[N - 1], A[N]);
    X[A[N].N].A := A[N - 1];
    X[A[N].N].B := A[N];
  End;
  Hoar(1, N);
  J := 1;
  For I := 1 to N do Begin
    If More(A[I], A[J]) Then Begin
      HoarLen(J, I - 1);
      J := I;
    End;
  End;
  HoarLen(J, N);
End;

Function Square(A, B: TPoint): Extended;
Begin
  Square := Abs(A.X * B.Y - B.X * A.Y) / 2;
End;

Function BorderSquare(A, B: TPoint): Extended;
Begin
  If More(B, RU) and More(RU, A)
  Then
    BorderSquare := BorderSquare(A, RU) + BorderSquare(RU, B)
  Else
    If More(B, RD) and More(RD, A)
    Then
      BorderSquare := BorderSquare(A, RD) + BorderSquare(RD, B)
    Else
      If More(B, LD) and More(LD, A)
      Then
        BorderSquare := BorderSquare(A, LD) + BorderSquare(LD, B)
      Else
        If More(B, LU) and More(LU, A)
        Then
          BorderSquare := BorderSquare(A, LU) + BorderSquare(LU, B)
        Else
          BorderSquare := Square(A, B);
End;

Procedure MakeBorder(var A: TPoint);
Begin
  If More(RU, A) or More(A, LU)
  Then Begin
    A.X := A.X / A.Y * RU.Y;
    A.Y := RU.Y
  End
  Else
    If More(RD, A)
    Then Begin
      A.Y := A.Y / A.X * RD.X;
      A.X := RD.X
    End
    Else
      If More(LD, A)
      Then Begin
        A.X := A.X / A.Y * LD.Y;
        A.Y := LD.Y
      End
      Else Begin
        A.Y := A.Y / A.X * LU.X;
        A.X := LU.X
      End;
End;

Function AddSquare(A, B: TPoint): Extended;
Begin
  MakeBorder(A);
  MakeBorder(B);
  AddSquare := BorderSquare(A, B);
End;

Begin
  Assign(Input, 'input.txt');
  Assign(Output, 'output.txt');
  Reset(Input);
  Rewrite(Output);
  Init;
  Temp.X := 0;
  Temp.Y := 1;
  Cur := A[1].N;
  Border := X[Cur].A;
  For I := 1 to N do Begin
    If Kol = 0
    Then Begin
      S := S + AddSquare(Temp, A[I]);
      Cur := A[I].N;
      Border := X[Cur].A;
    End
    Else Begin
      Mid := A[I];
      Cross(Mid, Border, X[Cur].B);
      S := S + Square(Border, Mid);
      Border := Mid;
      If Len(Mid) > Len(A[I])
      Then Begin
        Cur := A[I].N;
        Cross(Border, X[Cur].A, X[Cur].B);
      End
      Else
        If (Border.X <> X[Cur].B.X) or (Border.Y <> X[Cur].B.Y) Then
          Next := A[I].N;
      If (Border.X = X[Cur].B.X) and (Border.Y = X[Cur].B.Y) Then Begin
        Cur := Next;
        Cross(Border, X[Cur].A, X[Cur].B);
      End;
    End;
    If Use[A[I].N]
    Then
      Dec(Kol)
    Else Begin
      Use[A[I].N] := True;
      Inc(Kol);
    End;
    Temp := A[I];
  End;
  Temp.X := - E;
  Temp.Y := RU.Y;
  S := S + AddSquare(A[N], Temp);
  Write(S:0:6);
  Close(Input);
  Close(Output);
End.