{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_a;
const
  inpfile='input.txt';
  outfile='output.txt';
  eps=1e-8;
  nm=20005;
type
  Coord = record
    x,y : Extended;
  end;
  Line = record
    p1,p2 : Coord;
  end;
  Point= record
    p : Coord;
    n,k : LongInt;
  end;
  PNode = ^Node;
  Node=record
    n : LongInt;
    next : PNode;
  end;
var
  a : array [1..nm] of Line;
  d : array [0..nm] of Extended;
  b : array [1..nm] of Point;
  c : array [1..10] of Coord;
  g : array [1..5] of Coord;
  n,bn,cn : LongInt;
  m,res : Extended;
  hunt,hunt2 : Coord;
  root : PNode;
{}
Procedure Swap(var q,w : Coord);
var
  bak : Coord;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Function Vc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Vc:=(p2.x-p1.x)*(p4.y-p3.y)-(p4.x-p3.x)*(p2.y-p1.y);
end;
{}
Function Sc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Sc:=(p2.x-p1.x)*(p4.x-p3.x)+(p4.y-p3.y)*(p2.y-p1.y);
end;
{}
Procedure Inp;
var
  i,j : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m);
  read(hunt.x,hunt.y);
  j:=0;
  for i:=1 to n do begin
    inc(j);
    read(a[j].p1.x,a[j].p1.y,a[j].p2.x,a[j].p2.y);
    if Vc(hunt,a[j].p1,hunt,a[j].p2)<-eps then Swap(a[j].p1,a[j].p2);
    if (abs(Vc(hunt,a[j].p1,hunt,a[j].p2))<eps) then dec(j);
  end;
  n:=j;
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res:0:10);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(d,sizeof(d),0);
end;
{}
Function Len(var q,w : Coord) : Extended;
begin
  Len:=sqrt(sqr(q.x-w.x)+sqr(q.y-w.y));
end;
{}
Function Angle(q : Coord) : Extended;
var
  v,s : Extended;
  w : Coord;
begin
  w.x:=hunt.x+1; w.y:=hunt.y;
  v:=Vc(hunt,w,hunt,q);
  s:=Sc(hunt,w,hunt,q);

  if abs(v)<eps then begin
    if s<-eps then Angle:=pi
              else Angle:=0;
  end else
  if v>eps then begin
    if abs(s)<eps then Angle:=pi/2
    else if s>eps then Angle:=arctan(v/s)
    else Angle:=arctan(v/s)+pi;
  end else begin
    if abs(s)<eps then Angle:=3*pi/2
    else if s>eps then Angle:=arctan(v/s)+2*pi
    else Angle:=arctan(v/s)+pi;
  end;
end;
{}
Procedure SwapP(var q,w : Point);
var
  bak : Point;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Sort(l, r: LongInt);
var
  i, j : LongInt;
  x : Extended;
begin
  i := l; j := r; x := Angle(b[(l+r) DIV 2].p);
  repeat
    while Angle(b[i].p) < x do inc(i);
    while x < Angle(b[j].p) do dec(j);
    if i <= j then
    begin
      SwapP(b[i],b[j]);
      inc(i); dec(j);
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;
{}
Procedure Move(var r,p : Coord; dx,dy : Extended);
begin
  r.x:=p.x+dx;
  r.y:=p.y+dy;
end;
{}
Function Cross(var p1,p2,p3,p4,r : Coord) : Boolean;
var
  d,dx,dy : Extended;
begin
  r.x:=0; r.y:=0;

  if (abs(Vc(p1,p2,p1,p3))<eps) and (abs(Vc(p1,p2,p1,p4))<eps) then begin
    Cross:=false; exit;
  end;

  if (Vc(p1,p2,p1,p3)*Vc(p1,p2,p1,p4)<eps) then begin
    Cross:=true;

    d:=-Vc(p3,p1,p3,p4)/Vc(p1,p2,p3,p4);
    dx:=(p2.x-p1.x)*d; dy:=(p2.y-p1.y)*d;
    Move(r,p1,dx,dy);

    if Sc(p1,p2,p1,r)<-eps then Cross:=false;
  end else Cross:=false;
end;
{}
Function Eq(q,w : Coord) : Boolean;
begin
  if (abs(q.x-w.x)>eps) or (abs(q.y-w.y)>eps) then Eq:=false
                                              else Eq:=true;
end;
{}
Function Square : Extended;
var
  f : array [1..10] of Coord;
  i,j,m,min,fn : LongInt;
  s : Extended;
begin
  Square:=0;

  min:=1;
  for i:=2 to cn do
    if (c[i].y+eps<c[min].y)
    or (abs(c[i].y-c[min].y)<eps)
    and (c[i].x+eps>c[min].y) then min:=i;

  f[1]:=c[min]; Swap(c[min],c[1]);

  min:=2; fn:=1;
  repeat
    for i:=min to cn do
      if (Vc(f[fn],c[min],f[fn],c[i])<-eps)
      or (abs(Vc(f[fn],c[min],f[fn],c[i]))<eps)
      and (Len(f[fn],c[min])<Len(f[fn],c[i])+eps) then min:=i;

    inc(fn); f[fn]:=c[min]; min:=1;
  until Eq(f[1],f[fn]);

  s:=0; dec(fn);
  for i:=1 to fn do
    s:=s+f[i].x*f[i+1].y-f[i+1].x*f[i].y;
  Square:=abs(s)/2;
end;
{}
Procedure Solve;
var
  i,j,pp,kol : LongInt;
  fir,sec,r : Coord;
  ptr,qtr : PNode;
begin
  if n=0 then begin
    res:=m*m; Out;
  end;
  bn:=0;
  for i:=1 to n do begin
    inc(bn); b[bn].p:=a[i].p1;
    b[bn].n:=i; b[bn].k:=1;
    inc(bn); b[bn].p:=a[i].p2;
    b[bn].n:=i; b[bn].k:=-1;
  end;

  for i:=1 to n do
    d[i]:=abs(Vc(hunt,a[i].p1,hunt,a[i].p2))/Len(a[i].p1,a[i].p2);

  Sort(1,bn);

  hunt2.x:=m; hunt2.y:=hunt.y;

  kol:=0;
  new(root); root^.next:=nil;
  root^.n:=0; d[0]:=1e20;

  for i:=1 to n do
    if Cross(hunt,hunt2,a[i].p1,a[i].p2,r) then begin
      if Eq(r,a[i].p1) then continue;
      inc(kol);
      if root^.next=nil then begin
        new(ptr); ptr^.next:=root;
        ptr^.n:=i; root:=ptr;
      end else begin
        new(ptr); ptr^.next:=root;
        while d[ptr^.next^.n]<d[i] do ptr:=ptr^.next;
        new(qtr); qtr^.next:=ptr^.next; qtr^.n:=i;
        ptr^.next:=qtr;
      end;
    end;


  res:=m*m;
  if root^.n<>0 then
    Cross(hunt,hunt2,a[root^.n].p1,a[root^.n].p2,fir);

  g[1].x:=0; g[1].y:=0;
  g[2].x:=0; g[2].y:=m;
  g[3].x:=m; g[3].y:=m;
  g[4].x:=m; g[4].y:=0;
  g[5].x:=0; g[5].y:=0;

  b[bn+1].p:=fir;
  for j:=1 to bn+1 do begin
    if kol>0 then begin
      fillchar(c,sizeof(c),0);
      cn:=2; c[1]:=fir;
      Cross(hunt,b[j].p,a[root^.n].p1,a[root^.n].p2,c[2]);
      for i:=1 to 4 do begin
        if Cross(hunt,c[1],g[i],g[i+1],c[cn+1]) then begin
          inc(cn); break;
        end;
      end;
      for i:=1 to 4 do begin
        if Cross(hunt,c[2],g[i],g[i+1],c[cn+1]) then begin
          inc(cn); break;
        end;
      end;
      pp:=cn;
      for i:=1 to 4 do
        if (Vc(hunt,g[i],hunt,c[cn])*Vc(hunt,g[i],hunt,c[cn-1])<-eps)
        and (Sc(hunt,g[i],hunt,c[cn])>-eps)
        and (Sc(hunt,g[i],hunt,c[cn-1])>-eps)then begin
          inc(pp); c[pp]:=g[i];
        end;
      cn:=pp;

      res:=res-Square;
    end;

    kol:=kol+b[j].k;
    if b[j].k=-1 then begin
      ptr:=root;
      if root^.n=b[j].n then root:=root^.next
      else begin
        while ptr^.next^.n<>b[j].n do ptr:=ptr^.next;
        ptr^.next:=ptr^.next^.next;
      end;

      if root^.n>0 then
        Cross(hunt,b[j].p,a[root^.n].p1,a[root^.n].p2,fir)
      else begin fir.x:=0; fir.y:=0; end;
    end else
    if b[j].k=1 then begin
      if d[root^.n]>d[b[j].n] then begin
        new(ptr); ptr^.next:=root;
        ptr^.n:=b[j].n; root:=ptr;
      end else begin
        new(ptr); ptr^.next:=root;
        while d[ptr^.next^.n]<d[b[j].n] do ptr:=ptr^.next;
        new(qtr); qtr^.next:=ptr^.next; qtr^.n:=b[j].n;
        ptr^.next:=qtr;
      end;

      Cross(hunt,b[j].p,a[root^.n].p1,a[root^.n].p2,fir);
    end;

  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.