{$I-,Q-,R-,S-,N+}
const
  maxn=20000+4;
{  maxn=500+4;
}
  maxp=2*(maxn);
  eps=1e-8;

var
  p,i,j,n,m:longint;
  x0,y0:longint;
  x,y:array[1..maxp] of longint;
  z:array[1..maxp] of longint;
  a:array[1..maxp] of extended;
  b:array[1..maxp] of boolean;
  o:array[1..maxp] of longint;
  i1,j1:array[1..maxn] of longint;
  l:array[1..maxn] of boolean;
  h:array[1..maxn] of longint;
  hsize:longint;
  lastang:extended;
  lasttop:longint;
  s:extended;

procedure swap(i,j:longint);
var
  tempe:extended;
  templ:longint;
begin
  tempe:=a[i];
  a[i]:=a[j];
  a[j]:=tempe;
  templ:=x[i];
  x[i]:=x[j];
  x[j]:=templ;
  templ:=y[i];
  y[i]:=y[j];
  y[j]:=templ;
  templ:=z[i];
  z[i]:=z[j];
  z[j]:=templ;
end;

function good(a:extended):extended;
begin
  if a>=2*pi then
    good:=a-2*pi
  else
    good:=a;

end;


procedure qsort(l,r:longint);
var
  i,j:longint;
  x:extended;
begin
  i:=l;
  j:=r;
  x:=a[(longint(l)+r) div 2];
  repeat
    while (a[i]<x) do
      inc(i);
    while (x<a[j]) do
      dec(j);
    if i<=j then begin
      swap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;

procedure makeline(x1,y1,x2,y2:longint;var a,b,c:longint);
begin
  a:=y2-y1;
  b:=x1-x2;
  c:=-a*x1-b*x2;
end;

procedure makelinereal(x1,y1,x2,y2:extended;var a,b,c:extended);
begin
  a:=y2-y1;
  b:=x1-x2;
  c:=-a*x1-b*x2;
end;

function perlinereal(a1,b1,c1,a2,b2,c2:extended; var x,y:extended):boolean;
var
  t:extended;
begin
  t:=a2*b1-a1*b2;
  if abs(t)<eps then begin
    perlinereal:=false;
    exit;
  end;
  x:=(b2*c1-b1*c2)/t;
  y:=(a1*c2-a2*c1)/t;
  perlinereal:=true;
end;

function func1(a1,b1,a2,b2:extended;var a,b:extended):boolean;
begin
  if a1>a2 then
    a:=a1
  else
    a:=a2;
  if b1<b2 then
    b:=b1
  else
    b:=b2;
  func1:=b-a-eps>0;
end;

function nearest(i,j:longint):longint;
var
  a_,b_,c_:extended;
  a1,b1,c1,a2,b2,c2:longint;
  x1,y1,x2,y2:extended;
begin
  if not l[i] then begin
    nearest:=j;
    exit;
  end;
  if not l[j] then begin
    nearest:=i;
    exit;
  end;
  if not func1(a[i1[i]],a[j1[i]],a[i1[j]],a[j1[j]],a_,b_) then begin
    nearest:=i;
    exit;
  end;
  c_:=(a_+b_)/2;
  x1:=cos(c_);
  y1:=sin(c_);
  makelinereal(0,0,x1,y1,a_,b_,c_);
  makeline(x[i1[i]],y[i1[i]],x[j1[i]],y[j1[i]],a1,b1,c1);
  makeline(x[i1[j]],y[i1[j]],x[j1[j]],y[j1[j]],a2,b2,c2);
  perlinereal(a1,b1,c1,a_,b_,c_,x1,y1);
  perlinereal(a2,b2,c2,a_,b_,c_,x2,y2);
  if abs(x1)+abs(y1)>abs(x2)+abs(y2) then begin
    nearest:=j;
  end else begin
    nearest:=i;
  end;
end;

function polang(x,y:longint):extended;
var
  a:extended;
begin
  if x=0 then begin
    polang:=pi/2+ord(y<0)*pi;
  end else begin
    a:=arctan(y/x);
    if x<0 then begin
      a:=a+pi;
    end else begin
      if y<0 then
        a:=a+2*pi;
    end;
    polang:=a;
  end;
end;

procedure hswap(i,j:longint);
var
  temp:longint;
begin
  temp:=h[i];
  h[i]:=h[j];
  h[j]:=temp;
end;

function parent(i:longint):longint;
begin
  parent:=i shr 1;
end;

function left(i:longint):longint;
begin
  left:=i shl 1;
end;

function right(i:longint):longint;
begin
  right:=(i shl 1)+1;
end;

procedure heapifyup(i:longint);
var
  j:longint;
begin
  if i=1 then
    exit;
  j:=parent(i);
  if nearest(h[i],h[j])=h[i] then begin
    hswap(i,j);
    heapifyup(j);
  end;
end;

procedure insert(x:longint);
begin
  inc(hsize);
  h[hsize]:=x;
  heapifyup(hsize);
end;

procedure heapifydown(i:longint);
var
  l,r,max,m1:longint;
begin
  l:=left(i);
  if l>hsize then
    exit;
  r:=right(i);
  if r>hsize then
    max:=l
  else begin
    m1:=nearest(h[l],h[r]);
    if m1=h[l] then
      max:=l
    else
      max:=r;
  end;
  if nearest(h[i],h[max])=h[max] then begin
    hswap(i,max);
    heapifydown(max);
  end;
end;

procedure gettop;
begin
  h[1]:=h[hsize];
  dec(hsize);
  if hsize>0 then
    heapifydown(1);
end;

function count3(x1,y1,x2,y2:extended):extended;
var
  s:extended;
begin
  s:=x1*y1;
  s:=s+(x2-x1)*(y1+y2);
  s:=s-x2*y2;
  count3:=abs(s/2);
end;

function counts(ang1,ang2:extended;i:longint):extended;
var
  a0,b0,c0:longint;
  x1,y1,x2,y2:extended;
  a1,b1,c1,a2,b2,c2:extended;
begin
  makeline(x[i1[i]],y[i1[i]],x[j1[i]],y[j1[i]],a0,b0,c0);
  x1:=cos(ang1);
  y1:=sin(ang1);
  makelinereal(0,0,x1,y1,a1,b1,c1);
  x2:=cos(ang2);
  y2:=sin(ang2);
  makelinereal(0,0,x2,y2,a2,b2,c2);
  if not (perlinereal(a0,b0,c0,a1,b1,c1,x1,y1) and perlinereal(a0,b0,c0,a2,b2,c2,x2,y2)) then begin
    counts:=0;
    exit;
  end;
  counts:=count3(x1,y1,x2,y2);
end;

procedure out(ans:extended);
begin
  write(ans:0:5);
  close(input);
  close(output);
  halt(0);
end;

begin
  assign(input,'input.txt');
  reset(input);
  assign(output,'output.txt');
  rewrite(output);
  read(n,m);
  read(x0,y0);

  p:=0;
  for i:=1 to n do begin
    inc(p);
    read(x[p],y[p]);
    z[p]:=i;
    inc(p);
    read(x[p],y[p]);
    z[p]:=i;
  end;

  inc(n);
  inc(p);  x[p]:= -1;  y[p]:=0;  z[p]:=n;
  inc(p);  x[p]:=m+1;  y[p]:=0;  z[p]:=n;

  inc(n);
  inc(p);  x[p]:=m;    y[p]:=0;  z[p]:=n;
  inc(p);  x[p]:=m;    y[p]:=m;  z[p]:=n;

  inc(n);
  inc(p);  x[p]:=m+1;  y[p]:=m;  z[p]:=n;
  inc(p);  x[p]:= -1;  y[p]:=m;  z[p]:=n;

  inc(n);
  inc(p);  x[p]:=0;    y[p]:=m;  z[p]:=n;
  inc(p);  x[p]:=0;    y[p]:=0;  z[p]:=n;

  for i:=1 to p do begin
    x[i]:=x[i]-x0;
    y[i]:=y[i]-y0;
    a[i]:=polang(x[i],y[i]);
  end;

  qsort(1,p);
  fillchar(o,sizeof(o),0);
  fillchar(l,sizeof(l),true);
  for i:=1 to p do begin
    if o[z[i]]=0 then begin
      o[z[i]]:=i;
    end else begin
      j:=o[z[i]];
      if abs(a[i]-a[j])<eps then begin
        l[z[i]]:=false;
      end;
      if a[i]-a[j]>a[j]+2*pi-a[i] then begin
        b[i]:=true;
        b[j]:=false;
        i1[z[i]]:=i;
        j1[z[i]]:=j;
      end else begin
        b[i]:=false;
        b[j]:=true;
        i1[z[i]]:=j;
        j1[z[i]]:=i;
      end;
    end;
  end;

  for i:=1 to n do begin
    if a[j1[i]]<a[i1[i]] then
      a[j1[i]]:=a[j1[i]]+2*pi;
  end;
  fillchar(o,sizeof(o),0);

  s:=0;
  fillchar(h,sizeof(h),0);
  hsize:=0;
  lastang:=0;
  lasttop:=0;
  for i:=1 to p do begin
    if b[i] then begin
      insert(z[i]);
    end;
    while (hsize>0) and (good(a[j1[h[1]]])<good(a[i])+eps) do
      gettop;
    if (lasttop<>h[1]) and (hsize>0) then begin
      if (a[i]+eps>pi) and (a[i]-eps<2*pi) and (l[lasttop]) then begin
        s:=s+counts(good(lastang),good(a[i]),lasttop);
        l[lasttop]:=false;
      end;
      lasttop:=h[1];
      lastang:=a[i];
    end;
  end;

  for i:=1 to p do begin
    if b[i] then begin
      insert(z[i]);
    end;
    while (hsize>0) and (good(a[j1[h[1]]])<good(a[i])+eps) do
      gettop;
    if (lasttop<>h[1]) and (hsize>0) and (l[lasttop]) then begin
      s:=s+counts(good(lastang),good(a[i]),lasttop);
      lasttop:=h[1];
      lastang:=a[i];
    end;
{    if (a[i]+eps>pi) and (a[i]-eps<2*pi) then
      out(s);
}
  end;
  out(s);

end.
