{I-,Q-,R-,S-}

const
     FileIn='input.txt';
     FileOut='output.txt';
     MaxSLen=20;
     MaxM=100;
     MaxN=20;
     AlphabetPower=26;
     Alphabet: array [0..AlphabetPower-1] of Char=('q','w','e','r','t','y','u','i','o','p','a','s','d','f','g','h','j','k','l','z','x','c','v','b','n','m');
var
   S: string;
   M, N: LongInt;
// A: array [WLength, OccurencesCount, MaxSuffixLength] of CountOfSuchStrings;
   A: array [0..MaxM, 0..MaxN, 0..MaxSLen] of string;
// JumpTable: array [CurrentMaxSuffixLength, NewCharacterIndex] of NewMaxSuffixLength;
   JumpTable: array [0..MaxN, Low (Alphabet)..High (Alphabet)] of LongInt;
   Answer: string;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, S);
     Readln (F, M, N);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

function LongSumCh (aCh1, aCh2: Char): Char;
begin
     LongSumCh:=Chr (Ord (aCh1)+Ord (aCh2)-Ord ('0'));
end;

function KillFirstZeroes (const aA: string): string;
var
   NChar: LongInt;
   B: string;
begin
     for NChar:=1 to Length (aA)
         do if aA [NChar]<>'0'
               then Break;
     B:='';
     for NChar:=NChar to Length (aA)
         do B:=B+aA [NChar];
     KillFirstZeroes:=B;
end;

function LongSum (const aA, aB: string): string;
var
   B, C: string;
   NChar: LongInt;
begin
     C:=aA;
     B:=aB;
     while Length (C)<Length (B)
           do C:='0'+C;
     while Length (B)<Length (C)
           do B:='0'+B;
     if (C [1]<>'0') or (B [1]<>'0')
        then begin
             C:='0'+C;
             B:='0'+B;
        end;
     for NChar:=Length (B) downto 1
         do begin
            C [NChar]:=LongSumCh (C [NChar], B [NChar]);
            while C [NChar]>'9'
                  do begin
                     Dec (C [NChar], 10);
                     Inc (C [NChar-1], 1);
                  end;
         end;
     LongSum:=C;
end;

function Max (aA, aB: LongInt): LongInt;
begin
     if aA>aB
        then Max:=aA
        else Max:=aB;
end;

procedure BuildJumpTable;
var
   WTail: string;

function Search: LongInt;
var
   StartIndex, NChar: LongInt;
   Found: Boolean;
begin
     for StartIndex:=Max (1, Length (WTail)-Length (S)+1) to Length (WTail)
         do begin
            Found:=true;
            for NChar:=1 to Length (S)
                do begin
                   if StartIndex+NChar-1>Length (WTail)
                      then Break;
                   if S [NChar]<>WTail [StartIndex+NChar-1]
                      then begin
                           Found:=false;
                           Break;
                      end;
                end;
            if Found
               then begin
                    Search:=Length (WTail)-StartIndex+1;
                    Exit;
               end;
         end;
     Search:=0;
end;

var
   CurrentSuffixLength: LongInt;
   CharIndex: LongInt;
begin
     for CurrentSuffixLength:=0 to Length (S)
         do begin
            WTail:=Copy (S, 1, CurrentSuffixLength)+' ';
            for CharIndex:=Low (Alphabet) to High (Alphabet)
                do begin
                   WTail [Length (WTail)]:=Alphabet [CharIndex];
                   JumpTable [CurrentSuffixLength, CharIndex]:=Search;
                end;
         end;
end;

procedure Dynamic;
var
   WLength, OccurencesCount, MaxSuffixLength: LongInt;
   CharIndex: LongInt;
   NewOccurencesCount, NewSuffixLength: LongInt;
begin
     FillChar (A, SizeOf (A), 0);
     A [0, 0, 0]:='1';

     for WLength:=0 to M-1
         do for OccurencesCount:=0 to N
                do begin
                   for MaxSuffixLength:=0 to Length (S)
                       do if Length (A [WLength, OccurencesCount, MaxSuffixLength])>0
                             then for CharIndex:=Low (Alphabet) to High (Alphabet)
                                      do begin
                                         NewSuffixLength:=JumpTable [MaxSuffixLength, CharIndex];
                                         if NewSuffixLength=Length (S)
                                            then NewOccurencesCount:=OccurencesCount+1
                                            else NewOccurencesCount:=OccurencesCount;
                                         if NewOccurencesCount<=N
                                            then A [WLength+1, NewOccurencesCount, NewSuffixLength]:=LongSum (A [WLength+1, NewOccurencesCount, NewSuffixLength], A [WLength, OccurencesCount, MaxSuffixLength]);
                                      end;
                end;
end;

procedure FindAnswer;
var
   MaxSuffixLength: LongInt;
begin
     Answer:='0';
     for MaxSuffixLength:=0 to Length (S)
         do Answer:=LongSum (Answer, A [M, N, MaxSuffixLength]);
     Answer:=KillFirstZeroes (Answer);
end;

procedure Solve;
begin
     BuildJumpTable;
     Dynamic;
     FindAnswer;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
