program zzz;

const
  maxn = 20006;
  eps = 1E-6;

type
  TReal = Extended;
  TPoint = record
    x,y: TReal;
  end;
  rec = record
    num,ev: Longint;
    ang: TReal;
  end;

var
  bufpt,home,curpt: TPoint;
  ttt,ans: TReal;
  stp,sc,fst,i,j,k,n,m: Longint;
  a: array[1..2,0..maxn] of TPoint;
  rr: array[0..4*maxn] of rec;
  h: array[0..4*maxn] of Longint;
  buf: Rec;

function orsq(a,b,c: TPoint): TReal;
begin
  orsq := (a.x - b.x) * (c.y - b.y) - (a.y - b.y) * (c.x - b.x);
end;

function inside(a,b,c,pp: TPoint): Boolean;
var i,j,k: TReal;
begin
  i := abs(orsq(a,b,pp));
  j := abs(orsq(a,c,pp));
  k := abs(orsq(b,c,pp));
  inside := abs(orsq(a,b,c) - i - j - k) = 0;
end;

procedure swapr(var a,b: Rec);
var i: rec;
begin
  i := a;
  a := b;
  b := i;
end;

procedure intr(a,b,c,d: TPoint; var p: TPoint);
var dd,a1,a2,b1,b2,c1,c2: TReal;
begin
  a1 := b.y - a.y;
  a2 := d.y - c.y;
  b1 := a.x - b.x;
  b2 := c.x - d.x;
  c1 := a.y * (b.x - a.x) - a.x * (b.y - a.y);
  c2 := c.y * (d.x - c.x) - c.x * (d.y - c.y);
  dd := a1 * b2 - b1 * a2;
  p.x := -(c1 * b2 - c2 * b1) / dd;
  p.y := -(a1 * c2 - a2 * c1) / dd;
end;

function more2(i,j: Longint): Boolean;
begin
  if i = 0 then begin
    more2 := true;
    exit;
  end;
  if j = 0 then begin
    more2 := false;
    exit;
  end;
  more2 := inside(home,a[1,j],a[2,j],a[1,i]);
end;

procedure add(pos,v: Longint);
var i: Longint;
begin
  i := pos + n - 1;
  h[i] := v;
  while i <> 1 do begin
    i := i div 2;
    if not more2(h[i*2],h[i*2+1]) then h[i] := h[i*2] else h[i] := h[i*2+1];
  end;
end;

function more(a,b: Rec): Boolean;
begin
  more := a.ang > b.ang;
end;

procedure qsort(st,fin: Longint);
var i,j: Longint;
    key: rec;
begin
  key := rr[st + random(fin - st)];
  i := st;
  j := fin;
  while i <= j do begin
    while more(key,rr[i]) do inc(i);
    while more(rr[j],key) do dec(j);
    if i <= j then begin
      swapr(rr[i],rr[j]);
      inc(i);
      dec(j);
    end;
  end;
  if j > st then qsort(1,j);
  if i < fin then qsort(i,fin);
end;

procedure swap(var a,b: TReal);
var i: TReal;
begin
  i := a;
  a := b;
  b := i;
end;

function dis(a,b: TPoint): TReal;
begin
  dis := sqr(a.x - b.x) + sqr(a.y - b.y);
end;

function getangle(a,b: TPoint): TReal;
var ans: TReal;
begin
  ans := 0;
  if a.y = b.y then begin
    if b.x > a.x then ans := 0 else ans := pi;
  end else begin
    if a.x = b.x then begin
      ans := pi/2;
    end else begin
      ans := arctan((a.y - b.y) / (a.x - b.x));
      if ans < 0 then ans := ans + pi;
    end;
    if a.y > b.y then ans := ans + pi;
  end;
  getangle := ans;
end;

begin
  assign(input,'input.txt'); reset(input);
  read(n,m);
  read(home.x,home.y);
  for i := 1 to n do begin
    read(a[1,i].x,a[1,i].y,a[2,i].x,a[2,i].y);
  end;
  inc(n);
  a[1,n].x := 0;
  a[1,n].y := 0;
  a[2,n].x := m;
  a[2,n].y := 0;
  a[1,n+2].x := m;
  a[1,n+2].y := m;
  a[2,n+2].x := 0;
  a[2,n+2].y := m;
  a[1,n+1] := a[2,n];
  a[2,n+1] := a[1,n+2];
  a[1,n+3] := a[2,n+2];
  a[2,n+3] := a[1,n];
  inc(n,3);
  sc := 0;
  for i := 1 to n do begin
    for j := 1 to 2 do begin
      inc(sc);
      rr[sc].ang := getangle(home,a[j,i]);
      rr[sc].ev := j;
      rr[sc].num := i;
    end;
    if rr[sc].ang > rr[sc-1].ang then begin
      swap(rr[sc].ang,rr[sc-1].ang);
    end;
    if abs(rr[sc].ang - rr[sc-1].ang) > pi then begin
      swap(rr[sc].ang,rr[sc-1].ang);
      rr[sc].ang := rr[sc].ang - 2*pi;
    end;
  end;
  qsort(1,sc);
  ans := 0;
  fst := rr[1].num;
  ttt := rr[1].ang;
  for i := 1 to sc do begin
    rr[i+sc] := rr[i];
    rr[i].ang := rr[i].ang - 2 * pi;
  end;
  qsort(1,2*sc);
  sc := 2 * sc;
  for j := 1 to sc do begin
    case rr[j].ev of
      2: begin
        add(rr[j].num,rr[j].num);
      end;
      1: Begin
        add(rr[j].num,0);
      end;
    end;
    if (rr[j].num = fst) and (abs(ttt - rr[j].ang) < eps) then break;
  end;
  if h[1] = fst then curpt := a[1,fst] else begin
    intr(home,a[1,fst],a[1,h[1]],a[2,h[1]],curpt);
  end;
  buf := rr[j];
  for i := j+1 to sc do begin
    if (rr[i].ang - ttt - 2 * pi > eps) then rr[i] := buf;
    case rr[i].ev of
      2: begin
        if h[1] = 0 then begin
          curpt := a[1,rr[i].num];
          add(rr[i].num,rr[i].num);
        end else begin
          m := h[1];
          add(rr[i].num,rr[i].num);
          if m <> h[1] then begin
            intr(home,a[1,rr[i].num],a[1,m],a[2,m],bufpt);
            ans := ans + abs(orsq(curpt,bufpt,home))/2;
            curpt := a[1,rr[i].num];
          end else begin
            intr(home,a[1,rr[i].num],a[1,m],a[2,m],bufpt);
            ans := ans + abs(orsq(curpt,bufpt,home))/2;
            curpt := bufpt;
          end;
        end;
      end;
      1: begin
        if h[1] = rr[i].num then ans := ans + abs(orsq(curpt,home,a[2,rr[i].num]))/2 else begin
          intr(home,a[2,rr[i].num],a[1,h[1]],a[2,h[1]],bufpt);
          ans := ans + abs(orsq(home,curpt,bufpt))/2;
          curpt := bufpt;
        end;
        add(rr[i].num,0);
        if h[1] <> 0 then begin
          intr(home,a[2,rr[i].num],a[1,h[1]],a[2,h[1]],curpt);
        end;
      end;
    end;
    if (rr[i].num = buf.num) and (abs(rr[i].ang - buf.ang) < eps)
    and (i > j) then break;
  end;
  assign(output,'output.txt'); rewrite(Output);
  writeln(ans:0:10);
  close(input);
  close(output);
end.
