#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define NN 100000
#define MM 500000
//#define RR 262144
const int RR = 262144;

#define MANY 100000000

struct REB1 {
  int a;
  REB1 *n,*p;
  REB1 *inv;
};

struct REB2 {
  int a;
  REB2 *n;
};

struct POINT {
  int x,y;
};

int _stklen=16000000;

FILE *fi, *fo;
REB1 swap1[2*MM+10];
REB2 swap2[2*MM+10];
REB1 *g1[NN];
REB2 *g2[NN];
POINT all_reb[MM];
int g2g[NN];
int used[NN];
int r[NN];
int iswap1=0,iswap2=0;
int n,m,k,f,old_n;
POINT q[2*RR-1];
int qi;
int q_ind[NN];
int num2v[NN];
int v2num[NN];
int cur_num=0;
int tm[NN];
int c_time=0;

int min(int a, int b)
{
  return (a<b)?a:b;
}

int getcc()
{
  int c;
  c=getc(fi);
  while((c==' ')||(c=='\r')||(c=='\t')||(c=='\n'))
    c=getc(fi);
  return c;
}

int getint()
{
  int c;
  int res;
  c=getcc();
  res=0;
  while(isdigit(c))
  {
    res=res*10+c-'0';
    c=getc(fi);
  }
  return res;
}

REB1 *getnew1()
{
  return &swap1[iswap1++];
}

REB2 *getnew2()
{
  return &swap2[iswap2++];
}

int get_parent(int x)
{
  return (x-1)/2;
}

int rmq_get(int a, int b)
{
  int res;
  int f;
  if(a==b)
    return a;
  if(a>b)
    return 2*RR-1;
  res=a;
  f=rmq_get(get_parent(a+1),get_parent(b-1));
  if(q[res].x>q[f].x)
    res=f;
  if(q[res].x>q[b].x)
    res=b;
  return res;
}

void rmq_build()
{
  int i;
  for(i=RR-2;i>=0;i--)
    q[i]=(q[2*i+1].x<q[2*i+2].x)?q[2*i+1]:q[2*i+2];
}

int lca(int a, int b)
{
  int f;
  f=min(rmq_get(q_ind[v2num[a]],q_ind[v2num[b]]),
        rmq_get(q_ind[v2num[b]],q_ind[v2num[a]]));
  return q[f].y;
}

void Add1(int x, int y)
{
  REB1 *t;
  t=getnew1();
  t->a=y;
  t->n=g1[x];
  g1[x]->p=t;
  g1[x]=t;
  t->p=NULL;
}

void Dell(int x, REB1 *t)
{
  if(t->p!=NULL)
    t->p->n=t->n;
  else
    g1[x]=t->n;
  if(t->n!=NULL)
    t->n->p=t->p;
}

void dfs1_1(int v)
{
  REB1 *t;
  REB1 *p;
  used[v]=1;
  tm[c_time++]=v;
  for(t=g1[v];t!=NULL;t=p)
  {
    p=t->n;
    if(!used[t->a])
    {
      dfs1_1(t->a);
      Dell(v,t);
    }
  }
}

void dfs1_2(int v, int f)
{
  REB1 *t;
  used[v]=f+1;
  t=g1[v];
  for(t=g1[v];t!=NULL;t=t->n)
    if(!used[t->a])
      dfs1_2(t->a,f);
}

void Add2(int x, int y)
{
  REB2 *t;
  t=getnew2();
  t->a=y;
  t->n=g2[x];
  g2[x]=t;
}

void buildg2()
{
  int i,j;
  int w;
  for(i=0;i<n;i++)
    used[i]=0;
  dfs1_1(0);
  for(i=0;i<n;i++)
    used[i]=0;
  w=0;
  for(i=0;i<n;i++)
    if(!used[tm[i]])
      dfs1_2(tm[i],w++);
  for(i=0;i<n;i++)
    g2g[i]=used[i]-1;
  for(i=0;i<w;i++)
    g2[i]=NULL;
  for(i=0;i<m;i++)
  {
    if(g2g[all_reb[i].x]!=g2g[all_reb[i].y])
    {
      Add2(g2g[all_reb[i].x],g2g[all_reb[i].y]);
      Add2(g2g[all_reb[i].y],g2g[all_reb[i].x]);
    }
  }
  old_n=n;
  n=w;
}

void buildg1()
{
  int i,j;
  int x,y;
  for(i=0;i<n;i++)
    g1[i]=NULL;
  for(i=0;i<m;i++)
  {
    x=getint();
    y=getint();
    x--;
    y--;
    all_reb[i].x=x;
    all_reb[i].y=y;
    Add1(x,y);
    Add1(y,x);
  }
}

void dfs2_1(int v, int rr)
{
  REB2* t;
  used[v]=1;
  r[v]=rr;
//  q[qi++]=v;
  num2v[cur_num]=v;
  v2num[v]=cur_num++;
  for(t=g2[v];t!=NULL;t=t->n)
  {
    if(!used[t->a])
    {
      dfs2_1(t->a,rr+1);
//      q[qi++]=v;
    }
  }
}

void dfs2_2(int v)
{
  REB2* t;
  used[v]=1;
  q[qi].y=v;
  q_ind[v2num[v]]=qi;
  q[qi++].x=v2num[v];
  for(t=g2[v];t!=NULL;t=t->n)
  {
    if(!used[t->a])
    {
      dfs2_2(t->a);
      q[qi].y=v;
      q[qi++].x=v2num[v];
    }
  }
}

void num_g2()
{
  int i,j;
  qi=RR-1;
  for(i=0;i<n;i++)
    used[i]=0;
  for(i=0;i<2*RR-1;i++)
    q[i].x=MANY;
  dfs2_1(g2g[f],0);
  for(i=0;i<n;i++)
    used[i]=0;
  dfs2_2(g2g[f]);
  rmq_build();
}

int main()
{
  int i,j;
  int x,y;
  fi=fopen("magic.in","rt");
  fo=fopen("magic.out","wt");

  fscanf(fi,"%d%d%d",&n,&m,&f);
  f--;
  buildg1();
  buildg2();
  num_g2();
  fscanf(fi,"%d",&k);
  for(i=0;i<k;i++)
  {
    x=getint();
    y=getint();
    x=g2g[x-1];
    y=g2g[y-1];
    j=lca(x,y);
    fprintf(fo,"%d\n",r[j]);
  }

  fclose(fi);
  fclose(fo);
  return 0;
}
