#define ONLINE
#include <stdio.h>
#include <string.h>

#define INF ((short)0x7F00)

short n_x,n_y,n_cells,n_points;
short*points,*weights,weight_total; short*matrix;

short*matches; char*mark; char*sums[2];
short tryshift(const short shift) {
  short i,point;
  memset(matches,-1,sizeof(short)*n_points);
  for (i=0; i<n_points; i++) {
    point=matrix[((points[i]/n_y+shift/n_y)%n_x)*n_y+(points[i]+shift)%n_y];
    if (point<0) return(INF);
    matches[i]=point;
  }
  short weights_group[2],weight;
  memset(sums[0],0,sizeof(char)*(weight_total+1));
  *sums[0]=1;
  memset(mark,0,sizeof(char)*n_points);
  for (i=0; i<n_points; i++) if (!mark[i]) {
    weights_group[0]=weights_group[1]=0;
    for (point=i; !mark[point]; ) {
      weights_group[0]+=weights[point]; mark[point]=1;
      point=matches[point];
      if (mark[point]) return(INF);
      weights_group[1]+=weights[point]; mark[point]=1;
      point=matches[point];
    }
    memcpy(sums[1],sums[0],sizeof(char)*(weight_total+1));
    for (weight=0; weight<=weight_total; weight++) if (sums[1][weight]) {
      sums[0][weight+weights_group[0]]=1;
      sums[0][weight+weights_group[1]]=1;
    }
  }
  short diff_best=INF,diff_cur;
  for (weight=0; weight<=weight_total; weight++) if (sums[0][weight]) {
    diff_cur=weight_total-weight-weight;
    if (diff_cur<0) diff_cur=-diff_cur;
    if (diff_best>diff_cur) diff_best=diff_cur;
  }
  return(diff_best);
}
short*bypoint,*pcount;
short printshift(const short shift) {
  short i,point;
  memset(matches,-1,sizeof(short)*n_points);
  for (i=0; i<n_points; i++) {
    point=matrix[((points[i]/n_y+shift/n_y)%n_x)*n_y+(points[i]+shift)%n_y];
    if (point<0) return(INF);
    matches[i]=point;
  }
  printf("%d\n",n_points>>1);
  short weights_group[2],weight,count;
  memset(sums[0],0,sizeof(char)*(weight_total+1));
  memset(bypoint,-1,sizeof(short)*(weight_total+1));
  memset(pcount,0,sizeof(short)*(weight_total+1));
  *sums[0]=1;
  memset(mark,0,sizeof(char)*n_points);
  short z=0;
  for (i=0; i<n_points; i++) if (!mark[i]) {
    z^=1;
    weights_group[0]=weights_group[1]=0; count=0;
    for (point=i; !mark[point]; ) {
      weights_group[0]+=weights[point]; mark[point]=1;
      point=matches[point];
      if (z) printf("%hd %hd\n",points[point]/n_y,points[point]%n_y);
      if (mark[point]) return(INF);
      weights_group[1]+=weights[point]; mark[point]=1;
      point=matches[point];
      if (!z) printf("%hd %hd\n",points[point]/n_y,points[point]%n_y);
      count++;
    }
    memcpy(sums[1],sums[0],sizeof(char)*(weight_total+1));
    for (weight=0; weight<=weight_total; weight++) if (sums[1][weight]) {
      //if (bypoint[weight+weights_group[0]]<0) {
        sums[0][weight+weights_group[0]]=1;
        bypoint[weight+weights_group[0]]=i;
        pcount[weight+weights_group[0]]=pcount[weight]+count;
      //}
      //if (bypoint[weight+weights_group[1]]<0) {
        sums[0][weight+weights_group[1]]=1;
        bypoint[weight+weights_group[1]]=matches[i];
        pcount[weight+weights_group[1]]=pcount[weight]+count;
      //}
    }
  }
  short diff_best=INF,weight_best=0,diff_cur;
  for (weight=0; weight<=weight_total; weight++) if (sums[0][weight]) {
    diff_cur=weight_total-weight-weight;
    if (diff_cur<0) diff_cur=-diff_cur;
    if (diff_best>diff_cur) { diff_best=diff_cur; weight_best=weight; }
  }
  return(diff_best);
}

short*diffs;
short shift_best;

int main(void) {
  #ifdef ONLINE
  freopen("tore.in","rt",stdin);
  freopen("tore.out","wt",stdout);
  #endif
  short i;
  scanf("%hd%hd%hd",&n_x,&n_y,&n_points);
  n_cells=n_x*n_y;
  points=new short[n_points]; weights=new short[n_points];
  for (i=0; i<n_points; i++) {
    short x,y;
    scanf("%hd%hd",&x,&y);
    points[i]=x*n_y+y;
    weights[i]=x+y;
  }
  matrix=new short[n_cells];
  memset(matrix,-1,sizeof(short)*n_cells); weight_total=0;
  for (i=0; i<n_points; i++) {
    matrix[points[i]]=i;
    weight_total+=weights[i];
  }
  diffs=new short[n_cells];
  matches=new short[n_points]; mark=new char[n_points];
  sums[0]=new char[weight_total+1]; sums[1]=new char[weight_total+1];
  bypoint=new short[weight_total+1]; pcount=new short[weight_total+1];
  *diffs=INF;
  for (i=1; i<n_cells; i++) diffs[i]=tryshift(i);
  shift_best=0;
  for (i=1; i<n_cells; i++) if (diffs[i]<diffs[shift_best]) shift_best=i;
  if (shift_best) printshift(shift_best);
  else printf("-1\n");
  delete[]bypoint; delete[]pcount;
  delete[]sums[0]; delete[]sums[1];
  delete[]matches; delete[]mark;
  delete[]diffs;
  delete[]matrix;
  delete[]points; delete[]weights;
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


