{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}
Const MaxM = 500005;
      MaxN = 100005;

Type TEdge = Record
               A, B, P: Longint;
               C: Byte;
             End;
     TTree = Record
               L, P, N: Longint;
             End;

Var I, J, N, M, K, F, C, X, Y, MaxL, D: Longint;
    P1, P2, Left, Right, Middle: Longint;
    R1, R2: array[1..MaxM] of TEdge;
    G1, G2: array[1..MaxM] of Longint;
    T: array[1..MaxN] of TTree;
    Use, P, Go: array[1..MaxN] of Longint;

Procedure Swap(var A, B: TEdge);
Var C: TEdge;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure SwapInt(var A, B: Longint);
Var C: Longint;
Begin
  C := A;
  A := B;
  B := C;
End;

Procedure Hoar(Left, Right: Integer);
Var I, J: Integer;
    X: Longint;
Begin
  I := Left;
  J := Right;
  X := R1[Random(J - I + 1) + I].A;
  While I < J do Begin
    While R1[I].A < X do Inc(I);
    While R1[J].A > X do Dec(J);
    If I <= J Then Begin
      SwapInt(R2[R1[I].P].P, R2[R1[J].P].P);
      Swap(R1[I], R1[J]);
      Inc(I);
      Dec(J);
    End;
  End;
  If Left < J Then Hoar(Left, J);
  If I < Right Then Hoar(I, Right);
End;

Procedure Sort;
Begin
  Hoar(1, M);
  J := 1;
  For I := 1 to N do Begin
    While (J <= M) and (R1[J].A < I) do Inc(J);
    G1[I] := J;
  End;
  G1[N + 1] := M + 1;
End;

Procedure DeepSearchFirst(V: Longint);
Var I: Integer;
Begin
  Inc(D);
  Use[V] := D;
  Go[D] := V;
  For I := G1[V] to G1[V + 1] - 1 do
    If R1[I].C = 0 Then Begin
      R1[I].C := 2;
      R2[R1[I].P].C := 1;
      If Use[R1[I].B] = 0 Then DeepSearchFirst(R1[I].B);
    End;
  For I := G2[V] to G2[V + 1] - 1 do
    If R2[I].C = 0 Then Begin
      R2[I].C := 2;
      R1[R2[I].P].C := 1;
      If Use[R2[I].B] = 0 Then DeepSearchFirst(R2[I].B);
    End;
End;

Procedure DeepSearchSecond(V, K: Longint);
Var I: Integer;
Begin
  P[V] := K;
  For I := G1[V] to G1[V + 1] - 1 do
    If (R1[I].C = 1) and (P[R1[I].B] = 0) Then
      DeepSearchSecond(R1[I].B, K);
  For I := G2[V] to G2[V + 1] - 1 do
    If (R2[I].C = 1) and (P[R2[I].B] = 0) Then
      DeepSearchSecond(R2[I].B, K);
End;

Function CountLevel(V: Longint): Longint;
Begin
  If V = P[F]
  Then
    CountLevel := 1
  Else
    If T[V].L <> 0 Then CountLevel := T[V].L
                   Else CountLevel := CountLevel(T[V].P) + 1;
End;

Function Prev(X: Longint): Longint;
Var L: Longint;
Begin
  L := 1;
  While X and L > 0 do Begin
    X := X and not L;
    L := L shl 1;
  End;
  Prev := X;
End;

Function CountNext(V, L: Longint): Longint;
Var K: Longint;
Begin
  CountNext := 0;
  If (L < 0) or (T[V].L = L) Then Begin
    If T[V].L = L Then CountNext := V
                  Else CountNext := 0;
    Exit;
  End;
  If T[V].N = 0 Then T[V].N := CountNext(T[V].P, L);
  K := V;
  While T[K].L > L do
    If (T[K].N = 0) or (T[T[K].N].L < L)
    Then
      K := T[K].P
    Else
      K := T[K].N;
  CountNext := K;
End;

Procedure Divide;
Var I: Longint;
Begin
  For I := 1 to N do
    If P[Go[I]] = 0 Then Begin
      Inc(C);
      DeepSearchSecond(Go[I], C);
    End;
  For I := 1 to M do Begin
    If (R1[I].C = 1) and (P[R1[I].A] <> P[R1[I].B]) Then
      T[P[R1[I].A]].P := P[R1[I].B];
    If (R2[I].C = 1) and (P[R2[I].A] <> P[R2[I].B]) Then
      T[P[R2[I].A]].P := P[R2[I].B];
  End;
  For I := 1 to C do Begin
    T[I].L := CountLevel(I);
    If T[I].L > MaxL Then MaxL := T[I].L;
  End;
  For I := 1 to C do
    T[I].N := CountNext(I, Prev(T[I].L) - 1);
End;

Function Parent(V, L: Longint): Longint;
Var K: Longint;
Begin
  K := V;
  While T[K].L > L do
    If (T[K].N = 0) or (T[T[K].N].L < L)
    Then
      K := T[K].P
    Else
      K := T[K].N;
  Parent := K;
End;

Begin
  Assign(Input, 'magic.in');
  Assign(Output, 'magic.out');
  Reset(Input);
  Rewrite(Output);
  Read(N, M, F);
  For I := 1 to M do Begin
    Read(R1[I].A, R1[I].B);
    R2[I].A := R1[I].B;
    R2[I].B := R1[I].A;
    R1[I].P := I;
    R2[I].P := I;
  End;
  Sort;
  For I := 1 to M do
    Swap(R1[I], R2[I]);
  For I := 1 to N + 1 do
    SwapInt(G1[I], G2[I]);
  Sort;
  DeepSearchFirst(F);
  Divide;
  Read(K);
  For I := 1 to K do Begin
    Read(X, Y);
    X := P[X];
    Y := P[Y];
    Left := 1;
    If T[X].L < T[Y].L Then Right := T[X].L
                       Else Right := T[Y].L;
    While Left <= Right do Begin
      Middle := (Left + Right) shr 1;
      P1 := Parent(X, Middle);
      P2 := Parent(Y, Middle);
      If (P1 = P2) and (P1 <> 0) Then Left := Middle + 1
                                 Else Right := Middle - 1;
    End;
    While Parent(X, Middle) <> Parent(Y, Middle) do
      Dec(Middle);
    Writeln(Middle - 1);
  End;
  Close(Input);
  Close(Output);
End.