{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_c;
const
  inpfile='magic.in';
  outfile='magic.out';
  inf=MaxLongInt div 2;
  mm=500005;
  nm=100005;
type
  Rebr = record
    x,y : LongInt;
  end;
  PNode = ^Node;
  Node = record
    n,t_in,t_out,weight,h : LongInt;
    next : PNode;
  end;
var
  a : array [1..nm] of PNode;
  b,c : array [0..mm] of Rebr;
  pb,pc : array [0..nm] of LongInt;
  col : array [1..nm] of LongInt;
  cost : array [1..nm] of LongInt;
  n,m,s,tnum : LongInt;
  time : LongInt;
{}
Procedure Inp;
var
  i,j : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,m,s);
  for i:=1 to m do begin
    read(b[i].x,b[i].y);
    c[i].x:=b[i].y;
    c[i].y:=b[i].x;
  end;
  read(tnum);
end;
{}
Procedure Out;
begin
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  assign(output,outfile);
  rewrite(output);
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
  fillchar(pb,sizeof(pb),0);
  fillchar(pc,sizeof(pc),0);
  fillchar(col,sizeof(col),0);
  fillchar(cost,sizeof(cost),0);
end;
{}
Procedure Swap(var q,w : Rebr);
var
  bak : Rebr;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure SortB(l, r: LongInt);
var
  i, j, x : LongInt;
begin
  i := l; j := r; x := b[(l+r) DIV 2].x;
  repeat
    while b[i].x < x do inc(i);
    while x < b[j].x do dec(j);
    if i <= j then
    begin
      Swap(b[i],b[j]);
      inc(i); dec(j);
    end;
  until i > j;
  if l < j then SortB(l, j);
  if i < r then SortB(i, r);
end;
{}
Procedure SortC(l, r: LongInt);
var
  i, j, x : LongInt;
begin
  i := l; j := r; x := c[(l+r) DIV 2].x;
  repeat
    while c[i].x < x do inc(i);
    while x < c[j].x do dec(j);
    if i <= j then
    begin
      Swap(c[i],c[j]);
      inc(i); dec(j);
    end;
  until i > j;
  if l < j then SortC(l, j);
  if i < r then SortC(i, r);
end;
{}
Procedure CountPB;
var
  i,j : LongInt;
begin
  for i:=1 to m do begin
    pb[b[i].x]:=i;
    for j:=b[i-1].x+1 to b[i].x-1 do pb[j]:=i-1;
  end;
end;
{}
Procedure CountPC;
var
  i,j : LongInt;
begin
  for i:=1 to m do begin
    pc[c[i].x]:=i;
    for j:=c[i-1].x+1 to c[i].x-1 do pc[j]:=i-1;
  end;
end;
{}
Procedure Dfs(p : PNode; n : LongInt; var up : LongInt);
var
  i,ch_up : LongInt;
begin
  new(a[n]); fillchar(a[n]^,sizeof(a[n]^),0);

  col[n]:=1; up:=inf;
  a[n]^.next:=p; a[n]^.n:=n;
  inc(time); a[n]^.t_in:=time;
  if p<>nil then a[n]^.h:=p^.h+1
            else a[n]^.h:=1;

  for i:=pb[n-1]+1 to pb[n] do begin
    if col[b[i].y]=0 then begin
      Dfs(a[n],b[i].y,ch_up);
      if ch_up<up then up:=ch_up;
    end else
    if (col[b[i].y]=1) and (b[i].y<>p^.n) then begin
      if a[b[i].y]^.t_in<up then up:=a[b[i].y]^.t_in;
    end;
  end;

  for i:=pc[n-1]+1 to pc[n] do begin
    if col[c[i].y]=0 then begin
      Dfs(a[n],c[i].y,ch_up);
      if ch_up<up then up:=ch_up;
    end else
    if (col[c[i].y]=1) and (c[i].y<>p^.n) then begin
      if a[c[i].y]^.t_in<up then up:=a[c[i].y]^.t_in;
    end;
  end;

  col[n]:=2;
  if up<a[n]^.t_in then a[n]^.weight:=0
                   else a[n]^.weight:=1;

  inc(time); a[n]^.t_out:=time;
end;
{}
Function CountCost(p : PNode) : LongInt;
var
  q : PNode;
begin
  if p=nil then begin
    CountCost:=0; exit;
  end;

  if col[p^.n]<>0 then begin
    CountCost:=cost[p^.n];
    exit;
  end;

  col[p^.n]:=1;
  cost[p^.n]:=p^.weight+CountCost(p^.next);
  CountCost:=cost[p^.n];
end;
{}
Procedure SwapN(var q,w : LongInt);
var
  bak : LongInt;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure Solve;
var
  i,j,k : LongInt;
  x,y : LongInt;
  p : PNode;
begin
  SortB(1,m); CountPB;
  SortC(1,m); CountPC;

  time:=0;
  Dfs(nil,s,k);
  a[s]^.weight:=0;

  fillchar(col,sizeof(col),0);
  for i:=1 to n do
    if col[i]=0 then cost[i]:=CountCost(a[i]);

  for k:=1 to tnum do begin
    read(x,y);
    if a[x]^.h<a[y]^.h then SwapN(x,y);
    p:=a[x];
    while (p^.t_in>a[y]^.t_in) or (p^.t_out<a[y]^.t_out) do p:=p^.next;

    writeln(cost[p^.n]);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.