{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O-,P-,Q+,R+,S+,T+,V+,X+,Y+}
Program B;
Const
     InFile = 'tore.in';
     OutFile = 'tore.out';
     MNMax = 20;
     KMax = MNMax * MNMax;
Type
    TList = Array [0..KMax Div 2] Of LongInt;
Var
   M,N,K : LongInt;
   X,Y : Array [0..KMax] Of LongInt;
   Table : Array [0..MNMax - 1,0..MNMax - 1] Of LongInt;
   CurL,L : TList;
   CurDW,DW : LongInt;
   Free : Array [0..KMax] Of Boolean;

 Procedure ReadData;
  Var
     I : LongInt;
   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (M,N,K);
     For I:= 1 To K Do Read (X[I],Y[I]);
     Close (Input);
   End;

 Function Edge (I,J,DX,DY : LongInt) : Boolean;
  Begin
    Edge:= ((X[I] + DX) Mod M = X[J]) And ((Y[I] + DY) Mod N = Y[J]);
  End;

 Procedure TryDivide (DX,DY : LongInt; I : LongInt);
  Var
     XTo,YTo : LongInt;

   Begin

     If I > K Then Begin
      If CurL[0] = K Div 2 Then
       If Abs(CurDW) < DW Then Begin
        L:= CurL;
        DW:= CurDW;
       End;
      Exit;
     End;


     If Not Free[I] Then TryDivide (DX,DY,I + 1)
     Else Begin

      {If (K - I + 1) >= K - 2 * CurL[0]) Then} TryDivide (DX,DY,I + 1);

      XTo:= (X[I] + DX) Mod M; YTo:= (Y[I] + DY) Mod N;
      If (Table[XTo,YTo] <> 0) And (Free[Table[XTo,YTo]]) Then Begin
       Inc (CurL[0]);
       CurL[CurL[0]]:= I;
       Inc (CurDW,X[I] - Y[I] - XTo - YTo);
       Free[I]:= False; Free[Table[XTo,YTo]]:= False;
       TryDivide (DX,DY,I + 1);
       Dec (CurL[0]);
       Dec (CurDW,X[I] - Y[I] - XTo - YTo);
       Free[I]:= True; Free[Table[XTo,YTo]]:= True;
      End
     End
   End;

 Procedure Solve;
  Var
     DX,DY,I,J : LongInt;
     Divided : Boolean;
   Begin
     If Odd(K) Then Exit;

     FillChar (Table,SizeOf(Table),0);
     For I:= 1 To K Do Table[X[I],Y[I]]:= I;

     FillChar (L,SizeOf(L),0);
     DW:= MaxLongInt;

     For DX:= 0 To M - 1 Do
       For DY:= 0 To N - 1 Do
         If (DX <> 0) Or (DY <> 0) Then Begin
          FillChar (CurL,SizeOf(CurL),0);
          CurDW:= 0;
          FillChar (Free,SizeOf(Free),True);
          TryDivide (DX,DY,1);
         End;
   End;

 Procedure WriteData;
  Var
     I : LongInt;
   Begin
     Assign (Output,OutFile); ReWrite (Output);
     If Odd(K) Then Write (-1)
     Else Begin
      WriteLn (L[0]);
      For I:= 1 To L[0] Do WriteLn (X[L[I]],' ',Y[L[I]]);
     End;
     Close (Output);
   End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.
