const
  MaxN = 100000;
  MaxM = 500000;
  MaxK = 100000;

var
  fi, fo: text;
  n,m,f: longint;
  egs: array[1..MaxM*2,1..2] of longint;
  els: array[1..MaxN] of longint;
  PosNum: longint;
  Positions: array[1..MaxK,1..2] of longint;

procedure Swap(var a,b: longint);
var c: longint;
begin
  c:=a; a:=b; b:=c;
end;

procedure sort_egs(l,r: longint);
var
  i,j,x: longint;
begin
  i:=l;
  j:=r;
  x:=egs[(l+r) div 2,1];
  repeat
    while egs[i,1]<x do inc(i);
    while x<egs[j,1] do dec(j);
    if not(i>j) then begin
      Swap(egs[i,1],egs[j,1]);
      Swap(egs[i,2],egs[j,2]);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then sort_egs(l,j);
  if i<r then sort_egs(i,r);
end;

var
  stack,stack2: array[1..MaxN] of longint;
  sp, time: longint;
  vtime: array[1..MaxN] of longint;
  del: array[1..MaxM*2] of boolean;
  mark: array[1..MaxN] of boolean;
  ccount: longint;
  vcomp: array[1..MaxN] of longint;
  cprev: array[1..MaxN] of longint;
  tord: array[1..MaxN] of longint;

procedure sort_tord(l,r: longint);
var
  i,j,x: longint;
begin
  i:=l;
  j:=r;
  x:=vtime[tord[(l+r) div 2]];
  repeat
    while vtime[tord[i]]<x do inc(i);
    while x<vtime[tord[j]] do dec(j);
    if not(i>j) then begin
      Swap(tord[i],tord[j]);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then sort_tord(l,j);
  if i<r then sort_tord(i,r);
end;

procedure DFS(v: longint;mode:byte);
var i,e: longint;
begin
  time:=0;
  sp:=1;
  stack[1]:=v;
  stack2[1]:=0;
  while sp>0 do begin
    inc(time);
    v:=stack[sp]; e:=stack2[sp]; dec(sp);
    if not mark[v] then begin
      mark[v]:=true;
      if mode=1 then begin
        vtime[v]:=time;
        if e>0 then del[e]:=true;
      end;
      if mode=2 then vcomp[v]:=ccount;
      i:=els[v];
      while (i<=m) and (egs[i,1]=v) do begin
        if (not del[i]) and (not mark[egs[i,2]]) then begin
          inc(sp);
          stack[sp]:=egs[i,2];
          stack2[sp]:=i;
        end;
        inc(i);
      end;
    end;
    inc(time);
  end;
end;

var
  cdep: array[1..MaxN] of longint absolute vtime;

procedure Solve;
var i,j,v: longint;
begin
  sort_egs(1,m);
  For i:=1 to m do
    if els[egs[i,1]]=0 then els[egs[i,1]]:=i;
  DFS(f,1);
  For i:=1 to n do begin
    mark[i]:=false;
    tord[i]:=i;
  end;
  sort_tord(1,n);
  for i:=1 to n do begin
    v:=tord[i];
    if not mark[v] then begin
      inc(ccount);
      if ccount>1 then begin
        j:=els[v];
        while (j<=m) and (egs[j,1]=v) do begin
          if (not del[j]) and (vcomp[egs[j,2]]<>0) then
            cprev[ccount]:=vcomp[egs[j,2]];
          inc(j);
        end;
      end;
      DFS(v,2);
    end;
  end;
  {}
  cdep[1]:=0;
  For i:=2 to ccount do
    cdep[i]:=cdep[cprev[i]]+1;
  {}
  for v:=1 to PosNum do begin
    i:=vcomp[Positions[v,1]];
    j:=vcomp[Positions[v,2]];
    while cdep[i]>cdep[j] do
      i:=cprev[i];
    while cdep[j]>cdep[i] do
      j:=cprev[j];
    while i<>j do begin
      i:=cprev[i];
      j:=cprev[j];
    end;
    WriteLn(fo,cdep[i]);
  end;

end;

procedure Init;
var i,a,b: longint;
begin
  Assign(fi,'magic.in');
  Assign(fo,'magic.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,n,m,f);
  For i:=1 to m do begin
    Read(fi,a,b);
    egs[i*2-1,1]:=a;
    egs[i*2-1,2]:=b;
    egs[i*2,1]:=b;
    egs[i*2,2]:=a;
  end;
  m:=m*2;
  Read(fi,PosNum);
  For i:=1 to PosNum do
    Read(fi,Positions[i,1],Positions[i,2]);
end;

procedure Done;
begin

  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
