const
     FileIn='tore.in';
     FileOut='tore.out';
     MaxN=20;
     MaxM=MaxN;
     MaxK=MaxM*MaxN;
type
    TPoint=record
                 X, Y, NewX, NewY: LongInt;
                 Weight: LongInt;
           end;
    TPoints=array [1..MaxK] of TPoint;
    TAnswerItem=record
                      X, Y: LongInt;
                end;
    TAnswer=array [1..MaxK] of TAnswerItem;
var
   M, N, K: LongInt;
   Points: TPoints;
   B: LongInt;
   Answer: TAnswer;

procedure ReadData;
var
   F: Text;
   NPoint: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, M, N, K);
     for NPoint:=1 to K
         do Read (F, Points [NPoint].X, Points [NPoint].Y);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, B);
     for NItem:=1 to B
         do Writeln (F, Answer [NItem].X, #32, Answer [NItem].Y);
     Close (F);
end;

function Search (aX, aY: LongInt): LongInt;
var
   NPoint: LongInt;
begin
     for NPoint:=1 to K
         do if (Points [NPoint].X=aX) and (Points [NPoint].Y=aY)
               then begin
                    Search:=NPoint;
                    Exit;
               end;
     Search:=0;
end;

var
   JumpTable: array [1..MaxK] of LongInt;
   Colors: array [1..MaxK] of LongInt;
   BestDeltaWeight: LongInt;
   Used: array [1..MaxK] of Boolean;

procedure CheckIfTheBest;
var
   NPoint: LongInt;
   WeightOfBlue, WeightOfRed: LongInt;
   DeltaWeight: LongInt;
begin
     WeightOfBlue:=0;
     WeightOfRed:=0;
     FillChar (Used, SizeOf (Used), 0);
     for NPoint:=1 to K
         do case Colors [NPoint] of
                 1: begin
                         Inc (WeightOfBlue, Points [NPoint].Weight);
                         Used [NPoint]:=true;
                         if Colors [JumpTable [NPoint]]=2
                            then Used [JumpTable [NPoint]]:=true;
                    end;
                 2: Inc (WeightOfRed, Points [NPoint].Weight);
            end;
     for NPoint:=1 to K
         do if not Used [NPoint]
               then Exit;
     DeltaWeight:=Abs (WeightOfBlue-WeightOfRed);
     if (DeltaWeight<BestDeltaWeight) or (B<0)
        then begin
             B:=0;
             for NPoint:=1 to K
                 do if Colors [NPoint]=1
                       then begin
                            Inc (B);
                            Answer [B].X:=Points [NPoint].X;
                            Answer [B].Y:=Points [NPoint].Y;
                       end;
             BestDeltaWeight:=DeltaWeight;
             if DeltaWeight=0
                then begin
                     WriteData;
                     Halt;
                end;
        end;
end;

procedure DefineColor (aIndex: LongInt);

procedure CallGray;
var
   FoundGray: Boolean;
   Index: LongInt;
begin
     FoundGray:=false;
     for Index:=1 to K
         do if Colors [Index]=0
               then begin
                    DefineColor (Index);
                    FoundGray:=true;
                    Break;
               end;
     if not FoundGray
        then CheckIfTheBest;
end;

var
   Index: LongInt;
begin
     case Colors [aIndex] of
          0: if JumpTable [aIndex]=0
                then begin
                     Colors [aIndex]:=2;
                     CallGray;
                end
                else case Colors [JumpTable [aIndex]] of
                          0: begin
                                  Colors [aIndex]:=2;
                                  DefineColor (JumpTable [aIndex]);
                                  Colors [aIndex]:=1;
                                  Colors [JumpTable [aIndex]]:=2;
                                  DefineColor (JumpTable [aIndex]);
                                  Colors [JumpTable [aIndex]]:=0;
                             end;
                          1:;
                          2: begin
                                  Colors [aIndex]:=1;
                                  DefineColor (JumpTable [aIndex]);
                             end;
                     end;
          1: DefineColor (JumpTable [Index]);
          2: CallGray;
     end;
     Colors [aIndex]:=0;
end;

procedure Solve;
var
   DeltaX, DeltaY: LongInt;
   NPoint: LongInt;
   OK: Boolean;
begin
     B:=-1;
     for NPoint:=1 to K
         do Points [NPoint].Weight:=Points [NPoint].X+Points [NPoint].Y;
     for DeltaX:=-M+1 to M-1
         do for DeltaY:=-N+1 to N-1
                do if (DeltaX<>0) or (DeltaY<>0)
                      then begin
                           for NPoint:=1 to K
                               do with Points [NPoint]
                                       do begin
                                          NewX:=X+DeltaX;
                                          if NewX>M
                                             then Dec (NewX, M);
                                          if NewX<0
                                             then Inc (NewX, M);
                                          NewY:=Y+DeltaY;
                                          if NewY>M
                                             then Dec (NewY, M);
                                          if NewY<0
                                             then Inc (NewY, N);
                                       end;
                           for NPoint:=1 to K
                               do JumpTable [NPoint]:=Search (Points [NPoint].NewX, Points [NPoint].NewY);
                           FillChar (Colors, SizeOf (Colors), 0);
                           DefineColor (1);
                      end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
