program zzz;
{$M 20000000}

const
  inf = 100000000;
  maxn = 100000;
  maxm = 500000;
  o1 = 1 shl 19;

type
  Prib = ^TRib;
  TRib = record
    next: Prib;
    v,num: Longint;
  end;

var
  sc,i,j,k,ncol,ncapital,n,m: Longint;
  g2,g: array[1..maxn] of Prib;
  rl,rr,col,r,st: array[1..maxn] of Longint;
  vis: array[1..maxn] of Boolean;
  isbridge: array[1..maxm] of Boolean;
  eu,mn: array[1..3*maxn] of Longint;
  tr: array[1..2 * o1] of Longint;
  buf: Prib;

function min(a,b: Longint): Longint;
begin
  if a < b then min := a else min := b;
end;

procedure buildtree(n: Longint);
var i: Longint;
begin
  for i := 1 to o1 * 2 do begin
    tr[i] := inf;
  end;
  for i := 1 to n do begin
    tr[i+o1-1] := mn[i];
  end;
  for i := o1-1 downto 1 do begin
    tr[i] := min(tr[i*2],tr[i*2+1]);
  end;
end;

function query(st,fin: Longint): Longint;
var i,j,ans: Longint;
begin
  i := st + o1 - 1;
  j := fin + o1 - 1;
  ans := min(tr[i],tr[j]);
  while i <= j do begin
    ans := min(ans,tr[i]);
    ans := min(ans,tr[j]);
    i := (i+1) div 2;
    j := (j-1) div 2;
  end;
  query := ans;
end;

procedure add(v1,v2,num: Longint);
var buf: Prib;
begin
  new(buf);
  buf^.next := g[v1];
  g[v1] := buf;
  buf^.v := v2;
  buf^.num := num;
end;

procedure add2(v1,v2: Longint);
var buf: Prib;
begin
  new(buf);
  buf^.next := g2[v1];
  g2[v1] := buf;
  buf^.v := v2;
end;

procedure dfs2(v: Longint);
var buf: Prib;
begin
  vis[v] := true;
  buf := g[v];
  col[v] := ncol;
  while buf^.next <> nil do begin
    if not vis[buf^.v] then begin
      if not isbridge[buf^.num] then dfs2(buf^.v);
    end;
    buf := buf^.next;
  end;
end;

function dfs(v,dep: Longint): Longint;
var buf: Prib;
    ans,k: Longint;
begin
  buf := g[v];
  ans := dep;
  st[dep] := v;
  r[st[dep]] := dep;
  vis[v] := true;
  while buf^.next <> nil do begin
    if dep <> 1 then begin
      if st[dep-1] = buf^.v then begin
        buf := buf^.next;
        continue;
      end;
    end;
    if not vis[buf^.v] then begin
      k := dfs(buf^.v,dep+1);
      ans := min(ans,k);
      if k = dep+1 then begin
        isbridge[buf^.num] := true;
      end;
    end else begin
      if r[buf^.v] <> 0 then begin
        if ans > r[buf^.v] then ans := r[buf^.v];
      end;
    end;
    buf := buf^.next;
  end;
  r[st[dep]] := 0;
  st[dep] := 0;
  dfs := ans;
end;

function max(a,b: Longint): Longint;
begin
  if a > b then max := a else max := b;
end;

procedure euler(v,dep: Longint);
var buf: Prib;
begin
  buf := g2[v];
  inc(sc);
  vis[v] := true;
  eu[sc] := v;
  mn[sc] := dep;
  while buf^.next <> nil do begin
    if not vis[buf^.v] then begin
      euler(buf^.v,dep+1);
      inc(sc);
      mn[sc] := dep;
      eu[sc] := v;
    end;
    buf := buf^.next;
  end;
end;

begin
  assign(input,'magic.in'); reset(input);
  assign(output,'magic.out'); rewrite(output);
  read(n,m);
  read(ncapital);
  for i := 1 to n do begin
    new(g[i]);
    g[i]^.next := nil;
  end;
  for i := 1 to m do begin
    read(j,k);
    add(j,k,i);
    add(k,j,i);
  end;
  dfs(ncapital,1);
{  writeln('Bridges: ');
  for i := 1 to n do begin
    buf := g[i];
    while buf^.next <> nil do begin
      if isbridge[buf^.num] then writeln(i,' ',buf^.v);
      buf := buf^.next;
    end;
  end;}
  fillchar(vis,sizeof(vis),false);
  for i := 1 to n do begin
    if not vis[i] then begin
      inc(ncol);
      dfs2(i);
    end;
  end;
  for i := 1 to ncol do begin
    new(g2[i]);
    g2[i]^.next := nil;
  end;
  for i := 1 to n do begin
    buf := g[i];
    while buf^.next <> nil do begin
      if isbridge[buf^.num] then begin
        add2(col[i],col[buf^.v]);
      end;
      buf := buf^.next;
    end;
  end;
{  for i := 1 to n do writeln(col[i]);}
  fillchar(vis,sizeof(vis),false);
  euler(col[ncapital],0);
  for i := 1 to sc do begin
    if st[eu[i]] = 0 then st[eu[i]] := i;
  end;
{  for i := 1 to sc do write(eu[i],' ');
  writeln;
  for i := 1 to sc do write(mn[i],' ');
  writeln;}
  buildtree(sc);
  read(k);
  for i := 1 to k do begin
    read(j,m);
    writeln(query(min(st[col[j]],st[col[m]]),max(st[col[j]],st[col[m]])));
  end;
  close(input);
  close(output);
end.
