{$N+}
program TaskB;
const infile = 'sphere.in';
      outfile = 'sphere.out';
      MAXN = 1000;
      MPI = 3.1415926535897932;
      dt = 1e-5;
type t1 = record
  fi, la:extended;
end;
var N, S1, S2:integer;
    R, D:extended;
    ar:array[1..MAXN]of t1;
    G:array[1..MAXN, 1..MAXN]of boolean;

procedure inp;
var i:integer;
    ch:char;
    fi, l:extended;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input); rewrite(output);
  readln(N, S1, S2, R, D);
  for i:=1 to N do
  begin
    read(fi); read(ch); while ch=' ' do read(ch);
    if ch='S' then fi:=-fi; fi:=fi*MPI/180;

    read(l); read(ch); while ch=' ' do read(ch);
    if ch='W' then l:=-l; l:=l*MPI/180;
    ar[i].fi:=fi; ar[i].la:=l;
  end;
end;

function ArcCos(x:extended):extended;
var t:extended;
begin
  if abs(x)<dt then begin ArcCos:=MPI/2; exit; end;
  if abs(x+1)<dt then begin ArcCos:=MPI; exit; end;
  t:=ArcTan(sqrt(1-sqr(x))/x);
  if t<0 then t:=t+MPI;
  ArcCos:=t;
end;

function dist(i, j:integer):extended;
var alpha:extended;
begin
  alpha:=ArcCos(sin(ar[i].fi)*sin(ar[j].fi)+cos(ar[i].fi)*cos(ar[j].fi)*cos(ar[i].la-ar[j].la));
  dist:=alpha*R;
end;

procedure run;
var i, j:integer;
begin
  fillchar(G, sizeof(G), false);
  for i:=1 to N do
    for j:=1 to N do
      if dist(i, j)<=D then G[i, j]:=true;
end;

function BFS:longint;
var V, Q:array[1..MAXN]of longint;
    Ql, Qr, Cur, B:longint;
begin
  fillchar(V, sizeof(V), 255);
  Ql:=1; Qr:=1; Q[1]:=S1; V[S1]:=0;
  while Qr>=Ql do
  begin
    Cur:=Q[Ql]; inc(Ql);
    for B:=1 to N do
      if (G[Cur, B])and(V[B]=-1) then
      begin
        V[B]:=V[Cur]+1;
        inc(Qr);
        Q[Qr]:=B;
      end;
  end;
  BFS:=V[S2];
end;

procedure outp;
begin
  write(BFS);
  close(input);
  close(output);
end;

begin
  inp;
  run;
  outp;
end.
