#include <stdio.h>
#include <stdlib.h>

#define MANY 2000000000
#define NN 131072

struct POINT {
  int x,y,z;
};

FILE *fi, *fo;
POINT a[2*NN-1];
POINT b[NN];
int ans[NN];
int n,m;

void sift(POINT *a, int p, int q)
{
  int i,j;
  POINT x;
  i=p;
  x=a[i];
  j=i*2+1;
  if(j<q-1) if(a[j+1].x>a[j].x) j++;
  if(j<q) if(x.x>a[j].x) j=q+1;
  while(j<q)
  {
    a[i]=a[j];
    i=j;
    j=2*j+1;
    if(j<q-1) if(a[j+1].x>a[j].x) j++;
    if(j<q) if(x.x>a[j].x) j=q+1;
  }
  a[i]=x;
}

void HeapSort(POINT *a, int n)
{
  int i;
  POINT x;
  for(i=n/2+1;i>=0;i--)
    sift(a,i,n);
  for(i=n-1;i>=0;i--)
  {
    x=a[i];
    a[i]=a[0];
    a[0]=x;
    sift(a,0,i);
  }
}

void build_rmq()
{
  int i,j;
  for(i=0;i<2*NN-1;i++)
    a[i].x=MANY;
  for(i=0;i<n;i++)
  {
    a[NN-1+i].x=b[i].y;
    a[NN-1+i].y=i;
  }
  for(i=NN-2;i>=0;i--)
  {
    if(a[2*i+1].x<a[2*i+2].x)
      a[i]=a[2*i+1];
    else
      a[i]=a[2*i+2];
  }
}

int parent(int x)
{
   return (x-1)/2;
}

int rmq(int x, int y)
{
  int f;
  int ans;
  if(x==y)
    return a[x].y;
  if(x>y)
    return n+1;
  ans=a[x].y;
  if(a[y].x<a[x].x)
    ans=a[y].y;
  f=rmq(parent(x+1),parent(y-1));
  if(f<n)
  {
    if(a[NN-1+ans].x>a[NN-1+f].x)
      ans=f;
  }
  return ans;
}

void update(int x)
{
  if(a[2*x+1].x<a[2*x+2].x)
    a[x]=a[2*x+1];
  else
    a[x]=a[2*x+2];
  if(x>0)
    update(parent(x));
}

int bsearch1(int x)
{
  int bb,ee;
  int c;
  bb=0;
  ee=n;
  if(b[0].x>=x)
    return 0;
  if(b[n-1].x<x)
    return n;
  while((ee-bb)>1)
  {
    c=(bb+ee)/2;
    if(b[c].x<x)
      bb=c;
    else
      ee=c;
  }
  return ee;
}

int bsearch2(int x)
{
  int bb,ee;
  int c;
  bb=0;
  ee=n;
  if(b[0].x>x)
    return -1;
  if(b[n-1].x<=x)
    return n-1;
  while((ee-bb)>1)
  {
    c=(bb+ee)/2;
    if(b[c].x<=x)
      bb=c;
    else
      ee=c;
  }
  return bb;
}

int main()
{
  int i,j;
  int x,y;
  fi=fopen("docs.in","rt");
  fo=fopen("docs.out","wt");

  fscanf(fi,"%d",&n);
  for(i=0;i<n;i++)
  {
    fscanf(fi,"%d%d",&b[i].x,&b[i].y);
    b[i].z=i;
  }
  HeapSort(b,n);
  build_rmq();
  fscanf(fi,"%d",&m);
  for(i=0;i<m;i++)
  {
    fscanf(fi,"%d%d",&x,&y);
    x=bsearch1(x);
    y=bsearch2(y);
    if((x>=n)||(y<0))
    {
      fprintf(fo,"BOTVA\n");
      fclose(fi);
      fclose(fo);
      return 0;
    }
    j=rmq(NN+x-1,NN+y-1);
    if((j>=n)||(b[j].y>=MANY))
    {
      fprintf(fo,"BOTVA\n");
      fclose(fi);
      fclose(fo);
      return 0;
    }
    ans[i]=b[j].z;
    b[j].y=MANY;
    a[NN+j-1].x=MANY;
    update(parent(NN+j-1));
  }
  for(i=0;i<m;i++)
    fprintf(fo,"%d ",ans[i]+1);
  fprintf(fo,"\n");

  fclose(fi);
  fclose(fo);
  return 0;
}
