#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MANY 100000
//#define eps 1e-2
#define NN 1100

struct VECT {
  double x,y,z;
};

struct COORD {
  double h,d;
};

FILE *fi, *fo;
double r;
double d;
double eps;
int s1,s2;
int l[NN];
bool used[NN];
COORD a[NN];
VECT b[NN];
int g[NN][NN];
int n;

void c2v(COORD *a, VECT *b)
{
  b->z=sin(a->h);
  b->y=cos(a->h)*sin(a->d);
  b->x=cos(a->h)*cos(a->d);
}

double sqr(double x)
{
  return x*x;
}

double vp(VECT *a, VECT *b)
{
  return sqrt(sqr(a->x*b->y-a->y*b->x)+sqr(a->x*b->z-b->x*a->z)+
              sqr(a->y*b->z-a->z*b->y));
}

double sp(VECT *a, VECT *b)
{
  return a->x*b->x+a->y*b->y+a->z*b->z;
}

void buildg()
{
  int i,j;
  double ang;
  for(i=0;i<n;i++)
  {
    for(j=0;j<n;j++)
    {
//      ang=atan2(vp(&b[i],&b[j]),sp(&b[i],&b[j]));
      ang=acos(sp(&b[i],&b[j]));
      ang*=r;
      if(ang-eps<d)
        g[i][j]=1;
      else
        g[i][j]=0;
    }
  }
}

void Dejkstr()
{
  int i,k;
  int m;
  for(i=0;i<n;i++)
  {
    used[i]=false;
    l[i]=MANY;
  }
  l[s1]=0LL;
  while(true)
  {
    k=-1;
    m=MANY+1LL;
    for(i=0;i<n;i++)
    {
      if(!used[i])
      {
        if(m>l[i])
        {
          m=l[i];
          k=i;
        }
      }
    }
    if(k<0)
      break;
    used[k]=true;
    for(i=0;i<n;i++)
    {
      if(g[k][i])
      {
        if(l[i]>l[k]+1)
          l[i]=l[k]+1;
      }
    }
  }
}

int getcc()
{
  int c;
  c=getc(fi);
  while((c==' ')||(c=='\n')||(c=='\t')||(c=='\r'))
    c=getc(fi);
  return c;
}

void read_coord(COORD *a)
{
  int c;
  fscanf(fi,"%lf",&a->h);
  c=getcc();
  if((c=='S')||(c=='s'))
    a->h=-a->h;
  a->h=a->h/180.0*M_PI;
  fscanf(fi,"%lf",&a->d);
  c=getcc();
  if((c=='E')||(c=='e'))
    a->d=-a->d;
  a->d=a->d/180.0*M_PI;
}

int main()
{
  int i,j;
  fi=fopen("sphere.in","rt");
  fo=fopen("sphere.out","wt");
  
  fscanf(fi,"%d",&n);
  fscanf(fi,"%d%d",&s1,&s2);
  s1--; s2--;
  fscanf(fi,"%lf",&r);
  eps=r/1000000.0;
  eps/=10000000.0;
  fscanf(fi,"%lf",&d);
  for(i=0;i<n;i++)
  {
    read_coord(&a[i]);
    c2v(&a[i],&b[i]);
  }
  buildg();
  Dejkstr();
  if(l[s2]>=MANY)
    fprintf(fo,"-1\n");
  else
    fprintf(fo,"%d\n",l[s2]);

  fclose(fi);
  fclose(fo);
  return 0;
}
