#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define LL 50
#define MM 256
#define PP 101

#define BR_OPEN 0
#define BR_CLOSE 1
#define OPER 2
#define NUM 3
#define ERR -1

int _stklen = 16000000;

FILE *fi, *fo;
int p;
char v[MM][LL];
int pr[MM];
int cnst[MM];
int dv[PP][PP];
int lex;
int val;
int n,m;

int calc_oper(int a, int b, int c);
int ev_unary();
int ev_binary(int prior);
int ev_expr();
int ev_unary2(char **s,int a, int b);
int ev_binary2(char **s,int prior, int a ,int b);
int ev_expr2(char **s,int a, int b);
int calc_oper(int a, int b, int c);

int getcc()
{
  int c;
  c=getc(fi);
  while((c==' ')||(c=='\n')||(c=='\t')||(c=='\r'))
    c=getc(fi);
  return c;
}

void read_lex()
{
  int c;
  c=getcc();
  switch(c)
  {
    case '(':
      lex=BR_OPEN;
      break;
    case ')':
      lex=BR_CLOSE;
      break;
    default :
      if(isdigit(c))
      {
        lex=NUM;
        val=0;
        while(isdigit(c))
        {
          val=val*10+c-'0';
          c=getc(fi);
        }
        ungetc(c,fi);
        break;
      }
      if(isalpha(c))
      {
        lex=NUM;
        val=cnst[c];
        break;
      }
      if(c==EOF)
      {
        lex=ERR;
        break;
      }
      lex=OPER;
      val=c;
      break;
  }
}

void read_lex2(char **s, int a, int b)
{
  int c;
  c=(**s);
  (*s)++;
  switch(c)
  {
    case '(':
      lex=BR_OPEN;
      break;
    case ')':
      lex=BR_CLOSE;
      break;
    default :
      if(isdigit(c))
      {
        lex=NUM;
        val=0;
        while(isdigit(c))
        {
          val=val*10+c-'0';
          c=(**s);
          (*s)++;
        }
        (*s)--;
        break;
      }
      if(c=='a')
      {
        lex=NUM;
        val=a;
        break;
      }
      if(c=='b')
      {
        lex=NUM;
        val=b;
        break;
      }
      if(isalpha(c))
      {
        lex=NUM;
        val=cnst[c];
        break;
      }
      if(c<=0)
      {
        lex=ERR;
        break;
      }
      lex=OPER;
      val=c;
      break;
  }
}

int ev_unary()
{
  int v;
  if(lex==NUM)
  {
    v=val;
    read_lex();
    return v;
  }
  if(lex==OPER)
  {
    v=val;
    read_lex();
    return calc_oper(ev_unary(),1,v);
  }
  if(lex==BR_OPEN)
  {
    read_lex();
    v=ev_expr();
    read_lex();
    return v;
  }
  return 1;
}

int ev_binary(int prior)
{
  int v1,v2;
  int c;
  if(prior>=20)
    return ev_unary();
  v1=ev_binary(prior+1);
  while((lex==OPER)&&(pr[val]==prior))
  {
    c=val;
    read_lex();
    v2=ev_binary(prior+1);
    v1=calc_oper(v1,v2,c);
  }
  return v1;
}

int ev_expr()
{
  return ev_binary(1);
}

void builddv()
{
  int i,j;
  int r;
  for(i=0;i<p;i++)
  {
    for(j=0;j<p;j++)
    {
      r=(i*j)%p;
      dv[r][i]=j;
      dv[r][j]=i;
    }
  }
}

int ev_unary2(char **s, int a, int b)
{
  int v;
  if(lex==NUM)
  {
    v=val;
    read_lex2(s,a,b);
    return v;
  }
  if(lex==OPER)
  {
    v=val;
    read_lex2(s,a,b);
    return calc_oper(ev_unary2(s,a,b),1,v);
  }
  if(lex==BR_OPEN)
  {
    read_lex2(s,a,b);
    v=ev_expr2(s,a,b);
    read_lex2(s,a,b);
    return v;
  }
  return 1;
}

int ev_binary2(char **s,int prior,int a, int b)
{
  int v1,v2;
  int c;
  if(prior>=20)
    return ev_unary2(s,a,b);
  v1=ev_binary2(s,prior+1,a,b);
  while((lex==OPER)&&(pr[val]==prior))
  {
    c=val;
    read_lex2(s,a,b);
    v2=ev_binary2(s,prior+1,a,b);
    v1=calc_oper(v1,v2,c);
  }
  return v1;
}

int ev_expr2(char **s, int a, int b)
{
  return ev_binary2(s,1,a,b);
}

int divp(int a, int b)
{
  return dv[a][b];
}

void read_oper()
{
  int c;
  int pp;
  int nm;
  c=getcc();
  if(c=='U')
  {
    pp=20;
    nm=getcc();
    c=getcc();
  }
  else
  {
    fscanf(fi,"%d",&pp);
    c=getcc();
    nm=getcc();
    c=getcc();
  }
  pr[nm]=pp;
  c=getcc();
  pp=0;
  c=getcc();
  while((c!='\n')&&(c!=' ')&&(c!='\r')&&(c!='\t'))
  {
    v[nm][pp++]=c;
    c=getc(fi);
  }
  v[nm][pp]='\0';
}

void read_var()
{
  int c;
  int v;
  c=getcc();
  getcc();
  fscanf(fi,"%d\n",&v);
  cnst[c]=v;
}

int calc_oper(int a, int b, int c)
{
  char *s;
  int vv;
  int old_lex;
  int old_val;
  switch(c)
  {
    case '+':
      return (a+b)%p;
    case '-':
      return (a-b+p)%p;
    case '*':
      return (a*b)%p;
    case '/':
      return divp(a,b);
    default :
      s=v[c];
      old_lex=lex;
      old_val=val;
      read_lex2(&s,a,b);
      vv=ev_expr2(&s,a,b);
      lex=old_lex;
      val=old_val;
      return vv%p;
  }
}

int main()
{
  int i;
  fi=fopen("calc.in","rt");
  fo=fopen("calc.out","wt");

  fscanf(fi,"%d",&p);
  builddv();
  fscanf(fi,"%d",&n);
  for(i=0;i<n;i++)
    read_oper();
  fscanf(fi,"%d",&m);
  for(i=0;i<m;i++)
    read_var();
  pr['-']=5;
  pr['+']=5;
  pr['*']=15;
  pr['/']=15;
  read_lex();
  i=ev_expr();
  i%=p;
  fprintf(fo,"%d\n",i);

  fclose(fi);
  fclose(fo);
  return 0;
}
