#define ONLINE
#include <stdio.h>

#define INF ((long)0x7FFFFF00)

#define MIN(x,y) (((x)<=(y))?(x):(y))
#define MAX(x,y) (((x)>=(y))?(x):(y))

struct TDoc {
  long value,cost;
  long index;
};
void sort(TDoc*,const long);

struct TNode {
  long values[2],cost_min;
  char final,exists;
  TNode*parent,*children[2];
  TDoc*doc;
};
long findmincost(TNode*node,long v,long w) {
  if (!node->exists) return(-1);
  if ((w<node->values[0])||(v>node->values[1])) return(-1);
  while (!node->final) {
    int fits[2]={0,0};
    if (node->children[0]->exists)
      if ((v<=node->children[0]->values[1])&&(w>=node->children[0]->values[0]))
      fits[0]=1;
    if (node->children[1]->exists)
      if ((v<=node->children[1]->values[1])&&(w>=node->children[1]->values[0]))
      fits[1]=1;
    if (fits[0]&&fits[1]) {
      if (node->children[0]->cost_min<=node->children[1]->cost_min)
      node=node->children[0];
      else node=node->children[1];
    }
    else if (fits[0]) node=node->children[0];
    else if (fits[1]) node=node->children[1];
    else return(-1);
  }
  long index=node->doc->index;
  node->exists=0; node->cost_min=INF;
  node->values[0]=+INF; node->values[1]=-INF;
  for (node=node->parent; node; node=node->parent) {
    node->exists=node->children[0]->exists||node->children[1]->exists;
    node->cost_min=MIN(node->children[0]->cost_min,node->children[1]->cost_min);
    node->values[0]=MIN(node->children[0]->values[0],node->children[1]->values[0]);
    node->values[1]=MAX(node->children[0]->values[1],node->children[1]->values[1]);
  }
  return(index);
}

long n_docs,n_nodes,n_quests,c_seq;
TDoc*docs;
TNode*nodes,*root;
long*seq;

int main(void) {
  #ifdef ONLINE
  freopen("docs.in","rt",stdin);
  freopen("docs.out","wt",stdout);
  #endif
  long i,j;
  scanf("%ld",&n_docs);
  docs=new TDoc[n_docs];
  for (i=0; i<n_docs; i++) {
    scanf("%ld%ld",&docs[i].value,&docs[i].cost);
    docs[i].index=i;
  }
  sort(docs,n_docs);
  nodes=new TNode[n_docs<<2];
  for (n_nodes=0; n_nodes<n_docs; n_nodes++) {
    nodes[n_nodes].values[0]=nodes[n_nodes].values[1]=docs[n_nodes].value;
    nodes[n_nodes].cost_min=docs[n_nodes].cost;
    nodes[n_nodes].final=1; nodes[n_nodes].exists=1;
    nodes[n_nodes].parent=0;
    nodes[n_nodes].children[0]=nodes[n_nodes].children[1]=0;
    nodes[n_nodes].doc=&docs[n_nodes];
  }
  for (i=1; i<n_nodes; i<<=1);
  for (; n_nodes<i; n_nodes++) {
    nodes[n_nodes].values[0]=+INF; nodes[n_nodes].values[1]=-INF;
    nodes[n_nodes].cost_min=INF;
    nodes[n_nodes].final=1; nodes[n_nodes].exists=0;
    nodes[n_nodes].parent=0;
    nodes[n_nodes].children[0]=nodes[n_nodes].children[1]=0;
    nodes[n_nodes].doc=0;
  }
  for (i=0,j=1; j<n_nodes; i+=2,j+=2,n_nodes++) {
    nodes[n_nodes].values[0]=MIN(nodes[i].values[0],nodes[j].values[0]);
    nodes[n_nodes].values[1]=MAX(nodes[i].values[1],nodes[j].values[1]);
    nodes[n_nodes].cost_min=MIN(nodes[i].cost_min,nodes[j].cost_min);
    nodes[n_nodes].final=0;
    nodes[n_nodes].exists=nodes[i].exists||nodes[j].exists;
    nodes[n_nodes].parent=0;
    nodes[n_nodes].children[0]=&nodes[i]; nodes[i].parent=&nodes[n_nodes];
    nodes[n_nodes].children[1]=&nodes[j]; nodes[j].parent=&nodes[n_nodes];
    nodes[n_nodes].doc=0;
  }
  root=&nodes[i];
  seq=new long[n_docs];
  c_seq=0;
  scanf("%ld",&n_quests);
  for (i=0; i<n_quests; i++) {
    long v,w;
    scanf("%ld%ld",&v,&w);
    j=findmincost(root,v,w);
    if (j<0) { c_seq=-1; break; }
    seq[c_seq++]=j;
  }
  if (c_seq>=0) {
    for (i=0; i<c_seq; i++) {
      if (i) printf(" ");
      printf("%ld",seq[i]+1);
    } printf("\n");
  } else printf("BOTVA\n");
  delete[]seq;
  delete[]nodes;
  delete[]docs;
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


void heapify(TDoc*a,const long v,const long w) {
  long i,j; TDoc z;
  i=v; j=(v<<1)+1;
  if ((j<w)&&(a[j].value<a[j+1].value)) j++;
  z=a[i];
  while ((j<=w)&&(z.value<a[j].value)) {
    a[i]=a[j];
    i=j; j=(j<<1)+1;
    if ((j<w)&&(a[j].value<a[j+1].value)) j++;
  }
  a[i]=z;
}
void sort(TDoc*a,const long n) {
  long i,j; TDoc z;
  for (i=n>>1,j=n-1; i>0; i--) heapify(a,i,j);
  for (; j>0; j--) {
    heapify(a,i,j);
    z=a[i]; a[i]=a[j]; a[j]=z;
  }
}


