{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'docs.out';
  cinfile = 'docs.in';

  nmax = 100100;

  list = 1 shl 17;

  inf =  maxlongint shr 1;

type
  int = longint;
  real = extended;

  doc = record
          im, co, no : int;
        end;

var
  n, k : int;
  ans : int;

  d : array [0..nmax] of doc;
  tree : array [1..list shl 1] of int;
  an : array [1..nmax] of int;

procedure outdata;
var
  i, j : int;
begin
  for i:= 1 to k do write(an[i],' ');
  writeln;
end;

procedure heapsort;
var
  l, r : int;
  x : doc;

  procedure sift;
  var
    i, j : int;
  begin
    x:= d[l];
    i:= l;
    j:= i shl 1;
    if (j < r) and (d[j].im < d[j+1].im) then inc(j);
    while (j <= r) and (x.im < d[j].im) do
    begin
      d[i]:= d[j];
      i:= j;
      j:= i shl 1;
      if (j < r) and (d[j].im < d[j+1].im) then inc(j);
    end;
    d[i]:= x;
  end;

begin
  r:= n;
  for l:= n shr 1 downto 1 do sift;
  l:= 1;
  for r:= n-1 downto 1 do
  begin
    x:= d[1];
    d[1]:= d[r+1];
    d[r+1]:= x;
    sift;
  end;
end;

procedure change(no, x : int);
var
  i : int;
begin
  d[no].co:= x;
  i:= list+no-1;
  while i > 1 do
  begin
    i:= i shr 1;
    if d[tree[i shl 1]].co < d[tree[i shl 1+1]].co then
      tree[i]:= tree[i shl 1] else tree[i]:= tree[i shl 1 + 1];
  end;
end;

function fmin(x, y : int) : int;
var
  i, j : int;
  min, nmin : int;
begin
  i:= list + x - 1;
  j:= list + y - 1;
  min:= inf;
  nmin:= 0;
  while i <= j do
  begin
    if min > d[tree[i]].co then
    begin
      min:= d[tree[i]].co;
      nmin:= tree[i];
    end;
    if min > d[tree[j]].co then
    begin
      min:= d[tree[j]].co;
      nmin:= tree[j];
    end;
    i:= (i+1) shr 1;
    j:= (j-1) shr 1;
  end;
  fmin:= d[nmin].no;
  if nmin <> 0 then change(nmin,inf);
end;

procedure gentree;
var
  i : int;
begin
  for i:= 1 to list shl 1 do tree[i]:= 0;
  d[0].co:= inf;
  d[0].no:= 0;
  for i:= 1 to n do tree[list+i-1]:= i;
  for i:= list-1 downto 1 do
    if d[tree[i shl 1]].co < d[tree[i shl 1+1]].co then
      tree[i]:= tree[i shl 1] else tree[i]:= tree[i shl 1 + 1];
end;

function bin1(x : int) : int;
var
  l, r, m : int;
begin
  l:= 0;
  r:= n;
  while l + 1 < r do
  begin
    m:= (l+r) shr 1;
    if d[m].im < x then l:= m else r:= m;
  end;
  if d[r].im < x then bin1:= 0 else bin1:= r;
end;

function bin2(x : int) : int;
var
  l, r, m : int;
begin
  l:= 1;
  r:= n+1;
  while l + 1 < r do
  begin
    m:= (l+r) shr 1;
    if d[m].im <= x then l:= m else r:= m;
  end;
  if d[l].im > x then bin2:= 0 else bin2:= l;
end;

procedure solve;
var
  i, j : int;
  x, y : int;
begin
  heapsort;
  gentree;
  read(k);
  for i:= 1 to k do
  begin
    read(x,y);
    x:= bin1(x);
    y:= bin2(y);
    if (x = 0) or (y = 0) then
    begin
      writeln('BOTVA');
      close(output);
      halt(0);
    end;
    an[i]:= fmin(x,y);
    if an[i] = 0 then
    begin
      writeln('BOTVA');
      close(output);
      halt(0);
    end;
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
  for i:= 1 to n do
  begin
    read(d[i].im,d[i].co);
    d[i].no:= i;
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.