{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'sphere.out';
  cinfile = 'sphere.in';

  nmax = 1010;

  eps = 1e-13;
  inf = maxlongint shr 1;

type
  int = longint;
  real = extended;

  point = record
            x, y, z : real;
          end;

var
  n, k : int;
  ans : int;

  p : array [1..nmax] of point;
  u : array [1..nmax] of boolean;
  ds : array [1..nmax] of int;

  b, e : int;
  r, d : real;

procedure outdata;
var
  i, j : int;
begin
  if not u[e] then writeln('-1') else writeln(ds[e]);
end;

function arccos(x : real) : real;
var
  u : real;
begin
  if abs(x) < eps then arccos:= pi/2 else
  begin
    u:= arctan(sqrt(abs(1-x*x))/x);
    if x < eps then u:= u + pi;
    arccos:= u;
  end;
end;

function sqdist(p1, p2 : point) : real;
begin
  sqdist:= sqr(p1.x-p2.x)+sqr(p1.y-p2.y)+sqr(p1.z-p2.z);
end;

procedure width(b : int);
var
  q : array [1..nmax] of int;
  h, t : int;
  i, c : int;
  cs, rs : real;
begin
  fillchar(u,sizeof(u),0);
  fillchar(ds,sizeof(ds),0);
  h:= 1;
  t:= 1;
  q[1]:= b;
  while (h <= t) do
  begin
    c:= q[h];
    inc(h);
    u[c]:= true;
    for i:= 1 to n do
      if not u[i] then
      begin
        cs:= 1 - sqdist(p[c],p[i])/2;
        rs:= arccos(cs);
        if (rs < d + eps) then
        begin
          u[i]:= true;
          inc(t);
          q[t]:= i;
          ds[i]:= ds[c]+1;
        end;
      end;
  end;
end;

procedure solve;
var
  i, j : int;
begin
  width(b);
end;

procedure to_point(var p : point; g1, g2 : real);
begin
  p.x:= r*cos(g1)*cos(g2);
  p.y:= r*cos(g1)*sin(g2);
  p.z:= r*sin(g1);
end;

procedure readdata;
var
  i, j : int;
  ns, ew : char;
  g1, g2 : real;
begin
  read(n);
  read(b,e);
  read(r,d);
  d:= d/r;
  r:= 1;
  for i:= 1 to n do
  begin
    read(g1);
    g1:= (g1/180)*pi;
    read(ns);
    while not (ns in ['N'..'S']) do read(ns);
    if ns = 'S' then g1:= -g1;
    read(g2);
    g2:= (g2/180)*pi;
    read(ew);
    while not (ew in ['E'..'W']) do read(ew);
    if ew = 'W' then g2:= -g2;
    to_point(p[i],g1,g2);
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.