{$I-,Q-,R-,S-,N+}
Const MaxN = 1000;

Type TPoint = Record
                X, Y, Z: Extended;
              End;

Var I, J, N, S1, S2, First, Last: Integer;
    R, D, G1, G2: Extended;
    T1, T2: Char;
    T: array[1..MaxN] of TPoint;
    A: array[1..MaxN, 1..MaxN] of Boolean;
    F, Use: array[1..MaxN] of Integer;

Procedure CountCoors(G1, G2: Extended; var A: TPoint);
Var A1, A2, D: Extended;
Begin
  A1 := G1 / 180 * Pi;
  A2 := G2 / 180 * Pi;
  D := R * Cos(A1);
  A.Z := R * Sin(A1);
  A.X := D * Cos(A2);
  A.Y := D * Sin(A2);
End;

Function Path(A, B: TPoint): Extended;
Var D, C, X: Extended;
Begin
  D := Sqrt(Sqr(A.X - B.X) + Sqr(A.Y - B.Y) + Sqr(A.Z - B.Z));
  C := 1 - Sqr(D / R) / 2;
  If C = 0 Then X := Pi / 2
           Else X := ArcTan(Sqrt(1 - Sqr(C)) / C);
  If C < 0 Then X := X + Pi;
  Path := X * R;
End;

Begin
  Assign(Input, 'sphere.in');
  Assign(Output, 'sphere.out');
  Reset(Input);
  Rewrite(Output);
  Read(N, S1, S2, R, D);
  For I := 1 to N do Begin
    Read(G1);
    Read(T1, T1);
    Read(G2);
    Read(T2, T2);
    If T1 = 'N' Then G1 := - G1;
    If T2 = 'W' Then G2 := - G2;
    CountCoors(G1, G2, T[I]);
    Use[I] := - 1;
  End;
  For I := 1 to N - 1 do
    For J := I + 1 to N do Begin
      A[I, J] := (Path(T[I], T[J]) <= D);
      A[J, I] := A[I, J];
    End;
  F[1] := S1;
  Use[S1] := 0;
  First := 1;
  Last := 1;
  While First <= Last do Begin
    For I := 1 to N do
      If (Use[I] < 0) and A[F[First], I] Then Begin
        Inc(Last);
        Use[I] := Use[F[First]] + 1;
        F[Last] := I;
        If I = S2 Then Begin
          First := Last;
          Break;
        End;
      End;
    Inc(First);
  End;
  Write(Use[S2]);
  Close(Input);
  Close(Output);
End.