{$D-,L-,I-,Q-,R-,S-,N+}
Program pr_b;
const
  inpfile='sphere.in';
  outfile='sphere.out';
  eps=1e-5;
  inf=1e30;
  nm=1005;
type
  City = record
    g1,g2 : Extended;
    t1,t2 : Char;
  end;
  Coord = record
    x,y,z : Extended;
  end;
var
  a : array [1..nm,1..nm] of Extended;
  reb : array [1..nm,1..nm] of Boolean;
  b : array [1..nm] of City;
  c : array [1..nm] of Coord;
  v : array [0..nm] of Extended;
  u : array [1..nm] of Boolean;
  n,s1,s2 : LongInt;
  rad,dist : Extended;
  nul : Coord;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  readln(n,s1,s2,rad,dist);
  for i:=1 to n do
    read(b[i].g1,b[i].t1,b[i].t1,b[i].g2,b[i].t2,b[i].t2);
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  if v[s2]<-eps then writeln(-1)
                else writeln(trunc(v[s2]+0.99));
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(nul,sizeof(nul),0);
  fillchar(reb,sizeof(reb),0);
  fillchar(a,sizeof(a),0);
  fillchar(v,sizeof(v),0);
  fillchar(u,sizeof(u),0);
  fillchar(b,sizeof(b),0);
  fillchar(c,sizeof(c),0);
end;
{}
Procedure FindCoord(b : City; var c : Coord);
var
  alpha,beta : Extended;
begin
  alpha:=b.g1*pi/180;
  beta:=b.g2*pi/180;
  c.x:=abs(rad*sin(beta)*cos(alpha));
  c.y:=abs(rad*sin(alpha));
  c.z:=abs(rad*cos(beta)*cos(alpha));

  if b.t1='N' then begin
    if beta>pi/2+eps then c.z:=-c.z;
    if b.t2='W' then c.x:=-c.x;
  end else begin
    c.y:=-c.y;
    if beta>pi/2+eps then c.z:=-c.z;
    if b.t2='W' then c.x:=-c.x;
  end;
end;
{}
Function Len2(var q,w : Coord) : Extended;
begin
  Len2:=sqr(q.x-w.x)+sqr(q.y-w.y)+sqr(q.z-w.z);
end;
{}
Function Distantion(var q,w : Coord) : Extended;
var
  qw2,v,s,alpha,res : Extended;
begin
  qw2:=Len2(q,w);
  s:=(2*sqr(rad)-qw2)/(2*sqr(rad));
  v:=sqrt(1-sqr(s));

  if abs(s)<eps then alpha:=pi/2
  else begin
    if s>-eps then alpha:=arctan(v/s)
              else alpha:=arctan(v/s)+pi;
  end;

  res:=alpha*rad/dist;
  if res<1+eps then Distantion:=res
               else Distantion:=inf;
end;
{}
Procedure Solve;
var
  i,j,m : LongInt;
begin
  for i:=1 to n do
    FindCoord(b[i],c[i]);

  for i:=1 to n-1 do
    for j:=i+1 to n do begin
      a[i,j]:=Distantion(c[i],c[j]);
      a[j,i]:=a[i,j];
      if a[i,j]<inf-1 then begin
        reb[i,j]:=true;
        reb[j,i]:=true;
      end;
    end;

  for i:=0 to n do v[i]:=inf;
  v[0]:=inf-1;

  v[s1]:=0;
  while not u[s2] do begin
    m:=0;
    for i:=1 to n do
      if not u[i] and (v[i]<v[m]-eps) then m:=i;

    if m=0 then begin
      v[s2]:=-1; Out;
    end;
    u[m]:=true;

    for i:=1 to n do
      if not u[i] and reb[m,i] then begin
        if (v[i]>trunc(v[m]+0.99)+a[m,i]) then
          v[i]:=trunc(v[m]+0.99)+a[m,i];
      end;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.