{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
Program Docs;
Const
     InFile = 'docs.in';
     OutFile = 'docs.out';
     MaxSize = 100000;
Type
    TArray = Array [0..MaxSize] Of LongInt;
    TTree = Array [0..MaxSize] Of Record
     A,BMin,P : LongInt;
     LEnd,REnd : LongInt;
    End;
Var
   L,M,N : LongInt;
   A,B,C,D : TArray;
   T : TTree;
   Res : TArray;

 Procedure ReadData;
  Var
     I : LongInt;
   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (N);
     For I:= 1 To N Do Read (A[I],B[I]);
     Read (M);
     For I:= 1 To M Do Read (C[I],D[I]);
     Close (Input);
   End;

 Procedure BuildTree (CurNode : LongInt; L,R : LongInt);
  Var
     M : LongInt;
   Begin
     If L = R Then Begin
      T[CurNode].BMin:= B[L];
      T[CurNode].A:= A[L];
      T[CurNode].P:= L;
      T[2 * CurNode].BMin:= -1; T[2 * CurNode + 1].BMin:= -1;
     End
     Else Begin
      M:= (L + R) Div 2;
      BuildTree (2 * CurNode,L,M);
      BuildTree (2 * CurNode + 1,M + 1,R);
      If (T[2 * CurNode].BMin < T[2 * CurNode + 1].BMin) Or
          (T[2 * CurNode + 1].BMin = -1)
      Then Begin
       T[CurNode].BMin:= T[2 * CurNode].BMin;
       T[CurNode].A:= T[2 * CurNode].A;
       T[CurNode].P:= T[2 * CurNode].P;
      End
      Else Begin
       T[CurNode].BMin:= T[2 * CurNode + 1].BMin;
       T[CurNode].A:= T[2 * CurNode + 1].A;
       T[CurNode].P:= T[2 * CurNode + 1].P;
      End;
     End;
     T[CurNode].LEnd:= L; T[CurNode].REnd:= R;
   End;

 Function FindMin (Node : LongInt; I : LongInt) : LongInt;
  Var
     FindMinL,FindMinR : LongInt;
  Begin
    If T[Node].BMin = -1 Then FindMin:= -1
    Else
     If (T[Node].A >= C[I]) And (T[Node].A <= D[I])
      Then FindMin:= Node
      Else Begin
       FindMinL:= FindMin (2 * Node,I);
       FindMinR:= FindMin (2 * Node + 1,I);
       If (FindMinL = -1) And (FindMinR = -1)
        Then FindMin:= -1
        Else
         If FindMinL = -1 Then FindMin:= FindMinR
         Else
          If FindMinR = -1 Then FindMin:= FindMinL
          Else
           If T[FindMinR].BMin < T[FindMinL].BMin
            Then FindMin:= FindMinR Else FindMin:= FindMinL;
      End;
  End;

 Procedure Delete (CurNode : LongInt);
  Begin
    While (T[2 * CurNode].BMin <> -1) Or (T[2 * CurNode + 1].BMin <> -1) Do
      If T[CurNode].BMin = T[2 * CurNode].BMin
       Then CurNode:= 2 * CurNode
       Else CurNode:= 2 * CurNode + 1;

    T[CurNode].BMin:= -1;
    CurNode:= CurNode Div 2;
    While CurNode > 0 Do Begin
      If (T[2 * CurNode].BMin < T[2 * CurNode + 1].BMin) Or
          (T[2 * CurNode + 1].BMin = -1) Then Begin
       T[CurNode].BMin:= T[2 * CurNode].BMin;
       T[CurNode].A:= T[2 * CurNode].A;
       T[CurNode].P:= T[2 * CurNode].P;
      End
      Else Begin
       T[CurNode].BMin:= T[2 * CurNode + 1].BMin;
       T[CurNode].A:= T[2 * CurNode + 1].A;
       T[CurNode].P:= T[2 * CurNode + 1].P;
      End;
      CurNode:= CurNode Div 2;
    End;
  End;

 Procedure Solve;
  Var
     CurRes,I : LongInt;
   Begin
     BuildTree (1,1,N);
     L:= 0;
     For I:= 1 To M Do Begin
       CurRes:= FindMin (1,I);
       If CurRes = -1 Then Begin
        L:= 0;
        Exit;
       End
       Else Begin
        Inc (L);
        Res[I]:= T[CurRes].P;
        Delete (CurRes);
       End;
     End;
   End;

 Procedure WriteData;
  Var
     I : LongInt;
   Begin
     Assign (Output,OutFile); ReWrite (Output);
     If L < M Then Write ('BOTVA')
     Else
      For I:= 1 To M Do Write (Res[I],' ');
     Close (Output);
   End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.
