{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
Program Sphere;
Const
     InFile = 'sphere.in';
     OutFile = 'sphere.out';
     NMax = 1000;
     Eps = 1E-5;
Var
   N,S1,S2 : LongInt;
   D,R : Extended;
   G1,G2 : Array [0..NMax] Of Real;
   Day : Array [0..NMax,0..NMax] Of LongInt;
   L : Array [0..NMax] Of LongInt;
   Calc : Array [0..NMax] Of Boolean;

 Procedure ReadData;
  Var
     I,J : LongInt;
     T : Char;

   Procedure ReadCh (Var Ch : Char);
    Begin
      Read (Ch);
      While Not (Ch In ['N','S','E','W']) Do Read (Ch);
    End;

   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (N);
     Read (S1,S2);
     Read (R);
     Read (D);
     For I:= 1 To N Do Begin
       Read (G1[I]); ReadCh (T);
       If T = 'S' Then G1[I]:= -G1[I];
       G1[I]:= G1[I] * Pi / 180;
       Read (G2[I]); ReadCh (T);
       If T = 'W' Then G2[I]:= -G2[I];
       G2[I]:= G2[I] * Pi / 180;
       ReadLn;
     End;
     Close (Input);
   End;

 Function LInKM (S1,S2 : LongInt) : Extended;
  Var
     Ang,P,Q,X1,Y1,Z1,X2,Y2,Z2 : Real;
  Begin
    X1:= Cos (G1[S1]) * Cos (G2[S1]);
    Y1:= Cos (G1[S1]) * Sin (G2[S1]);
    Z1:= Sin (G1[S1]);

    X2:= Cos (G1[S2]) * Cos (G2[S2]);
    Y2:= Cos (G1[S2]) * Sin (G2[S2]);
    Z2:= Sin (G1[S2]);

    P:= Sqrt(Sqr(Y1 * Z2 - Y2 * Z1) +
              Sqr(X1 * Z2 - X2 * Z1) +
               Sqr(X1 * Y2 - X2 * Y1));
    Q:= X1 * X2 + Y1 * Y2 + Z1 * Z2;

    If Abs(Q) < Eps Then
     If P > Eps Then Ang:= Pi / 2
     Else
      If P < -Eps Then Ang:= -Pi / 2
      Else Ang:= 0
    Else
     If Q > Eps Then Ang:= ArcTan (P / Q)
     Else
      If Q < - Eps Then
       If P > -Eps Then Ang:= ArcTan(P / Q) + Pi
       Else
        If P < Eps Then Ang:= ArcTan(P / Q) - Pi;

    LInKM:= R * Ang;
  End;

 Procedure Solve;

  Var
     Cur,I,J,Min : LongInt;
     CurL : Extended;
     F : Boolean;
   Begin
     For I:= 1 To N Do
       For J:= 1 To N Do Begin
         CurL:= LInKM (I,J);
         If CurL > D - Eps Then Day[I,J]:= 1
         Else Day[I,J]:= -1;
       End;

     For I:= 1 To N Do Begin
       L[I]:= -1;
       Calc[I]:= False;
     End;

     L[S1]:= 0; Calc[S1]:= True;
     F:= True;
     Cur:= S1;
     While (Cur <> S2) And F Do Begin
       F:= False;
       For I:= 1 To N Do
         If Day[Cur,I] > 0 Then
          If (L[I] = -1) Or (L[I] > L[Cur] + Day[Cur,I])
           Then L[I]:= L[Cur] + Day[Cur,I];
       Min:= 0;
       L[Min]:= -1;
       For I:= 1 To N Do
         If (L[I] > 0) Then
          If (Not Calc[I]) Then
           If (L[I] < L[Min]) Or (L[Min] = -1) Then Min:= I;
       If L[Min] > 0 Then Begin
        Cur:= Min;
        Calc[Cur]:= True;
        F:= True;
       End;
     End;
   End;

 Procedure WriteData;
  Begin
    Assign (Output,OutFile); ReWrite (Output);
    Write (L[S2]);
    Close (Output);
  End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.

