{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 50000,0,655360}

Const INPUTFILE='sphere.in';
      OUTPUTFILE='sphere.out';

Const MaxN=1010;
Const EPS=1E-7;

Type Real=Extended;
     Point=record
     x,y,z:Real;
     end;
     Town=record
     G1:Real;
     T1:Char;
     G2:Real;
     T2:Char;
     end;

Function REqual(a,b:Real):Boolean;
begin
REqual:=(Abs(a-b)<EPS);
end;

Function RMore(a,b:Real):Boolean;
begin
RMore:=(a-b)>EPS;
end;

Function RLess(a,b:Real):Boolean;
begin
RLess:=(b-a)>EPS;
end;

var a:Array[1..MaxN,1..MaxN] of Longint;
    Towns:Array[1..MaxN] of Town;
    Points:Array[1..MaxN] of Point;
    N:Longint;
    S1,S2:Longint;
    R,D:Real;
    i,j:Longint;

Procedure FRead;
var ch:Char;
begin
Assign(Input,INPUTFILE);
Reset(Input);
Read(N,S1,S2,R,D);
for i:=1 to N do
begin
  Read(Towns[i].G1);
  Towns[i].G1:=Towns[i].G1/180*Pi;
  Repeat Read(Towns[i].T1) Until Towns[i].T1<>' ';
  Read(Towns[i].G2);
  Towns[i].G2:=Towns[i].G2/180*Pi;
  Repeat Read(Towns[i].T2) Until Towns[i].T2<>' ';

end;

Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OUTPUTFILE);
Rewrite(Output);
Writeln(Answer);

Close(Output);
Halt;
end;

Procedure GetPoint(i:Longint;var p:Point);
begin
p.z:=R*sin(Towns[i].G1);
if Towns[i].T1='S' then p.z:=-p.z;
p.y:=Sqrt(Sqr(R)-Sqr(p.z))*cos(Towns[i].G2);
p.x:=Sqrt(Sqr(R)-Sqr(p.z)-Sqr(p.y));
if Towns[i].T2='W' then p.x:=-p.x;
end;

Function Dist(i,j:Longint):Real;
var p1,p2:Point;
    di:Real;
    CosP,P:Real;
begin
p1:=Points[i];
p2:=Points[j];
di:=Sqr(p1.x-p2.x)+Sqr(p1.y-p2.y)+Sqr(p1.z-p2.z);
CosP:=1-di/2/Sqr(R);
if REqual(CosP,-1) then
  P:=Pi
else if REqual(CosP,0) then
  P:=Pi/2
else
  P:=Arctan(Sqrt(1-Sqr(CosP))/CosP);
if RLess(P,0) then P:=P+Pi;
Dist:=R*Abs(P);
end;


var Que:Array[1..MaxN] of Longint;
    Were:Array[1..MaxN] of Boolean;
    Days:Array[1..MaxN] of Longint;
    Cur,Last:Longint;

Procedure Solve;
begin
FillChar(Points,SizeOf(Points),0);
for i:=1 to N do
  GetPoint(i,Points[i]);
FillChar(a,SizeOf(a),0);
for i:=1 to N do
begin
  for j:=i+1 to N do
    if RMore(Dist(i,j),D)=False then
    begin
      a[i,j]:=1;
      a[j,i]:=1;
    end;
end;

FillChar(Were,SizeOf(Were),False);
FillChar(Days,SizeOf(Days),0);
Were[S1]:=True;
Que[1]:=S1;
Cur:=1;
Last:=1;
Repeat
  for i:=1 to N do
    if (a[i,Que[Cur]]=1) AND (Were[i]=False) then
    begin
      Inc(Last);
      Que[Last]:=i;
      Were[i]:=True;
      Days[i]:=Days[Que[Cur]]+1;
    end;
  Inc(Cur);
Until Cur>Last;
if Were[S2]=False then FWrite(-1);
FWrite(Days[S2]);
end;

begin
FRead;
Solve;
end.