const
  MaxN = {1000}100005;
  RMQlen = {1024*2}131072*2;

procedure Swap(var a,b: longint);
var c: longint;
begin
  c:=a; a:=b; b:=c;
end;

var
  fi, fo: text;
  n,m: longint;
  a,b,ls: array[0..MaxN] of longint;
  rmq: array[1..RMQLen] of longint;
  n2: longint;

procedure sort(l,r: longint);
var
  i,j,x: longint;
begin
  i:=l;
  j:=r;
  x:=a[rmq[(l+r) div 2]];
  repeat
    while a[rmq[i]]<x do inc(i);
    while x<a[rmq[j]] do dec(j);
    if not(i>j) then begin
      ls[rmq[i]]:=j;
      ls[rmq[j]]:=i;
      Swap(rmq[i],rmq[j]);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

function idMin(x,y: longint): longint;
begin
  if b[x]<=b[y] then idMin:=x else idMin:=y;
end;

function FindL(x: longint): longint;
var l,r,m: longint;
begin
  l:=n2;
  r:=n2+n-1;
  if a[rmq[l]]>=x then begin
    FindL:=l;
    exit;
  end;
  if a[rmq[r]]<x then begin
    FindL:=-1;
    exit;
  end;
  while l+1<r do begin
    m:=(l+r) div 2;
    if a[rmq[m]]>=x then r:=m else l:=m;
  end;
  FindL:=r;
end;

function FindR(x: longint): longint;
var l,r,m: longint;
begin
  l:=n2;
  r:=n2+n-1;
  if a[rmq[r]]<=x then begin
    FindR:=r;
    exit;
  end;
  if a[rmq[l]]>x then begin
    FindR:=-1;
    exit;
  end;
  while l+1<r do begin
    m:=(l+r) div 2;
    if a[rmq[m]]<=x then l:=m else r:=m;
  end;
  FindR:=l;
end;

var
  res: boolean;
  ra: array[1..MaxN] of longint;
  rn: longint;

function Check(x,y: longint): boolean;
var i,j,min_id: longint;
begin
  Check:=false;
  i:=FindL(x);
  j:=FindR(y);
  if (i=-1) or (j=-1) or (i>j) then exit;
  min_id:=rmq[i];
  while i<j do begin
     if b[rmq[i]]<b[min_id] then min_id:=rmq[i];
     if b[rmq[j]]<b[min_id] then min_id:=rmq[j];
     i:=(i+1) div 2;
     j:=(j-1) div 2;
  end;
  if b[min_id]=MaxLongint then exit;
  inc(rn);
  ra[rn]:=min_id;
  b[min_id]:=MaxLongint;
  i:=ls[min_id] div 2;
  while i>0 do begin
    rmq[i]:=idMin(rmq[2*i],rmq[2*i+1]);
    i:=i div 2;
  end;
  Check:=true;
end;

procedure Solve;
var i,x,y: longint;
begin
  sort(n2,n2+n-1);
  For i:=n2-1 downto 1 do
    rmq[i]:=idMin(rmq[2*i],rmq[2*i+1]);
  res:=true;
  Read(fi,m);
  For i:=1 to m do begin
    Read(fi,x,y);
    if not Check(x,y) then begin
      res:=false;
      break;
    end;
  end;
end;

procedure Init;
var i: longint;
begin
  Assign(fi,'docs.in');
  Assign(fo,'docs.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,n);
  n2:=1;
  while n2<n do
    n2:=n2*2;
  For i:=1 to n do begin
    Read(fi,a[i],b[i]);
    rmq[n2+i-1]:=i;
    ls[i]:=n2+i-1;
  end;
  b[0]:=MaxLongint;
end;

procedure Done;
var i: longint;
begin
  if res then begin
    For i:=1 to rn do
      Write(fo,ra[i],' ');
  end else WriteLn(fo,'BOTVA');
  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
