type
  float = extended;

const
  MaxN = 1500;
  eps = 1e-10;

var
  fi, fo: text;

function ArcCos(x: float): float;
begin
  if x=0 then ArcCos:=pi/2 else
    if x>0 then ArcCos:=ArcTan(sqrt(1-sqr(x))/x) else
      if x<0 then ArcCos:=pi+ArcTan(sqrt(1-sqr(x))/x);
end;

function dist(a1,b1,a2,b2,r: float): float;
var x1,y1,z1,x2,y2,z2,t: float;
begin
  t:=cos(a1);
  x1:=cos(b1)*t;
  y1:=sin(b1)*t;
  z1:=sin(a1);
  t:=cos(a2);
  x2:=cos(b2)*t;
  y2:=sin(b2)*t;
  z2:=sin(a2);
  t:=x1*x2+y1*y2+z1*z2;
  t:=ArcCos(t);
  dist:=t*r;
end;

var
  cs: array[1..MaxN,1..2] of float;
  N,s1,s2: integer;
  r,d: float;
  a: array[1..MaxN,1..MaxN] of byte;
  b: array[1..MaxN] of integer;

const
  qlen = MaxN+1;

var
  q: array[0..qlen-1] of integer;
  qb, qn: integer;

procedure BFS(v: integer);
var i: integer;
begin
  qb:=0; qn:=1;
  q[0]:=v;
  while qn>0 do begin
    v:=q[qb]; qb:=(qb+1) mod qlen; dec(qn);
    for i:=1 to n do
      if (a[v,i]=1) and (b[i]=-1) then begin
        q[(qb+qn) mod qlen]:=i;
        inc(qn);
        b[i]:=b[v]+1;
      end;
  end;
end;

procedure Solve;
var i,j: integer;
    t: float;
begin
  For i:=1 to n-1 do
    For j:=i+1 to n do begin
      t:=dist(cs[i,1],cs[i,2],cs[j,1],cs[j,2],r);
      if t-d<=eps then a[i,j]:=1;
      a[j,i]:=a[i,j];
    end;
  For i:=1 to n do
    b[i]:=-1;
  b[s1]:=0;
  BFS(s1);
end;

procedure Init;
var i: integer;
    t: float;
    ch: char;
begin
  Assign(fi,'sphere.in');
  Assign(fo,'sphere.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,n,s1,s2,r,d);
  For i:=1 to n do begin
    Read(fi,t);
    ch:=#0;
    while not(ch in ['S','N']) do
      Read(fi,ch);
    if ch='S' then t:=-t;
    cs[i,1]:=(t/180)*pi;

    Read(fi,t);
    ch:=#0;
    while not(ch in ['E','W']) do
      Read(fi,ch);
    if ch='W' then t:=-t;
    cs[i,2]:=(t/180)*pi;
  end;
end;

procedure Done;
begin
  WriteLn(fo,b[s2]);
  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
