{$I-,Q-,R-,S-}
Const
  FIn  = 'sphere.in';
  FOut = 'sphere.out';
{---------------------------------------------------------------------------}
Var
  Input,Output:TEXT;
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=1000;
  MMM=MaxLongInt div 2-1;
  Eps=1E-8;

Type
  TCoo=Extended;
  TMas=array[1..MaxN] of Record
    G1,G2:TCoo; T1,T2:Char;
  end;
  TPixel=Record
    X,Y,Z:TCoo;
  end;

Var
  S1,S2,N:LongInt;
  D,Rad:TCoo;
  Mas:TMas;

  R,R1,R2:LongInt;
  Ch:Char;

  Mat:array[1..MaxN,1..MaxN]of LongInt;

Function Cmp(A,B:TCoo):Boolean;
begin
  Cmp:=abs(A-B)<=Eps;
end;

function sign(x:TCoo):TCoo;
begin
  if x > 0 then sign :=  1.0 else
  if x < 0 then sign := -1.0 else
                sign :=  0.0;
end;

function arcsin(x:TCoo):TCoo;
begin
  if abs(x)>1 then else
  if abs(x) < 0.5 then
    arcsin := arctan(x/sqrt(1-sqr(x))) else
    arcsin := sign(x) * (pi*0.5 - arctan(sqrt(1 / sqr(x) - 1)));
end;

function Arccos(x:TCoo):TCoo;
begin
  arccos:=pi*0.5-arcsin(x);
end;

Procedure Coo(i:LongInt; Var A:TPixel);
Var temp,alpha,beta:TCoo;
begin
  With A do
  begin
    alpha:=Mas[i].G1*Pi/180;
    temp:=Rad*cos(alpha);
    If Mas[i].T1='N' then z:=Rad*sin(alpha) else z:=-1*Rad*sin(alpha);

    if Mas[i].G2>90 then
    begin
      beta:=(Mas[i].G2-90)*Pi/180;
      x:=-1*temp*cos(beta);
    end else
    begin
      beta:=Mas[i].G2*Pi/180;
      x:=temp*cos(beta);
    end;
    If Mas[i].T2='E' then y:=temp*sin(beta) else y:=-1*temp*sin(beta);
  end;
end;

Function IsRas(i,j:LongInt):LongInt;
Var
  A,B,C:TPixel;
  temp,_sin,_cos:TCoo;
begin
  Coo(i,A); Coo(j,B);

  _cos:=(A.x*B.x+A.y*B.y+A.z*B.z)/(Rad*Rad);
  temp:=arccos(_cos)*Rad;

  If temp<D then IsRas:=1 else IsRas:=MMM;
end;

Procedure Floid;
Var i,j,k:LongInt;
begin
  For k:=1 to N do
    For i:=1 to N do
      For j:=1 to N do
        If Mat[i,k]+Mat[k,j]<Mat[i,j] then Mat[i,j]:=Mat[i,k]+Mat[k,j];
end;

begin
  Init;
  {}
  ReadLn(Input,N,S1,S2,Rad,D);
  For R:=1 to N do
    With Mas[R] do
      ReadLn(Input,G1,Ch,T1,Ch,G2,Ch,T2);
  {}
  For R1:=1 to N do
    For R2:=1 to N do
      If R1=R2 then Mat[R1,R2]:=0 else
        Mat[R1,R2]:=IsRas(R1,R2);
  Floid;
  If Mat[S1,S2]=MMM then WriteLn(Output,-1) else WriteLn(Output,Mat[S1,S2]);
  {}
  Done;
end.
