{$I-,Q-,R-,S-}
Const
  FIn  = 'calc.in';
  FOut = 'calc.out';
{---------------------------------------------------------------------------}
Var
  Input,Output:TEXT;
Procedure Init;
begin
  Assign(Input,FIn);
  Assign(Output,FOut);
  Reset(Input);
  Rewrite(Output);
end;
Procedure Done;
begin
  Close(Input);
  Close(Output);
  Halt(0);
end;
{---------------------------------------------------------------------------}
Const
  MaxN=30;
  MaxP=100;
  MaxLen=30;

Type
  TResult=Byte;
  TVars=array['a'..'z']of TResult;
  TOp=array[1..30]of Record
    S:Char;
    Prior:Byte;
    St:String;
  end;
  TExp=String[MaxLen];
  TToken=(_Op,_Var,_Open,_Close,_Const,_Add,_Sub,_Mul,_Div,_End);

Var
  N,M:LongInt;
  P,Ans:TResult;
  Vars:TVars;
  Op:TOp;

  Ch2:Char;
  R,Pr:LongInt;

{-------------------------------}
Function _Add_(A,B:TResult):TResult;
begin
  if A+B>P then _Add_:=A+B-P else _Add_:=A+B;
end;

Function _Sub_(A,B:TResult):TResult;
begin
  if A<B then _Sub_:=A+P-B else _Sub_:=A-B;
end;

Function _Mul_(A,B:TResult):TResult;
Var A1,A2:LongInt;
begin
  A1:=A; A2:=B;
  A1:=(A1*A2) mod P;
  _Mul_:=A1;
end;

Function _Div_(A,B:TResult):TResult;
Var R:LongInt;
begin
  For R:=P-1 downto 1 do
    If (R*B) mod P=A then
    begin
      _Div_:=R;
      Exit;
    end;
  If A mod B<>0 then _Div_:=1+A div B else _Div_:=A div B;
end;
{-------------------------------}
Const
  MaxStack=100*100000;
Var
  Stack:array[1..MaxStack] of Byte;
  SP:LongInt;
Procedure Push(A:Byte);
begin
  {!!!:}
{  if SP=MaxStack then
  begin
    WriteLn('Stack overflow error!!! SP=',SP);
    RunError(202);
  end;}
  {:!!!}
  Inc(SP);
  Stack[SP]:=A;
end;
Function Pop:Byte;
begin
  {!!!:}
{  if SP=0 then
  begin
    WriteLn('Stack overflow error!!! SP=',SP);
    RunError(202);
  end;}
  {:!!!}
  Pop:=Stack[SP];
  Dec(SP);
end;
{-------------------------------}

Var
  Name:Char;
  Num:LongInt;
  Token:TToken;

  From:Boolean; {True=from file,False=from St}
  Ch:Char;
  St:String;
  Pos:LongInt;

Procedure Get;
begin
  If From then
  begin
    If (EOF(Input))or(EOLn(Input)) then Ch:=#0 else Read(Input,Ch);
  end else
  begin
    If Pos>=Length(St) then Ch:=#0 else
    begin
      Inc(Pos);
      Ch:=St[Pos];
    end;
  end;
end;

Procedure GetToken;
begin
  If Ch=#0 then Token:=_End else
  If Ch in ['0'..'9'] then
  begin
    Token:=_Const;
    Num:=0;
    While (Ch in ['0'..'9']) do
    begin
      Num:=Num*10+Ord(Ch)-Ord('0');
      Get;
    end;
  end else
  If Ch in ['a','b','c'..'z'] then
  begin
    Token:=_Var;
    Name:=Ch;
    Get;
  end else
  If Ch in ['+','-','*','/'] then
  begin
    Case Ch of
      '+': Token:=_Add;
      '-': Token:=_Sub;
      '*': Token:=_Mul;
      '/': Token:=_Div;
    end;
    Get;
  end else
  If Ch='(' then
  begin
    Token:=_Open;
    Get;
  end else
  If Ch=')' then
  begin
    Token:=_Close;
    Get;
  end else
  If Ch in [#33..#127] then
  begin
    For R:=1 to N do
      If Op[R].S=Ch then
      begin
        Num:=R;
        Token:=_Op;
        Get;
        Exit;
      end;
    WriteLn('Unknown operation!!!');
    RunError(1);
  end else
  begin
    WriteLn('Unknown symbol in input!!!');
    RunError(1);
  end;
end;

{-------------------------------}

Function Go:TResult; Forward;

Function Eval(What:TExp):TResult;
Var _St:TExp;
begin
  _St:=St; St:=What;

  Push(Pos); Pos:=1;
  Push(Ord(Ch)); Ch:=St[Pos];
  Push(Ord(From)); From:=False;

  Eval:=Go;
  {!!!:}
{  If Token<>_End then
  begin
    WriteLn('Something wrong in the end of line!!!');
    RunError(1);
  end;}
  {:!!!}

  From:= Pop=1;
  Ch:=Chr(Pop);
  Pos:=Pop;

  St:=_St;
end;

Function Go:TResult;
Label 0,1,2,3,4,5,6,7,8, 9,10,11, 13,14;
Var Level:Byte; C:TResult;
begin
  Push(0);
  Level:=0;
0:
  Level:=Level+1;

  if Level=21 then
  begin
    Push(13);

13:
    GetToken;
    If Token=_Const then C:=Num else
    If Token=_Open then
    begin
      {C:=Go(0);}
      Level:=0;
      Push(8);
      Goto 0;
8:
      Level:=21;
    end else
    If Token=_Var then C:=Vars[Name] else
    If Token=_Op then
    begin
{      Temp:=Num;
      Vars['a']:=Level21;
      Level21:=Eval(Op[Temp].St);}
      Push(Num);
      Push(14);
      Goto 13;
14:
      Vars['a']:=C;
      C:=Eval(Op[Pop].St);
    end else
    begin
      WriteLn('Something wrong in the level21!!!');
      RunError(1);
    end;
    GetToken;
    If Pop=14 then Goto 14;
  end else
  if Level=5 then
  begin
    {C:=Go(Level);}
    Push(1);
    Goto 0;
1:

    While (Token=_Add)or(Token=_Sub)or(Token=_Op) do
    begin
      If Token=_Add then
      begin
        {C:=_Add_(C,Go(Level))}
        Push(C);
        Push(4);
        Goto 0;
4:
        C:=_Add_(Pop,C);
      end else
      If Token=_Sub then
      begin
        {C:=_Sub_(C,Go(Level))}
        Push(C);
        Push(5);
        Goto 0;
5:
        C:=_Sub_(Pop,C)
      end else
      If Token=_Op then
      begin
        If Op[Num].Prior=Level then
        begin
          {R:=Num;
          Vars['a']:=C;
          Vars['b']:=Go(Level);
          C:=Eval(Op[R].St);}
          Push(Num);
          Vars['a']:=C;
          Push(9);
          Goto 0;
9:
          Vars['b']:=C;
          C:=Eval(Op[Pop].St);
        end else Break;
      end;
    end;
  end else
  if Level=15 then
  begin
    {C:=Go(Level);}
    Push(2);
    Goto 0;
2:

    While (Token=_Mul)or(Token=_Div)or(Token=_Op) do
    begin
      If Token=_Mul then
      begin
        {C:=_Mul_(C,Go(Level))}
        Push(C);
        Push(6);
        Goto 0;
6:
        C:=_Mul_(Pop,C)
      end else
      If Token=_Div then
      begin
        {C:=_Div_(C,Go(Level))}
        Push(C);
        Push(7);
        Goto 0;
7:
        C:=_Div_(Pop,C)
      end else
      If Token=_Op then
      begin
        If Op[Num].Prior=Level then
        begin
          {R:=Num;
          Vars['a']:=C;
          Vars['b']:=Go(Level);
          C:=Eval(Op[R].St);}
          Push(Num);
          Vars['a']:=C;
          Push(10);
          Goto 0;
10:
          Vars['b']:=C;
          C:=Eval(Op[Pop].St);
        end else Break;
      end;
    end;
  end else
  begin
    {C:=Go(Level);}
    Push(3);
    Goto 0;
3:

    While (Token=_Op) do
      If Op[Num].Prior=Level then
      begin
        {R:=Num;
        Vars['a']:=C;
        Vars['b']:=Go(Level);
        C:=Eval(Op[R].St);}
        Push(Num);
        Vars['a']:=C;
        Push(11);
        Goto 0;
11:
        Vars['b']:=C;
        C:=Eval(Op[Pop].St);
      end else Break;
  end;
  Go:=C;

  Level:=Level-1;
  Case Pop of
    0:Exit;
    1:Goto 1;
    2:Goto 2;
    3:Goto 3;
    4:Goto 4;
    5:Goto 5;
    6:Goto 6;
    7:Goto 7;
    8:Goto 8;
    9:Goto 9;
    10:Goto 10;
    11:Goto 11;
  end;
end;

{-------------------------------}

begin
  SP:=0;
  Init;
  {}
  ReadLn(Input,P);
  ReadLn(Input,N);
  For R:=1 to N do
    With Op[R] do
    begin
      Read(Input,Ch);
      Case Ch of
        'U':begin
          Read(Input,Ch2); {#32}
          Read(Input,Ch);
          Read(Input,Ch2); {a}
          Read(Input,Ch2); {=}
          S:=Ch;
          Prior:=20;
          ReadLn(Input,St);
        end;
        'B':begin
          Read(Input,Ch2); {#32}
          Read(Input,Pr);
          Prior:=Pr;
          Read(Input,Ch2); {#32}
          Read(Input,Ch2); {a}
          Read(Input,Ch);
          S:=Ch;
          Read(Input,Ch2); {b}
          Read(Input,Ch2); {=}
          ReadLn(Input,St);
        end;
      end;
    end;
  ReadLn(Input,M);
  For R:=1 to M do
  begin
    Read(Input,Ch);
    Read(Input,Ch2); {=}
    ReadLn(Input,Vars[Ch]);
  end;
  {}
  Read(Input,Ch); From:=True;
  Ans:=Go;

  {!!!:}
{  If Token<>_End then
  begin
    WriteLn('Something wrong in the end of line!!!');
    RunError(1);
  end;
  If SP<>0 then
  begin
    WriteLn('Something wrong with STACK!!!');
    RunError(1);
  end;}
  {:!!!}

  WriteLn(Output,Ans);
  Done;
end.