const
  MaxN = 100000;

type
  PTree = ^TTree;
  TTree = record
             x,y,index,min : longint;
             l,r           : PTree;
           end;

var
  gmin         : longint;
  stack        : array [1..maxn] of longint;
  res          : longint;
  min1         : longint;
  index        : array [1..MaxN] of longint;
  a1,b1        : longint;
  ind,q,cost,r : longint;
  a,b          : array [1..MaxN] of longint;
  Tree         : PTree;
  c,d,m,n,i,j  : longint;

procedure init;
begin
  res:=0;
  assign(input,'docs.in'); reset(input);
  assign(output,'docs.out'); rewrite(output);
  readln(n);
  for i:=1 to n do read(a[i],b[i]);
  read(m);
end;

procedure BuildTree(var v : PTree; a,b : longint);
begin
  new(v);
  v^.l:=nil; v^.r:=nil; v^.index:=0; v^.min:=maxlongint;
  v^.x:=a; v^.y:=b;
  if a<>b then
  begin
    BuildTree(v^.l,a,a+(b-a) div 2);
    BuildTree(v^.r,a+(b-a) div 2+1,b);
  end;
end;

function Minimum(q,w : longint) : longint;
begin
  if q<w then minimum:=q else minimum:=w;
end;

procedure GetMin(var v : Ptree; a,b : longint);
begin
  if (v^.x=a)and(v^.y=b) then
  begin
    if v^.min<gmin then
    begin
      GMin:=v^.min;
      ind:=v^.index;
      exit;
    end;
  end else
  begin
    if (a>=v^.l^.x)and(b<=v^.l^.y) then GetMin(v^.l,a,b) else
    if (a>=v^.r^.x)and(b<=v^.r^.y) then GetMin(v^.r,a,b) else
    begin
      GetMin(v^.l,a,v^.l^.y);
      GetMin(v^.r,v^.r^.x,b);
    end;
  end;
end;

procedure ChangeKey(var v : Ptree);
begin
  if (v^.x=q)and(v^.y=q) then v^.min:=cost else
  begin
    if (q>=v^.l^.x)and(q<=v^.l^.y) then ChangeKey(v^.l) else ChangeKey(v^.r);
  end;
  if not((v^.x=q)and(v^.y=q)) then
  begin
    if v^.r^.min<v^.l^.min then
    begin
      v^.min:=v^.r^.min;
      v^.index:=v^.r^.index;
    end else
    begin
      v^.min:=v^.l^.min;
      v^.index:=v^.l^.index;
    end;
  end;
end;

procedure AddKey(var v : PTree);
begin
  if v^.min>cost then
  begin
    v^.min:=cost;
    v^.index:=i;
  end;
  if not((q=v^.x)and(q=v^.y)) then
    if (q>=v^.l^.x)and(q<=v^.l^.y) then AddKey(v^.l) else AddKey(v^.r);
end;

procedure KillTree(var v : PTree);
begin
  if not(v^.l=nil)and(v^.r=nil) then
  begin
    if v^.l<>nil then
      if (v^.l^.l=nil)and(v^.l^.r=nil) then dispose(v^.l) else KillTree(v^.l);
    if v^.r<>nil then
      if (v^.r^.l=nil)and(v^.r^.r=nil) then dispose(v^.r) else KillTree(v^.r);
  end;
end;

procedure Sort(l, r: Integer);
var
  i, j, x, y: longint;
begin
  i := l; j := r; x := a[(l+r) DIV 2];
  repeat
    while a[i] < x do i := i + 1;
    while x < a[j] do j := j - 1;
    if i <= j then
    begin
      y := a[i]; a[i] := a[j]; a[j] := y;
      y := b[i]; b[i] := b[j]; b[j] := y;
      y := index[i]; index[i] := index[j]; index[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure Find(ac,bc : longint);
var
  q,l,r : longint;

begin
  l:=1; r:=n; a1:=0; b1:=0;
  while (r-l)>1 do
  begin
    q:=(l+r) div 2;
    if a[q]<ac then l:=q else
    if a[q]>ac then r:=q else
    begin
      a1:=q;
      break;
    end;
  end;
  if a1=0 then
  begin
    if a[l]>=ac then a1:=l else a1:=r;
  end;
  l:=1; r:=n;
  while (r-l)>1 do
  begin
    q:=(l+r) div 2;
    if a[q]<bc then l:=q else
    if a[q]>bc then r:=q else
    begin
      b1:=q;
      break;
    end;
  end;
  if b1=0 then
  begin
    if a[r]<=bc then b1:=r else b1:=l;
  end;
end;

begin
  init;
  for i:=1 to n do index[i]:=i;
  Sort(1,n);
  new(Tree);
  Tree^.l:=nil; Tree^.r:=nil; Tree^.index:=0; Tree^.min:=maxlongint;
  Tree^.x:=1; Tree^.y:=n;
  BuildTree(Tree^.l,1,n div 2);
  BuildTree(Tree^.r,n div 2 +1,n);
  for i:=1 to n do
  begin
    q:=i; cost:=b[i];
    AddKey(Tree);
  end;
  min1:=0;
  for i:=1 to m do
  begin
    read(c,d);
    Find(c,d);
    if a1=b1 then
      if (a[a1]>d)or(a[b1]<c) then
      begin
        writeln('BOTVA');
        KillTree(tree);
        close(output);
        halt;
      end;
    if a1>b1 then
    begin
        writeln('BOTVA');
        KillTree(tree);
        close(output);
        halt;
    end;
    gmin:=maxlongint;
    GetMin(Tree,a1,b1);
    if gmin=maxlongint then
    begin
      writeln('BOTVA');
      KillTree(tree);
      close(output);
      halt;
    end;
    res:=res+1;
    stack[res]:=index[ind];
    q:=ind; cost:=maxlongint;
    ChangeKey(Tree);
  end;
  for i:=1 to res do writeln(stack[i]);
  KillTree(Tree);
  dispose(Tree);
  close(output);
end.
