const
  MaxN = 1000;

type
  TPoint = record x,y,z : extended; end;

var
  ok          : boolean;
  res         : integer;
  use         : array [1..MaxN] of boolean;
  center      : TPoint;
  a           : array [1..MaxN,1..MaxN] of 0..1;
  ch          : char;
  c           : array [1..1000] of TPoint;
  dist,d,r    : extended;
  n,s1,s2,i,j : integer;

procedure init;
begin
  assign(input,'sphere.in'); reset(input);
  assign(output,'sphere.out'); rewrite(output);
  read(n,s1,s2,r,d);
  center.x:=0; center.y:=0; center.z:=-r;
  fillchar(a,sizeof(a),0);
  for i:=1 to n do c[i].z:=0;
  for i:=1 to n do
  begin
    read(c[i].y);
    read(ch);
    while not((ch='N')or(ch='S')) do read(ch);
    if ch='S' then c[i].y:=-c[i].y;
    read(ch);
    read(c[i].x);
    read(ch);
    while not((ch='W')or(ch='E')) do read(ch);
    if ch='E' then c[i].x:=-c[i].x;
{    with c[i] do
    begin
      if y>0 then y:=y*2 else y:=y/2;
      x:=(2*pi*r)*(x/360);
      y:=(2*pi*r)*(y/360);
    end;}
    readln;
  end;
  close(input);
end;

function More(q,w : extended) : boolean;
begin
  More:=(q-w)>=(1e-10);
end;

function Eq(q,w : extended) : boolean;
begin
  Eq:=abs(q-w)<=1e-10;
end;

function GetAngle(q1,q2 : integer) : extended;
var
  sin,cos,tan,arct : comp;

begin
  cos:=(c[q1].x*c[q2].x+c[q1].y*c[q2].y)/sqr(r);
  sin:=sqrt(1-sqr(cos));
  if Eq(cos,0) then
  begin
    GetAngle:=90.0;
    exit;
  end;
  tan:=sin/cos;
  arct:=arctan(tan)*180/pi;
  arct:=abs(arct);
  if More(arct,(360-arct)) then arct:=360-arct;
  GetAngle:=arct;
end;

function GetDist(q,w : integer) : extended;
var
  angle : extended;

begin
  angle:=GetAngle(q,w);
  GetDist:=(pi*r)/180*Angle;
end;

procedure BFS;
var
  t       : array [1..MaxN] of record v,q : longint; end;
  down,up : longint;
  i       : integer;

begin
  res:=-1;
  for i:=1 to n do
  begin
    t[i].v:=0; t[i].q:=0;
    use[i]:=false;
  end;
  down:=1; up:=2;
  t[down].v:=s1;
  use[s1]:=true;
  while down<up do
  begin
    for i:=1 to n do
      if use[i]=false then
        if a[t[down].v,i]=1 then
        begin
          t[up].v:=i;
          t[up].q:=t[down].q+1;
          up:=up+1;
          if i=s2 then
          begin
            ok:=true;
            res:=t[up-1].q;
            exit;
          end;
        end;
    down:=down+1;
  end;
end;

begin
  init;
  for i:=1 to n-1 do
    for j:=i+1 to n do
    begin
      dist:=GetDist(i,j);
      if More(d,Dist) then
      begin
        a[i,j]:=1;
        a[j,i]:=1;
      end;
    end;
  res:=-1; ok:=false;
  BFS;
  write(res);
{ for i:=1 to n do
  writeln(sqrt(sqr(c[i].x)+sqr(c[i].y)+sqr(r)):0:3);}
  close(output);
end.


