const
     FileIn='docs.in';
     FileOut='docs.out';
     MaxN=100000;
     MaxM=100000;
var
   N, M: LongInt;
   A, B: array [1..MaxN] of LongInt;
   C, D: array [1..MaxM] of LongInt;

   Indexes: array [1..MaxN] of LongInt;
   Used: array [1..MaxN] of Boolean;

   Answer: Boolean;
   OutDocuments: array [1..MaxM] of LongInt;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, N);
     for NItem:=1 to N
         do Read (F, A [NItem], B [NItem]);
     Read (F, M);
     for NItem:=1 to M
         do Read (F, C [NItem], D [NItem]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NEvent: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if Answer
        then begin
             for NEvent:=1 to M-1
                 do Write (F, OutDocuments [NEvent], #32);
             Writeln (F, OutDocuments [M]);
        end
        else Writeln (F, 'BOTVA');
     Close (F);
end;

procedure QSort (aLeft, aRight: LongInt);
var
   i, j: LongInt;
   MiddleKey: LongInt;
   T: LongInt;
begin
     i:=aLeft;
     j:=aRight;
     MiddleKey:=A [Indexes [(aLeft+aRight) div 2]];
     repeat
           while A [Indexes [i]]<MiddleKey
                 do Inc (i);
           while MiddleKey<A [Indexes [j]]
                 do Dec (j);
           if i<=j
              then begin
                   T:=Indexes [i];
                   Indexes [i]:=Indexes [j];
                   Indexes [j]:=T;
                   Inc (i);
                   Dec (j);
              end;
     until i>j;
     if aLeft<j
        then QSort (aLeft, j);
     if i<aRight
        then QSort (i, aRIght);
end;

function Search (aValue: LongInt): LongInt;
var
   Left, Right, Middle: LongInt;
begin
     Left:=1;
     Right:=N;
     Middle:=(Left+Right) div 2;
     repeat
           if A [Indexes [Middle]]<aValue
              then Left:=Middle+1
              else if A [Indexes [Middle]]>aValue
                      then Right:=Middle-1
                      else begin
                           Right:=Middle;
                           Left:=Right+1;
                      end;
     until Left>=Right;
     Search:=Right;
end;

procedure Solve;
var
   Index, BestIndex: LongInt;
   NEvent: LongInt;
begin
     if N<M
        then Answer:=false
        else begin
             for Index:=1 to N
                 do Indexes [Index]:=Index;
             QSort (1, N);
             Answer:=true;
             FillChar (Used, SizeOf (Used), false);
             for NEvent:=1 to M
                 do begin
                    BestIndex:=0;
                    Index:=Search (C [NEvent]);
                    if Index<1
                       then Index:=1;
                    while (Index<=N) and (A [Indexes [Index]]<=D [NEvent])
                          do begin
                             if ((BestIndex=0) or (B [Indexes [Index]]<B [Indexes [BestIndex]])) and
                                (C [NEvent]<=A [Indexes [Index]]) and (not Used [Index])
                                then BestIndex:=Index;
                             Inc (Index);
                          end;
                    if BestIndex=0
                       then begin
                            Answer:=false;
                            Exit;
                       end
                       else begin
                            OutDocuments [NEvent]:=Indexes [BestIndex];
                            Used [BestIndex]:=true;
                       end;
                 end;
        end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
