{$H+}
uses Objects;
const
     FileIn='calc.in';
     FileOut='calc.out';
     MaxN=30;
type
    TOperation=record
                     Binary: Boolean;
                     PriorityLevel: LongInt;
                     Symbol: Char;
                     Expression: string;
               end;
var
   p: LongInt;
   N: LongInt;
   Operations: array [1..MaxN] of TOperation;
   M: LongInt;
   Variables: array ['c'..'z'] of LongInt;
   GlobalExpression: string;

   Priority: array [#33..#127] of LongInt;
   Indexes: array [#33..#127] of LongInt;

   Answer: LongInt;

procedure ReadData;
var
   F: Text;
   NOperation: LongInt;
   Ch, VarCh: Char;
   NVariable: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, p);
     Readln (F, N);
     for NOperation:=1 to N
         do with Operations [NOperation]
                 do begin
                    Read (F, Ch);
                    Binary:=Ch='B';
                    if Binary
                       then Read (F, PriorityLevel);
                    Read (F, Ch);
                    if Binary
                       then Read (F, Ch);
                    Read (F, Symbol);
                    Read (F, Ch);
                    Read (F, Ch);
                    Readln (F, Expression);
                    if not Binary
                       then PriorityLevel:=20;
                    Priority [Symbol]:=PriorityLevel;
                    Indexes [Symbol]:=NOperation;
                 end;
     Readln (F, M);
     for NVariable:=1 to M
         do begin
            Read (F, VarCh);
            Read (F, Ch);
            Readln (F, Variables [VarCh]);
         end;
     Readln (F, GlobalExpression);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

type
    PEvaluator=^TEvaluator;
    TEvaluator=object (TObject)
                     Expression: string;
                     A, B: LongInt;

                     NChar: LongInt;

                     constructor Init (const aExpression: string);

                     function BracketEval: LongInt;
                     function Eval: LongInt;
               end;

constructor TEvaluator.Init (const aExpression: string);
begin
     inherited Init;

     Expression:=aExpression;
end;

function TEvaluator.BracketEval: LongInt;
type
    TState=record
                 Level: LongInt;
                 Value: LongInt;
                 HasArgument: Boolean;
                 Argument: LongInt;
                 Operation: Char;
           end;
var
   States: array [1..30] of TState;
   StateIndex: LongInt;

function Division (aA, aB: LongInt): LongInt;
var
   C: LongInt;
begin
     for C:=0 to p-1
         do if (C*aB) mod p=aA
               then Break;
     Division:=C;
end;

procedure Apply;
var
   Ev: PEvaluator;
begin
     case States [StateIndex].Operation of
          '=': States [StateIndex].Value:=States [StateIndex].Argument;
          '+': Inc (States [StateIndex].Value, States [StateIndex].Argument);
          '-': begin
                    Dec (States [StateIndex].Value, States [StateIndex].Argument);
                    if States [StateIndex].Value<0
                       then Inc (States [StateIndex].Value, p);
               end;
          '*': States [StateIndex].Value:=States [StateIndex].Value*States [StateIndex].Argument;
          '/': Division (States [StateIndex].Value, States [StateIndex].Argument);
          else begin
               Ev:=New (PEvaluator, Init (Operations [Indexes [States [StateIndex].Operation]].Expression));
               if Operations [Indexes [States [StateIndex].Operation]].Binary
                  then begin
                       Ev^.A:=States [StateIndex].Value;
                       Ev^.B:=States [StateIndex].Argument;
                  end
                  else Ev^.A:=States [StateIndex].Argument;
               States [StateIndex].Value:=Ev^.Eval;
               Dispose (Ev, Done);
          end;
     end;
     States [StateIndex].Value:=States [StateIndex].Value mod p;
     States [StateIndex].HasArgument:=false;
end;

begin
     StateIndex:=1;
     States [StateIndex].Level:=0;
     States [StateIndex].Operation:='=';
     States [StateIndex].HasArgument:=false;
     while NChar<=Length (Expression)
           do case Expression [NChar] of
                   '(': begin
                             if States [StateIndex].HasArgument
                                then Apply;
                             Inc (NChar);
                             States [StateIndex].Argument:=BracketEval();
                             States [StateIndex].HasArgument:=true;
                        end;
                   ')': begin
                             Inc (NChar);
                             Break;
                        end;
                   'a': begin
                             if States [StateIndex].HasArgument
                                then Apply;
                             States [StateIndex].Argument:=A;
                             States [StateIndex].HasArgument:=true;
                             Inc (NChar);
                        end;
                   'b': begin
                             if States [StateIndex].HasArgument
                                then Apply;
                             States [StateIndex].Argument:=B;
                             States [StateIndex].HasArgument:=true;
                             Inc (NChar);
                        end;
                   'c'..'z': begin
                                  if States [StateIndex].HasArgument
                                     then Apply;
                                  States [StateIndex].Argument:=Variables [Expression [NChar]];
                                  States [StateIndex].HasArgument:=true;
                                  Inc (NChar);
                             end;
                   '0'..'9': begin
                                  if States [StateIndex].HasArgument
                                     then Apply;
                                  States [StateIndex].Argument:=0;
                                  while (NChar<=Length (Expression)) and (Expression [NChar] in ['0'..'9'])
                                        do begin
                                           States [StateIndex].Argument:=States [StateIndex].Argument*10+(Ord (Expression [NChar])-Ord ('0'));
                                           Inc (NChar);
                                        end;
                                  States [StateIndex].HasArgument:=true;
                             end;
                   else begin
                        while States [StateIndex].Level>Priority [Expression [NChar]]
                              do begin
                                 if States [StateIndex].HasArgument
                                    then Apply;
                                 Dec (StateIndex);
                                 States [StateIndex].Argument:=States [StateIndex+1].Value;
                                 States [StateIndex].HasArgument:=true;
                              end;
                        if States [StateIndex].Level<Priority [Expression [NChar]]
                           then begin
                                Inc (StateIndex);
                                States [StateIndex].Level:=Priority [Expression [NChar]];
                                States [StateIndex].Value:=0;
                                States [StateIndex].Operation:=Expression [NChar];
                                States [StateIndex].Value:=States [StateIndex-1].Argument;
                                States [StateIndex].HasArgument:=false;
                           end
                           else begin
                                if States [StateIndex].HasArgument
                                   then Apply;
                                States [StateIndex].Operation:=Expression [NChar];
                           end;
                        Inc (NChar);
                   end;
           end;
     while StateIndex>=1
           do begin
              Apply;
              Dec (StateIndex);
              if StateIndex>=1
                 then States [StateIndex].Argument:=States [StateIndex+1].Value;
           end;
     BracketEval:=States [1].Value;
end;

function TEvaluator.Eval: LongInt;
begin
     NChar:=1;
     Eval:=BracketEval;
end;

procedure Solve;
var
   Ev: TEvaluator;
begin
     Priority ['+']:=5;
     Priority ['-']:=5;
     Priority ['*']:=15;
     Priority ['/']:=15;
     Ev.Init (GlobalExpression);
     Answer:=Ev.Eval;
     Ev.Done;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
