program zzz;

const
  maxn = 100000;
  inf = 2000000000;
  osn = 1 shl 18;

type
  rec = record
    x,y,num: Longint;
  end;
  rec1 = record
    val,v,num: Longint;
  end;

var
  buf: rec1;
  i,j,t1,t2,k,n,m: Longint;
  a: array[1..maxn] of rec;
  tr: array[1..osn*2] of rec1;
  ans: array[1..maxn] of Longint;

function getmin(a,b: rec1): rec1;
begin
  if a.val > b.val then getmin := b else getmin := a;
end;

procedure buildtree(n: Longint);
var i,j: Longint;
begin
  for i := 1 to osn*2 do begin
    tr[i].val := inf;
  end;
  for i := 1 to n do begin
    tr[i+osn-1].val := a[i].y;
    tr[i+osn-1].v := i;
    tr[i+osn-1].num := a[i].num;
  end;
  for i := osn-1 downto 1 do begin
    tr[i] := getmin(tr[i*2],tr[i*2+1]);
  end;
end;

procedure add(v: Longint; val: rec1);
var i,j: Longint;
begin
  i := v + osn - 1;
  tr[i] := val;
  while i <> 1 do begin
    i := i div 2;
    tr[i] := getmin(tr[i*2],tr[i*2+1]);
  end;
end;

function query(st,fin: Longint): rec1;
var ans: rec1;
    i,j: Longint;
begin
  ans.v := 0;
  ans.val := inf;
  i := st + osn - 1;
  j := fin + osn - 1;
  while i <= j do begin
    ans := getmin(ans,tr[i]);
    ans := getmin(ans,tr[j]);
    i := (i+1) div 2;
    j := (j-1) div 2;
  end;
  query := ans;
end;

function bsearchl(val: Longint): Longint;
var l,r,m: Longint;
begin
  l := 0;
  r := n+1;
  while r - l > 1 do begin
    m := (r + l) div 2;
    if a[m].x > val then r := m else l := m;
  end;
  bsearchl := l;
end;

function bsearchr(val: Longint): Longint;
var l,r,m: Longint;
begin
  l := 0;
  r := n+1;
  while r - l > 1 do begin
    m := (r + l) div 2;
    if a[m].x >= val then r := m else l := m;
  end;
  bsearchr := r;
end;

procedure swap(var a,b: rec);
var i: rec;
begin
  i := a;
  a := b;
  b := i;
end;

function more(a,b: rec): Boolean;
begin
  more := a.x > b.x;
end;

procedure qsort(st,fin: Longint);
var key: rec;
    i,j: Longint;
begin
  i := st;
  j := fin;
  key := a[st + random(fin - st)];
  while i <= j do begin
    while more(key,a[i]) do inc(i);
    while more(a[j],key) do dec(j);
    if i <= j then begin
      swap(a[i],a[j]);
      inc(i);
      dec(j);
    end;
  end;
  if j > st then qsort(st,j);
  if i < fin then qsort(i,fin);
end;

begin
  assign(output,'docs.out'); rewrite(Output);
  assign(input,'docs.in'); reset(input);
  read(n);
  for i := 1 to n do begin
    read(a[i].x,a[i].y);
    a[i].num := i;
  end;
  qsort(1,n);
{  for i := 1 to n do begin
    writeln(a[i].x,' ',a[i].y);
  end;
  writeln(bsearchl(5));
  halt(0);}
  buildtree(n);
  read(m);
  for i := 1 to m do begin
    read(j,k);
    t1 := bsearchr(j);
    t2 := bsearchl(k);
    buf := query(t1,t2);
    if buf.val = inf then begin
      writeln('BOTVA');
      close(input);
      close(output);
      halt(0);
    end;
    ans[i] := buf.num;
    buf.val := inf;
    add(buf.v,buf);
  end;
  for i := 1 to m do begin
    write(ans[i],' ');
  end;
  close(input);
  close(output);
end.
