{$I+,Q-,R-,S-}
Label This;
Const
  InputFile  = 'docs.in';
  OutputFile = 'docs.out';
  None       = 'BOTVA';

Type
  Integer = longint;
  PTree = ^Ttree;
  TTree = record
    X, Y, N  : Longint;
    L, R     : PTree;
  End;

Var
  I       : Longint;
  T       : PTree;
  N, M    : Longint;
  Res     : Array [0..100000]Of Longint;
  RR      : Boolean;

  Procedure Done;Forward;

  Procedure Add(V : Longint);
  Begin
    Inc(Res[0]);
    Res[Res[0]] := V;
  End;

  Procedure Split(T : PTree; X : Longint; Var L, R : PTree);
  Begin
    If T = Nil Then
      Begin
        L := Nil;
        R := Nil;
      End
    Else
      If X > T^.X Then
        Begin
          Split(T^.R, X, T^.R, R);
          L := T;
        End
      Else
        Begin
          Split(T^.L, X, L, T^.L);
          R := T;
        End;
  End;

  Function Merge(L, R : PTree): PTree;
  Begin
    If L = Nil Then Begin Merge := R;Exit;End;
    If R = Nil Then Begin Merge := L;Exit;End;
    If L^.Y < R^.Y Then
      Begin
        L^.R := Merge(L^.R, R);
        Merge := L;
      End
    Else
      Begin
        R^.L := Merge(L, R^.L);
        Merge := R;
      End;
  End;

  Procedure Insert(var T:PTree; X, Y, N : Longint);
  Var T1 : PTree;
  Begin
    If T = nil Then
      Begin
        New(T1);
        T1^.X := X;
        T1^.Y := Y;
        T1^.N := N;
        T1^.L := Nil;
        T1^.R := Nil;
        T := T1;
        Exit;
      End;
    If Y < T^.Y Then
      Begin
        New(T1);
        Split(T, X, T1^.L, T1^.R);
        T1^.X := X;
        T1^.Y := Y;
        T1^.N := N;
        T := T1;
      End
    Else
      If X < T^.X Then Insert(T^.L, X, Y, N) Else Insert(T^.R, X, Y, N);
  End;

  Procedure Delete(Var T: PTree ; X,Mx : Longint);
  Var T1 : PTree;
  Begin
    If T = Nil Then
      Begin
        RR := False;
        Done;
      End;
    If MX < T^.X Then Delete(T^.L, X, Mx)
    Else
      If X > T^.X Then Delete(T^.R, X, Mx)
        Else
          Begin
           T1 := T;
           Add(T^.N);
           T := Merge(T^.L, T^.R);
           Dispose(T1);
          End;
  End;

  Procedure Init;
  Var
    J, X, Y : Longint;
    Buf        : Array [1..1024]Of Longint;
  Begin
    RR := True;
    FillChar(Res, SizeOf(Res), 0);
    New(T);
    T^.R := Nil;
    T^.L := Nil;
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);
    SetTextBuf(Input, Buf);

    Read(N);
    Read(T^.X, T^.Y);
    T^.N := 1;
    For I := 2 To N Do
      Begin
        If I = 65842 Then
          Begin
            I :=I;
          End;
        Read(X, Y);
        Insert(T, X, Y, I);
      End;
    Read(M);
    If M > N Then Begin Writeln(None);Halt(0);End;
    For I := 1 to M DO
      Begin
        Read(X, Y);
        Delete(T, X, Y);
      End;
    Close(Input);
  End;

  Procedure Done;
  Var I : Longint;
  Begin
    If T <> Nil Then Dispose(T);
    If RR Then For I := 1 to Res[0] Do Write(Res[I], ' ')
    Else Writeln(NONE);
    Close(Output);
    Halt(0);
  End;

Begin
  Init;
  Done;
End.
