{$I+,Q-,R-,S-}
Const
  InputFile  = 'sphere.in';
  OutputFile = 'sphere.out';
  GrToRad    = Pi/180;
  MaxN       = 1000;

Type
  Real = Extended;
  SSS  = Record
    X, Y       : Real;
    Xc, Yc     : Char;
  End;
  Vect  = Record
    X, Y, Z, XY : Real;
  End;

Var
  Res           : Longint;
  N             : Longint;
  A             : Array[1..MaxN,1..MaxN]Of Real;
  B             : Array[1..MaxN]Of Longint;
  V             : Array[1..MaxN]Of SSS;

  S1, S2        : Longint;
  R, D          : Real;

  Function MulVect(A, B : Vect) : Real; Forward;

  Function Rast(A, B : SSS): Real;
  Var C, D : Vect; Ang1, Ang2, C1, C2 : Real;
  Begin
    Ang1  := A.X * GrToRad;
    C.Z   := R * Sin(Ang1);
    C.XY  := R * Cos(Ang1);
    If A.Xc = 'S' Then C.Z := - C.Z;
    Ang2  := A.Y * GrToRad;
    C.X   := C.XY * Sin(Ang2);
    C.Y   := C.XY * Cos(Ang2);
    If A.Yc = 'W' Then C.X := -C.X;

    Ang1  := B.X * GrToRad;
    D.Z   := R * Sin(Ang1);
    D.XY  := R * Cos(Ang1);
    If B.Xc = 'S' Then D.Z := - D.Z;
    Ang2  := B.Y * GrToRad;
    D.X   := D.XY * Sin(Ang2);
    D.Y   := D.XY * Cos(Ang2);
    If B.Yc = 'W' Then D.X := -D.X;

    C1 := Abs(MulVect(C, D));
    C2 := C.X * D.X + C.Y * D.Y + C.Z * D.Z;
    If C2 <> 0 Then Ang1 := ArcTan(C1/C2) Else Ang1 := pi/2;
    If Ang1 < 0 Then Ang1 := Ang1 + Pi;

    Rast := Ang1 * R;
  End;

  Procedure Solve;
  Var
    C        : Array[1..MaxN]Of Boolean;
    RR       : Array[1..MaxN]Of Real;
    I, J     : Longint;
    Ok       : Boolean;
    Min, V   : Longint;
    MM       : Real;
  Begin
    FillChar(C, SizeOf(C), False);
    FillChar(RR, SizeOf(RR), 0);
    B[s1] := 1;
    RR[S1] := D;
    Ok := True;
    While Ok Do
      begin
        Ok :=False;
        Min := MaxLongint;
        For I := 1 to n Do
          If (Not C[I])And(B[I]<>-1)And((B[I]<Min)or((B[I] = Min) And(RR[I] > MM))) Then
          Begin
            V   := I;
            Min := B[I];
            MM  := RR[I];
            Ok := True;
          End;
        C[V] := True;
        For I := 1 to N Do
          If (A[V, I] > 0) Then
            Begin
              MM := RR[V]-A[V,I];
              If (MM > 0)And((B[I] = -1)or((B[I]>=B[V])And(MM > RR[I]))) Then
                Begin
                  B[I]  := B[V];
                  RR[I] := MM;
                End;
              If (MM < 0)And((B[I] = -1)Or(B[I] > B[V] + 1)Or((B[I]=B[V] + 1)And(RR[I]<D-A[V,I])))
                Then
                  Begin
                    B[I] := B[V] + 1;
                    RR[I] := D - A[V, I];
                  End;
            End;
      End;
    Res := B[S2];
  End;

  Procedure Init;
  Var
    Buf     : array[1..1024]Of longint;
    I, J    : Longint;
    Ch      : Char;
    XX, YY    : Real;
    Xcc, Ycc  : Char;
  Begin
    For I := 1 to MaxN Do Begin B[I] := -1;A[I,I] := 0; End;
    Assign(Input, InputFile);   Reset(Input);
    Assign(Output, OutputFile); Rewrite(Output);
    SetTextBuf(Input, Buf);
    Readln(N, s1, s2, R, D);
    For I := 1 To N Do
      Begin
        Read(XX);
        Read(Ch);
        While (Ch = ' ')And(Not Eoln) Do Read(Ch);
        Xcc := Ch;
        Read(YY);
        Read(Ch);
        While (Ch = ' ')And(Not Eoln) Do Read(Ch);
        Ycc := Ch;
        With V[I] Do
          Begin
            X := XX;
            Y := YY;
            Xc := Xcc;
            Yc := Ycc;
          End;
      End;
    Close(Input);
    For I := 1 to n do For J := I+1 To N Do
      Begin
        XX := Rast(V[I],V[J]);
        If XX <= D Then
          Begin
            A[I, J] := XX;
            A[J, I] := XX;
          End
        Else
          Begin
            A[I, J] := -1;
            A[J, I] := -1;
          End;
      End;
  End;

  Function MulVect(A, B : Vect) : Real;
  Begin
    MulVect := a.x*(b.y-b.z) + a.y*(b.z-b.x) + a.z*(b.x-b.y);
  End;

  Procedure Done;
  Begin
    If Res >= 0  then Writeln(Res) Else Writeln('-1');
    Close(Output);
  End;

Begin
  Init;
    Solve;
  Done;
End.
