#include <stdio.h>
#include <stdlib.h>

#define BASE 100000000
#define NN 51
#define LL 25

struct LLONG {
  int l;
  long long a[LL];
};

FILE *fi, *fo;
int n,m;
int b[NN];
int d[NN];
LLONG a[NN+1][NN+1];

int min(int a, int b)
{
  return (a<b)?a:b;
}

int max(int a, int b)
{
  return (a>b)?a:b;
}

void zero(LLONG *a)
{
  int i;
  a->l=0;
  for(i=0;i<LL;i++)
    a->a[i]=0LL;
}

void set_one(LLONG *a)
{
  int i;
  a->l=1;
  for(i=0;i<LL-1;i++)
    a->a[i]=0LL;
  a->a[LL-1]=1LL;
}

void cpy(LLONG *a, LLONG *b) // <=> b=a
{
  int i;
  b->l=a->l;
  for(i=0;i<LL;i++)
    b->a[i]=a->a[i];
}

void umn(LLONG *a, long long q)
{
  int i;
  long long r;
  r=0;
  if(a->l==0)
    return ;
  if(q==0)
  {
    zero(a);
    return ;
  }
  for(i=LL-1;i>=LL-a->l;i--)
  {
    a->a[i]=a->a[i]*q+r;
    r=a->a[i]/BASE;
    a->a[i]%=BASE;
  }
  while(r>0)
  {
    a->a[LL-(++(a->l))]=r%BASE;
    r/=BASE;
  }
}

void umn(LLONG *a, long long q,int shift)
{
  int i;
  long long r;
  LLONG b;
  r=0;
  if(a->l==0)
    return ;
  if(q==0)
  {
    zero(a);
    return ;
  }
  zero(&b);
  b.l=a->l+shift;
  for(i=LL-1;i>=LL-a->l;i--)
  {
    b.a[i-shift]=a->a[i]*q+r;
    r=b.a[i-shift]/BASE;
    b.a[i-shift]%=BASE;
  }
  cpy(&b,a);
//  a->l+=shift;
  while(r>0)
  {
    a->a[LL-(++(a->l))]=r%BASE;
    r/=BASE;
  }
}

void sum(LLONG *a, LLONG *b)
{
  int i;
  long long r;
  a->l=max(a->l,b->l);
  r=0;
  for(i=LL-1;i>=LL-a->l;i--)
  {
    a->a[i]+=r+b->a[i];
    r=a->a[i]/BASE;
    a->a[i]%=BASE;
  }
  while(r>0)
  {
    a->a[LL-(++(a->l))]=r%BASE;
    r/=BASE;
  }
}

void div(LLONG *a, long long q)
{
  long long r;
  int i;
  r=0;
  if(a->l==0)
    return ;
  for(i=LL-a->l;i<LL;i++)
  {
    r=r*BASE+a->a[i];
    a->a[i]=r/q;
    r%=q;
  }
  while(a->a[LL-a->l]==0)
  {
    a->l--;
    if(a->l==0)
      break;
  }
}

void umn(LLONG *a, LLONG *b)
{
  int i;
  LLONG c;
  LLONG res;
  zero(&res);
  for(i=LL-1;i>=LL-b->l;i--)
  {
    if(b->a[i]!=0)
    {
      cpy(a,&c);
      umn(&c,b->a[i],LL-1-i);
      sum(&res,&c);
    }
  }
  cpy(&res,a);
}

void umn_c(LLONG *a, int n, int k)
{
  int i;
  if(k>n-k)
   k=n-k;
  for(i=n-k+1;i<=n;i++)
    umn(a,i);
  for(i=2;i<=k;i++)
    div(a,i);
}

void umn_f(LLONG *a, int n)
{
  int i;
  for(i=2;i<=n;i++)
    umn(a,i);
}

void div_f(LLONG *a, int n)
{
  int i;
  for(i=2;i<=n;i++)
    div(a,i);
}

void wr(LLONG *a)
{
  int i;
  if(a->l==0)
  {
    fprintf(fo,"0\n");
    return ;
  }
  fprintf(fo,"%lld",a->a[LL-a->l]);
  for(i=LL-a->l+1;i<LL;i++)
    fprintf(fo,"%08lld",a->a[i]);
  fprintf(fo,"\n");
}

int main()
{
  int i,j, k;
  int s;
  LLONG aa;
  fi=fopen("casino.in","rt");
  fo=fopen("casino.out","wt");

  fscanf(fi,"%d",&n);
  m=0; j=0; s=0;
  for(i=0;i<n;i++)
  {
    fscanf(fi,"%d",&b[i]);
    if(b[i]==0)
    {
      j++;
      s++;
    }
    else
    {
      if(j>0)
      {
        d[m++]=j;
        j=0;
      }
    }
  }
  if(s==n)
  {
    set_one(&aa);
    for(i=0;i<n;i++)
      umn(&aa,n);
    wr(&aa);
    fclose(fi);
    fclose(fo);
    return 0;
  }
  if(j>0)
    d[m++]=j;
  if((b[0]==0)&&(b[n-1]==0))
    d[0]+=d[--m];
  set_one(&a[0][0]);
  for(i=1;i<=n;i++)
    zero(&a[i][0]);
  for(i=1;i<=n;i++)
  {
    for(j=0;j<=i;j++)
    {
      zero(&a[i][j]);
      for(k=0;k<=j;k++)
      {
        cpy(&a[i-1][j-k],&aa);
        umn_c(&aa,j,k);
        sum(&a[i][j],&aa);
      }
    }
    for(j=i+1;j<=n;j++)
      zero(&a[i][j]);
  }
  set_one(&aa);
  for(i=0;i<m;i++)
    umn(&aa,&a[d[i]][d[i]]);
  umn_f(&aa,s);
  for(i=0;i<m;i++)
    div_f(&aa,d[i]);
  wr(&aa);

/*  //BEGIN_TEST
  
  LLONG bb,cc;
  zero(&bb);
  zero(&cc);
  bb.l=2;
  cc.l=1;
  bb.a[LL-2]=1000000;
  bb.a[LL-1]=1;
  cc.a[LL-2]=1000000;
  cc.a[LL-1]=100;
  umn(&cc,&bb);
  wr(&cc);
  
  //END_TEST*/

  fclose(fi);
  fclose(fo);
  return 0;
}
