#define ONLINE
//#define DEBUG
#include <stdio.h>
#include <string.h>

#define NUM_SIZE 32

class TNum {
  private:
    long data[NUM_SIZE];
    static long buf[NUM_SIZE];
    int len;
    static const int size;
  public:
    void print(void);
    TNum* set(const long=0);
    TNum* set(const TNum*);
    TNum* mul(const long);
    TNum* div(const long);
    TNum* add(const TNum*);
    TNum* mul(const TNum*);
};
const int TNum::size=NUM_SIZE;
long TNum::buf[NUM_SIZE];


short n_total,n_cells,n_moves_total,n_series;
char*moves; short*series;
TNum*comps_cont,*vars_cont,**comps,**vars,total;

int main(void) {
  #ifdef ONLINE
  freopen("casino.in","rt",stdin);
  freopen("casino.out","wt",stdout);
  #endif
  short i,j;
  scanf("%hd",&n_total);
  moves=new char[n_total]; series=new short[n_total];
  n_moves_total=0;
  for (i=0; i<n_total; i++) {
    scanf("%hd",&j);
    moves[i]=j?0:1;
    if (moves[i]) n_moves_total++;
  }
  if (n_moves_total<n_total) {
    for (i=0; i<n_total; i++) if (!moves[i]) break;
    n_series=0;
    for (j=i+1; j<=i+n_total; j++) if (moves[j%n_total]) {
      if (!moves[(j-1)%n_total]) series[n_series++]=0;
      series[n_series-1]++;
    }
  } else { n_series=1; *series=n_moves_total; }
  #ifdef DEBUG
  printf("%hd\n",n_series);
  for (i=0; i<n_series; i++) {
    if (i) printf(" ");
    printf("%hd",series[i]);
  } printf("\n");
  #endif
  n_cells=(n_total+1)*(n_total+1);
  comps_cont=new TNum[n_cells]; vars_cont=new TNum[n_cells];
  comps=new TNum*[n_total+1]; vars=new TNum*[n_total+1];
  for (i=0,j=0; i<=n_total; i++,j+=n_total+1) {
    comps[i]=&comps_cont[j];
    vars[i]=&vars_cont[j];
  }
  for (i=0; i<=n_total; i++) {
    comps[i][0].set(1);
    for (j=1; j<=i; j++) {
      comps[i][j].set(&comps[i][j-1]);
      comps[i][j].mul((long)(i-j+1));
      comps[i][j].div((long)j);
    }
    for (; j<=n_total; j++) comps[i][j].set();
  }
  TNum z; short k;
  for (j=0; j<=n_total; j++) vars[0][j].set(1);
  for (i=1; i<=n_total; i++) {
    vars[i][0].set();
    for (j=1; j<=i; j++) {
      vars[i][j].set();
      for (k=0; k<=i-j+1; k++) {
        z.set(&vars[i-k][j-1]);
        z.mul(&comps[i][k]);
        vars[i][j].add(&z);
      }
    }
    for (; j<=n_total; j++) vars[i][j].set(&vars[i][i]);
    #ifdef DEBUG
    printf("[%hd]=",i); vars[i][i].print(); printf("\n");
    #endif
  }
  total.set(1);
  if (n_moves_total<n_total) {
    if (n_series>0) {
      k=*series; total.set(&vars[*series][*series]);
      for (i=1; i<n_series; i++) {
        k+=series[i];
        total.mul(&vars[series[i]][series[i]]);
        total.mul(&comps[k][series[i]]);
      }
    }
  } else {
    for (i=1; i<=n_total; i++) total.mul((long)n_total);
  }
  total.print(); printf("\n");
  delete[]comps; delete[]vars;
  delete[]comps_cont; delete[]vars_cont;
  delete[]moves; delete[]series;
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


void TNum::print(void) {
  if (len>0) {
    int pos;
    printf("%ld",data[len-1]);
    for (pos=len-2; pos>=0; pos--) printf("%04ld",data[pos]);
  } else printf("0");
}
TNum* TNum::set(const long arg) {
  memset(data,0,sizeof(long)*size);
  if (arg) {
    *data=arg;
    len=1;
  } else len=0;
  return(this);
}
TNum* TNum::set(const TNum*arg) {
  memcpy(data,arg->data,sizeof(long)*size);
  len=arg->len;
  return(this);
}
TNum* TNum::mul(const long arg) {
  int pos;
  long reg=0;
  for (pos=0; ((pos<len)||(reg))&&(pos<size); pos++) {
    data[pos]=data[pos]*arg+reg;
    reg=data[pos]/10000;
    data[pos]%=10000;
  }
  for (len=pos; len>0; len--) if (data[len-1]) break;
  return(this);
}
TNum* TNum::div(const long arg) {
  int pos;
  long reg=0;
  for (pos=len-1; pos>=0; pos--) {
    data[pos]+=reg*10000;
    reg=data[pos]%arg;
    data[pos]/=arg;
  }
  for (; len>0; len--) if (data[len-1]) break;
  return(this);
}
TNum* TNum::add(const TNum*arg) {
  int pos;
  long reg=0;
  for (pos=0; ((pos<len)||(pos<arg->len)||(reg))&&(pos<size); pos++) {
    data[pos]+=arg->data[pos]+reg;
    reg=data[pos]/10000;
    data[pos]%=10000;
  }
  for (len=pos; len>0; len--) if (data[len-1]) break;
  return(this);
}
TNum* TNum::mul(const TNum*arg) {
  int pos,argpos,maxpos=0;
  memset(buf,0,sizeof(long)*size);
  for (argpos=0; argpos<arg->len; argpos++) {
    long reg=0;
    for (pos=0; ((pos<len)||(reg))&&(pos+argpos<size); pos++) {
      buf[pos+argpos]+=data[pos]*arg->data[argpos]+reg;
      reg=buf[pos+argpos]/10000;
      buf[pos+argpos]%=10000;
    }
    if (maxpos<pos+argpos) maxpos=pos+argpos;
  }
  memcpy(data,buf,sizeof(long)*size);
  for (len=maxpos; len>0; len--) if (data[len-1]) break;
  return(this);
}


