#define ONLINE
//#define DEBUG
#include <stdio.h>
#include <string.h>

#define NUM_SIZE 16

class TNum {
  private:
    long data[NUM_SIZE];
    int len;
    static const int size;
  public:
    void print(void);
    TNum* set(const long=0);
    TNum* mul(const long);
};
const int TNum::size=NUM_SIZE;


void graphify(short*edges,const short module) {
  short degree,*polynom;
  short i_num,i_deg;
  scanf("%hd",&degree);
  polynom=new short[degree+1];
  for (i_deg=degree; i_deg>=0; i_deg--) scanf("%hd",&polynom[i_deg]);
  for (i_num=0; i_num<module; i_num++) {
    short numdeg;
    edges[i_num]=0;
    for (i_deg=0,numdeg=1; i_deg<=degree; i_deg++,numdeg=(numdeg*i_num)%module)
    edges[i_num]=(edges[i_num]+polynom[i_deg]*numdeg)%module;
  }
  delete[]polynom;
}

short paintverts(const short*edges,short*colors,const short n_verts) {
  char*mark=new char[n_verts];
  short n_colors=0;
  memset(colors,-1,sizeof(short)*n_verts);
  memset(mark,0,sizeof(char)*n_verts);
  short i,vert;
  for (i=0; i<n_verts; i++) if (!mark[i]) {
    for (vert=i; !mark[vert]; vert=edges[vert]) mark[vert]=1;
    if (colors[vert]>=0) continue;
    for (; colors[vert]<0; vert=edges[vert]) colors[vert]=n_colors;
    n_colors++;
  }
  delete[]mark;
  for (i=0; i<n_verts; i++) if (colors[i]<0) colors[i]=n_colors;
  return(n_colors);
}

void makecyclegraph(char**matrix,short*const colors[2],const short n_verts) {
  short i;
  for (i=0; i<n_verts; i++) matrix[colors[0][i]][colors[1][i]]=1;
}
short paintcycles(char*const*matrix,short*colors[2],const short n_cycles[2]) {
  short n_colors=0;
  short i,j,color_to,color_from,k;
  for (k=0; k<n_cycles[0]; k++) colors[0][k]=n_colors++; colors[0][k]=-1;
  for (k=0; k<n_cycles[1]; k++) colors[1][k]=n_colors++; colors[1][k]=-1;
  for (i=0; i<=n_cycles[0]; i++) for (j=0; j<=n_cycles[1]; j++) if (matrix[i][j]) {
    if (colors[0][i]==colors[1][j]) continue;
    color_to=colors[0][i]; color_from=colors[1][j];
    for (k=0; k<=n_cycles[0]; k++) if (colors[0][k]==color_from) colors[0][k]=color_to;
    for (k=0; k<=n_cycles[1]; k++) if (colors[1][k]==color_from) colors[1][k]=color_to;
    n_colors--;
  }
  return(n_colors);
}

short module,n_colors[2],n_cycolors;
short*edges[2],*colors[2],*cycolors[2];
char*matrix_cont,**matrix;
TNum count;

int main(void) {
  #ifdef ONLINE
  freopen("invar.in","rt",stdin);
  freopen("invar.out","wt",stdout);
  #endif
  scanf("%hd",&module);
  edges[0]=new short[module]; edges[1]=new short[module];
  colors[0]=new short[module]; colors[1]=new short[module];
  cycolors[0]=new short[module+2]; cycolors[1]=new short[module+2];
  graphify(edges[0],module);
  graphify(edges[1],module);
  n_colors[0]=paintverts(edges[0],colors[0],module);
  n_colors[1]=paintverts(edges[1],colors[1],module);
  matrix_cont=new char[(n_colors[0]+1)*(n_colors[1]+1)];
  matrix=new char*[(n_colors[0]+1)];
  { short i,j;
    for (i=0,j=0; i<=n_colors[0]; i++,j+=n_colors[1]+1)
    matrix[i]=&matrix_cont[j];
  } memset(matrix_cont,0,sizeof(char)*(n_colors[0]+1)*(n_colors[1]+1));
  makecyclegraph(matrix,colors,module);
  n_cycolors=paintcycles(matrix,cycolors,n_colors);
  #ifdef DEBUG
  printf("%hd\n",n_cycolors);
  #endif
  delete[]matrix_cont; delete[]matrix;
  delete[]cycolors[0]; delete[]cycolors[1];
  delete[]colors[0]; delete[]colors[1];
  delete[]edges[0]; delete[]edges[1];
  for (count.set(1); n_cycolors>0; count.mul(2),n_cycolors--);
  count.print(); printf("\n");
  #ifdef ONLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


void TNum::print(void) {
  if (len>0) {
    int pos;
    printf("%ld",data[len-1]);
    for (pos=len-2; pos>=0; pos--) printf("%04ld",data[pos]);
  } else printf("0");
}
TNum* TNum::set(const long arg) {
  memset(data,0,sizeof(long)*size);
  if (arg) {
    *data=arg;
    len=1;
  } else len=0;
  return(this);
}
TNum* TNum::mul(const long arg) {
  int pos;
  long reg=0;
  for (pos=0; ((pos<len)||(reg))&&(pos<size); pos++) {
    data[pos]=data[pos]*arg+reg;
    reg=data[pos]/10000;
    data[pos]%=10000;
  }
  for (len=pos; len>0; len--) if (data[len-1]) break;
  return(this);
}


