{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'invar.out';
  cinfile = 'invar.in';

  nmax = 410;

  dmax = 10;
  dig = 8;
  base = 100000000;

type
  int = longint;
  real = extended;

  pol = array [0..nmax] of int;
  thuge = array [0..dmax] of int;

var
  n, k : int;

  ans : thuge;

  kq, kp : int;
  p, q : pol;

  zp, zq : pol;

  kcp, kcq : int;
  cp, cq : pol;

  bad : array [1..nmax] of boolean;

  pr, r : array [0..nmax] of int;

procedure debug;
var
  i, j : int;
begin
  for j:= 0 to n-1 do write(cp[j]);
  writeln;
  for j:= 0 to n-1 do write(cq[j]);
  writeln;
  writeln;
end;

procedure outdata;
var
  i, j : int;
  s : string;
begin
  write(ans[ans[0]]);
  for i:= ans[0]-1 downto 1 do
  begin
    str(ans[i],s);
    for j:= length(s) to dig-1 do write('0');
    write(s);
  end;
  writeln;
end;

procedure mul2int(var a : thuge);
var
  i, r : int;
begin
  r:= 0;
  for i:= 1 to a[0] do
  begin
    a[i]:= a[i] shl 1 + r;
    r:= a[i] div base;
    a[i]:= a[i] - r*base;
  end;
  while r > 0 do
  begin
    inc(a[0]);
    a[a[0]]:= r mod base;
    r:= r div base;
  end;
end;

procedure calc(var a, b : pol; k : int);
var
  i, j : int;
begin
  fillchar(b,sizeof(b),0);
  for i:= 0 to n-1 do
    for j:= k downto 0 do b[i]:= (b[i]*i+a[j]) mod n;
end;

procedure findc;
var
  i : int;
  u : array [0..nmax] of int;
  v, v2 : int;
begin
  fillchar(cq,sizeof(cq),0);
  fillchar(cp,sizeof(cp),0);
  fillchar(u,sizeof(u),0);
  kcp:= 0;
  for i:= 0 to n-1 do
  begin
    if u[i] <> 0 then continue;
    v:= i;
    while u[v] = 0 do
    begin
      u[v]:= i+1;
      v:= zp[v];
    end;
    if u[v] <> i+1 then continue;
    inc(kcp);
    cp[v]:= kcp;
    v2:= zp[v];
    while v2 <> v do
    begin
      cp[v2]:= kcp;
      v2:= zp[v2];
    end;
  end;
  fillchar(u,sizeof(u),0);
  kcq:= kcp;
  for i:= 0 to n-1 do
  begin
    if u[i] <> 0 then continue;
    v:= i;
    while u[v]  = 0 do
    begin
      u[v]:= i+1;
      v:= zq[v];
    end;
    if u[v] <> i+1 then continue;
    inc(kcq);
    cq[v]:= kcq;
    v2:= zq[v];
    while v2 <> v do
    begin
      cq[v2]:= kcq;
      v2:= zq[v2];
    end;
  end;
end;

function find(x : int) : int;
begin
  if pr[x] <> x then
  begin
    pr[x]:= find(pr[x]);
    find:= pr[x];
  end else find:= x;
end;

procedure link(x, y : int);
begin
  if r[x] > r[y] then pr[y]:= x else
    if r[y] > r[x] then pr[x]:= y else
    begin
      pr[x]:= y;
      inc(r[y]);
    end;
end;

procedure union(x, y : int);
begin
  if find(x) <> find(y) then link(pr[x],pr[y]);
end;

procedure solve;
var
  i, j : int;
  u : array [0..nmax] of boolean;
begin
  calc(p,zp,kp);
  calc(q,zq,kq);
  fillchar(ans,sizeof(ans),0);
  ans[0]:= 1;
  ans[1]:= 1;
  findc;
  debug;
  for i:= 0 to kcq do
  begin
    r[i]:= 0;
    pr[i]:= i;
  end;
  for i:= 0 to n-1 do union(cp[i],cq[i]);
  fillchar(u,sizeof(u),0);
  u[find(0)]:= true;
  for i:= 1 to kcq do
    if not u[find(i)] then
    begin
      mul2int(ans);
      u[find(i)]:= true;
    end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n);
  read(kq);
  for i:= kq downto 0 do read(q[i]);
  read(kp);
  for i:= kp downto 0 do read(p[i]);
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.