{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
Program Casino;
Uses SysUtils;
Const
     InFile = 'casino.in';
     OutFile = 'casino.out';
     LMax = 23;
     TimeTest = 2;
     Sec = 24 * 60 * 60;
Type
    TBits = Array [0..LMax] Of ShortInt;
Var
   L : LongInt;
   EndPos : TBits;
   NEnd : Int64;
   F : Array [0..1 ShL LMax] Of LongInt;
   P,PNext : Array [0..1 ShL LMax] Of LongInt;
   PLen,PNextLen : LongInt;
   Start : Double;

 Procedure ReadData;
  Var
     I : LongInt;
   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (L);
     For I:= 1 To L Do Read (EndPos[I]);
     Close (Input);
   End;

 Procedure Code (Bits : TBits; L : LongInt; Var N : Int64);
  Var
     CurDeg,I : LongInt;
   Begin
     N:= 0;
     CurDeg:= 1;
     For I:= L DownTo 1 Do Begin
       Inc (N,CurDeg * Bits[I]);
       CurDeg:= CurDeg * 2;
     End;
   End;

 Procedure Decode (N : Int64; Var Bits : TBits; L : LongInt);
  Var
     I : LongInt;
   Begin
     I:= L;
     While N > 0 Do Begin
       Bits[I]:= N Mod 2;
       N:= N Div 2;
       Dec (I);
     End;
     For I:= I DownTo 1 Do Bits[I]:= 0;
  End;

 Procedure AddToPNext (N : LongInt);
  Var
     LL : LongInt;
     Was : Boolean;
   Begin
     Was:= False;
     For LL:= 1 To PNextLen Do
       If PNext[LL] = N Then Begin
        Was:= True;
        Break;
       End;
     If Not Was Then Begin
      Inc (PNextLen);
      PNext[PNextLen]:= N;
     End;
   End;

 Procedure Solve;
  Var
     CurPrev1,I,LL,NSteps : LongInt;
     NCur,NNext : Int64;
     BitCur : TBits;
     Prev1 : Array [0..LMax] Of LongInt;
  Begin
    If L > LMax Then Exit;

    FillChar (F,SizeOf(F),0);
    F[1 ShL L - 1]:= 1;

    PLen:= 1;
    P[PLen]:= 1 ShL L - 1;

    For NSteps:= 1 To L Do Begin
      For LL:= 1 To PLen Do Begin

        NCur:= P[LL];
        DeCode (NCur,BitCur,L);

        CurPrev1:= 1;
        While BitCur[CurPrev1] = 0 Do Inc (CurPrev1);
        For I:= CurPrev1 To L Do
          If BitCur[I] = 1 Then CurPrev1:= I
          Else
           Prev1[I]:= CurPrev1;
        I:= 1;
        While BitCur[I] = 0 Do Begin
          Prev1[I]:= CurPrev1;
          Inc (I);
        End;

        For I:= 1 To L Do Begin
          If BitCur[I] = 1 Then Begin
           BitCur[I]:= 0;
           Code (BitCur,L,NNext);
           F[NNext]:= F[NNext] + F[NCur];
           AddToPNext (NNext);
           BitCur[I]:= 1;
          End
          Else Begin
           BitCur[Prev1[I]]:= 0;
           Code (BitCur,L,NNext);
           F[NNext]:= F[NNext] + F[NCur];
           BitCur[Prev1[I]]:= 1;
          End;
        End;
      End;

      If (Now - Start) * Sec > (TimeTest - 0.2) Then Exit;

      P:= PNext;
      PLen:= PNextLen;
      PNextLen:= 0;
    End;
  End;

 Procedure WriteData;
  Begin
    Assign (Output,OutFile); ReWrite (Output);
    If L > LMax Then Write (0)
    Else Begin
     Code (EndPos,L,NEnd);
     Write (F[NEnd]);
    End;
    Close (Output);
  End;

 BEGIN
   Start:= Now;
   ReadData;
   Solve;
   WriteData;
 END.
