{$A+,B-,D-,E+,F+,G-,I-,L-,N+,O-,P-,Q-,R-,S+,T+,V+,X+,Y+}
Program Invar;
Const
     InFile = 'invar.in';
     OutFile = 'invar.out';
     MMax = 100;
     DegMax = 100;
Type
    TPolynom = Array [0..DegMax] Of LongInt;
    TArray = Array [0..MMax] Of LongInt;
    TSet = Set Of Byte;
    TCycles = Array [0..MMax] Of TSet;
Var
   M : LongInt;
   P,Q : TPolynom;
   PDeg,QDeg : LongInt;
   PX,QX : TArray;
   CP,CQ : TCycles;
   NCP,NCQ : LongInt;
   GC : Array [0..2 * MMax] Of TSet;
   Deg : LongInt;
   Res : Int64;

 Procedure ReadData;
  Var
     Num,I : LongInt;
   Begin
     Assign (Input,InFile); ReSet (Input);
     Read (M);
     Read (PDeg);
     For I:= PDeg DownTo 0 Do Read (P[I]);
     Read (QDeg);
     For I:= QDeg DownTo 0 Do Read (Q[I]);
     Close (Input);
   End;

 Procedure Compute (P : TPolynom; PDeg : LongInt; Var PX : TArray);
  Var
     I,X,XInDeg : LongInt;
   Begin
     FillChar (PX,SizeOf(PX),0);
     For X:= 0 To M - 1 Do Begin
       XInDeg:= 1;
       For I:= 0 To PDeg Do Begin
         PX[X]:= (PX[X] + P[I] * XInDeg) Mod M;
         XInDeg:= (XInDeg * X) Mod M;
       End;
     End;
   End;

 Procedure FindCycles (PX : TArray; Var NC : LongInt; Var C : TCycles);
  Var
     X : LongInt;
     Mark : Array [0..MMax] Of Boolean;
     Prev : Array [0..MMax] Of LongInt;
     InCycle : Array [0..MMax] Of Boolean;

   Procedure DFS (XCur : LongInt);
    Var
       Y : LongInt;
     Begin
       Mark[XCur]:= True;
       If (Mark[PX[XCur]]) Then Begin
        If (Not InCycle[PX[XCur]]) Then Begin
         Inc (NC);
         Y:= XCur;
         While Y <> PX[XCur] Do Begin
           C[NC]:= C[NC] + [Y];
           InCycle[Y]:= True;
           Y:= Prev[Y];
         End;
         C[NC]:= C[NC] + [PX[XCur]];
         InCycle[PX[XCur]]:= True;
        End
       End
       Else Begin
        Prev[PX[XCur]]:= XCur;
        DFS (PX[XCur]);
       End;
     End;

   Begin
     For X:= 0 To M - 1 Do Begin
       Mark[X]:= False;
       Prev[X]:= -1;
       InCycle[X]:= False;
     End;
     For X:= 0 To M - 1 Do C[X]:= [];
     NC:= 0;
     For X:= 0 To M - 1 Do
       If Not Mark[X] Then DFS (X);
   End;

 Procedure Solve;
  Var
     I,J,X,X0,PXCur,QXCur : LongInt;
     Len : LongInt;
     Mark : Array [0..2 * MMax] Of Boolean;
     CurG : TSet;
     F : Boolean;

   Procedure DFS (I : LongInt);
    Var
       J : LongInt;
     Begin
       Mark[I]:= True;
       For J:= 1 To Len Do
         If (GC[I] * GC[J] <> []) And (Not Mark[J]) Then Begin
          CurG:= (CurG + GC[J]) - (CurG * GC[J]);
          DFS (J);
         End;
     End;

   Begin
     Compute (P,PDeg,PX);
     Compute (Q,QDeg,QX);

     FindCycles (PX,NCP,CP);
     FindCycles (QX,NCQ,CQ);

     Len:= 0;
     For I:= 1 To NCP Do Begin
       CurG:= CP[I];
       For J:= 1 To NCQ Do Begin
         If CurG = [] Then Break;
         CurG:= CurG - (CurG * CQ[J]);
       End;
       If CurG = [] Then Begin
        Inc (Len);
        GC[Len]:= CP[I];
       End;
     End;

     For I:= 1 To NCQ Do Begin
       CurG:= CQ[I];
       For J:= 1 To NCP Do Begin
        If CurG = [] Then Break;
        CurG:= CurG - (CurG * CP[J]);
       End;
       If CurG = [] Then Begin
        Inc (Len);
        GC[Len]:= CQ[I];
       End;
     End;

     Deg:= 0;

     FillChar (Mark,SizeOf(Mark),False);
     For I:= 1 To Len Do
       If Not Mark[I] Then Begin
        CurG:= GC[I];
        DFS (I);
        If CurG = [] Then Inc (Deg);
       End;
     Res:= 1;
     For I:= 1 To Deg Do Res:= Res * 2;
   End;

 Procedure WriteData;
  Begin
    Assign (Output,OutFile); ReWrite (Output);
    Write (Res);
    Close (Output);
  End;

 BEGIN
   ReadData;
   Solve;
   WriteData;
 END.
