Const
  MaxN = 51;
  llen = 100;

type
  Tlong = array[0..llen] of byte;

procedure MulToShort(var a: Tlong;v: integer);
var i,r,t: integer;
begin
  r:=0;
  for i:=1 to a[0] do begin
    t:=a[i]*v+r;
    a[i]:=t mod 100;
    r:=t div 100;
  end;
  if r>0 then begin
    if a[0]=llen then begin
      WriteLn('OVERFLOW!!!');
    end else begin
      inc(a[0]); a[a[0]]:=r;
    end;
  end;
end;

procedure Zero(var a: Tlong);
begin
  fillchar(a,sizeof(a),0);
end;

procedure One(var a: Tlong);
begin
  Zero(a);
  a[0]:=1; a[1]:=1;
end;

var
  fi, fo: text;
  n,bn: integer;
  a,b: array[1..MaxN] of byte;
  f: array[1..MaxN-1] of Tlong;
  res: Tlong;

const
  pnum = 15;
  primes: array[1..pnum] of integer =
            (2,3,5,7,11,13,17,19,23,29,31,37,41,43,47);

procedure dvzrs(n: integer;var b:array of integer);
var i,j,t: integer;
begin
  fillchar(b,pnum*sizeof(integer),0);
  For i:=2 to n do begin
    t:=i; j:=1;
    while (j<=pnum) and (primes[j]<=t) do begin
      while t mod primes[j]=0 do begin
        inc(b[j-1]);
        t:=t div primes[j];
      end;
      inc(j);
    end;
  end;
end;

procedure calc_a(var t: Tlong);
var aa,bb: array[1..pnum] of integer;
    i,j: integer;
begin
  j:=0;
  For i:=1 to bn do
    j:=j+b[i];
  dvzrs(j,aa);
  For i:=1 to bn do begin
    dvzrs(b[i],bb);
    For j:=1 to pnum do
      aa[j]:=aa[j]-bb[j];
  end;
  one(t);
  For i:=1 to pnum do
    For j:=1 to aa[i] do
      MulToShort(t,primes[i]);
end;

function Max(a,b: integer):integer;
begin
  if a>b then Max:=a else Max:=b;
end;

procedure AddLong(var a,b: Tlong;shift: integer); {a:=a+b*100^shift}
var i,r,t: integer;
begin
  if b[0]+shift>llen then begin
    WriteLn('OVERFLOW!!!'); exit;
  end;
  r:=0;
  For i:=shift+1 to max(a[0],b[0]+shift) do begin
    t:=a[i]+b[i-shift]+r;
    a[i]:=t mod 100;
    r:=t div 100;
  end;
  a[0]:=max(a[0],b[0]+shift);
  if r>0 then begin
    if a[0]=llen then begin
      WriteLn('OVERFLOW!!!');
    end else begin
      inc(a[0]); a[a[0]]:=r;
    end;
  end;
end;

procedure MulLong(var a,b,c: Tlong); {c:=a*b}
var i: integer;
    t: Tlong;
begin
  fillchar(c,sizeof(Tlong),0);
  For i:=1 to b[0] do begin
    move(a,t,sizeof(Tlong));
    MulToShort(t,b[i]);
    AddLong(c,t,i-1);
  end;
end;

procedure Solve;
var
  i,j: integer;
  t: Tlong;
begin
  For i:=1 to MaxN-1 do begin
    one(t);
    For j:=1 to i-1 do
      MulToShort(t,i+1);
    f[i]:=t;
  end;
  j:=0;
  For i:=1 to n do
    if a[i]=0 then inc(j)
     else if j>0 then
       begin
         inc(bn);
         b[bn]:=j;
         j:=0;
       end;
  if j>0 then
    if a[1]=0 then begin
      b[1]:=b[1]+j;
      if bn=0 then bn:=1;
    end else begin
      inc(bn);
      b[bn]:=j;
    end;
  if b[1]=0 then begin
    one(res);
    exit;
  end;
  if b[1]=n then begin
    one(res);
    For i:=1 to n do
      MulToShort(res,n);
    exit;
  end;
  calc_a(res);
  For i:=1 to bn do begin
    MulLong(res,f[b[i]],t);
    res:=t;
  end;
end;

procedure Init;
var i: integer;
begin
  Assign(fi,'casino.in');
  Assign(fo,'casino.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,n);
  For i:=1 to n do
    Read(fi,a[i]);
end;

procedure WriteLong(var f:text;var a:Tlong);
var i: integer;
begin
  Write(f,a[a[0]]);
  For i:=a[0]-1 downto 1 do begin
    if a[i]<10 then Write(f,0);
    Write(f,a[i]);
  end;
end;

procedure Done;
begin
  WriteLong(fo,res);
  WriteLn(fo);
  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
