const
  Ys1  = 1801;
  Yf1  = 2201;
  MaxN = 101;

const
  Months : array [1..12] of string =
    ('January','February','March','April','May','June','Jule','August','September','October','November','December');
  Days : array [1..12] of integer = (31,28,31,30,31,30,31,31,30,31,30,31);

type
  TSign    = (_added,_removed);
  TDate    = record y,m,d : integer; end;
  THoliday = record Added,Removed : integer; D : TDate end;


var
  a,b                 : integer;
  s                   : string;
  ch                  : char;
  Sign                : 0..1;
  Dates               : array [0..MaxN] of record D1,D2 : TDate; sign : TSign; end;
  Holiday             : array [1..MaxN] of THoliday;
  q                   : array [1800..2200] of longint;
  NowY                : integer;
  HNum,Res            : integer;
  p,ys,yf,n,c,d,m,i,j : integer;

procedure init;
begin
  assign(input,'holidays.in'); reset(input);
  assign(output,'holidays.out'); rewrite(output);
  readln(ys,yf);
  readln(n);
end;

procedure ReadDate(var D : TDate);
var
  j,q  : integer;

begin
  read(ch);
  while ch=' ' do read(ch);
  s:='';
  while (ch in ['A'..'Z'])or(ch in ['a'..'z']) do
  begin
    s:=s+ch;
    read(ch);
  end;
  for j:=1 to 12 do
    if s=months[j] then
    begin
      D.m:=j;
      break;
    end;
  read(ch); q:=0;
  while ch in ['0'..'9'] do
  begin
    q:=q*10+ord(ch)-48;
    read(ch);
  end;
  D.d:=q;
end;

procedure ReadSign(var Sign : TSign);
begin
  s:='';
  while not((ch in ['a'..'z'])or(ch in ['A'..'Z'])) do read(ch);
  while (ch in ['a'..'z'])or(ch in ['A'..'Z']) do
  begin
    s:=s+ch;
    read(ch);
  end;
  if s='added' then sign:=_added else sign:=_removed;
end;

function DateMore(d1,d2 : TDate) : boolean;
begin
  if d1.m>d2.m then DateMore:=true else
  if d1.m<d2.m then DateMore:=false else
  begin
    if d1.d>d2.d then DateMore:=true else DateMore:=false;
  end;
end;

function EqDates(d1,d2 : TDate) : boolean;
begin
  EqDates:=(d1.m=d2.m)and(d1.d=d2.d);
end;

function GetYearHA(Date : TDate) : integer;
var
  y : integer;

begin
  if (Date.m=2)and(Date.d=29) then
  begin
    if DateMore(Date,Dates[i].D1) then y:=Dates[i].d1.y else y:=dates[i].d1.y+1;
    while (y mod 4 <> 0)and(not((y mod 100 = 0)and(y mod 400 <> 0))) do
      y:=y+1;
    GetYearHA:=y;
  end else
  begin
    if DateMore(Date,Dates[i].D1) then GetYearHA:=Dates[i].D1.y else
      GetYearHA:=Dates[i].D1.y+1;
  end;
end;

function GetYearHR(Date : TDate) : integer;
begin
  if (Date.m=2)and(Date.d=29) then
  begin
    if DateMore(Date,Dates[i].D1) then GetYearHR:=Dates[i].D1.y-1 else
      GetYearHR:=Dates[i].D1.y;
  end else
  begin
    if DateMore(Date,Dates[i].D1) then GetYearHR:=Dates[i].D1.y-1 else
      GetYearHR:=Dates[i].D1.y;
  end;
end;

function GetYearE(Date : TDate) : integer;
var
  y : integer;

begin
  if (Date.m=2)and(Date.d=29) then
  begin
    if DateMore(Date,Dates[i-1].D1) then y:=nowy else y:=nowy+1;
    while not((y mod 4 = 0)and(not((y mod 100 = 0)and(y mod 400 <> 0)))) do
      y:=y+1;
    GetYearE:=y;
  end else
  if DateMore(Date,Dates[i-1].D1) then GetYearE:=NowY else GetYearE:=NowY+1;
end;

procedure Print;
begin
  for i:=1 to n do
  begin
    write(months[Dates[i].d1.m],' ',Dates[i].d1.d,' ',Dates[i].d1.y,', ');
    if Dates[i].sign=_added then write('added ') else write('removed ');
    write(months[Dates[i].d2.m],' ',Dates[i].d2.d);
    writeln;
  end;
end;

begin
  init;
  Dates[0].D1.m:=0; Dates[0].D1.d:=0;
  HNum:=0; NowY:=Ys;
  for i:=1 to n do
  begin
    ReadDate(Dates[i].D1);
    ReadSign(Dates[i].Sign);
    ReadDate(Dates[i].D2);
    {readln;}
    read(ch);
  end;
  for i:=1 to n do
  begin
    Dates[i].D1.y:=GetYearE(Dates[i].D1);
    NowY:=Dates[i].D1.y;
  end;
  for i:=1 to n do
    if Dates[i].Sign=_added then Dates[i].D2.y:=GetYearHA(Dates[i].D2) else
      Dates[i].D2.y:=GetYearHR(Dates[i].d2);
  HNum:=0;
  for i:=1 to n do
    if Dates[i].Sign=_added then
    begin
      HNum:=HNum+1;
      Holiday[HNum].Added:=Dates[i].D2.y;
      Holiday[HNum].D:=Dates[i].D2;
      Holiday[HNum].Removed:=Yf;
      for j:=i+1 to n do
      begin
        if Dates[j].Sign=_removed then
          if EqDates(Dates[i].D2,Dates[j].D2) then
          begin
            Holiday[HNum].Removed:=Dates[j].D2.y;
            break;
          end;
      end;
    end;
  Res:=0;
  for i:=1800 to 2200 do q[i]:=0;
  for i:=1 to HNum do
  begin
    a:=Holiday[i].Added;
    b:=Holiday[i].Removed;
    if (a<=b)and(a<=yf)and(b<=yf) then
    begin
      if (Holiday[i].D.M=2)and(Holiday[i].D.D=29) then
      begin
        for j:=a to b do
          if (j mod 4 = 0)and(not((j mod 100 = 0)and(j mod 400 <> 0))) then
            inc(q[j]);
      end else
        for j:=a to b do inc(q[j]);
    end else
    begin
      writeln(-1);
      close(output);
      halt;
    end;
  end;
  res:=0;
  for i:=ys to yf do res:=res+q[i];
  writeln(res);
  Print;
  close(output);
end.
