{$I-,Q-,R-,S-}
const
     FileIn='holidays.in';
     FileOut='holidays.out';
     MinYear=1800;
     MaxYear=2200;
     MaxDeltaYears=100;
     MaxN=100;
     MonthsCount=12;
     Months: array [1..MonthsCount] of string=('January','February','March','April','May','June','July','August','September','October','November','December');
     actAdded=1;
     actRemoved=2;
type
    TRecord=record
                  Month, Day, AddMonth, AddDay: LongInt;
                  Action: LongInt;
            end;
var
   StartYear, FinishYear: LongInt;
   N: LongInt;
   Records: array [1..MaxN] of TRecord;

   Answer: LongInt;
   Years: array [1..MaxN] of LongInt;

function Month2Index (const aMonth: string): LongInt;
var
   NMonth: LongInt;
begin
     for NMonth:=Low (Months) to High (Months)
         do if Months [NMonth]=aMonth
               then begin
                    Month2Index:=NMonth;
                    Exit;
               end;
     Month2Index:=0;
end;

procedure ReadData;
var
   F: Text;
   NRecord: LongInt;
   S, MonthStr, DayStr, Action: string;
   NChar: LongInt;
   Err: Integer;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, StartYear, FinishYear);
     Readln (F, N);
     for NRecord:=1 to N
         do begin
            Readln (F, S);
            MonthStr:='';
            for NChar:=1 to Length (S)
                do begin
                   if S [NChar]=#32
                      then Break;
                   MonthStr:=MonthStr+S [NChar];
                end;
            Records [NRecord].AddMonth:=Month2Index (MonthStr);
            DayStr:='';
            for NChar:=NChar+1 to Length (S)
                do begin
                   if S [NChar]=','
                      then Break;
                   DayStr:=DayStr+S [NChar];
                end;
             Val (DayStr, Records [NRecord].AddDay, Err);
             Action:='';
             for NChar:=NChar+2 to Length (S)
                 do begin
                    if S [NChar]=#32
                       then Break;
                    Action:=Action+S [NChar];
                 end;
             if Action='added'
                then Records [NRecord].Action:=actAdded
                else Records [NRecord].Action:=actRemoved;
             MonthStr:='';
             for NChar:=NChar+1 to Length (S)
                 do begin
                    if S [NChar]=#32
                       then Break;
                    MonthStr:=MonthStr+S [NChar];
                 end;
             Records [NRecord].Month:=Month2Index (MonthStr);
             DayStr:='';
             for NChar:=NChar+1 to Length (S)
                 do DayStr:=DayStr+S [NChar];
             Val (DayStr, Records [NRecord].Day);
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   NRecord: LongInt;

function Action2CaptionHehe (aAction: LongInt): string;
begin
     case aAction of
          actAdded: Action2CaptionHehe:='added';
          actRemoved: Action2CaptionHehe:='removed';
          else Action2CaptionHehe:='I don''t know such action!!!';
     end;
end;

begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     if Answer>=0
        then for NRecord:=1 to N
                 do Writeln (F, Months [Records [NRecord].AddMonth], #32, Records [NRecord].AddDay, #32, Years [NRecord], ', ', Action2CaptionHehe (Records [NRecord].Action), #32, Months [Records [NRecord].Month], #32, Records [NRecord].Day);
     Close (F);
end;

var
   LeapYears: array [MinYear..MaxYear] of Boolean;
   CanBeAddedThisYear, CanHappenThisYear: array [1..MaxN, MinYear..MaxYear] of Boolean;
   JumpTable: array [1..MaxN, MinYear..MaxYear] of LongInt;

function IsLeapYear (aYear: LongInt): Boolean;
begin
     IsLeapYear:=((aYear mod 4=0) and (not (aYear mod 100=0))) or (aYear mod 400=0);
end;

function FirstIsSooner (aFirstMonth, aFirstDay, aSecondMonth, aSecondDay: LongInt): Boolean;
begin
     FirstIsSooner:=(aFirstMonth<aSecondMonth) or ((aFirstMonth=aSecondMonth) and (aFirstDay<aSecondDay));
end;

procedure BuildJumpTable;
var
   NYear: LongInt;
   NRecord: LongInt;
   ComesAfterMessage: Boolean;
begin
     for NYear:=StartYear to FinishYear
         do LeapYears [NYear]:=IsLeapYear (NYear);
     for NRecord:=1 to N
         do for NYear:=StartYear to FinishYear
                do CanBeAddedThisYear [NRecord, NYear]:=(Records [NRecord].AddMonth<>2) or (Records [NRecord].AddDay<>29) or LeapYears [NYear];
     for NRecord:=1 to N
         do for NYear:=StartYear to FinishYear
                do CanHappenThisYear [NRecord, NYear]:=(Records [NRecord].Month<>2) or (Records [NRecord].Day<>29) or LeapYears [NYear];
     for NRecord:=1 to N
         do begin
            ComesAfterMessage:=FirstIsSooner (Records [NRecord].AddMonth, Records [NRecord].AddDay, Records [NRecord].Month, Records [NRecord].Day);
            for NYear:=FinishYear downto StartYear
                do if CanHappenThisYear [NRecord, NYear]
                      then Break;
            if ComesAfterMessage
               then JumpTable [NRecord, NYear]:=1
               else JumpTable [NRecord, NYear]:=0;
            for NYear:=NYear-1 downto StartYear
                do if CanHappenThisYear [NRecord, NYear]
                      then JumpTable [NRecord, NYear]:=JumpTable [NRecord, NYear+1]+1
                      else JumpTable [NRecord, NYear]:=JumpTable [NRecord, NYear+1];
         end;
end;

type
    TACell=record
                 FilledIn: Boolean;
                 FromYear: Integer;
                 Count: Integer;
           end;
var
   A: array [1..MaxN, MinYear..MaxYear] of TACell;

procedure Solve;
var
   NRecord: LongInt;
   NYear, NAddYear: LongInt;
   NewCount: LongInt;
begin
     BuildJumpTable;
     FillChar (A, SizeOf (A), 0);
     for NYear:=StartYear to FinishYear
         do if CanBeAddedThisYear [1, NYear]
               then with A [1, NYear]
                         do begin
                            FilledIn:=true;
                            FromYear:=0;
                            Count:=JumpTable [1, NYear];
                         end;
     for NRecord:=1 to N-1
         do for NYear:=StartYear to FinishYear
                do if A [NRecord, NYear].FilledIn
                      then for NAddYear:=NYear to FinishYear
                               do if CanBeAddedThisYear [NRecord+1, NAddYear] and ((NYear<NAddYear) or ((NYear=NYear) and
                                     FirstIsSooner (Records [NRecord].AddMonth, Records [NRecord].AddDay, Records [NRecord+1].AddMonth, Records [NRecord+1].AddDay)))
                                     then begin
                                          if Records [NRecord+1].Action=actAdded
                                             then NewCount:=A [NRecord, NYear].Count+JumpTable [NRecord+1, NAddYear]
                                             else NewCount:=A [NRecord, NYear].Count-JumpTable [NRecord+1, NAddYear];
                                          with A [NRecord+1, NAddYear]
                                               do if (not FilledIn) or (Count<NewCount)
                                                     then begin
                                                          FilledIn:=true;
                                                          FromYear:=NYear;
                                                          Count:=NewCount;
                                                     end;
                                     end;
     NAddYear:=0;
     for NYear:=StartYear to FinishYear
         do if A [N, NYear].FilledIn
               then if (NAddYear=0) or (A [N, NAddYear].Count<A [N, NYear].Count)
                       then NAddYear:=NYear;
     if NAddYear=0
        then Answer:=-1
        else begin
             Answer:=A [N, NAddYear].Count;
             NYear:=NAddYear;
             for NRecord:=N downto 1
                 do begin
                    Years [NRecord]:=NYear;
                    NYear:=A [NRecord, NYear].FromYear;
                 end;
        end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
