program zzz;

type
  TLong = array[0..200] of Longint;

const
  maxn = 100;
  osn = 10;

var
  buf,res: TLong;
  ans,i,j,k,cur,n,m,p,q,sc1,sc2: Longint;
  a,b: array[0..maxn] of Longint;
  p1,p2: array[0..maxn] of Longint;
  col1,col2: array[0..maxn] of Longint;
  g: array[1..maxn,1..maxn] of Boolean;
  is1,is2,vis1,vis2: array[0..maxn] of boolean;
  found: Boolean;

function max(a,b: Longint): Longint;
begin
  if a > b then max := a else max := b;
end;

procedure prodsmall(var a: Tlong; num: Longint);
var i,j: Longint;
begin
  for i := 1 to a[0] do begin
    a[i] := a[i] * num;
  end;
  for i := 1 to a[0] do begin
    a[i+1] := a[i+1] + a[i] div osn;
    a[i] := a[i] mod osn;
  end;
  a[0] := a[0] + 1;
  while (a[a[0]] = 0) and (a[0] <> 0) do dec(a[0]);
end;

procedure prodlong(a,b: Tlong; var c: Tlong);
var i,j: Longint;
begin
  fillchar(c,sizeof(c),0);
  for i := 1 to a[0] do begin
    for j := 1 to b[0] do begin
      c[i+j-1] := c[i+j-1] + a[i] * b[j];
    end;
  end;
  for i := 1 to a[0] + b[0] do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] Mod osn;
  end;
  c[0] := a[0] + b[0];
  while (c[c[0]] = 0) and (c[0] <> 0) do dec(c[0]);
end;

procedure PrintLong(a: TLong);
var i,j: Longint;
begin
  write(a[a[0]]);
  for i := a[0] - 1 downto 1 do begin
    j := osn;
    while j <> 1 do begin
      j := j div 10;
      write(a[i] div j);
      a[i] := a[i] mod j;
    end;
  end;
end;

procedure sum(a,b: Tlong; var c: Tlong);
var i,j,k: Longint;
begin
  for i := 1 to max(a[0],b[0]) do begin
    c[i] := a[i] + b[i];
  end;
  for i := 1 to max(a[0],b[0]) do begin
    c[i+1] := c[i+1] + c[i] div osn;
    c[i] := c[i] mod osn;
  end;
  c[0] := max(a[0],b[0])+1;
  while (c[c[0]] = 0) and (c[0] <> 0) do dec(c[0]);
end;

procedure rec2(v: Longint); forward;
procedure rec1(v: Longint);
var i,j: Longint;
begin
  vis1[v] := true;
  for i := 1 to sc2 do begin
    if g[v,i] and not vis2[i] then begin
      rec2(i);
    end;
  end;
end;

procedure rec2(v: Longint);
var i,j: Longint;
begin
  vis2[v] := true;
  for i := 1 to sc1 do begin
    if g[i,v] and not vis1[i] then begin
      rec1(i);
    end;
  end;
end;

function iscycle1(i: Longint): Boolean;
var j: Longint;
begin
  fillchar(vis1,sizeof(vis1),false);
  j := p1[i];
  vis1[i] := true;
  while not vis1[j] do begin
    vis1[j] := true;
    j := p1[j];
  end;
  iscycle1 := i = j;
end;

function iscycle2(i: Longint): Boolean;
var j: Longint;
begin
  fillchar(vis1,sizeof(vis1),false);
  j := p2[i];
  vis1[i] := true;
  while not vis1[j] do begin
    vis1[j] := true;
    j := p2[j];
  end;
  iscycle2 := i = j;
end;

procedure paintcycle1(i,col: longint);
var j: Longint;
begin
  j := p1[i];
  col1[i] := col;
  while j <> i do begin
    col1[j] := col;
    j := p1[j];
  end;
end;

procedure paintcycle2(i,col: longint);
var j: Longint;
begin
  j := p2[i];
  col2[i] := col;
  while j <> i do begin
    col2[j] := col;
    j := p2[j];
  end;
end;

procedure buildgraph();
var i,j: Longint;
begin
  for i := 0 to m-1 do begin
    if (col1[i] <> 0) and (col2[i] <> 0) then begin
      g[col1[i],col2[i]] := true;
    end else begin
      if col2[i] = 0 then if col1[i] <> 0 then is1[col1[i]] := true;
      if col1[i] = 0 then if col2[i] <> 0 then is2[col2[i]] := true;
    end;
  end;
end;

begin
  assign(input,'invar.in'); reset(input);
  assign(output,'invar.out'); rewrite(output);
  read(m);
  read(p);
  for i := p downto 0 do begin
    read(a[i]);
  end;
  read(q);
  for i := q downto 0 do read(b[i]);
  for i := 0 to m-1 do begin
    cur := a[p];
    for j := p downto 1 do begin
      cur := (cur * i + a[j-1]) mod m;
    end;
    p1[i] := cur;
  end;
  for i := 0 to m-1 do begin
    cur := b[p];
    for j := q downto 1 do begin
      cur := (cur * i + b[j-1]) mod m;
    end;
    p2[i] := cur;
  end;
  for i := 0 to m-1 do begin
    if iscycle1(i) and (col1[i] = 0) then begin
      inc(sc1);
      paintcycle1(i,sc1);
    end;
  end;
  for i := 0 to m-1 do begin
    if iscycle2(i) and (col2[i] = 0) then begin
      inc(sc2);
      paintcycle2(i,sc2);
    end;
  end;
  BuildGraph();
  fillchar(vis1,sizeof(vis1),false);
  fillchar(vis2,sizeof(vis2),false);
  for i := 1 to sc2 do begin
    if is2[i] then rec2(i);
  end;
  for i := 1 to sc1 do begin
    if not vis1[i] and not is1[i] then begin
      rec1(i);
      inc(ans);
    end;
  end;
  res[0] := 1;
  res[1] := 1;
  for i := 1 to ans do begin
    ProdSmall(res,2);
  end;
  PrintLong(res);
  close(input);
  close(output);
end.
