{$A+,B-,D+,E-,F-,G+,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}

const
  coutfile = 'ackerman.out';
  cinfile = 'ackerman.in';

  nmax = 110;

type
  int = longint;
  real = extended;

var
  n, m, t : int;
  ans : int;

  per, pred : array [2..nmax,0..nmax] of int;

  a : array [2..nmax,1..nmax,1..nmax] of int;
  ca : array [-1..nmax,-1..nmax] of int;

procedure outdata;
var
  i, j : int;
begin
  writeln(ans);
end;

function two_n(n, t : int) : int;
begin
  two_n:= per[t,(n-1-pred[t,0]+per[t,0] shl 5) mod per[t,0] + 1];
end;

function coolack(n,m : int) : int;
begin
  if (n = -1) or (m = -1) then
  begin
    coolack:= -1;
  end;
  if n = 1 then coolack:= m shl 1 else
    if m= 1 then coolack:= 2 else
      if m = 2 then coolack:= 4 else
        if (n = 2) and (m <= 6) then coolack:= 1 shl m else
          if (n = 3) and (m = 3) then coolack:= 16 else coolack:= -1;
end;

function ackerman(t,n,m : int) : int;
var
  i, c, x, n2 : int;
begin
  if (n = -1) or (m = -1) then
  begin
    ackerman:= -1;
    exit;
  end;
  if a[t,n,m] > -1 then
  begin
    ackerman:= a[t,n,m];
    exit;
  end;
  if n = 1 then
  begin
    a[t,n,m]:= (m shl 1) mod t;
    ackerman:= (m shl 1) mod t;
  end else
    if m= 1 then
    begin
      a[t,n,m]:= 2 mod t;
      ackerman:= 2 mod t;
    end else
    begin
      c:= coolack(n,m-1);
      if c > -1 then
      begin
        a[t,n,m]:= ackerman(t,n-1,c);
        ackerman:= a[t,n,m];
        exit;
      end else
      begin
        if n = 2 then
        begin
          c:= 1;
          for i:= 1 to m do c:= (c shl 1) mod t;
          ackerman:= c;
          exit;
        end;
        if n = 3 then
        begin
          a[t,n,m]:= two_n(m,t);
          ackerman:= a[t,n,m];
          exit;
        end;
        if n = 4 then
        begin
          a[t,n,m]:= two_n(ackerman(per[t,0],n,m-1),t);
          ackerman:= a[t,n,m];
          exit;
        end;
        if n > 4 then
        begin
          x:= two_n(ackerman(per[t,0],n,m-1),per[t,0]);
          n2:= n;
          while n2 > 4 do
          begin
            dec(n2);
            x:= two_n(x,per[t,0]);
          end;
          x:= two_n(x,t);
          a[n,m,t]:= x;
          ackerman:= x;
          exit;
        end;
        ackerman:= 1;
      end;
    end;
end;

function q(x, k : int) : int;
var
  c : int;
  i : int;
begin
  c:= 1;
  for i:= 1 to x do c:= (c shl 1) mod k;
  q:= c;
end;

procedure circle;
var
  i, j, k : int;
  x, y : int;
  u : array [0..nmax] of boolean;
begin
  fillchar(per,sizeof(per),0);
  fillchar(pred,sizeof(pred),0);
  for k:= 2 to t do
  begin
    fillchar(u,sizeof(u),0);
    x:= 2;
    while not u[x] do
    begin
      u[x]:= true;
      x:= q(x,k);
    end;
    inc(per[k,0]);
    per[k,per[k,0]]:= x;
    y:= q(x,k);
    while x <> y do
    begin
      inc(per[k,0]);
      per[k,per[k,0]]:= y;
      y:= q(y,k);
    end;
    y:= 2 mod k;
    while y <> x do
    begin
      inc(pred[k,0]);
      pred[k,pred[k,0]]:= y;
      y:= q(y,k);
    end;
  end;
end;

procedure solve;
var
  i, j : int;
begin
  ans:= ackerman(t,n,m);
end;

procedure readdata;
var
  i, j : int;
  c : int;
begin
  fillchar(a,sizeof(a),255);
  read(t);
  circle;
  c:= 0;
  while not eof do
  begin
    read(n,m);
    if n = 0 then exit;
    inc(c);
    write('Case ',c,': ');
    solve;
    outdata;
  end;
end;

begin
  assign(input,cinfile);
  reset(input);
  assign(output,coutfile);
  rewrite(output);
  readdata;
  close(input);
  close(output);
end.


procedure debug;
var
  i, j, q : int;
begin
  for i:= 2 to 5 do
    for j:= 1 to 5 do
      for q:= 1 to 5 do ackerman(i,j,q);
  writeln;
  for i:= 2 to 5 do
  begin
    for j:= 1 to 5 do
    begin
      for q:= 1 to 5 do write(a[i,j,q],' ');
      writeln;
    end;
    writeln;
  end;
end;

