type
  float = extended;

const
  eps = 1e-7;
  MaxIters = 1000;

var
  fi, fo: text;
  s1,s2,s3: float;
  h,w: float;
  x1,y1,x2,y2,x3,y3,x4,y4: float;
  rx1,ry1,rx2,ry2,rx3,ry3,rx4,ry4: float;
  res: boolean;
  xp,yp: float;

procedure solve_eq(a1,b1,c1,a2,b2,c2: float; var x,y: float);
var t: float;
begin
  t:=a1*b2-a2*b1;
  x:=-(b1*c2-b2*c1)/t;
  y:=(a1*c2-a2*c1)/t;
end;

function IsInside(x,y,x1,y1,x2,y2,x3,y3,x4,y4: float): boolean;
var s,s1: float;
begin
  s:=abs(x*y1-x1*y+x1*y2-x2*y1+x2*y-x*y2)+
     abs(x*y2-x2*y+x2*y3-x3*y2+x3*y-x*y3)+
     abs(x*y3-x3*y+x3*y4-x4*y3+x4*y-x*y4)+
     abs(x*y4-x4*y+x4*y1-x1*y4+x1*y-x*y1);
  s1:=abs(x1*y2-x2*y1+x2*y3-x3*y2+x3*y4-x4*y3+x4*y1-x1*y4);
  if abs(s1-s)<eps then IsInside:=true else
    IsInside:=false;
end;


procedure Solve;
var a,b,c,d,xp1,yp1,h1,w1: float;
    i: longint;
    tx1,ty1,tx2,ty2,tx3,ty3,tx4,ty4: float;
begin
  a:=(x2-x1)/w;
  b:=(x4-x1)/h;
  c:=(y2-y1)/w;
  d:=(y4-y1)/h;
  solve_eq(a-1,b,-x1,c,d-1,-y1,xp,yp);
  xp1:=xp*(s2/s1);
  yp1:=yp*(s2/s1);
  h1:=h*(s2/s1);
  w1:=w*(s2/s1);
  tx1:=-xp1;
  ty1:=-yp1;
  tx2:=w1-xp1;
  ty2:=-yp1;
  tx3:=w1-xp1;
  ty3:=h1-yp1;
  tx4:=-xp1;
  ty4:=h1-yp1;
  RandSeed:=666;
  for i:=1 to MaxIters do begin
    c:=random*2*pi;
    a:=cos(c);
    b:=sin(c);
    rx1:=xp+tx1*a-ty1*b;
    ry1:=yp+tx1*b+ty1*a;
    rx2:=xp+tx2*a-ty2*b;
    ry2:=yp+tx2*b+ty2*a;
    rx3:=xp+tx3*a-ty3*b;
    ry3:=yp+tx3*b+ty3*a;
    rx4:=xp+tx4*a-ty4*b;
    ry4:=yp+tx4*b+ty4*a;
    res:=IsInside(rx1,ry1,0,0,w,0,w,h,0,h);
    res:=res and IsInside(rx2,ry2,0,0,w,0,w,h,0,h);
    res:=res and IsInside(rx3,ry3,0,0,w,0,w,h,0,h);
    res:=res and IsInside(rx4,ry4,0,0,w,0,w,h,0,h);
    res:=res and IsInside(x1,y1,rx1,ry1,rx2,ry2,rx3,ry3,rx4,ry4);
    res:=res and IsInside(x2,y2,rx1,ry1,rx2,ry2,rx3,ry3,rx4,ry4);
    res:=res and IsInside(x3,y3,rx1,ry1,rx2,ry2,rx3,ry3,rx4,ry4);
    res:=res and IsInside(x4,y4,rx1,ry1,rx2,ry2,rx3,ry3,rx4,ry4);
    if res then break;
  end;
end;

procedure Init;
begin
  Assign(fi,'maps.in');
  Assign(fo,'maps.out');
  Reset(fi);
  Rewrite(fo);
  Read(fi,s1,w,h,s2,s3,x1,y1,x2,y2,x3,y3,x4,y4);
end;

procedure Done;
begin
  if res then begin
    WriteLn(fo,rx1:7:7,' ',ry1:7:7);
    WriteLn(fo,rx2:7:7,' ',ry2:7:7);
    WriteLn(fo,rx3:7:7,' ',ry3:7:7);
    WriteLn(fo,rx4:7:7,' ',ry4:7:7);
  end else WriteLn(fo,'impossible');
  Close(fi);
  Close(fo);
end;

Begin
  Init;
  Solve;
  Done;
End.
