{$I-,Q-,R-,S-,N+}
type
  type1=record
    a:extended;
    add:boolean;
  end;

const
  pi:extended=3.1415926535897932385;
  maxbads=500;
  maxn=maxbads*2;
  eps=1e-10;

var
  s1,s2,s3:extended;
  x1,y1:extended;
  x0,y0,x,y,x_,y_,x3,y3:extended;
  x_1,y_1,x_2,y_2,x_3,y_3:array[1..4] of extended;

  step:extended;
  found:boolean;
  aox,box,cox,aoy,boy,coy:extended;
  i,j,i1,j1:integer;
  z:array[-1..1,-1..1] of extended;
  bads:array[1..maxbads] of record
    a,b:extended;
  end;
  badcount:integer;
  a,b:extended;
  a1,b1,c1,a2,b2,c2:array[1..4] of extended;
  q:array[1..maxn] of type1;
  n,k:integer;

procedure makeline(x1,y1,x2,y2:extended;var a,b,c:extended);
var
  d:extended;
begin
  a:=y2-y1;
  b:=x1-x2;
  c:=-a*x1-b*y1;
  d:=sqrt(sqr(a)+sqr(b));
  a:=a/d;
  b:=b/d;
  c:=c/d;
end;

procedure swap(x,y:extended);
var
  t:extended;
begin
  t:=x;
  x:=y;
  y:=t;
end;

procedure qswap(x,y:integer);
var
  temp:type1;
begin
  temp:=q[x];
  q[x]:=q[y];
  q[y]:=temp;
end;

procedure qsort(l,r:integer);
var
  i,j:integer;
  x:type1;
begin
  i:=l;
  j:=r;
  x:=q[(l+r) div 2];
  repeat
    while (q[i].a<x.a) do
      inc(i);
    while (x.a<q[j].a) do
      dec(j);
    if i<=j then begin
      qswap(i,j);
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then
    qsort(l,j);
  if i<r then
    qsort(i,r);
end;

function polarangle(x,y:extended):extended; assembler;
asm
  fld y
  fld x
  fpatan
end;

procedure count3(x1,y1:extended;var x,y:extended);
begin
  x:=aoy*x1+boy*y1+coy;
  y:=aox*x1+box*y1+cox;
  x:=x/s3;
  y:=y/s3;
end;

function goodangle(a:extended):extended;
var
  a1:extended;

begin
  a1:=a;
  while a1<0 do
    a1:=a1+2*pi;
  while a1-2*pi+eps>0 do
    a1:=a1-2*pi;
  goodangle:=a1;
end;

procedure addbad(a,b:extended);
var
  a1,b1:extended;

begin
  if goodangle(a-b)<=pi then begin
    a1:=goodangle(a);
    b1:=goodangle(b);
  end else begin
    a1:=goodangle(b);
    b1:=goodangle(a);
  end;
  if b1<a1 then begin
    inc(badcount);
    bads[badcount].a:=a1;
    bads[badcount].b:=2*pi;
    inc(badcount);
    bads[badcount].a:=0;
    bads[badcount].b:=b1;
  end else begin
    inc(badcount);
    bads[badcount].a:=a1;
    bads[badcount].b:=b1;
  end;
end;

function perline(a1,b1,c1,a2,b2,c2:extended;var x,y:extended):boolean;
var
  d:extended;

begin
  d:=a2*b1-a1*b2;
  if abs(d)<eps then begin
    perline:=false;
    exit;
  end;
  x:=(b2*c1-b1*c2)/d;
  y:=(a1*c2-a2*c1)/d;
  perline:=true;
end;

function badangles(oa,ob,oc,x,y:extended;var a,b:extended):boolean;
var
  a1,b1,c1:extended;
  r,r2:extended;
  a0:extended;
  x0,y0:extended;
  d,d2:extended;
  s:extended;
  x_,y_:extended;
  sa1,sb1:extended;

begin
  a0:=polarangle(x,y);
  r2:=x*x+y*y;
  r:=sqrt(r2);
  d:=oc;
  d2:=d*d;
  if d2-r2+eps>0 then begin
    badangles:=false;
    exit;
  end;
  a1:=ob;
  b1:=-oa;
  c1:=0;
  perline(a1,b1,c1,oa,ob,oc,x0,y0);
  if x0<(1e-15) then
    x0:=0;
  if y0<(1e-15) then
    y0:=0;
  s:=sqrt(r2-d2);
  sa1:=s*a1;
  sb1:=s*b1;
  x_:=x0+sa1;
  y_:=y0+sb1;
  a:=polarangle(x_,y_);
  x_:=x0-sa1;
  y_:=y0-sb1;
  b:=polarangle(x_,y_);
  a:=a-a0;
  b:=b-a0;
  badangles:=true;
end;

procedure rotate(var x,y:extended;a:extended);
var
  d:extended;
  a0:extended;
begin
  d:=sqrt(x*x+y*y);
  a0:=polarangle(x,y);
  x:=d*cos(a+a0);
  y:=d*sin(a+a0);
end;

procedure addans(a:extended);
var
  i:integer;
begin
  for i:=1 to 4 do
    rotate(x_2[i],y_2[i],a);
  for i:=1 to 4 do begin
    x_2[i]:=x_2[i]+x0;
    y_2[i]:=y_2[i]+y0;
  end;
  for i:=1 to 4 do begin
    writeln(x_2[i]:0:10,' ',y_2[i]:0:10);
  end;
  close(input);
  close(output);
  halt(0);
end;

begin
  assign(input,'maps.in');
  reset(input);
  assign(output,'maps.out');
  rewrite(output);
  read(s1,x1,y1,s2,s3);
  for i:=1 to 4 do
    read(x_3[i],y_3[i]);


  if s2-s3<eps then begin
    for i:=1 to 4 do
      writeln(x_3[i]:0:10,' ',y_3[i]:0:10);
    close(input);
    close(output);
    halt(0);
  end;

  s2:=s2/s1;
  s3:=s3/s1;
  s1:=1;
  x:=(x_3[1]+x_3[3])/2;
  y:=(y_3[1]+y_3[3])/2;
  makeline(x_3[2],y_3[2],x_3[1],y_3[1],aox,box,cox);
  makeline(x_3[1],y_3[1],x_3[4],y_3[4],aoy,boy,coy);
  step:=10;
  found:=false;
  while not found do begin
    for i:=-1 to 1 do begin
      for j:=-1 to 1 do begin
        x_:=x+step*i;
        y_:=y+step*j;
        count3(x_,y_,x3,y3);
        if (x_>0) and (x_<x1) and (y_>0) and (y_<y1) and
         (x3>0) and (x3<x1) and (y_>0) and (y3<y1) then
          z[i,j]:=sqr(x3-x_)+sqr(y3-y_)
        else
          z[i,j]:=1e10;
      end;
    end;
    i1:=-1;
    j1:=-1;
    for i:=-1 to 1 do
      for j:=-1 to 1 do
        if z[i,j]<z[i1,j1] then begin
          i1:=i;
          j1:=j;
        end;

    if (i1=0) and (j1=0) then begin
      step:=step*3/4;
      if step<eps then
        found:=true;
    end else begin
      x:=x+step*i1;
      y:=y+step*j1;
    end;
  end;

  x0:=x;
  y0:=y;

  x_1[1]:=0;
  y_1[1]:=0;
  x_1[2]:=x1;
  y_1[2]:=0;
  x_1[3]:=x1;
  y_1[3]:=y1;
  x_1[4]:=0;
  y_1[4]:=y1;

  for i:=1 to 4 do begin
    x_2[i]:=x_1[i]*s2;
    y_2[i]:=y_1[i]*s2;
  end;

  x_:=x0*s2;
  y_:=y0*s2;
  for i:=1 to 4 do begin
    x_2[i]:=x_2[i]-x_;
    y_2[i]:=y_2[i]-y_;
    x_1[i]:=x_1[i]-x0;
    y_1[i]:=y_1[i]-y0;
    x_3[i]:=x_3[i]-x0;
    y_3[i]:=y_3[i]-y0;
  end;

  badcount:=0;
  for i:=1 to 3 do begin
    makeline(x_1[i],y_1[i],x_1[i+1],y_1[i+1],a1[i],b1[i],c1[i]);
  end;
  makeline(x_1[4],y_1[4],x_1[1],y_1[1],a1[4],b1[4],c1[4]);
  for i:=1 to 4 do begin
    for j:=1 to 4 do begin
      if badangles(a1[i],b1[i],c1[i],x_2[j],y_2[j],a,b) then begin
        addbad(a,b);
      end;
    end;
  end;

  for i:=1 to 3 do begin
    makeline(x_2[i],y_2[i],x_2[i+1],y_2[i+1],a2[i],b2[i],c2[i]);
  end;
  makeline(x_2[4],y_2[4],x_2[1],y_2[1],a2[4],b2[4],c2[4]);
  for i:=1 to 4 do begin
    for j:=1 to 4 do begin
      if badangles(a2[i],b2[i],c2[i],x_3[j],y_3[j],a,b) then begin
        addbad(-a,-b);
      end;
    end;
  end;

  n:=0;
  for i:=1 to badcount do begin
    inc(n);
    q[n].add:=true;
    q[n].a:=bads[i].a;
    inc(n);
    q[n].add:=false;
    q[n].a:=bads[i].b;
  end;

  addans(0);

  qsort(1,n);
  inc(n);
  q[n+1].add:=true;
  q[n+1].a:=2*pi-2*eps;
  if q[1].a>eps then begin
    addans(0);

  end;
  k:=0;
  for i:=1 to n do begin
    if q[i].add then
      inc(k)
    else
      dec(k);
    if (k=0) and (abs(q[i].a-q[i+1].a)<eps) then begin
      a:=(q[i].a+q[i+1].a)/2;
      addans(a);
    end;
  end;
  write('impossible');
  close(input);
  close(output);
  halt;
end.