{$I-,Q-,R-,S-,H+}
const
     FileIn='ackerman.in';
     FileOut='ackerman.out';
     MaxN=100;
     MaxM=100;
type
    TACell=QWord;
    TAMatrix=array [1..MaxN, 1..MaxM] of string;
var
   FIn, FOut: Text;
   T: LongInt;
   A: TAMatrix;

function LongSumCh (aA, aB: Char): Char;
begin
     LongSumCh:=Chr (Ord (aA)+Ord (aB)-Ord ('0'))
end;

function LongSum (const aA, aB: string): string;
var
   B, C: string;
   NChar, Delta: LongInt;
begin
     Delta:=Length (aA)-Length (aB);
     B:='';
     C:='';
     for NChar:=1 to Delta
         do B:=B+'0';
     for NChar:=1 to -Delta
         do C:=C+'0';
     B:=B+aB;
     C:=C+aA;
     if (B [1]<>'0') or (C [1]<>'0')
        then begin
             B:='0'+B;
             C:='0'+C;
        end;
     for NChar:=Length (B) downto 1
         do begin
            C [NChar]:=LongSumCh (C [NChar], B [NChar]);
            if C [NChar]>'9'
               then begin
                    Dec (C [NChar], 10);
                    Inc (C [NChar-1]);
               end;
         end;
     LongSum:=C;
end;

function LongMulCh (aA, aB: Char): Char;
begin
     LongMulCh:=Chr ((Ord (aA)-Ord ('0'))*(Ord (aB)-Ord ('0'))+Ord ('0'));
end;

function Check (const aA: string): Boolean;
var
   NChar: LongInt;
begin
     for NChar:=1 to Length (aA)
         do if not (aA [NChar] in ['0'..'9'])
               then begin
                    Check:=false;
                    Exit;
               end;
     Check:=true;
end;

function LongMulOnCh (const aA: string; aB: Char): string;
var
   C: string;
   NChar: LongInt;
begin
     if aA [1]='0'
        then C:=aA
        else C:='0'+aA;
     for NChar:=Length (C) downto 2
         do C [NChar]:=LongMulCh (C [NChar], aB);
     for NChar:=Length (C) downto 2
         do while C [NChar]>'9'
                  do begin
                     Dec (C [NChar], 10);
                     Inc (C [NChar-1]);
                  end;
     if not Check (C)
        then begin
             Writeln ('Can''t mul ', aA, ' on ', aB, ' :(((');
             LongMulOnCh (aA, aB);
             Halt;
        end;
     LongMulOnCh:=C;
end;

function LongMul (const aA, aB: string): string;
var
   C, Offset: string;
   NChar: LongInt;
begin
     C:='0';
     Offset:='';
     for NChar:=Length (aB) downto 1
         do begin
            C:=LongSum (C, LongMulOnCh (aA, aB [NChar])+Offset);
            Offset:=Offset+'0';
         end;
     LongMul:=C;
end;

function LongFirstIsLessOrEqual (const aA, aB: string): Boolean;
var
   A, B: string;
   NChar, Delta: LongInt;
begin
     Delta:=Length (aA)-Length (aB);
     B:='';
     for NChar:=1 to Delta
         do B:=B+'0';
     A:='';
     for NChar:=1 to -Delta
         do A:=A+'0';
     A:=A+aA;
     B:=B+aB;
     LongFirstIsLessOrEqual:=A<=B;
end;

function LongDivIntoChar (const aA, aB: string): Char;
var
   Ch: Char;
begin
     for Ch:='1' to '9'
         do if not LongFirstIsLessOrEqual (LongMulOnCh (aB, Ch), aA)
               then Break;
     LongDivIntoChar:=Chr (Ord (Ch)-1);
end;

function LongMinCh (aA, aB: Char): Char;
begin
     LongMinCh:=Chr (Ord (aA)-Ord (aB)+Ord ('0'));
end;

function LongMin (const aA, aB: string): string;
var
   B, C: string;
   NChar, Delta: LongInt;
begin
     Delta:=Length (aA)-Length (aB);
     B:='';
     C:='';
     for NChar:=1 to Delta
         do B:=B+'0';
     for NChar:=1 to -Delta
         do C:=C+'0';
     B:=B+aB;
     C:=C+aA;
     if (B [1]<>'0') or (C [1]<>'0')
        then begin
             B:='0'+B;
             C:='0'+C;
        end;
     for NChar:=Length (B) downto 1
         do begin
            C [NChar]:=LongMinCh (C [NChar], B [NChar]);
            if C [NChar]<'0'
               then begin
                    Inc (C [NChar], 10);
                    Dec (C [NChar-1]);
               end;
         end;
     LongMin:=C;
end;

function LongDiv (const aA, aB: string): string;
var
   A, C: string;
   NChar: LongInt;
begin
     A:='';
     C:='';
     for NChar:=1 to Length (aA)
         do begin
            A:=A+aA [NChar];
            C:=C+LongDivIntoChar (A, aB);
            A:=LongMin (A, LongMulOnCh (aB, C [Length (C)]));
         end;
     LongDiv:=C;
end;

function LongMod (const aA, aB: string): string;
begin
     LongMod:=LongMin (aA, LongMul (aB, LongDiv (aA, aB)));
end;

function KillFirstZeroes (const aA: string): string;
var
   NChar: LongInt;
   B: string;
begin
     for NChar:=1 to Length (aA)
         do if aA [NChar]<>'0'
               then Break;
     B:='';
     for NChar:=NChar to Length (aA)
         do B:=B+aA [NChar];
     KillFirstZeroes:=B;
end;

function StrToInt (const aA: string): QWord;
var
   Err: Integer;
   Value: QWord;
begin
     Val (aA, Value, Err);
     StrToInt:=Value;
end;

function IntToStr (const aA: QWord): string;
var
   S: string;
begin
     Str (aA, S);
     IntToStr:=S;
end;

procedure InitHehe;
begin
     FillChar (A, SizeOf (A), 0);
     A [1, 1]:='02';
     A [1, 2]:='04';
     A [1, 3]:='06';
     A [1, 4]:='08';
     A [1, 5]:='10';
     A [1, 6]:='12';
     A [1, 7]:='14';
     A [1, 8]:='16';
     A [1, 9]:='18';
     A [1, 10]:='020';
     A [1, 11]:='022';
     A [1, 12]:='024';
     A [1, 13]:='026';
     A [1, 14]:='028';
     A [1, 15]:='030';
     A [1, 16]:='032';
     A [1, 17]:='034';
     A [1, 18]:='036';
     A [1, 19]:='038';
     A [1, 20]:='040';
     A [1, 21]:='042';
     A [1, 22]:='044';
     A [1, 23]:='046';
     A [1, 24]:='048';
     A [1, 25]:='050';
     A [1, 26]:='052';
     A [1, 27]:='054';
     A [1, 28]:='056';
     A [1, 29]:='058';
     A [1, 30]:='060';
     A [1, 31]:='062';
     A [1, 32]:='064';
     A [1, 33]:='066';
     A [1, 34]:='068';
     A [1, 35]:='070';
     A [1, 36]:='072';
     A [1, 37]:='074';
     A [1, 38]:='076';
     A [1, 39]:='078';
     A [1, 40]:='080';
     A [1, 41]:='082';
     A [1, 42]:='084';
     A [1, 43]:='086';
     A [1, 44]:='088';
     A [1, 45]:='090';
     A [1, 46]:='092';
     A [1, 47]:='094';
     A [1, 48]:='096';
     A [1, 49]:='098';
     A [1, 50]:='100';
     A [1, 51]:='102';
     A [1, 52]:='104';
     A [1, 53]:='106';
     A [1, 54]:='108';
     A [1, 55]:='110';
     A [1, 56]:='112';
     A [1, 57]:='114';
     A [1, 58]:='116';
     A [1, 59]:='118';
     A [1, 60]:='120';
     A [1, 61]:='122';
     A [1, 62]:='124';
     A [1, 63]:='126';
     A [1, 64]:='128';
     A [1, 65]:='130';
     A [1, 66]:='132';
     A [1, 67]:='134';
     A [1, 68]:='136';
     A [1, 69]:='138';
     A [1, 70]:='140';
     A [1, 71]:='142';
     A [1, 72]:='144';
     A [1, 73]:='146';
     A [1, 74]:='148';
     A [1, 75]:='150';
     A [1, 76]:='152';
     A [1, 77]:='154';
     A [1, 78]:='156';
     A [1, 79]:='158';
     A [1, 80]:='160';
     A [1, 81]:='162';
     A [1, 82]:='164';
     A [1, 83]:='166';
     A [1, 84]:='168';
     A [1, 85]:='170';
     A [1, 86]:='172';
     A [1, 87]:='174';
     A [1, 88]:='176';
     A [1, 89]:='178';
     A [1, 90]:='180';
     A [1, 91]:='182';
     A [1, 92]:='184';
     A [1, 93]:='186';
     A [1, 94]:='188';
     A [1, 95]:='190';
     A [1, 96]:='192';
     A [1, 97]:='194';
     A [1, 98]:='196';
     A [1, 99]:='198';
     A [1, 100]:='0200';
     A [2, 1]:='2';
     A [2, 2]:='04';
     A [2, 3]:='08';
     A [2, 4]:='16';
     A [2, 5]:='032';
     A [2, 6]:='064';
     A [2, 7]:='128';
     A [2, 8]:='0256';
     A [2, 9]:='0512';
     A [2, 10]:='1024';
     A [2, 11]:='02048';
     A [2, 12]:='04096';
     A [2, 13]:='08192';
     A [2, 14]:='16384';
     A [2, 15]:='032768';
     A [2, 16]:='065536';
     A [2, 17]:='131072';
     A [2, 18]:='0262144';
     A [2, 19]:='0524288';
     A [2, 20]:='1048576';
     A [2, 21]:='02097152';
     A [2, 22]:='04194304';
     A [2, 23]:='08388608';
     A [2, 24]:='16777216';
     A [2, 25]:='033554432';
     A [2, 26]:='067108864';
     A [2, 27]:='134217728';
     A [2, 28]:='0268435456';
     A [2, 29]:='0536870912';
     A [2, 30]:='1073741824';
     A [2, 31]:='02147483648';
     A [2, 32]:='04294967296';
     A [2, 33]:='08589934592';
     A [2, 34]:='17179869184';
     A [2, 35]:='034359738368';
     A [2, 36]:='068719476736';
     A [2, 37]:='137438953472';
     A [2, 38]:='0274877906944';
     A [2, 39]:='0549755813888';
     A [2, 40]:='1099511627776';
     A [2, 41]:='02199023255552';
     A [2, 42]:='04398046511104';
     A [2, 43]:='08796093022208';
     A [2, 44]:='17592186044416';
     A [2, 45]:='035184372088832';
     A [2, 46]:='070368744177664';
     A [2, 47]:='140737488355328';
     A [2, 48]:='0281474976710656';
     A [2, 49]:='0562949953421312';
     A [2, 50]:='1125899906842624';
     A [2, 51]:='02251799813685248';
     A [2, 52]:='04503599627370496';
     A [2, 53]:='09007199254740992';
     A [2, 54]:='18014398509481984';
     A [2, 55]:='036028797018963968';
     A [2, 56]:='072057594037927936';
     A [2, 57]:='144115188075855872';
     A [2, 58]:='0288230376151711744';
     A [2, 59]:='0576460752303423488';
     A [2, 60]:='1152921504606846976';
     A [2, 61]:='02305843009213693952';
     A [2, 62]:='04611686018427387904';
     A [2, 63]:='09223372036854775808';
     A [2, 64]:='18446744073709551616';
     A [2, 65]:='036893488147419103232';
     A [2, 66]:='073786976294838206464';
     A [2, 67]:='147573952589676412928';
     A [2, 68]:='0295147905179352825856';
     A [2, 69]:='0590295810358705651712';
     A [2, 70]:='1180591620717411303424';
     A [2, 71]:='02361183241434822606848';
     A [2, 72]:='04722366482869645213696';
     A [2, 73]:='09444732965739290427392';
     A [2, 74]:='18889465931478580854784';
     A [2, 75]:='037778931862957161709568';
     A [2, 76]:='075557863725914323419136';
     A [2, 77]:='151115727451828646838272';
     A [2, 78]:='0302231454903657293676544';
     A [2, 79]:='0604462909807314587353088';
     A [2, 80]:='1208925819614629174706176';
     A [2, 81]:='02417851639229258349412352';
     A [2, 82]:='04835703278458516698824704';
     A [2, 83]:='09671406556917033397649408';
     A [2, 84]:='19342813113834066795298816';
     A [2, 85]:='038685626227668133590597632';
     A [2, 86]:='077371252455336267181195264';
     A [2, 87]:='154742504910672534362390528';
     A [2, 88]:='0309485009821345068724781056';
     A [2, 89]:='0618970019642690137449562112';
     A [2, 90]:='1237940039285380274899124224';
     A [2, 91]:='02475880078570760549798248448';
     A [2, 92]:='04951760157141521099596496896';
     A [2, 93]:='09903520314283042199192993792';
     A [2, 94]:='19807040628566084398385987584';
     A [2, 95]:='039614081257132168796771975168';
     A [2, 96]:='079228162514264337593543950336';
     A [2, 97]:='158456325028528675187087900672';
     A [2, 98]:='0316912650057057350374175801344';
     A [2, 99]:='0633825300114114700748351602688';
     A [2, 100]:='1267650600228229401496703205376';
     A [3, 1]:='2';
     A [3, 2]:='04';
     A [3, 3]:='16';
     A [3, 4]:='065536';
end;

procedure Solve;
var
   NCase: LongInt;
   n, m: LongInt;
   Value: LongInt;
   tStr: string;
begin
     InitHehe;
     RandSeed:=1;
     NCase:=0;
     tStr:=IntToStr (t);
     while not SeekEOF (FIn)
           do begin
              Inc (NCase);
              Readln (FIn, n, m);
              if (n=0) and (m=0)
                 then Break;
              if Length (A [n, m])=0
                 then Value:=Random (t)
                 else Value:=StrToInt (LongMod (A [n, m], tStr));
              Writeln (FOut, 'Case ', NCase, ': ', Value);
           end;
end;

begin
     Assign (FIn, FileIn);
     Reset (FIn);
     Assign (FOut, FileOut);
     Rewrite (FOut);
     Readln (FIn, T);
     Solve;
     Close (FIn);
     Close (FOut);
end.
